[![CI build wheels](https://github.com/PySCeS/pysces/actions/workflows/cibuildwheel.yml/badge.svg)](https://github.com/PySCeS/pysces/actions/workflows/cibuildwheel.yml)
[![CI build Anaconda](https://github.com/PySCeS/pysces/actions/workflows/build-conda.yml/badge.svg)](https://github.com/PySCeS/pysces/actions/workflows/build-conda.yml)
[![Documentation Status](https://readthedocs.org/projects/pyscesdocs/badge/?version=latest)](https://pyscesdocs.readthedocs.io/en/latest/?badge=latest)

# PySCeS - Python Simulator for Cellular Systems

PySCeS is a flexible, user-friendly tool for the analysis of cellular systems. For more
information please see https://pysces.github.io/

## Table of contents

* [Introduction](#introduction)
* [Installation](#installation)
* [Getting help](#getting-help)
* [Citing PySCeS](#citing-pysces)
* [Contributing](#contributing)
* [Licence](#licence)
* [Authors and acknowledgments](#authors-and-acknowledgments)

## Introduction

Computer modelling has become an integral tool in the analysis and understanding of the
reaction networks that underlie cellular processes. PySCeS, first released in 2003, is
extremely flexible, user-extensible, open source, software actively used and developed
by a community of researchers and developers.

### Features

* **Simulate** your time courses with solvers like LSODA and CVODE.
* Efficiently determine **steady states** using a selection of non-linear, root-finding
  algorithms (e.g. HYBRD, NLEQ2).
* Use **Metabolic Control Analysis** (MCA) to investigate control and regulation of
  cellular systems (elasticities, flux- and concentration-control and response
  coefficients).
* Auto-generate the stoichiometric matrix and perform **structural analysis**, determine
  nullspaces and reduced stoichiometric and MCA matrices.
* Investigate systems which exhibit multiple (stable and unstable) steady-state
  solutions using a PITCON-based bifurcation analysis module.
* Define models with a human-readable **Model Description Language**.
* Use the full power of Python available to test, build and share your modelling
  experiments.
* User-friendly methods for generating and 1-, 2- and n-dimensional **parameter scans**.
* Distributed parameter scanning with the **ParScanner** module within the *ipyparallel*
  framework.
* **Visualise** results of simulations with flexible Matplotlib and Gnuplot interfaces.
* PySCeS supports open community standards for **model
  exchange** ([SBML](http://sbml.org/)) and archiving (SEDML, OMEX).

## Installation

PySCeS releases are available on [PyPI](https://pypi.org/project/pysces/#files), 
[Anaconda.org](https://anaconda.org/pysces/pysces) and 
[Github](https://github.com/PySCeS/pysces)

PySCeS binaries are available for Python 3.6+ on Windows, Linux and OSX and can be
installed using

**PyPI**

```bash
pip install pysces
```

**Anaconda.org**

```bash
conda install -c conda-forge -c pysces pysces
```

**Building from source**

PySCeS requires a Python 3 development environment as well as C++ and FORTRAN compilers
to build. For more information please see the [INSTALL](./INSTALL.md) instructions.

## Getting help

We currently encourage users to ask questions and request support using a
GitHub [issue](https://github.com/PySCeS/pysces/issues).

General information on PySCeS can be found on the [website](https://pysces.github.io/)
and extensive documentation on installing, configuring and using PySCeS is available
on [pyscesdocs.readthedocs.io](https://pyscesdocs.readthedocs.io/en/latest/).

## Citing PySCeS

**Publication**

Brett G. Olivier, Johann M. Rohwer and Jan-Hendrik S. Hofmeyr, **Modelling cellular
systems with PySCeS**,
*Bioinformatics*, Volume 21, Issue 4, 15 February 2005, Pages
560–561, https://doi.org/10.1093/bioinformatics/bti046

**Published code releases**

PySCeS releases are archived on [Zenodo](http://zenodo.org). 
[![DOI](https://zenodo.org/badge/DOI/10.5281/zenodo.2600905.svg)](https://doi.org/10.5281/zenodo.2600905)

## Contributing

Primary development is on GitHub, feel free to fork and submit pull requests! Want to
add new code to PySCeS, go 
[![Code style: black](https://img.shields.io/badge/code%20style-black-000000.svg)](https://github.com/psf/black)

## Licence

PySCeS is distributed as Open Source software under a BSD style licence, please
see [LICENCE.txt](./LICENCE.txt) for details. The licences of software that is bundled
with, or used by, PySCeS are available
in [ADDITIONAL_LICENCES.md](./ADDITIONAL_LICENCES.md).

## Authors and acknowledgments

PySCeS main authors are [Brett Olivier](https://research.vu.nl/en/persons/bg-olivier)
and [Johann Rohwer](https://github.com/jmrohwer) and in particular, PySCeS founding
father [Jannie Hofmeyr]().

We would also like to acknowledge everyone who has contributed to PySCeS and would like
to thank the following (in alphabetical order):

* Evert Bosdriesz
* James Dominy
* Jannie Hofmeyr
* Morgan Hough
* Jonathan Karr
* Ruchir Khandelwal
* Charl Moller
* Danie Palm
* Herbert Sauro
* Lafras Uys

This information can also be found in [CONTRIBUTORS.md](./CONTRIBUTORS.md)
In addition we would like to acknowledge financial support from the following funding
organisations:

* The South African National Bioinformatics Network (2003-2008)
* The South African National Research Foundation (2000-2004)

© Brett G. Olivier & Johann M. Rohwer, August 2021

# Outdated!

The information and scripts in this folder are outdated. Wheels on Windows are now built automatically as part of the Anaconda build process. Refer to the information in `packaging/conda`.

Johann Rohwer, August 2021

PySCeS - Python Simulator for Cellular Systems
----------------------------------------------

Copyright (c) 2004 - 2021, Brett G. Olivier, Johann M. Rohwer and Jan-Hendrik S. Hofmeyr
All rights reserved.

PySCeS is distributed under a BSD style licence, please see LICENCE.txt for details

Author information
------------------

Brett G. Olivier

Vrije Universiteit Amsterdam
Faculty of Earth and Life Sciences
Department of Molecular Cell Physiology
De Boelelaan 1085
NL-1081 HV AMSTERDAM
The Netherlands

previous address

Triple-J Group for Molecular Cell Physiology
Department of Biochemistry
University of Stellenbosch
Private Bag X1
Matieland
7602


email: bgoli@users.sourceforge.net
web:   http://pysces.sourceforge.net

Installation
------------

Please see INSTALL.txt for information on building PySCeS an its modules.


Additional licence information
------------------------------

PySCeS has interfaces to and is distributed with additional packages that
are supplied under their own licence conditions.

NLEQ2
~~~~~

The NLEQ2 algorithm from ZIB which has it's own licence and warranty
and does not fall under the PySCeS GPL licence. ZIB has kindly given us
permission to distribute NLEQ2 with PySCeS provided it's use falls
within their terms of usage (/nleq2/nleq2_readme):

You may use or modify this code for your own non commercial
purposes for an unlimited time.
In any case you should not deliver this code without a special
permission of ZIB.
In case you intend to use the code commercially, we oblige you
to sign an according licence agreement with ZIB.

If you are not using PySCeS for research or personal use you **must** disable
NLEQ2 by setting nleq2 = 0 in setup.py before installation. This is a plug-in
solver and its removal does not otherwise influence PySCeS.

Other software (or parts there of) distributed with PySCeS
----------------------------------------------------------

PLY
~~~

David Beazley's PLY 3.3 (http://www.dabeaz.com/ply/). This package is included
unchanged and consists of two files lex.py and yacc.py in the lib/ and core2/
modules.


Brett G. Olivier, Amsterdam,  2020

NLEQ2 package - release 2.3 at January 3, 1992

Description of the package:
---------------------------

The NLEQ2 package consists of the files listed and briefly described
below:

filename    contents of file

nleq2.f     NLEQ2 standard user interface and internal subroutines.

wnorm.f     Norm computation subroutine used for termination criteria.

main_nleq2.f    An example main program illustrating the usage of NLEQ2.

nleq2e.f    An easy-to-use driver subroutine to NLEQ2 for nonlinear
            problems with n <= 50 equations. The calling parameter list
            consists of 4 items and, additionally, only the nonlinear
            problem function (named FCN) must be supplied.

main_nleq2_easy.f    An example main program illustrating the usage of NLEQ2E.

linalg_nleq2.f Linear algebra routines (decoon, solcon).

zibmon.f    Monitor.

zibsec.f    Time routine ZIBSEC.

zibconst.f   Machine constants ZIBCONST.

makefile    An input file to the UNIX make utility containing informa-
            tion how to build the executable programs nleq2 and
            nleq2-easy.

readme      This information.

nleq2_out.nrm   Example monitor output of program run of nleq2.

nleq2_dat.nrm   Example data output of program run of nleq2.

nleq2_easy.nrm  Example monitor output (to FORTRAN unit 6) of program run
            of nleq2-easy.


The two main programs solve the same sequence of test problems 
(the Chebyquad problem with dimensions n=2,3,...,9) in two
slightly different ways. To build the executable programs, you need to
compile and to link:

main_nleq2.f, nleq2.f, linalg_nleq2.f, zibmon.f, zibsec.f,
  zibconst.f   (to build program nleq2),
main_nleq2_easy.f, nleq2e.f, nleq2.f, linalg_nleq2.f, zibmon.f,
  zibsec.f, zibconst.f   (to build program nleq2-easy).

Under UNIX with the make-utility, for example simply type in:
make             -   to build program nleq2    - or
make nleq2-easy  -   to build program nleq2-easy.

Note that a few adaptations may be necessary to utilize the code for
your computer at hand. Please examine the two subroutines ZIBCONST and
ZIBSEC. Probably, you need to adapt ZIBCONST to correspond to the arithmetic 
of your computer. If you want to obtain time measurements from the time
monitor, you must supply a "time stamp", measured in seconds, through the 
argument of the subroutine zibsec.
If you replace version 2.2 with the new one and if you examine the
output values from RWK (e.g. CONV, SUMX, DLEVF), please notice that
the positions of some RWK output values have been changed.

What is new within the current release?
---------------------------------------

A lot of improvements have been included within release 2.3 of NLEQ2
since the previous release 2.2. They are shortly summarized below:

- The easy to use interface NLEQ2E - see above
- The time monitor, which can be used to measure the performance
  of the package and of the users problem subroutines -
  see IOPT(19), IOPT(20) and subroutine ZIBSEC
- An optionally selectable bounded damping strategy which can be helpful
  for solving extremely nonlinear problems -
  see IOPT(38) (also IOPT(31)) and RWK(20)
- If the user problem function FCN returns IERR=1, indicating that
  F(X1) cannot be evaluated for the given X1, a damping factor reduction
  is done and F is tried to be evaluated again with a different argument
  X2. The degree of reduction of the damping factor may be also
  controlled by the user - see description of FCN
- Certain characteristic internal parameters of the numerical approxi-
  mation subroutines may be altered now easily by the user -
  see RWK(26), RWK(27), RWK(28), RWK(29)
- The convergence rate of the Newton iteration is monitored and based
  in this, the iteration will be terminated if it significantly slows
  down when approaching the solution - due to roundoff errors. (A
  corresponding warning message will be printed and a warning code
  returned through parameter IERR). Also, in connection with this 
  monitor feature, a warning message and code will be given, if 
  the iteration terminated because the usual criterion has been 
  fulfilled, but the corresponding error estimate may not be appro-
  priate due to lack of theoretical assumptions in the actual context.
  see IOPT(39) and error messages
- The standard rank-1 updates procedure, operating directly on the
  Jacobian, has been replaced by an (equivalent) iterative rank-1
  updates algorithm which uses exclusively vectors for computations -
  see IOPT(32), IWK(36).
- Double precision storage will be saved against the previous version
  if rank-1 updates are inhibited - up to n(n-1) elements.
- The computation of the norm which is used in connection with the
  convergence termination criterion, is now separated in the function
  subroutine WNORM and may be easily exchanged.
- NLEQ2 is now a real extension of NLEQ1 applied with full mode Jacobian
  - in the sense that the damping factor calculations produce the same
  sequence of damping factors as NLEQ1 - until damping factor reduction
  would lead to error termination of NLEQ1 - the case when rank 
  reduction is activated by NLEQ2. (but practically iteration sequences
  of NLEQ1 and NLEQ2 may differ before this condition meets because
  of using different linear solver procedures)

Further minor changes:

- The default value for IOPT(3) (JACGEN) is now 2 (Jacobian by numerical
  approximation  w i t h o u t  feedback device).
- RWK positions, which have been changed:
  name     new   old
  CONV     17    24
  SUMX     18    26
  DLEVF    19    27
  SIGMA2   24    28



 

# Building `manylinux` compatible Python wheels for PySCeS

The various *manylinux* specifications were developed to set a minimum standard in terms 
of compiler compatibility for distribution of binary Python wheels. 
See https://github.com/pypa/manylinux for background.

This directory provides a set of scripts to build PySCeS *manylinux* wheels via a docker 
image.

## Prerequisites and preparation

1. Install `docker` via your Linux distribution's repositories.

2. Install the required docker image:

    ```shell
    $ docker pull quay.io/pypa/manylinux2014_x86_64
    ```

    ---
    **NOTE:**
    
    If compatibility with earlier compiler versions is desired, the `manylinux1` or 
    `manylinux2010` images can also be used (see https://github.com/pypa/manylinux).
    
    ---
    
## Build

1. Open a terminal and navigate to this folder.

2. If desired, update `build_pysces.sh` with your Unix UID to ensure write access to the 
files during the build and after the build has completed. 

3. If desired/needed, update the `DNS_SERVER` and `DOCKER_IMAGE` variables in 
`run_pysces.sh`.

4. Run the build script:

    ```shell
    $ sh run_pysces.sh
    ```

5. Portable patched wheels are in the `dist/wheelhouse` subdirectory of the PySCeS source.

(C) Johann Rohwer, August 2021

# IMPORTANT INFORMATION
## OUTDATED!

The information in this file is **outdated**! For updated building instructions 
refer to [INSTALL.md](../../INSTALL.md).

Note that *updated conda packages* are distributed via 
[anaconda.org](https://anaconda.org/pysces/pysces).

# Building Anaconda packages and Python wheels

This guide describes building **portable** Anaconda packages and binary Python wheels for 
distribution of PySCeS on all supported OSs (Linux, Windows, macOS). With the 
exception of Linux (see below), Python wheels are built in the Anaconda environment as 
well and a single build script provides both Anaconda packages and Python wheels.

Build variants (builds for different Python versions built with the correct associated 
NumPy version) are handled automatically by the build scripts making use of 
`conda_build_config.yaml` and Jinja 2 templates in the various `meta.yaml` files. 
Normally, it should not be necessary to mess with this other than to customise your build 
variants in `conda_build_config.yaml`.

## Contents

- [Prerequisites](#prerequisites)
- [Linux](#linux)
- [Windows](#windows)
- [macOS](#macos)

## Prerequisites

1. An updated Anaconda 64-bit environment for your OS. I recommend using 
[Miniconda3](https://docs.conda.io/en/latest/miniconda.html). Your base environment 
should have `conda-build>=3.0` installed.

2. Set conda-forge as the default channel:

    ```shell
    $ conda config --add channels conda-forge
    ```

3. (Optional) Install `mamba` for faster builds and dependency resolution of environments:

    ```shell
    $ conda install mamba
    ```

OS-specific instructions are provided below.

## Linux

1. Install `gcc` and `gfortran` via your Linux distribution.

2. Activate your Anaconda base environment and navigate to this directory.

3. Run the build script:

    ```shell
    $ bash ./build_conda_linux.sh
    ```

4. Depending on where you installed Anaconda/Miniconda, the binary packages will be in
`$HOME/miniconda3/conda-bld/linux-64/` or similar. You have to upload the packages to the 
Anaconda repo yourself, the script does not do this.

5. If desired, clean up disk space:

    ```shell
    $ conda build purge
    $ conda clean -a
    ```

6. Portable wheels on Linux have to be built with the `manylinux` specification; this is 
achieved with a docker image. See instructions under `packaging/many_linux/`.
    
## Windows

1. Get [Microsoft Visual C++ Build Tools for Visual Studio 
2019](https://visualstudio.microsoft.com/downloads/#build-tools-for-visual-studio-2019). 
You can also get the complete VS Community 2019 edition, but it is not needed for this 
compile.

2. Download and install [MinGW-W64](https://sourceforge.net/projects/mingw-w64/) 
(x86_64-win32-seh build). Link to 
[online installer](https://sourceforge.net/projects/mingw-w64/files/Toolchains%20targetting%20Win32/Personal%20Builds/mingw-builds/installer/mingw-w64-install.exe).
*Modify the batch file* that launches the MinGW-W64 Command Prompt to set the paths and also 
activate the conda base environment (modify the location of your Anaconda/Miniconda 
installation as needed):

    ```bat
    @echo off
    set PATH=C:\Program Files\mingw-w64\x86_64-8.1.0-win32-seh-rt_v6-rev0\mingw64\bin;%PATH%
    cd %USERPROFILE%
    C:\Windows\system32\cmd.exe /K %USERPROFILE%\miniconda3\condabin\activate.bat
    ```
3. Activate the environment with this modified shortcut, navigate to this directory, and run the build script:

    ```shell
    $ build_conda_windows.bat
    ```

4. Depending on where you installed Anaconda/Miniconda, the binary packages will be in 
`%USERPROFILE%\miniconda3\conda-bld\win-64\` or similar. You have to upload the packages 
to the Anaconda repo yourself, the script does not do this. Binary wheels will be in the 
`dist` subfolder of your PySCeS source directory.

5. If desired, clean up disk space:

    ```shell
    $ conda build purge
    $ conda clean -a
    ```

## macOS

1. Install the Command Line Tools for Xcode by running the following from a terminal and 
following the prompts:

    ```shell
    $ xcode-select --install
    ```

    You can of course install the complete Xcode, but it is a huge multi-Gb install, and 
    only the Command Line Tools are needed.

2. Create a file `conda_build_config.yaml` in your `$HOME` directory with the following 
content:

    ```yaml
    CONDA_BUILD_SYSROOT:
      - /Library/Developer/CommandLineTools/SDKs/MacOSX.sdk
    ```

3. Download and install 
[gfortran](https://github.com/fxcoudert/gfortran-for-macOS/releases/tag/8.2). This will 
set up the compiler executable automatically to be in the path
(`/usr/local/bin/`).

4. Open a terminal, activate the conda base environment,

    ```shell
    $ conda activate
    ```
    
    Install `delocate` (needed to create portable Python wheel files).
    
    ```shell
    $ conda install delocate
    ```
    
5. Change to this directory and run the build script:

    ```shell
    $ sh ./build_conda_macos.sh
    ```

6. Depending on where you installed Anaconda/Miniconda, the binary packages will be in
`$HOME/miniconda3/conda-bld/osx-64/` or similar. You have to upload the packages to the 
Anaconda repo yourself, the script does not do this. Binary wheels will be in the 
`dist/wheelhouse` subfolder of your PySCeS source directory.

5. If desired, clean up disk space:

    ```shell
    $ conda build purge
    $ conda clean -a
    ```

(C) Johann Rohwer, August 2021

Extracted from dpcon61.f

C  PCON61 is version 6.1 of PITCON, the University of Pittsburgh continuation
C  program.
C
C  PITCON was written by
C
C    Professor Werner C Rheinboldt and John Burkardt,
C    Department of Mathematics and Statistics
C    University of Pittsburgh,
C    Pittsburgh, Pennsylvania, 15260, USA. 
C  H. References
C
C
C  1.
C  Werner Rheinboldt,
C  Solution Field of Nonlinear Equations and Continuation Methods,
C  SIAM Journal of Numerical Analysis,
C  Volume 17, 1980, pages 221-237.
C
C  2.
C  Cor den Heijer and Werner Rheinboldt,
C  On Steplength Algorithms for a Class of Continuation Methods,
C  SIAM Journal of Numerical Analysis,
C  Volume 18, 1981, pages 925-947.
C
C  3.
C  Werner Rheinboldt,
C  Numerical Analysis of Parametrized Nonlinear Equations
C  John Wiley and Sons, New York, 1986
C
C  4.
C  Werner Rheinboldt and John Burkardt,
C  A Locally Parameterized Continuation Process,
C  ACM Transactions on Mathematical Software,
C  Volume 9, Number 2, June 1983, pages 215-235.
C
C  5.
C  Werner Rheinboldt and John Burkardt,
C  Algorithm 596, A Program for a Locally Parameterized Continuation Process,
C  ACM Transactions on Mathematical Software,
C  Volume 9, Number 2, June 1983, Pages 236-241. 

This is an additional package that is distributed unchanged, with permission
from ZIB, under the terms of their own licence and warranty as described in nleq2.f
and *not* the PySCeS BSD style licence.

Please take careful notice of the usage conditions, licence and warranty as
described in nleq2_readme.txt and nleq2.f. If you do not agree with these usage
conditions you must either disable the installation of nleq2 or obtain a licence from ZIB.

The co-installation of the nleq2 non-linear solver can be disabled in one of two ways:

1. Use the environment variable PYSCES_SKIP, i.e.
  $ PYSCES_SKIP=nleq2 python -m build .    (to build)
or
  $ PYSCES_SKIP=nleq2 pip install .        (to install)

2. In the user configuration section at the top of config.py, set nleq to False:
-- config.py --
##### USER CONFIGURATION SECTION #####
  nleq2 = False

      SUBROUTINE ZIBCONST(EPMACH,SMALL)
      DOUBLE PRECISION EPMACH,SMALL
C
C*********************************************************************
C  Set Approximations to machine constants.
C  This routine is machine dependent.
C*********************************************************************
C
C  Output parameters
C    EPMACH    DOUBLE     Relative machine precision
C    SMALL     DOUBLE     SQRT of smallest positive machine number
C 
C  The proposed values should work on Intel compatible cpus,
C  PowerPCs and Sun sparcs
C
C*********************************************************************
C
      EPMACH = 1.0D-17
      SMALL  = 1.0D-150
      RETURN
      END

C  PCON61SUBD.F  25 February 1991
C
      INTEGER FUNCTION IDAMAX(N,DX,INCX)
C
C     FINDS THE INDEX OF ELEMENT HAVING MAX. ABSOLUTE VALUE.
C     JACK DONGARRA, LINPACK, 3/11/78.
C
      DOUBLE PRECISION DX(1),DMAX
      INTEGER I,INCX,IX,N
C
      IDAMAX = 0
      IF( N .LT. 1 ) RETURN
      IDAMAX = 1
      IF(N.EQ.1)RETURN
      IF(INCX.EQ.1)GO TO 20
C
C        CODE FOR INCREMENT NOT EQUAL TO 1
C
      IX = 1
      DMAX = DABS(DX(1))
      IX = IX + INCX
      DO 10 I = 2,N
         IF(DABS(DX(IX)).LE.DMAX) GO TO 5
         IDAMAX = I
         DMAX = DABS(DX(IX))
    5    IX = IX + INCX
   10 CONTINUE
      RETURN
C
C        CODE FOR INCREMENT EQUAL TO 1
C
   20 DMAX = DABS(DX(1))
      DO 30 I = 2,N
         IF(DABS(DX(I)).LE.DMAX) GO TO 30
         IDAMAX = I
         DMAX = DABS(DX(I))
   30 CONTINUE
      RETURN
      END
      DOUBLE PRECISION FUNCTION DDOT(N,DX,INCX,DY,INCY)
C
C     FORMS THE DOT PRODUCT OF TWO VECTORS.
C     USES UNROLLED LOOPS FOR INCREMENTS EQUAL TO ONE.
C     JACK DONGARRA, LINPACK, 3/11/78.
C
      DOUBLE PRECISION DX(1),DY(1),DTEMP
      INTEGER I,INCX,INCY,IX,IY,M,MP1,N
C
      DDOT = 0.0D0
      DTEMP = 0.0D0
      IF(N.LE.0)RETURN
      IF(INCX.EQ.1.AND.INCY.EQ.1)GO TO 20
C
C        CODE FOR UNEQUAL INCREMENTS OR EQUAL INCREMENTS
C          NOT EQUAL TO 1
C
      IX = 1
      IY = 1
      IF(INCX.LT.0)IX = (-N+1)*INCX + 1
      IF(INCY.LT.0)IY = (-N+1)*INCY + 1
      DO 10 I = 1,N
        DTEMP = DTEMP + DX(IX)*DY(IY)
        IX = IX + INCX
        IY = IY + INCY
   10 CONTINUE
      DDOT = DTEMP
      RETURN
C
C        CODE FOR BOTH INCREMENTS EQUAL TO 1
C
C
C        CLEAN-UP LOOP
C
   20 M = MOD(N,5)
      IF( M .EQ. 0 ) GO TO 40
      DO 30 I = 1,M
        DTEMP = DTEMP + DX(I)*DY(I)
   30 CONTINUE
      IF( N .LT. 5 ) GO TO 60
   40 MP1 = M + 1
      DO 50 I = MP1,N,5
        DTEMP = DTEMP + DX(I)*DY(I) + DX(I + 1)*DY(I + 1) +
     *   DX(I + 2)*DY(I + 2) + DX(I + 3)*DY(I + 3) + DX(I + 4)*DY(I + 4)
   50 CONTINUE
   60 DDOT = DTEMP
      RETURN
      END
      SUBROUTINE DGEFA(A,LDA,N,IPVT,INFO)
      INTEGER LDA,N,IPVT(1),INFO
      DOUBLE PRECISION A(LDA,1)
C
C     DGEFA FACTORS A DOUBLE PRECISION MATRIX BY GAUSSIAN ELIMINATION.
C
C     DGEFA IS USUALLY CALLED BY DGECO, BUT IT CAN BE CALLED
C     DIRECTLY WITH A SAVING IN TIME IF  RCOND  IS NOT NEEDED.
C     (TIME FOR DGECO) = (1 + 9/N)*(TIME FOR DGEFA) .
C
C     ON ENTRY
C
C        A       DOUBLE PRECISION(LDA, N)
C                THE MATRIX TO BE FACTORED.
C
C        LDA     INTEGER
C                THE LEADING DIMENSION OF THE ARRAY  A .
C
C        N       INTEGER
C                THE ORDER OF THE MATRIX  A .
C
C     ON RETURN
C
C        A       AN UPPER TRIANGULAR MATRIX AND THE MULTIPLIERS
C                WHICH WERE USED TO OBTAIN IT.
C                THE FACTORIZATION CAN BE WRITTEN  A = L*U  WHERE
C                L  IS A PRODUCT OF PERMUTATION AND UNIT LOWER
C                TRIANGULAR MATRICES AND  U  IS UPPER TRIANGULAR.
C
C        IPVT    INTEGER(N)
C                AN INTEGER VECTOR OF PIVOT INDICES.
C
C        INFO    INTEGER
C                = 0  NORMAL VALUE.
C                = K  IF  U(K,K) .EQ. 0.0 .  THIS IS NOT AN ERROR
C                     CONDITION FOR THIS SUBROUTINE, BUT IT DOES
C                     INDICATE THAT DGESL OR DGEDI WILL DIVIDE BY ZERO
C                     IF CALLED.  USE  RCOND  IN DGECO FOR A RELIABLE
C                     INDICATION OF SINGULARITY.
C
C     LINPACK. THIS VERSION DATED 08/14/78 .
C     CLEVE MOLER, UNIVERSITY OF NEW MEXICO, ARGONNE NATIONAL LAB.
C
C     SUBROUTINES AND FUNCTIONS
C
C     BLAS DAXPY,DSCAL,IDAMAX
C
C     INTERNAL VARIABLES
C
      DOUBLE PRECISION T
      INTEGER IDAMAX,J,K,KP1,L,NM1
C
C
C     GAUSSIAN ELIMINATION WITH PARTIAL PIVOTING
C
      INFO = 0
      NM1 = N - 1
      IF (NM1 .LT. 1) GO TO 70
      DO 60 K = 1, NM1
         KP1 = K + 1
C
C        FIND L = PIVOT INDEX
C
         L = IDAMAX(N-K+1,A(K,K),1) + K - 1
         IPVT(K) = L
C
C        ZERO PIVOT IMPLIES THIS COLUMN ALREADY TRIANGULARIZED
C
         IF (A(L,K) .EQ. 0.0D0) GO TO 40
C
C           INTERCHANGE IF NECESSARY
C
            IF (L .EQ. K) GO TO 10
               T = A(L,K)
               A(L,K) = A(K,K)
               A(K,K) = T
   10       CONTINUE
C
C           COMPUTE MULTIPLIERS
C
            T = -1.0D0/A(K,K)
            CALL DSCAL(N-K,T,A(K+1,K),1)
C
C           ROW ELIMINATION WITH COLUMN INDEXING
C
            DO 30 J = KP1, N
               T = A(L,J)
               IF (L .EQ. K) GO TO 20
                  A(L,J) = A(K,J)
                  A(K,J) = T
   20          CONTINUE
               CALL DAXPY(N-K,T,A(K+1,K),1,A(K+1,J),1)
   30       CONTINUE
         GO TO 50
   40    CONTINUE
            INFO = K
   50    CONTINUE
   60 CONTINUE
   70 CONTINUE
      IPVT(N) = N
      IF (A(N,N) .EQ. 0.0D0) INFO = N
      RETURN
      END
      SUBROUTINE DGESL(A,LDA,N,IPVT,B,JOB)
      INTEGER LDA,N,IPVT(1),JOB
      DOUBLE PRECISION A(LDA,1),B(1)
C
C     DGESL SOLVES THE DOUBLE PRECISION SYSTEM
C     A * X = B  OR  TRANS(A) * X = B
C     USING THE FACTORS COMPUTED BY DGECO OR DGEFA.
C
C     ON ENTRY
C
C        A       DOUBLE PRECISION(LDA, N)
C                THE OUTPUT FROM DGECO OR DGEFA.
C
C        LDA     INTEGER
C                THE LEADING DIMENSION OF THE ARRAY  A .
C
C        N       INTEGER
C                THE ORDER OF THE MATRIX  A .
C
C        IPVT    INTEGER(N)
C                THE PIVOT VECTOR FROM DGECO OR DGEFA.
C
C        B       DOUBLE PRECISION(N)
C                THE RIGHT HAND SIDE VECTOR.
C
C        JOB     INTEGER
C                = 0         TO SOLVE  A*X = B ,
C                = NONZERO   TO SOLVE  TRANS(A)*X = B  WHERE
C                            TRANS(A)  IS THE TRANSPOSE.
C
C     ON RETURN
C
C        B       THE SOLUTION VECTOR  X .
C
C     ERROR CONDITION
C
C        A DIVISION BY ZERO WILL OCCUR IF THE INPUT FACTOR CONTAINS A
C        ZERO ON THE DIAGONAL.  TECHNICALLY THIS INDICATES SINGULARITY
C        BUT IT IS OFTEN CAUSED BY IMPROPER ARGUMENTS OR IMPROPER
C        SETTING OF LDA .  IT WILL NOT OCCUR IF THE SUBROUTINES ARE
C        CALLED CORRECTLY AND IF DGECO HAS SET RCOND .GT. 0.0
C        OR DGEFA HAS SET INFO .EQ. 0 .
C
C     TO COMPUTE  INVERSE(A) * C  WHERE  C  IS A MATRIX
C     WITH  P  COLUMNS
C           CALL DGECO(A,LDA,N,IPVT,RCOND,Z)
C           IF (RCOND IS TOO SMALL) GO TO ...
C           DO 10 J = 1, P
C              CALL DGESL(A,LDA,N,IPVT,C(1,J),0)
C        10 CONTINUE
C
C     LINPACK. THIS VERSION DATED 08/14/78 .
C     CLEVE MOLER, UNIVERSITY OF NEW MEXICO, ARGONNE NATIONAL LAB.
C
C     SUBROUTINES AND FUNCTIONS
C
C     BLAS DAXPY,DDOT
C
C     INTERNAL VARIABLES
C
      DOUBLE PRECISION DDOT,T
      INTEGER K,KB,L,NM1
C
      NM1 = N - 1
      IF (JOB .NE. 0) GO TO 50
C
C        JOB = 0 , SOLVE  A * X = B
C        FIRST SOLVE  L*Y = B
C
         IF (NM1 .LT. 1) GO TO 30
         DO 20 K = 1, NM1
            L = IPVT(K)
            T = B(L)
            IF (L .EQ. K) GO TO 10
               B(L) = B(K)
               B(K) = T
   10       CONTINUE
            CALL DAXPY(N-K,T,A(K+1,K),1,B(K+1),1)
   20    CONTINUE
   30    CONTINUE
C
C        NOW SOLVE  U*X = Y
C
         DO 40 KB = 1, N
            K = N + 1 - KB
            B(K) = B(K)/A(K,K)
            T = -B(K)
            CALL DAXPY(K-1,T,A(1,K),1,B(1),1)
   40    CONTINUE
      GO TO 100
   50 CONTINUE
C
C        JOB = NONZERO, SOLVE  TRANS(A) * X = B
C        FIRST SOLVE  TRANS(U)*Y = B
C
         DO 60 K = 1, N
            T = DDOT(K-1,A(1,K),1,B(1),1)
            B(K) = (B(K) - T)/A(K,K)
   60    CONTINUE
C
C        NOW SOLVE TRANS(L)*X = Y
C
         IF (NM1 .LT. 1) GO TO 90
         DO 80 KB = 1, NM1
            K = N - KB
            B(K) = B(K) + DDOT(N-K,A(K+1,K),1,B(K+1),1)
            L = IPVT(K)
            IF (L .EQ. K) GO TO 70
               T = B(L)
               B(L) = B(K)
               B(K) = T
   70       CONTINUE
   80    CONTINUE
   90    CONTINUE
  100 CONTINUE
      RETURN
      END
      SUBROUTINE DGEDI(A,LDA,N,IPVT,DET,WORK,JOB)
      INTEGER LDA,N,IPVT(1),JOB
      DOUBLE PRECISION A(LDA,1),DET(2),WORK(1)
C
C     DGEDI COMPUTES THE DETERMINANT AND INVERSE OF A MATRIX
C     USING THE FACTORS COMPUTED BY DGECO OR DGEFA.
C
C     ON ENTRY
C
C        A       DOUBLE PRECISION(LDA, N)
C                THE OUTPUT FROM DGECO OR DGEFA.
C
C        LDA     INTEGER
C                THE LEADING DIMENSION OF THE ARRAY  A .
C
C        N       INTEGER
C                THE ORDER OF THE MATRIX  A .
C
C        IPVT    INTEGER(N)
C                THE PIVOT VECTOR FROM DGECO OR DGEFA.
C
C        WORK    DOUBLE PRECISION(N)
C                WORK VECTOR.  CONTENTS DESTROYED.
C
C        JOB     INTEGER
C                = 11   BOTH DETERMINANT AND INVERSE.
C                = 01   INVERSE ONLY.
C                = 10   DETERMINANT ONLY.
C
C     ON RETURN
C
C        A       INVERSE OF ORIGINAL MATRIX IF REQUESTED.
C                OTHERWISE UNCHANGED.
C
C        DET     DOUBLE PRECISION(2)
C                DETERMINANT OF ORIGINAL MATRIX IF REQUESTED.
C                OTHERWISE NOT REFERENCED.
C                DETERMINANT = DET(1) * 10.0**DET(2)
C                WITH  1.0 .LE. DABS(DET(1)) .LT. 10.0
C                OR  DET(1) .EQ. 0.0 .
C
C     ERROR CONDITION
C
C        A DIVISION BY ZERO WILL OCCUR IF THE INPUT FACTOR CONTAINS
C        A ZERO ON THE DIAGONAL AND THE INVERSE IS REQUESTED.
C        IT WILL NOT OCCUR IF THE SUBROUTINES ARE CALLED CORRECTLY
C        AND IF DGECO HAS SET RCOND .GT. 0.0 OR DGEFA HAS SET
C        INFO .EQ. 0 .
C
C     LINPACK. THIS VERSION DATED 08/14/78 .
C     CLEVE MOLER, UNIVERSITY OF NEW MEXICO, ARGONNE NATIONAL LAB.
C
C     SUBROUTINES AND FUNCTIONS
C
C     BLAS DAXPY,DSCAL,DSWAP
C     FORTRAN DABS,MOD
C
C     INTERNAL VARIABLES
C
      DOUBLE PRECISION T
      DOUBLE PRECISION TEN
      INTEGER I,J,K,KB,KP1,L,NM1
C
C
C     COMPUTE DETERMINANT
C
      IF (JOB/10 .EQ. 0) GO TO 70
         DET(1) = 1.0D0
         DET(2) = 0.0D0
         TEN = 10.0D0
         DO 50 I = 1, N
            IF (IPVT(I) .NE. I) DET(1) = -DET(1)
            DET(1) = A(I,I)*DET(1)
C        ...EXIT
            IF (DET(1) .EQ. 0.0D0) GO TO 60
   10       IF (DABS(DET(1)) .GE. 1.0D0) GO TO 20
               DET(1) = TEN*DET(1)
               DET(2) = DET(2) - 1.0D0
            GO TO 10
   20       CONTINUE
   30       IF (DABS(DET(1)) .LT. TEN) GO TO 40
               DET(1) = DET(1)/TEN
               DET(2) = DET(2) + 1.0D0
            GO TO 30
   40       CONTINUE
   50    CONTINUE
   60    CONTINUE
   70 CONTINUE
C
C     COMPUTE INVERSE(U)
C
      IF (MOD(JOB,10) .EQ. 0) GO TO 150
         DO 100 K = 1, N
            A(K,K) = 1.0D0/A(K,K)
            T = -A(K,K)
            CALL DSCAL(K-1,T,A(1,K),1)
            KP1 = K + 1
            IF (N .LT. KP1) GO TO 90
            DO 80 J = KP1, N
               T = A(K,J)
               A(K,J) = 0.0D0
               CALL DAXPY(K,T,A(1,K),1,A(1,J),1)
   80       CONTINUE
   90       CONTINUE
  100    CONTINUE
C
C        FORM INVERSE(U)*INVERSE(L)
C
         NM1 = N - 1
         IF (NM1 .LT. 1) GO TO 140
         DO 130 KB = 1, NM1
            K = N - KB
            KP1 = K + 1
            DO 110 I = KP1, N
               WORK(I) = A(I,K)
               A(I,K) = 0.0D0
  110       CONTINUE
            DO 120 J = KP1, N
               T = WORK(J)
               CALL DAXPY(N,T,A(1,J),1,A(1,K),1)
  120       CONTINUE
            L = IPVT(K)
            IF (L .NE. K) CALL DSWAP(N,A(1,K),1,A(1,L),1)
  130    CONTINUE
  140    CONTINUE
  150 CONTINUE
      RETURN
      END
      SUBROUTINE DGBFA(ABD,LDA,N,ML,MU,IPVT,INFO)
      INTEGER LDA,N,ML,MU,IPVT(1),INFO
      DOUBLE PRECISION ABD(LDA,1)
C
C     DGBFA FACTORS A DOUBLE PRECISION BAND MATRIX BY ELIMINATION.
C
C     DGBFA IS USUALLY CALLED BY DGBCO, BUT IT CAN BE CALLED
C     DIRECTLY WITH A SAVING IN TIME IF  RCOND  IS NOT NEEDED.
C
C     ON ENTRY
C
C        ABD     DOUBLE PRECISION(LDA, N)
C                CONTAINS THE MATRIX IN BAND STORAGE.  THE COLUMNS
C                OF THE MATRIX ARE STORED IN THE COLUMNS OF  ABD  AND
C                THE DIAGONALS OF THE MATRIX ARE STORED IN ROWS
C                ML+1 THROUGH 2*ML+MU+1 OF  ABD .
C                SEE THE COMMENTS BELOW FOR DETAILS.
C
C        LDA     INTEGER
C                THE LEADING DIMENSION OF THE ARRAY  ABD .
C                LDA MUST BE .GE. 2*ML + MU + 1 .
C
C        N       INTEGER
C                THE ORDER OF THE ORIGINAL MATRIX.
C
C        ML      INTEGER
C                NUMBER OF DIAGONALS BELOW THE MAIN DIAGONAL.
C                0 .LE. ML .LT. N .
C
C        MU      INTEGER
C                NUMBER OF DIAGONALS ABOVE THE MAIN DIAGONAL.
C                0 .LE. MU .LT. N .
C                MORE EFFICIENT IF  ML .LE. MU .
C     ON RETURN
C
C        ABD     AN UPPER TRIANGULAR MATRIX IN BAND STORAGE AND
C                THE MULTIPLIERS WHICH WERE USED TO OBTAIN IT.
C                THE FACTORIZATION CAN BE WRITTEN  A = L*U  WHERE
C                L  IS A PRODUCT OF PERMUTATION AND UNIT LOWER
C                TRIANGULAR MATRICES AND  U  IS UPPER TRIANGULAR.
C
C        IPVT    INTEGER(N)
C                AN INTEGER VECTOR OF PIVOT INDICES.
C
C        INFO    INTEGER
C                = 0  NORMAL VALUE.
C                = K  IF  U(K,K) .EQ. 0.0 .  THIS IS NOT AN ERROR
C                     CONDITION FOR THIS SUBROUTINE, BUT IT DOES
C                     INDICATE THAT DGBSL WILL DIVIDE BY ZERO IF
C                     CALLED.  USE  RCOND  IN DGBCO FOR A RELIABLE
C                     INDICATION OF SINGULARITY.
C
C     BAND STORAGE
C
C           IF  A  IS A BAND MATRIX, THE FOLLOWING PROGRAM SEGMENT
C           WILL SET UP THE INPUT.
C
C                   ML = (BAND WIDTH BELOW THE DIAGONAL)
C                   MU = (BAND WIDTH ABOVE THE DIAGONAL)
C                   M = ML + MU + 1
C                   DO 20 J = 1, N
C                      I1 = MAX0(1, J-MU)
C                      I2 = MIN0(N, J+ML)
C                      DO 10 I = I1, I2
C                         K = I - J + M
C                         ABD(K,J) = A(I,J)
C                10    CONTINUE
C                20 CONTINUE
C
C           THIS USES ROWS  ML+1  THROUGH  2*ML+MU+1  OF  ABD .
C           IN ADDITION, THE FIRST  ML  ROWS IN  ABD  ARE USED FOR
C           ELEMENTS GENERATED DURING THE TRIANGULARIZATION.
C           THE TOTAL NUMBER OF ROWS NEEDED IN  ABD  IS  2*ML+MU+1 .
C           THE  ML+MU BY ML+MU  UPPER LEFT TRIANGLE AND THE
C           ML BY ML  LOWER RIGHT TRIANGLE ARE NOT REFERENCED.
C
C     LINPACK. THIS VERSION DATED 08/14/78 .
C     CLEVE MOLER, UNIVERSITY OF NEW MEXICO, ARGONNE NATIONAL LAB.
C
C     SUBROUTINES AND FUNCTIONS
C
C     BLAS DAXPY,DSCAL,IDAMAX
C     FORTRAN MAX0,MIN0
C
C     INTERNAL VARIABLES
C
      DOUBLE PRECISION T
      INTEGER I,IDAMAX,I0,J,JU,JZ,J0,J1,K,KP1,L,LM,M,MM,NM1
C
C
      M = ML + MU + 1
      INFO = 0
C
C     ZERO INITIAL FILL-IN COLUMNS
C
      J0 = MU + 2
      J1 = MIN0(N,M) - 1
      IF (J1 .LT. J0) GO TO 30
      DO 20 JZ = J0, J1
         I0 = M + 1 - JZ
         DO 10 I = I0, ML
            ABD(I,JZ) = 0.0D0
   10    CONTINUE
   20 CONTINUE
   30 CONTINUE
      JZ = J1
      JU = 0
C
C     GAUSSIAN ELIMINATION WITH PARTIAL PIVOTING
C
      NM1 = N - 1
      IF (NM1 .LT. 1) GO TO 130
      DO 120 K = 1, NM1
         KP1 = K + 1
C
C        ZERO NEXT FILL-IN COLUMN
C
         JZ = JZ + 1
         IF (JZ .GT. N) GO TO 50
         IF (ML .LT. 1) GO TO 50
            DO 40 I = 1, ML
               ABD(I,JZ) = 0.0D0
   40       CONTINUE
   50    CONTINUE
C
C        FIND L = PIVOT INDEX
C
         LM = MIN0(ML,N-K)
         L = IDAMAX(LM+1,ABD(M,K),1) + M - 1
         IPVT(K) = L + K - M
C
C        ZERO PIVOT IMPLIES THIS COLUMN ALREADY TRIANGULARIZED
C
         IF (ABD(L,K) .EQ. 0.0D0) GO TO 100
C
C           INTERCHANGE IF NECESSARY
C
            IF (L .EQ. M) GO TO 60
               T = ABD(L,K)
               ABD(L,K) = ABD(M,K)
               ABD(M,K) = T
   60       CONTINUE
C
C           COMPUTE MULTIPLIERS
C
            T = -1.0D0/ABD(M,K)
            CALL DSCAL(LM,T,ABD(M+1,K),1)
C
C           ROW ELIMINATION WITH COLUMN INDEXING
C
            JU = MIN0(MAX0(JU,MU+IPVT(K)),N)
            MM = M
            IF (JU .LT. KP1) GO TO 90
            DO 80 J = KP1, JU
               L = L - 1
               MM = MM - 1
               T = ABD(L,J)
               IF (L .EQ. MM) GO TO 70
                  ABD(L,J) = ABD(MM,J)
                  ABD(MM,J) = T
   70          CONTINUE
               CALL DAXPY(LM,T,ABD(M+1,K),1,ABD(MM+1,J),1)
   80       CONTINUE
   90       CONTINUE
         GO TO 110
  100    CONTINUE
            INFO = K
  110    CONTINUE
  120 CONTINUE
  130 CONTINUE
      IPVT(N) = N
      IF (ABD(M,N) .EQ. 0.0D0) INFO = N
      RETURN
      END
      SUBROUTINE DGBSL(ABD,LDA,N,ML,MU,IPVT,B,JOB)
      INTEGER LDA,N,ML,MU,IPVT(1),JOB
      DOUBLE PRECISION ABD(LDA,1),B(1)
C
C     DGBSL SOLVES THE DOUBLE PRECISION BAND SYSTEM
C     A * X = B  OR  TRANS(A) * X = B
C     USING THE FACTORS COMPUTED BY DGBCO OR DGBFA.
C
C     ON ENTRY
C
C        ABD     DOUBLE PRECISION(LDA, N)
C                THE OUTPUT FROM DGBCO OR DGBFA.
C
C        LDA     INTEGER
C                THE LEADING DIMENSION OF THE ARRAY  ABD .
C
C        N       INTEGER
C                THE ORDER OF THE ORIGINAL MATRIX.
C
C        ML      INTEGER
C                NUMBER OF DIAGONALS BELOW THE MAIN DIAGONAL.
C
C        MU      INTEGER
C                NUMBER OF DIAGONALS ABOVE THE MAIN DIAGONAL.
C
C        IPVT    INTEGER(N)
C                THE PIVOT VECTOR FROM DGBCO OR DGBFA.
C
C        B       DOUBLE PRECISION(N)
C                THE RIGHT HAND SIDE VECTOR.
C
C        JOB     INTEGER
C                = 0         TO SOLVE  A*X = B ,
C                = NONZERO   TO SOLVE  TRANS(A)*X = B , WHERE
C                            TRANS(A)  IS THE TRANSPOSE.
C
C     ON RETURN
C
C        B       THE SOLUTION VECTOR  X .
C
C     ERROR CONDITION
C
C        A DIVISION BY ZERO WILL OCCUR IF THE INPUT FACTOR CONTAINS A
C        ZERO ON THE DIAGONAL.  TECHNICALLY THIS INDICATES SINGULARITY
C        BUT IT IS OFTEN CAUSED BY IMPROPER ARGUMENTS OR IMPROPER
C        SETTING OF LDA .  IT WILL NOT OCCUR IF THE SUBROUTINES ARE
C        CALLED CORRECTLY AND IF DGBCO HAS SET RCOND .GT. 0.0
C        OR DGBFA HAS SET INFO .EQ. 0 .
C
C     TO COMPUTE  INVERSE(A) * C  WHERE  C  IS A MATRIX
C     WITH  P  COLUMNS
C           CALL DGBCO(ABD,LDA,N,ML,MU,IPVT,RCOND,Z)
C           IF (RCOND IS TOO SMALL) GO TO ...
C           DO 10 J = 1, P
C              CALL DGBSL(ABD,LDA,N,ML,MU,IPVT,C(1,J),0)
C        10 CONTINUE
C
C     LINPACK. THIS VERSION DATED 08/14/78 .
C     CLEVE MOLER, UNIVERSITY OF NEW MEXICO, ARGONNE NATIONAL LAB.
C
C     SUBROUTINES AND FUNCTIONS
C
C     BLAS DAXPY,DDOT
C     FORTRAN MIN0
C
C     INTERNAL VARIABLES
C
      DOUBLE PRECISION DDOT,T
      INTEGER K,KB,L,LA,LB,LM,M,NM1
C
      M = MU + ML + 1
      NM1 = N - 1
      IF (JOB .NE. 0) GO TO 50
C
C        JOB = 0 , SOLVE  A * X = B
C        FIRST SOLVE L*Y = B
C
         IF (ML .EQ. 0) GO TO 30
         IF (NM1 .LT. 1) GO TO 30
            DO 20 K = 1, NM1
               LM = MIN0(ML,N-K)
               L = IPVT(K)
               T = B(L)
               IF (L .EQ. K) GO TO 10
                  B(L) = B(K)
                  B(K) = T
   10          CONTINUE
               CALL DAXPY(LM,T,ABD(M+1,K),1,B(K+1),1)
   20       CONTINUE
   30    CONTINUE
C
C        NOW SOLVE  U*X = Y
C
         DO 40 KB = 1, N
            K = N + 1 - KB
            B(K) = B(K)/ABD(M,K)
            LM = MIN0(K,M) - 1
            LA = M - LM
            LB = K - LM
            T = -B(K)
            CALL DAXPY(LM,T,ABD(LA,K),1,B(LB),1)
   40    CONTINUE
      GO TO 100
   50 CONTINUE
C
C        JOB = NONZERO, SOLVE  TRANS(A) * X = B
C        FIRST SOLVE  TRANS(U)*Y = B
C
         DO 60 K = 1, N
            LM = MIN0(K,M) - 1
            LA = M - LM
            LB = K - LM
            T = DDOT(LM,ABD(LA,K),1,B(LB),1)
            B(K) = (B(K) - T)/ABD(M,K)
   60    CONTINUE
C
C        NOW SOLVE TRANS(L)*X = Y
C
         IF (ML .EQ. 0) GO TO 90
         IF (NM1 .LT. 1) GO TO 90
            DO 80 KB = 1, NM1
               K = N - KB
               LM = MIN0(ML,N-K)
               B(K) = B(K) + DDOT(LM,ABD(M+1,K),1,B(K+1),1)
               L = IPVT(K)
               IF (L .EQ. K) GO TO 70
                  T = B(L)
                  B(L) = B(K)
                  B(K) = T
   70          CONTINUE
   80       CONTINUE
   90    CONTINUE
  100 CONTINUE
      RETURN
      END
      SUBROUTINE DGBDI(ABD,LDA,N,ML,MU,IPVT,DET)
      INTEGER LDA,N,ML,MU,IPVT(1)
      DOUBLE PRECISION ABD(LDA,1),DET(2)
C
C     DGBDI COMPUTES THE DETERMINANT OF A BAND MATRIX
C     USING THE FACTORS COMPUTED BY DGBCO OR DGBFA.
C     IF THE INVERSE IS NEEDED, USE DGBSL  N  TIMES.
C
C     ON ENTRY
C
C        ABD     DOUBLE PRECISION(LDA, N)
C                THE OUTPUT FROM DGBCO OR DGBFA.
C
C        LDA     INTEGER
C                THE LEADING DIMENSION OF THE ARRAY  ABD .
C
C        N       INTEGER
C                THE ORDER OF THE ORIGINAL MATRIX.
C
C        ML      INTEGER
C                NUMBER OF DIAGONALS BELOW THE MAIN DIAGONAL.
C
C        MU      INTEGER
C                NUMBER OF DIAGONALS ABOVE THE MAIN DIAGONAL.
C
C        IPVT    INTEGER(N)
C                THE PIVOT VECTOR FROM DGBCO OR DGBFA.
C
C     ON RETURN
C
C        DET     DOUBLE PRECISION(2)
C                DETERMINANT OF ORIGINAL MATRIX.
C                DETERMINANT = DET(1) * 10.0**DET(2)
C                WITH  1.0 .LE. DABS(DET(1)) .LT. 10.0
C                OR  DET(1) = 0.0 .
C
C     LINPACK. THIS VERSION DATED 08/14/78 .
C     CLEVE MOLER, UNIVERSITY OF NEW MEXICO, ARGONNE NATIONAL LAB.
C
C     SUBROUTINES AND FUNCTIONS
C
C     FORTRAN DABS
C
C     INTERNAL VARIABLES
C
      DOUBLE PRECISION TEN
      INTEGER I,M
C
C
      M = ML + MU + 1
      DET(1) = 1.0D0
      DET(2) = 0.0D0
      TEN = 10.0D0
      DO 50 I = 1, N
         IF (IPVT(I) .NE. I) DET(1) = -DET(1)
         DET(1) = ABD(M,I)*DET(1)
C     ...EXIT
         IF (DET(1) .EQ. 0.0D0) GO TO 60
   10    IF (DABS(DET(1)) .GE. 1.0D0) GO TO 20
            DET(1) = TEN*DET(1)
            DET(2) = DET(2) - 1.0D0
         GO TO 10
   20    CONTINUE
   30    IF (DABS(DET(1)) .LT. TEN) GO TO 40
            DET(1) = DET(1)/TEN
            DET(2) = DET(2) + 1.0D0
         GO TO 30
   40    CONTINUE
   50 CONTINUE
   60 CONTINUE
      RETURN
      END
      SUBROUTINE DAXPY(N,DA,DX,INCX,DY,INCY)
C
C     CONSTANT TIMES A VECTOR PLUS A VECTOR.
C     USES UNROLLED LOOPS FOR INCREMENTS EQUAL TO ONE.
C     JACK DONGARRA, LINPACK, 3/11/78.
C
      DOUBLE PRECISION DX(1),DY(1),DA
      INTEGER I,INCX,INCY,M,MP1,N
C
      IF(N.LE.0)RETURN
      IF (DA .EQ. 0.0D0) RETURN
      IF(INCX.EQ.1.AND.INCY.EQ.1)GO TO 20
C
C        CODE FOR UNEQUAL INCREMENTS OR EQUAL INCREMENTS
C          NOT EQUAL TO 1
C
      IX = 1
      IY = 1
      IF(INCX.LT.0)IX = (-N+1)*INCX + 1
      IF(INCY.LT.0)IY = (-N+1)*INCY + 1
      DO 10 I = 1,N
        DY(IY) = DY(IY) + DA*DX(IX)
        IX = IX + INCX
        IY = IY + INCY
   10 CONTINUE
      RETURN
C
C        CODE FOR BOTH INCREMENTS EQUAL TO 1
C
C
C        CLEAN-UP LOOP
C
   20 M = MOD(N,4)
      IF( M .EQ. 0 ) GO TO 40
      DO 30 I = 1,M
        DY(I) = DY(I) + DA*DX(I)
   30 CONTINUE
      IF( N .LT. 4 ) RETURN
   40 MP1 = M + 1
      DO 50 I = MP1,N,4
        DY(I) = DY(I) + DA*DX(I)
        DY(I + 1) = DY(I + 1) + DA*DX(I + 1)
        DY(I + 2) = DY(I + 2) + DA*DX(I + 2)
        DY(I + 3) = DY(I + 3) + DA*DX(I + 3)
   50 CONTINUE
      RETURN
      END
      SUBROUTINE  DCOPY(N,DX,INCX,DY,INCY)
C
C     COPIES A VECTOR, X, TO A VECTOR, Y.
C     USES UNROLLED LOOPS FOR INCREMENTS EQUAL TO ONE.
C     JACK DONGARRA, LINPACK, 3/11/78.
C
      DOUBLE PRECISION DX(1),DY(1)
      INTEGER I,INCX,INCY,IX,IY,M,MP1,N
C
      IF(N.LE.0)RETURN
      IF(INCX.EQ.1.AND.INCY.EQ.1)GO TO 20
C
C        CODE FOR UNEQUAL INCREMENTS OR EQUAL INCREMENTS
C          NOT EQUAL TO 1
C
      IX = 1
      IY = 1
      IF(INCX.LT.0)IX = (-N+1)*INCX + 1
      IF(INCY.LT.0)IY = (-N+1)*INCY + 1
      DO 10 I = 1,N
        DY(IY) = DX(IX)
        IX = IX + INCX
        IY = IY + INCY
   10 CONTINUE
      RETURN
C
C        CODE FOR BOTH INCREMENTS EQUAL TO 1
C
C
C        CLEAN-UP LOOP
C
   20 M = MOD(N,7)
      IF( M .EQ. 0 ) GO TO 40
      DO 30 I = 1,M
        DY(I) = DX(I)
   30 CONTINUE
      IF( N .LT. 7 ) RETURN
   40 MP1 = M + 1
      DO 50 I = MP1,N,7
        DY(I) = DX(I)
        DY(I + 1) = DX(I + 1)
        DY(I + 2) = DX(I + 2)
        DY(I + 3) = DX(I + 3)
        DY(I + 4) = DX(I + 4)
        DY(I + 5) = DX(I + 5)
        DY(I + 6) = DX(I + 6)
   50 CONTINUE
      RETURN
      END
      DOUBLE PRECISION FUNCTION DNRM2 ( N, DX, INCX)
      INTEGER          NEXT
      DOUBLE PRECISION   DX(1), CUTLO, CUTHI, HITEST, SUM, XMAX,ZERO,ONE
      DATA   ZERO, ONE /0.0D0, 1.0D0/
C
C     EUCLIDEAN NORM OF THE N-VECTOR STORED IN DX() WITH STORAGE
C     INCREMENT INCX .
C     IF    N .LE. 0 RETURN WITH RESULT = 0.
C     IF N .GE. 1 THEN INCX MUST BE .GE. 1
C
C           C.L.LAWSON, 1978 JAN 08
C
C     FOUR PHASE METHOD     USING TWO BUILT-IN CONSTANTS THAT ARE
C     HOPEFULLY APPLICABLE TO ALL MACHINES.
C         CUTLO = MAXIMUM OF  DSQRT(U/EPS)  OVER ALL KNOWN MACHINES.
C         CUTHI = MINIMUM OF  DSQRT(V)      OVER ALL KNOWN MACHINES.
C     WHERE
C         EPS = SMALLEST NO. SUCH THAT EPS + 1. .GT. 1.
C         U   = SMALLEST POSITIVE NO.   (UNDERFLOW LIMIT)
C         V   = LARGEST  NO.            (OVERFLOW  LIMIT)
C
C     BRIEF OUTLINE OF ALGORITHM..
C
C     PHASE 1    SCANS ZERO COMPONENTS.
C     MOVE TO PHASE 2 WHEN A COMPONENT IS NONZERO AND .LE. CUTLO
C     MOVE TO PHASE 3 WHEN A COMPONENT IS .GT. CUTLO
C     MOVE TO PHASE 4 WHEN A COMPONENT IS .GE. CUTHI/M
C     WHERE M = N FOR X() REAL AND M = 2*N FOR COMPLEX.
C
C     VALUES FOR CUTLO AND CUTHI..
C     FROM THE ENVIRONMENTAL PARAMETERS LISTED IN THE IMSL CONVERTER
C     DOCUMENT THE LIMITING VALUES ARE AS FOLLOWS..
C     CUTLO, S.P.   U/EPS = 2**(-102) FOR  HONEYWELL.  CLOSE SECONDS ARE
C                   UNIVAC AND DEC AT 2**(-103)
C                   THUS CUTLO = 2**(-51) = 4.44089E-16
C     CUTHI, S.P.   V = 2**127 FOR UNIVAC, HONEYWELL, AND DEC.
C                   THUS CUTHI = 2**(63.5) = 1.30438E19
C     CUTLO, D.P.   U/EPS = 2**(-67) FOR HONEYWELL AND DEC.
C                   THUS CUTLO = 2**(-33.5) = 8.23181D-11
C     CUTHI, D.P.   SAME AS S.P.  CUTHI = 1.30438D19
C     DATA CUTLO, CUTHI / 8.232D-11,  1.304D19 /
C     DATA CUTLO, CUTHI / 4.441E-16,  1.304E19 /
      DATA CUTLO, CUTHI / 8.232D-11,  1.304D19 /
C
      IF(N .GT. 0) GO TO 10
         DNRM2  = ZERO
         GO TO 300
C
   10 ASSIGN 30 TO NEXT
      SUM = ZERO
      NN = N * INCX
C                                                 BEGIN MAIN LOOP
      I = 1
   20    GO TO NEXT,(30, 50, 70, 110)
   30 IF( DABS(DX(I)) .GT. CUTLO) GO TO 85
      ASSIGN 50 TO NEXT
      XMAX = ZERO
C
C                        PHASE 1.  SUM IS ZERO
C
   50 IF( DX(I) .EQ. ZERO) GO TO 200
      IF( DABS(DX(I)) .GT. CUTLO) GO TO 85
C
C                                PREPARE FOR PHASE 2.
      ASSIGN 70 TO NEXT
      GO TO 105
C
C                                PREPARE FOR PHASE 4.
C
  100 I = J
      ASSIGN 110 TO NEXT
      SUM = (SUM / DX(I)) / DX(I)
  105 XMAX = DABS(DX(I))
      GO TO 115
C
C                   PHASE 2.  SUM IS SMALL.
C                             SCALE TO AVOID DESTRUCTIVE UNDERFLOW.
C
   70 IF( DABS(DX(I)) .GT. CUTLO ) GO TO 75
C
C                     COMMON CODE FOR PHASES 2 AND 4.
C                     IN PHASE 4 SUM IS LARGE.  SCALE TO AVOID OVERFLOW.
C
  110 IF( DABS(DX(I)) .LE. XMAX ) GO TO 115
         SUM = ONE + SUM * (XMAX / DX(I))**2
         XMAX = DABS(DX(I))
         GO TO 200
C
  115 SUM = SUM + (DX(I)/XMAX)**2
      GO TO 200
C
C
C                  PREPARE FOR PHASE 3.
C
   75 SUM = (SUM * XMAX) * XMAX
C
C
C     FOR REAL OR D.P. SET HITEST = CUTHI/N
C     FOR COMPLEX      SET HITEST = CUTHI/(2*N)
C
   85 HITEST = CUTHI/FLOAT( N )
C
C                   PHASE 3.  SUM IS MID-RANGE.  NO SCALING.
C
      DO 95 J =I,NN,INCX
      IF(DABS(DX(J)) .GE. HITEST) GO TO 100
   95    SUM = SUM + DX(J)**2
      DNRM2 = DSQRT( SUM )
      GO TO 300
C
  200 CONTINUE
      I = I + INCX
      IF ( I .LE. NN ) GO TO 20
C
C              END OF MAIN LOOP.
C
C              COMPUTE SQUARE ROOT AND ADJUST FOR SCALING.
C
      DNRM2 = XMAX * DSQRT(SUM)
  300 CONTINUE
      RETURN
      END
      SUBROUTINE  DSCAL(N,DA,DX,INCX)
C
C     SCALES A VECTOR BY A CONSTANT.
C     USES UNROLLED LOOPS FOR INCREMENT EQUAL TO ONE.
C     JACK DONGARRA, LINPACK, 3/11/78.
C
      DOUBLE PRECISION DA,DX(1)
      INTEGER I,INCX,M,MP1,N,NINCX
C
      IF(N.LE.0)RETURN
      IF(INCX.EQ.1)GO TO 20
C
C        CODE FOR INCREMENT NOT EQUAL TO 1
C
      NINCX = N*INCX
      DO 10 I = 1,NINCX,INCX
        DX(I) = DA*DX(I)
   10 CONTINUE
      RETURN
C
C        CODE FOR INCREMENT EQUAL TO 1
C
C
C        CLEAN-UP LOOP
C
   20 M = MOD(N,5)
      IF( M .EQ. 0 ) GO TO 40
      DO 30 I = 1,M
        DX(I) = DA*DX(I)
   30 CONTINUE
      IF( N .LT. 5 ) RETURN
   40 MP1 = M + 1
      DO 50 I = MP1,N,5
        DX(I) = DA*DX(I)
        DX(I + 1) = DA*DX(I + 1)
        DX(I + 2) = DA*DX(I + 2)
        DX(I + 3) = DA*DX(I + 3)
        DX(I + 4) = DA*DX(I + 4)
   50 CONTINUE
      RETURN
      END
      SUBROUTINE  DSWAP (N,DX,INCX,DY,INCY)
C
C     INTERCHANGES TWO VECTORS.
C     USES UNROLLED LOOPS FOR INCREMENTS EQUAL ONE.
C     JACK DONGARRA, LINPACK, 3/11/78.
C
      DOUBLE PRECISION DX(1),DY(1),DTEMP
      INTEGER I,INCX,INCY,IX,IY,M,MP1,N
C
      IF(N.LE.0)RETURN
      IF(INCX.EQ.1.AND.INCY.EQ.1)GO TO 20
C
C       CODE FOR UNEQUAL INCREMENTS OR EQUAL INCREMENTS NOT EQUAL
C         TO 1
C
      IX = 1
      IY = 1
      IF(INCX.LT.0)IX = (-N+1)*INCX + 1
      IF(INCY.LT.0)IY = (-N+1)*INCY + 1
      DO 10 I = 1,N
        DTEMP = DX(IX)
        DX(IX) = DY(IY)
        DY(IY) = DTEMP
        IX = IX + INCX
        IY = IY + INCY
   10 CONTINUE
      RETURN
C
C       CODE FOR BOTH INCREMENTS EQUAL TO 1
C
C
C       CLEAN-UP LOOP
C
   20 M = MOD(N,3)
      IF( M .EQ. 0 ) GO TO 40
      DO 30 I = 1,M
        DTEMP = DX(I)
        DX(I) = DY(I)
        DY(I) = DTEMP
   30 CONTINUE
      IF( N .LT. 3 ) RETURN
   40 MP1 = M + 1
      DO 50 I = MP1,N,3
        DTEMP = DX(I)
        DX(I) = DY(I)
        DY(I) = DTEMP
        DTEMP = DX(I + 1)
        DX(I + 1) = DY(I + 1)
        DY(I + 1) = DTEMP
        DTEMP = DX(I + 2)
        DX(I + 2) = DY(I + 2)
        DY(I + 2) = DTEMP
   50 CONTINUE
      RETURN
      END

C
C*    Group  Linear Solver subroutines (Code DECCON/SOLCON)
C
      SUBROUTINE DECCON(A,NROW,NCOL,MCON,M,N,IRANKC,IRANK,COND,
     *                  D,PIVOT,KRED,AH,V,IERR)
C*    Begin Prologue DECCON
      INTEGER IRANKC,IRANK,MCON
      INTEGER M,N,NROW,NCOL,KRED
      INTEGER PIVOT(NCOL)
      DOUBLE PRECISION COND
      DOUBLE PRECISION A(NROW,NCOL),AH(NCOL,NCOL)
      DOUBLE PRECISION D(NCOL),V(NCOL)
      INTEGER IERR
C     ------------------------------------------------------------
C
C*  Title
C
C*    Deccon - Constrained Least Squares QR-Decomposition
C
C*  Written by        P. Deuflhard, U. Nowak, L. Weimann 
C*  Purpose           Solution of least squares problems, optionally
C                     with equality constraints.
C*  Method            Constrained Least Squares QR-Decomposition
C                     (see references below)
C*  Category          D9b1. -  Singular, overdetermined or
C                              underdetermined systems of linear 
C                              equations, generalized inverses. 
C                              Constrained Least Squares solution
C*  Keywords          Linear Least Square Problems, constrained, 
C                     QR-decomposition, pseudo inverse.
C*  Version           1.3
C*  Revision          December 1993
C*  Latest Change     August 2006
C*  Library           CodeLib
C*  Code              Fortran 77, Double Precision
C*  Environment       Standard Fortran 77 environment on PC's,
C                     workstations and hosts.
C*  Copyright     (c) Konrad-Zuse-Zentrum fuer
C                     Informationstechnik Berlin (ZIB)
C                     Takustrasse 7, D-14195 Berlin-Dahlem
C                     phone : + 49/30/84185-0
C                     fax   : + 49/30/84185-125
C*  Contact           Lutz Weimann
C                     ZIB, Division Scientific Computing, 
C                          Department Numerical Analysis and Modelling
C                     phone : + 49/30/84185-185
C                     fax   : + 49/30/84185-107
C                     e-mail: weimann@zib.de
C
C*    References:
C     ===========
C
C       /1/ P.Deuflhard, V.Apostolescu:
C           An underrelaxed Gauss-Newton method for equality
C           constrained nonlinear least squares problems.
C           Lecture Notes Control Inform. Sci. vol. 7, p.
C           22-32 (1978)
C       /2/ P.Deuflhard, W.Sautter:
C           On rank-deficient pseudoinverses.
C           J. Lin. Alg. Appl. vol. 29, p. 91-111 (1980)
C    
C*    Related Programs:     SOLCON
C
C  ---------------------------------------------------------------
C
C* Licence
C    You may use or modify this code for your own non commercial
C    purposes for an unlimited time. 
C    In any case you should not deliver this code without a special 
C    permission of ZIB.
C    In case you intend to use the code commercially, we oblige you
C    to sign an according licence agreement with ZIB.
C
C* Warranty 
C    This code has been tested up to a certain level. Defects and
C    weaknesses, which may be included in the code, do not establish
C    any warranties by ZIB. ZIB does not take over any liabilities
C    which may follow from acquisition or application of this code.
C
C* Software status 
C    This code is under care of ZIB and belongs to ZIB software class 1.
C
C     ------------------------------------------------------------
C
C*    Summary:
C     ========
C     Constrained QR-decomposition of (M,N)-system  with
C     computation of pseudoinverse in case of rank-defeciency .
C     First MCON rows belong to equality constraints.
C
C     ------------------------------------------------------------
C
C*    Parameters list description (* marks inout parameters)
C     ======================================================
C
C*    Input parameters
C     ================
C
C       A(NROW,NCOL) Dble   Array holding the (M,N)-Matrix to be 
C                           decomposed
C       NROW         Int    Declared number of rows of array A
C       NCOL         Int    Declared number of columns of array A and 
C                           rows and columns of array AH
C       MCON         Int    Number of equality constraints (MCON.LE.N)
C                           Internally reduced if equality constraints
C                           are linearly dependent
C       M            Int    Current number of rows of matrix A
C       N            Int    Current number of columns of matrix A
C     * IRANKC       Int    Prescribed maximum pseudo-rank of 
C                           constrained part of matrix A (IRANKC.LE.MCON)
C     * IRANK        Int    Prescribed maximum pseudo-rank of matrix A
C                           (IRANK.LE.N)
C     * COND         Dble   Permitted upper bound for the subcondition
C                           of the least squares part of A, .i.e.
C                           DABS(D(IRANKC+1)/D(IRANK))
C       KRED         Int    Type of operation
C                           >=0  Householder triangularization
C                                (build up pseudo-inverse,if IRANK.LT.N)
C                           < 0  Reduction of pseudo-rank of matrix A, 
C                                skipping Householder triangularization,
C                                 build-up new pseudo-inverse
C
C*    Output parameters
C     =================
C
C       A(NROW,NCOL)  Dble   Array holding the (M,N)-output consisting
C                            of the transformed matrix in the upper 
C                            right triangle and the performed House-
C                            holder transf. in the lower left triangle.
C     * IRANKC        Int    New pseudo-rank of constrained part of
C                            matrix A, determined so that
C                            DABS(D(1)/D(IRANKC))<1/EPMACH
C     * IRANK         Int    New pseudo-rank of matrix A, determined
C                            so that DABS(D(IRANKC+1)/D(IRANK)) < COND
C       D(IRANK)      Dble   Diagonal elements of upper triangular matr.
C       PIVOT(N)      Int    Index vector storing permutation of columns
C                            due to pivoting
C     * COND          Dble   The sub-condition number belonging to the
C                            least squares part of A.
C                            (in case of rank reduction:
C                             sub-condition number which led to
C                             rank reduction)
C                            COND=0 indicates COND=infinity
C       AH(NCOL,NCOL) Dble   In case of rank-defect used to compute the
C                            pseudo-inverse (currently used will be an
C                            (N,N)-part of this array)
C       V(N)          Dble   V(1) holds on output the sub-condition
C                            number belonging to the constrained part
C                            of A.
C       IERR          Int    Error indicator:
C                            = 0 : DECCON computations are successfull.
C                            =-2 : Numerically negative diagonal element
C                                  encountered during computation of
C                                  pseudo inverse - due to extremely bad
C                                  conditioned Matrix A. DECCON is
C                                  unable to continue rank-reduction.
C
C*    Workspace parameters
C     ====================
C
C       V(N)         Dble   Workspace array
C
C*    Subroutines called: ZIBCONST
C
C*    Machine constants used
C     ======================
C
C     EPMACH = relative machine precision
      DOUBLE PRECISION EPMACH, SMALL
C
C     ------------------------------------------------------------
C*    End Prologue
      INTRINSIC DABS,DSQRT
      DOUBLE PRECISION ZERO
      PARAMETER (ZERO=0.0D0)
      DOUBLE PRECISION ONE
      PARAMETER (ONE=1.0D0)
      DOUBLE PRECISION REDUCE
      PARAMETER (REDUCE=0.05D0)
      INTEGER L1
      DOUBLE PRECISION S1
      INTEGER I,II,IRANKH,IRK1,I1,J,JD,JJ,K,K1,LEVEL,MH, IDATA
      DOUBLE PRECISION DD,D1MACH,H,HMAX,S,SH,T
C*    Begin
C     --------------------------------------------------------------
C     1 Initialization
      CALL ZIBCONST(EPMACH,SMALL)
      IF(IRANK.GT.N) IRANK = N
      IF(IRANK.GT.M) IRANK = M
C     --------------------------------------------------------------
C     1.1 Special case M=1 and N=1
      IF(M.EQ.1.AND.N.EQ.1)THEN
        PIVOT(1)=1
        D(1)=A(1,1)
        COND = ONE
        RETURN
      ENDIF
      IF(KRED.GE.0) THEN
C       ------------------------------------------------------------
C       1.1 Initialize pivot-array
        DO 11 J=1,N
          PIVOT(J)=J
11      CONTINUE
C       ------------------------------------------------------------
C       2. Constrained Householder triangularization    
        JD = 1
        IRANC1 = IRANKC + 1
        MH = MCON
        IRANKH = IRANKC
        IDATA = 0
        IF(MH.EQ.0) THEN
          IRANKH = IRANK
          MH = M
          IDATA = 1
        ENDIF
        IRK1 = IRANK
        DO 2  K=1,IRK1
2000      LEVEL = 1
          IF(K.NE.N) THEN
             K1 = K+1
C            DO (Until)
20           CONTINUE
             IF(JD.NE.0) THEN
               DO 201 J=K,N
                 S = ZERO
                 DO 2011 L1=K,MH
                    S = S+A(L1,J)**2
2011             CONTINUE
                 D(J)=S
201           CONTINUE
             ENDIF
C            ------------------------------------------------------
C            2.1 Column pivoting
             S1 = D(K)
             JJ = K
             DO 21 L1=K,N
               IF(D(L1).GT.S1) THEN
                 S1=D(L1)
                 JJ = L1
               ENDIF
21           CONTINUE
             H = D(JJ)
             IF(JD.EQ.1) HMAX = H/(DMAX1(1.0D1,COND*REDUCE))
             JD = 0
             IF(H.LT.HMAX) JD = 1
             IF(.NOT.(H.GE.HMAX)) GOTO 20
C            UNTIL ( expression - negated above)
C
             IF(JJ.NE.K) THEN
C              ------------------------------------------------------
C               2.2 Column interchange
                I = PIVOT(K)
                PIVOT(K)=PIVOT(JJ)
                PIVOT(JJ)=I
                D(JJ)=D(K)
                DO 221 L1=1,M
                   S1=A(L1,JJ)
                   A(L1,JJ)=A(L1,K)
                   A(L1,K)=S1
221             CONTINUE
             ENDIF
C          endif for k.ne.n case
           ENDIF
           H = ZERO
           DO 222 L1=K,MH
              H = H+A(L1,K)**2
222        CONTINUE
           T = DSQRT(H)
C          ----------------------------------------------------------
C          2.3.0 A-priori test on pseudo-rank
           IF  ( K.EQ.1 .OR. K.EQ.IRANC1 )  DD = T/COND
           IF(T.LE.DD .OR. K.GT.IRANKH) THEN
C            ------------------------------------------------------
C             2.3.1 Rank reduction
              IRANKH = K-1
              IF  (MH.NE.MCON .OR. IDATA.EQ.1)  THEN
                 IRANK = IRANKH
                 IF (IRANKC.EQ.IRANK) THEN
                    LEVEL = 4
                 ELSE
                    LEVEL = 3
                 ENDIF
              ELSE
                 IRANKC = IRANKH
                 IF  (IRANKC.NE.MCON) THEN
                    MH = M
                    IRANKH = IRANK
                    JD = 1
                    IDATA = 1
                    GOTO 2000
                 ELSE
                   STOP 'INTERNAL ERROR OF DECCON'
                 ENDIF
              ENDIF
           ENDIF
C
           IF (LEVEL.EQ.1) THEN
C             ------------------------------------------------------
C             2.4 Householder step
              S = A(K,K)
              T = -DSIGN(T,S)
              D(K)=T
C             By updating a(k,k) at this stage the 241 and 242 loop
C             must not be modified for l1=k.
              A(K,K)=S-T
              IF(K.NE.N) THEN
                 T = ONE/(H-S*T)
                 DO 24 J=K1,N
                    S = ZERO
                    DO 241 L1=K,MH
                          S = S+A(L1,K)*A(L1,J)
241                 CONTINUE
                    S = S*T
                    S1 = -S
                    IF(S.NE.0.D0) THEN
C                      Update the sub columns
                       DO 242 L1=K,M
                          A(L1,J) = A(L1,J)+A(L1,K)*S1
242                    CONTINUE
                    ENDIF
C                   Update sub column norms
                    D(J) = D(J)-A(K,J)**2
24               CONTINUE
                 IF(K.EQ.IRANKC) THEN
                    MH = M
                    JD = 1
                    IRANKH = IRANK
                  ENDIF
                  IF (K.EQ.IRK1) LEVEL = 3
              ELSE
                 LEVEL = 4
              ENDIF
C endif Householder step
           ENDIF
C        Exit Do 2 If ... 
           IF(LEVEL.GT.1) GOTO  2999
2        CONTINUE
C        ENDDO
2999     CONTINUE
      ELSE
         K = -1
         LEVEL = 3
      ENDIF
C     --------------------------------------------------------------
C     3 Rank-deficient pseudo-inverse
      IF(LEVEL.EQ.3) THEN
         IRK1 = IRANK+1
         DO 3 J=IRK1,N
            DO 31 II=1,IRANK
               I = IRK1-II
               S = A(I,J)
               IF(II.NE.1) THEN
                  SH = ZERO
                  DO 311 L1=I1,IRANK
                     SH=SH+A(I,L1)*V(L1)
311               CONTINUE
                  S = S-SH
               ENDIF
               I1 = I
               V(I)=S/D(I)
               AH(I,J)=V(I)
31          CONTINUE
            DO 32 I=IRK1,J
              S = ZERO
              DO 321 L1=1,I-1
                 S = S+AH(L1,I)*V(L1)
321           CONTINUE
              IF(I.NE.J)THEN
                 V(I)=-S/D(I)
                 AH(I,J)=-V(I)
              ENDIF
32         CONTINUE
           IF (S.GT.-ONE) THEN
              D(J)=DSQRT(S+ONE)
           ELSE 
              IERR=-2
              GOTO 999
           ENDIF
3        CONTINUE
      ENDIF
C    --------------------------------------------------------------
C     9 Exit
      IF (IRANKC.NE.0) THEN
        SH = D(IRANKC)
        IF(SH.NE.ZERO) SH = DABS(D(1)/SH)
      ELSE
        SH=ZERO
      ENDIF
      V(1) = SH
      IF (K.EQ.IRANK) T = D(IRANK)
      IF (IRANKC+1.LE.IRANK .AND. T.NE.ZERO) THEN
        S = DABS(D(IRANKC+1)/T)
      ELSE
        S = ZERO
      ENDIF
      COND = S
      IERR=0
999   CONTINUE
      RETURN
      END

      SUBROUTINE SOLCON(A,NROW,NCOL,MCON,M,N,X,B,IRANKC,IRANK,
     *                  D,PIVOT,KRED,AH,V)
C*    Begin Prologue SOLCON
      DOUBLE PRECISION A(NROW,NCOL),AH(NCOL,NCOL)
      DOUBLE PRECISION X(NCOL),B(NROW),D(NCOL),V(NCOL)
      INTEGER NROW,NCOL,MCON,M,N,IRANKC,IRANK,KRED
      INTEGER PIVOT(NCOL)
C     ------------------------------------------------------------
C    
C*    Summary
C     =======
C
C     Best constrained linear least squares solution of (M,N)-
C     system . First MCON rows comprise MCON equality constraints.
C     To be used in connection with subroutine DECCON
C     References:       See DECCON
C     Related Programs: DECCON
C    
C*    Parameters:
C     ===========
C
C*    Input parameters (* marks inout parameters)
C     ===========================================
C
C       A(M,N), NROW, NCOL, M, N, MCON, IRANKC, IRANK,
C       D(N), PIVOT(N), AH(N,N), KRED
C                           See input- respective output-parameters
C                           description of subroutine DECCON
C     * B(M)         Dble   Right-hand side of linear system, if
C                           KRED.GE.0
C                           Right-hand side of upper linear system,
C                           if KRED.LT.0
C
C*    Output parameters
C     =================
C
C       X(N)         Dble   Best LSQ-solution of linear system
C       B(M)         Dble   Right-hand of upper trigular system
C                           (transformed right-hand side of linear
C                            system)
C
C*    Workspace parameters
C     ====================
C
C       V(N)         Dble   Workspace array
C
C     ------------------------------------------------------------
C*    End Prologue
      DOUBLE PRECISION ZERO
      PARAMETER (ZERO=0.0D0)
      INTEGER L1,L2
      INTEGER I,II,I1,IRANC1,IRK1,J,JJ,J1,MH
      DOUBLE PRECISION S,SH
C*    Begin
C     ------------------------------------------------------------
C     1 Solution for pseudo-rank zero
      IF(IRANK.EQ.0)THEN
        DO 11 L1=1,N
          X(L1)=ZERO
11      CONTINUE
        RETURN
      ENDIF
      IF  ((IRANK.LE.IRANKC).AND.(IRANK.NE.N)) THEN
        IRANC1 = IRANKC + 1
        DO 12 L1=IRANC1,N
          V(L1) = ZERO
12      CONTINUE
      ENDIF
      IF(KRED.GE.0.AND.(M.NE.1.OR.N.NE.1))THEN
C       ----------------------------------------------------------
C       2 Constrained householder transformations of right-hand side
        MH = MCON
        IF(IRANKC.EQ.0) MH = M
        DO 21 J=1,IRANK
          S = ZERO
          DO 211 L1=J,MH
            S = S+A(L1,J)*B(L1)
211       CONTINUE
          S = S/(D(J)*A(J,J))
          DO 212 L1=J,M
            B(L1)=B(L1)+A(L1,J)*S
212       CONTINUE
          IF(J.EQ.IRANKC) MH = M
21      CONTINUE
      ENDIF
C     ------------------------------------------------------------
C     3 Solution of upper triangular system
      IRK1 = IRANK+1
      DO 31 II=1,IRANK
        I = IRK1-II
        I1 = I+1
        S = B(I)
        IF(II.NE.1)THEN 
          SH = ZERO
          DO 311 L1=I1,IRANK 
            SH=SH+A(I,L1)*V(L1)
311       CONTINUE
          S = S-SH
        ENDIF
        V(I)=S/D(I)
31    CONTINUE
      IF((IRANK.NE.N).AND.(IRANK.NE.IRANKC)) THEN
C       ----------------------------------------------------------
C       3.2 Computation of the best constrained least squares-
C           solution
        DO 321 J=IRK1,N
          S = ZERO
          DO 3211 L1=1,J-1
            S = S+AH(L1,J)*V(L1)
3211      CONTINUE
          V(J)=-S/D(J)
321     CONTINUE
        DO 322 JJ=1,N
          J = N-JJ+1
          S = ZERO
          IF(JJ.NE.1) THEN
            DO 3221 L1=J1,N
              S=S+AH(J,L1)*V(L1)
3221        CONTINUE
          ENDIF
          IF(JJ.NE.1.AND.J.LE.IRANK) THEN
            V(J)=V(J)-S
          ELSE
            J1 = J
            V(J)=-(S+V(J))/D(J)
          ENDIF
322     CONTINUE
      ENDIF
C     ------------------------------------------------------------
C     4 Back-permutation of solution components
      DO 4 L1=1,N
        L2 = PIVOT(L1)
        X(L2) = V(L1)
4     CONTINUE
      RETURN
      END
C*    End package

      SUBROUTINE ZIBSEC (CPTIM, IFAIL)
C
C*********************************************************************
C  Set CPTIM to cpu time in seconds.
C  This routine is machine dependent.
C*********************************************************************
C
C  Output parameters
C    CPTIM    REAL        Cpu time in seconds
C    IFAIL    INTEGER     Errorcode
C 
C  CSUN code works on sun and MacOSX (g77).
C  CXLF code works on MacOSX (xlf)
C  CVIS code works with Visual Fortran (Windows)
C
C*********************************************************************
C
      REAL CPTIM
      INTEGER IFAIL
C
CSUN      REAL RTIME(2)
CXLF      REAL(4) etime_
CXLF      TYPE TB_TYPE
CXLF      SEQUENCE
CXLF      REAL(4) USRTIME
CXLF      REAL(4) SYSTIME
CXLF      END TYPE
CXLF      TYPE (TB_TYPE) ETIME_STRUCT
C
      CPTIM = 0
      IFAIL = 0
C
CSUN      CPTIM = ETIME(RTIME)
CSUN      CPTIM = RTIME(1)
C
CXLF      CPTIM = etime_(ETIME_STRUCT)
C
CVIS      CALL CPU_TIME(CPTIM)
C
      RETURN
      END

C  PCON61.FOR  27 February 1991
C
      SUBROUTINE PITCON(DF,FPAR,FX,IERROR,IPAR,IWORK,LIW,NVAR,RWORK,
     *LRW,XR,SLNAME)
C
C***********************************************************************
C
C  This is the interface program between the user and the PITCON package.
C
C
C  A. Introduction
C
C
C  PCON61 is version 6.1 of PITCON, the University of Pittsburgh continuation
C  program.
C
C  PITCON was written by
C
C    Professor Werner C Rheinboldt and John Burkardt,
C    Department of Mathematics and Statistics
C    University of Pittsburgh,
C    Pittsburgh, Pennsylvania, 15260, USA.
C
C    E-Mail: wcrhein@vms.cis.pitt.edu
C            burkardt@psc.edu
C
C  The original work on this package was partially supported by the National
C  Science Foundation under grants MCS-78-05299 and MCS-83-09926.
C
C  PITCON computes a sequence of solution points along a one dimensional
C  manifold of a system of nonlinear equations F(X)=0 involving NVAR-1
C  equations and an NVAR dimensional unknown vector X.
C
C  The operation of PITCON is somewhat analogous to that of an initial value
C  ODE solver.  In particular, the user must begin the computation by
C  specifying an approximate initial solution, and subsequent points returned
C  by PITCON lie on the curve which passes through this initial point and is
C  implicitly defined by F(X)=0.  The extra degree of freedom in the system is
C  analogous to the role of the independent variable in a differential
C  equations.
C
C  However, PITCON does not try to solve the algebraic problem by turning it
C  into a differential equation system.  Unlike differential equations, the
C  solution curve may bend and switch back in any direction, and there may be
C  many solutions for a fixed value of one of the variables.  Accordingly,
C  PITCON is not required to parametrize the implicitly defined curve with a
C  fixed parameter.  Instead, at each step, PITCON selects a suitable variable
C  as the current parameter and then determines the other variables as
C  functions of it.  This allows PITCON to go around relatively sharp bends.
C  Moreover, if the equations were actually differentiated - that is, replaced
C  by some linearization - this would introduce an inevitable "drift" away from
C  the true solution curve.  Errors at previous steps would be compounded in a
C  way that would make later solution points much less reliable than earlier
C  ones.  Instead, PITCON solves the algebraic equations explicitly and each
C  solution has to pass an acceptance test in an iterative solution process
C  with tolerances provided by the user.
C
C  PITCON is only designed for systems with one degree of freedom.  However,
C  it may be used on systems with more degrees of freedom if the user reduces
C  the available degrees of freedom by the introduction of suitable constraints
C  that are added to the set of nonlinear equations.  In this sense, PITCON may
C  be used to investigate the equilibrium behavior of physical systems with
C  several degrees of freedom.
C
C  Program options include the ability to search for solutions for which a
C  given component has a specified value.  Another option is a search for a
C  limit or turning point with respect to a given component; that is, of a
C  point where this particular solution component has a local extremum.
C
C  Another feature of the program is the use of two work arrays, IWORK and
C  RWORK.  All information required for continuing any interrupted computation
C  is saved in these two arrays.
C
C
C  B. PITCON Calling Sequence
C
C
C  SUBROUTINE PITCON(DF,FPAR,FX,IERROR,IPAR,IWORK,LIW,NVAR,RWORK,LRW,XR,SLVNAM)
C
C  On the first call, PITCON expects a point XR and a routine FX defining a
C  nonlinear function F.  As noted earlier, XR and FX specify a curve which
C  PITCON is to trace. On the first call, PITCON simply verifies that F(XR)=0,
C  and if this is not the case, the program attempts to correct XR to a new
C  value satisfying the equation.
C
C  On subsequent calls, PITCON assumes that the input vector XR contains the
C  point which had been computed on the previous call.  It also assumes that
C  the work arrays IWORK and RWORK contain the results of the prior
C  calculations.  PITCON estimates an appropriate stepsize, computes the
C  tangent direction to the curve at the given input point, and calculates a
C  predicted new point on the curve.  A form of Newton's method is used to
C  correct this point so that it lies on the curve.  If the iteration is
C  successful, the code returns with a new point XR.  Otherwise, the stepsize
C  may be reduced, and the calculation retried.
C
C  Aside from its ability to produce successive points on the solution curve,
C  PITCON may be asked to search for "target points" or "limit points".
C  Target points are solution vectors for which a certain component has a
C  specified value.  One might ask for all solutions for which XR(17)=4.0, for
C  instance.  Limit points occur when the curve turns back in a given
C  direction, and have the property that the corresponding component of the
C  tangent vector vanishes there.
C
C  If the user has asked for the computation of target or limit points, then
C  PITCON will usually proceed as described earlier, producing a new
C  continuation point on each return.  But if a target or limit point is
C  found, such a point is returned as the value of XR, temporarily interrupting
C  the usual form of the computation.
C
C
C  C. Overview of PITCON parameters:
C
C
C  DF     Input,        EXTERNAL DF, routine for evaluating the Jacobian of F.
C  FPAR   Input/output, REAL FPAR(*), user defined parameter array.
C  FX     Input,        EXTERNAL FX, routine for evaluating the function F.
C  IERROR       Output, INTEGER IERROR, error return flag.
C  IPAR   Input/output, INTEGER IPAR(*), user defined parameter array.
C  IWORK  Input/output, INTEGER IWORK(LIW).  Communication and work array.
C  LIW    Input,        INTEGER LIW, the dimension of IWORK.
C  NVAR   Input,        INTEGER NVAR, number of variables, the dimension of X.
C  RWORK  Input/output, REAL RWORK(LRW), Communication and work space array.
C  LRW    Input,        INTEGER LRW, the dimension of RWORK.
C  XR     Input/output, REAL XR(NVAR), the current solution point.
C  SLVNAM Input,        EXTERNAL SLVNAM, the solver to use on linear systems.
C
C
C  D. Details of PITCON parameters:
C
C
C  DF     Input, EXTERNAL DF, the name of the Jacobian evaluation routine.
C         This name must be declared EXTERNAL in the calling program.
C
C         DF is not needed if the finite difference option is used
C         (IWORK(9)=1 or 2). In that case, only a dummy name is needed for DF.
C
C         Otherwise, the user must write a routine which evaluates the
C         Jacobian matrix of the function FX at a given point X and stores it
C         in the FJAC array in accordance with the format used by the solver
C         specified in SLVNAM.
C
C         In the simplest case, when the full matrix solverDENSLV solver
C         provided with the package is used, DF must store  D F(I)/D X(J) into
C         FJAC(I,J).
C
C         The array to contain the Jacobian will be zeroed out before DF is
C         called, so that only nonzero elements need to be stored.  DF must
C         have the form:
C
C           SUBROUTINE DF(NVAR,FPAR,IPAR,X,FJAC,IERROR)
C
C           NVAR   Input, INTEGER NVAR, number of variables.
C
C           FPAR   Input, REAL FPAR(*), vector for passing real parameters.
C                  This vector is not used by the program, and is only provided
C                  for the user's convenience.
C
C           IPAR   Input, INTEGER IPAR(*), vector for passing integer
C                  parameters.  This vector is not used by the program, and is
C                  only provided for the user's convenience.
C
C           X      Input, REAL X(NVAR), the point at which the Jacobian is
C                  desired.
C
C           FJAC   Output, REAL FJAC(*), the array containing the Jacobian.
C
C                  If DENSLV is the solver:  FJAC must be dimensioned
C                  FJAC(NVAR,NVAR) as shown above, and DF sets
C                  FJAC(I,J)=D F(I)/DX(J).
C
C                  If BANSLV is the solver:  the main portion of the Jacobian,
C                  rows and columns 1 through NVAR-1, is assumed to be a banded
C                  matrix in the standard LINPACK form with lower bandwidth ML
C                  and upper bandwidth MU.  However, the final column of the
C                  Jacobian is allowed to be full.
C
C                  BANSLV will pass to DF the beginning of the storage for
C                  FJAC, but it is probably best not to doubly dimension FJAC
C                  inside of DF, since it is a "hybrid" object.  The first
C                  portion of it is a (2*ML+MU+1, NEQN) array, followed by a
C                  single column of length NEQN (the last column of the
C                  Jacobian).  Thus the simplest approach is to declare FJAC to
C                  be a vector, and then then to store values as follows:
C
C                    If J is less than NVAR, then
C                      if I-J .LE. ML and J-I .LE. MU,
C                        set K=(2*ML+MU)*J + I - ML
C                        set FJAC(K)=D F(I)/DX(J).
C                      else
C                        do nothing, index is outside the band
C                      endif
C                    Else if J equals NVAR, then
C                      set K=(2*ML+MU+1)*(NVAR-1)+I,
C                      set FJAC(K)=D F(I)/DX(J).
C                    endif.
C
C           IERROR Output, INTEGER IERROR, error return flag.  DF should set
C                  this to 0 for normal return, nonzero if trouble.
C
C  FPAR   Input/output, REAL FPAR(*), a user defined parameter array.
C
C         FPAR is not used in any way by PITCON.  It is provided for the user's
C         convenience.  It is passed to DF and FX, and hence may be used to
C         transmit information between the user calling program and these user
C         subprograms. The dimension of FPAR and its contents are up to the
C         user.  Internally, the program declares DIMENSION FPAR(*) but never
C         references its contents.
C
C  FX     Input, EXTERNAL FX, the name of the routine which evaluates the
C         function.
C
C         FX computes the value of the nonlinear function.  This name must be
C         declared EXTERNAL in the calling program.  FX should evaluate the
C         NVAR-1 function components at the input point X, and store the result
C         in the vector FVEC.  An augmenting equation will be stored in entry
C         NVAR of FVEC by the PITCON program.
C
C         FX should have the following form:
C
C           SUBROUTINE FX(NVAR,FPAR,IPAR,X,FVEC,IERROR)
C
C           NVAR   Input, INTEGER NVAR, number of variables.
C
C           FPAR   Input/output, REAL FPAR(*), array of user parameters.
C
C           IPAR   Input/output, INTEGER IPAR(*), array of user parameters.
C
C           X      Input, REAL X(NVAR), the point at which function evaluation
C                  is required.
C
C           FVEC   Output, REAL FVEC(NVAR), the value of the function at point
C                  X.  Only the first NVAR-1 entries of FVEC are to be set by
C                  the routine.  PITCON sets the final value itself.
C
C           IERROR Output, INTEGER IERROR, error flag.  FX should set this to 0
C                  if there are no problems, or to 2 if there is a problem.
C
C  IERROR Output, INTEGER IERROR, error return flag.
C
C         On return from PITCON, a nonzero value of IERROR is a warning of some
C         problem which may be minor, serious, or fatal.
C
C         0, No errors occurred.
C
C         1, Insufficient storage provided in RWORK and IWORK, or NVAR is less
C            than 2.  This is a fatal error, which occurs on the first call to
C            PITCON.
C
C         2, A user defined error condition occurred in the FX or DF
C            subroutines.  PITCON treats this as a fatal error.
C
C         3, A numerically singular matrix was encountered.  Continuation
C            cannot proceed without some redefinition of the problem.  This is
C            a fatal error.
C
C         4, Unsuccessful corrector iteration.  Loosening the tolerances
C            RWORK(1) and RWORK(2), or decreasing the maximum stepsize RWORK(4)
C            might help.  This is a fatal error.
C
C         5, Too many corrector steps.  The corrector iteration was proceeding
C            properly, but too slowly.  Increase number of Newton steps
C            IWORK(17), increase the error tolerances RWORK(1) or RWORK(2), or
C            decrease RWORK(4).  This is a fatal error.
C
C         6, Null tangent vector.  A serious error which indicates a data
C            problem or singularity in the nonlinear system.  This is a fatal
C            error.
C
C         7, Root finder failed while searching for a limit point.
C            This is a warning.  It means that the target or limit point
C            computation has failed, but the main computation (computing the
C            continuation curve itself) may continue.
C
C         8, Limit point iteration took too many steps.  This is a warning
C            error.  It means that the limit point computation has failed, but
C            the main computation (computing the continuation curve itself) may
C            continue.
C
C         9, Undiagnosed error condition.  This is a fatal error.
C
C  IPAR   Input/output, INTEGER IPAR(*), user defined parameter array.
C
C         IPAR is not used in any way by PITCON.  It is provided for the user's
C         convenience in transmitting parameters between the calling program
C         and the user routines FX and DF.  IPAR is declared in the PITCON
C         program and passed through it to FX and DF, but otherwise ignored.
C         Note, however, that if BANSLV is used for the solver routine, then
C         IPAR(1) must contain the lower bandwidth, and IPAR(2) the upper
C         bandwidth of the Jacobian matrix.
C
C  IWORK  Input/output, INTEGER IWORK(LIW).  Communication and workspace array.
C
C         The specific allocation of IWORK is described in the section devoted
C         to the work arrays.  Some elements of IWORK MUST be set by the user,
C         others may be set to change the way PITCON works.
C
C  LIW    Input, INTEGER LIW, the dimension of IWORK.
C
C         The minimum acceptable value of LIW depends on the solver chosen,
C         but for either DENSLV or BANSLV, setting LIW=29+NVAR is sufficient.
C
C  NVAR   Input, INTEGER NVAR, the number of variables, the dimension of X.
C
C         This is, of course, one greater than the number of equations or
C         functions.  NVAR must be at least 2.
C
C  RWORK  Input/output, REAL RWORK(LRW), work array.
C
C         The specific allocation of RWORK is described in the section
C         devoted to the work arrays.
C
C  LRW    Input, INTEGER LRW, the dimension of RWORK.
C
C         The minimum acceptable value depends heavily on the solver options.
C         There is storage required for scalars, vectors, and the Jacobian
C         array.  The minimum acceptable value of LRW is the sum of three
C         corresponding numbers.
C
C         For DENSLV with user-supplied Jacobian,
C
C           LRW=29 + 4*NVAR + NVAR*NVAR.
C
C         For DENSLV with internally approximated Jacobian,
C
C           LRW=29 + 6*NVAR + NVAR*NVAR.
C
C         For BANSLV, with a Jacobian matrix with upper bandwidth MU and lower
C         bandwidth ML, and NBAND=2*ML+MU+1, with user supplied Jacobian,
C
C           LRW=29 + 6*NVAR + (NVAR-1)*NBAND.
C
C         For BANSLV with internally approximated Jacobian,
C
C           LRW=29 + 9*NVAR + (NVAR-1)*NBAND.
C
C  XR     Input/output, REAL XR(NVAR), the current solution point.
C
C         On the first call, the user should set XR to a starting point which
C         at least approximately satisfies F(XR)=0.  The user need never
C         update XR again.
C
C         Thereafter, on each return from the program with IERROR=0, XR will
C         hold the most recently computed point, whether a continuation, target
C         or limit point.
C
C  SLVNAM Input, EXTERNAL SLVNAM, the name of the solver to use on linear
C         systems.
C
C         The linear systems have the form A*x=b, where A is the augmented
C         Jacobian matrix.  A will be square, and presumably nonsingular.
C         The routine must return the value of the solution x.
C
C         Two possible choices for SLVNAM are "DENSLV" and "BANSLV", which are
C         the names of routines provided with the package.  DENSLV is
C         appropriate for a full storage jacobian, and BANSLV for a jacobian
C         which is banded except for the last column.
C
C         The advanced user may study the source code for these two routines
C         and write an equivalent solver more suited to a given problem.
C
C
C  E. The Integer Work Array IWORK
C
C
C  Input to the program includes the setting of some of the entries in IWORK.
C  Some of this input is optional.  The user input section of IWORK involves
C  entries 1 through 8, and, possibly also 17 and 29.
C
C  IWORK(1) must be set by the user.  All other entries have default values.
C
C
C  IWORK(1)        On first call only, the user must set IWORK(1)=0.
C                  Thereafter, the program sets IWORK(1) before return to
C                  explain what kind of point is being returned.  This return
C                  code is:
C
C                      1 return of corrected starting point.
C                      2 return of continuation point.
C                      3 return of target point.
C                      4 return of limit point.
C
C                  NOTE:  At any time, PITCON may be called with a negative
C                  value of IWORK(1). This requests a check of the
C                  jacobian routine against a finite difference approximation.
C                  The program will call the jacobian routine, and
C                  then estimate the jacobian.  If IWORK(1)=-1, then it will
C                  print out the value of the maximum difference, and the row
C                  and column of the jacobian in which it appears.  Otherwise,
C                  the program will print out the entire matrix
C                  FP(I,J)-DEL(J)F(I), where DEL(J)F(I) represents the finite
C                  difference approximation.
C
C                  Before a call with negative IWORK(1), the current value of
C                  IWORK(1) should be saved, and then restored to the previous
C                  value after the call, in order to resume calculation.
C
C                  IWORK(1) does not have a default value.  The user MUST set
C                  it.
C
C  IWORK(2)        The component of the current continuation point XR which is
C                  to be used as the continuation parameter.  On first call,
C                  the program is willing to use the index NVAR as a default,
C                  but the user should set this value if better information is
C                  available.
C
C                  After the first call, the program sets this value for each
C                  step automatically unless the user prevents this by setting
C                  the parameterization option IWORK(3) to a non-zero valus.
C                  Note that a poor choice of IWORK(2) may cause the algorithm
C                  to fail.  IWORK(2) defaults to NVAR on the first step.
C
C  IWORK(3)        Parameterization option.  The program would prefer to be
C                  free to choose a new local parameter from step to step.
C                  The value of IWORK(3) allows or prohibits this action.
C                  IWORK(3)=0 allows the program to vary the parameter,
C                  IWORK(3)=1 forces the program to use whatever the contents
C                  of IWORK(2) are, which will not be changed from the user's
C                  input or the default.  The default is IWORK(3)=0.
C
C  IWORK(4)        Newton iteration Jacobian update option.
C                  0, the Jacobian is reevaluated at every step of the
C                     Newton iteration.  This is costly, but may result in
C                     fewer Newton steps and fewer Newton iteration rejections.
C                  1, the Jacobian is evaluated only on the first and
C                     IWORK(17)-th steps of the Newton process.
C                  2, the Jacobian is evaluated only when absolutely
C                     necessary, namely, at the first step, and when the
C                     process fails. This option is most suitable for problems
C                     with mild nonlinearities.
C
C                  The default is IWORK(4)=0.
C
C  IWORK(5)        Target point index.  If IWORK(5) is not zero, it is presumed
C                  to be the component index between 1 and NVAR for which
C                  target points are sought.  In this case, the value of
C                  RWORK(7) is assumed to be the target value.  The program
C                  will monitor every new continuation point, and if it finds
C                  that a target point may lie between the new point and the
C                  previous point, it will compute this target point and
C                  return.  This target point is defined by the property that
C                  its component with the index prescribed in IWORK(5) will
C                  have the value given in RWORK(7).  For a given problem there
C                  may be zero, one, or many target points requested.
C                  The default of IWORK(5) is 0.
C
C  IWORK(6)        Limit point index.  If IWORK(6) is nonzero, then the program
C                  will search for limit points with respect to the component
C                  with index IWORK(6); that is, of points for which the
C                  IWORK(6)-th variable has a local extremum, or equivalently
C                  where the IWORK(6)-th component of the tangent vector is
C                  zero.  The default of IWORK(6) is zero.
C
C  IWORK(7)        Control of the amount of intermediate output produced by the
C                  program. IWORK(7) may have a value between 0 and 3.
C                  For IWORK(7) = 0 there is no intermediate output while for
C                  IWORK(7) = 3 the most intermediate output is produced.
C                  The default is 1.
C
C  IWORK(8)        FORTRAN unit to which output is to be written.  The
C                  default value is site dependent but should be the standard
C                  output device.
C                  The default is 6 on the Cray, Vax and PC, or 9 on the
C                  Macintosh.
C
C  IWORK(9)        Control of the Jacobian option specifying whether the user
C                  has supplied a Jacobian routine, or wants the program
C                  to approximate the Jacobian.
C                  0, the user has supplied the Jacobian.
C                  1, program is to use forward difference approximation.
C                  2, program is to use central difference approximation.
C                  IWORK(9) defaults to 0.
C
C  IWORK(10)       State indicator of the progress of the program.
C                  The values are:
C                  0, start up with unchecked starting point.
C                  1, first step.  Corrected starting point available.
C                  2, two successive continuation points available, as well
C                     as the tangent vector at the oldest of them.
C                  3, two successive continuation points available, as well
C                     as the tangent vector at the newest of them.
C
C  IWORK(11)       Index of the last computed target point. This is used to
C                  avoid repeated computation of a target point.  If a target
C                  point has been found, then the target index IWORK(5) is
C                  copied into IWORK(11).
C
C  IWORK(12)       Second best choice for the local parameterization index.
C                  This index may be tried if the first choice causes poor
C                  performance in the Newton corrector.
C
C  IWORK(13)       Beginning location in IWORK of unused integer work space
C                  available for use by the solver.
C
C  IWORK(14)       LIW, the user declared dimension of the array IWORK.
C
C  IWORK(15)       Beginning location in RWORK of unused real work space
C                  available for use by the solver.
C
C  IWORK(16)       LRW, the user declared dimension of RWORK.
C
C  IWORK(17)       Maximum number of corrector steps allowed during one run
C                  of the Newton process in which the Jacobian is updated at
C                  every step.  If the Jacobian is only evaluated at
C                  the beginning of the Newton iteration then 2*IWORK(17) steps
C                  are allowed.
C                  IWORK(17) must be greater than 0.  It defaults to 10.
C
C  IWORK(18)       Number of stepsize reductions that were needed for
C                  producing the last continuation point.
C
C  IWORK(19)       Total number of calls to the user Jacobian routine DF.
C
C  IWORK(20)       Total number of calls to the matrix factorization routine.
C                  If DENSLV is the chose solver then factorization is done by
C                  the LINPACK routine SGEFA.  If BANSLV is the solver, the
C                  LINPACK routine SGBFA will be used.
C
C  IWORK(21)       Total number of calls to the back-substitution routine.
C                  If DENSLV is the chosen solver, then back substitution is
C                  done by the LINPACK routine SGESL.  If BANSLV is used, then
C                  the LINPACK routine SGBSL will be used.
C
C  IWORK(22)       Total number of calls to the user function routine FX.
C
C  IWORK(23)       Total number of steps taken in limit point iterations.
C                  Each step involves determining an approximate limit point
C                  and applying a Newton iteration to correct it.
C
C  IWORK(24)       Total number of Newton corrector steps used during the
C                  computation of target points.
C
C  IWORK(25)       Total number of Newton steps taken during the correction
C                  of a starting point or the continuation points.
C
C  IWORK(26)       Total number of predictor stepsize-reductions needed
C                  since the start of the continuation procesds.
C
C  IWORK(27)       Total number of calls to the program.  This also
C                  corresponds to the number of points computed.
C
C  IWORK(28)       Total number of Newton steps taken during current iteration.
C
C  IWORK(30)       and on are reserved for use by the linear equation solver,
C                  and typically are used for pivoting.
C
C
C  F. The Real Work Array RWORK
C
C
C  Input to the program includes the setting of some of the entries in RWORK.
C  Some of this input is optional.  The user input section of RWORK involves
C  entries 1 through 7 and possibly 20.  All entries of RWORK have default
C  values.
C
C
C  RWORK(1)        Absolute error tolerance.   This value is used mainly during
C                  the Newton iteration.  RWORK(1) defaults to SQRT(EPMACH)
C                  where EPMACH is the machine relative precision stored in
C                  RWORK(8).
C
C  RWORK(2)        Relative error tolerance.  This value is used mainly during
C                  the Newton iteration.  RWORK(2) defaults to SQRT(EPMACH)
C                  where EPMACH is the machine relative precision stored in
C                  RWORK(8).
C
C  RWORK(3)        Minimum allowable predictor stepsize.  If failures of
C                  the Newton correction force the stepsize down to this level,
C                  then the program will give up.  The default value is
C                  SQRT(EPMACH).
C
C  RWORK(4)        Maximum allowable predictor step.  Too generous a value
C                  may cause erratic behavior of the program.  The default
C                  value is SQRT(NVAR).
C
C  RWORK(5)        Predictor stepsize.  On first call, it should be set by
C                  the user.  Thereafter it is set by the program.
C                  RWORK(5) should be positive.  In order to travel in the
C                  negative direction, see RWORK(6).
C                  The default initial value equals 0.5*(RWORK(3)+RWORK(4)).
C
C  RWORK(6)        The local continuation direction, which is either +1.0
C                  or -1.0 .  This asserts that the program is moving in the
C                  direction of increasing or decreasing values of the local
C                  continuation variable, whose index is in IWORK(2).  On first
C                  call, the user must choose IWORK(2).  Therefore, by setting
C                  RWORK(6), the user may also specify whether the program is
C                  to move initially to increase or decrease the variable whose
C                  index is IWORK(2).
C                  RWORK(6) defaults to +1.
C
C  RWORK(7)        A target value.  It is only used if a target index
C                  has been specified through IWORK(5).  In that case, solution
C                  points with the IWORK(5) component equal to RWORK(7) are
C                  to be computed. The code will return each time it finds such
C                  a point.  RWORK(7) does not have a default value.  The
C                  program does not set it, and it is not referenced unless
C                  IWORK(5) has been set.
C
C  RWORK(8)        EPMACH, the value of the machine precision.  The computer
C                  can distinguish 1.0+EPMACH from 1.0, but it cannot
C                  distinguish 1.0+(EPMACH/2) from 1.0. This number is used
C                  when estimating a reasonable accuracy request on a given
C                  computer.  PITCON computes a value for EPMACH internally.
C
C  RWORK(9)        Not currently used.
C
C  RWORK(10)       A minimum angle used in the steplength computation,
C                  equal to 2.0*ARCCOS(1-EPMACH).
C
C  RWORK(11)       Estimate of the angle between the tangent vectors at the
C                  last two continuation points.
C
C  RWORK(12)       The pseudo-arclength coordinate of the previous continuation
C                  pointl; that is, the sum of the Euclidean distances between
C                  all computed continuation points beginning with the start
C                  point.  Thus each new point should have a larger coordinate,
C                  except for target and limit points which lie between the two
C                  most recent continuation points.
C
C  RWORK(13)       Estimate of the pseudo-arclength coordinate of the current
C                  continuation point.
C
C  RWORK(14)       Estimate of the pseudoarclength coordinate of the current
C                  limit or target point, if any.
C
C  RWORK(15)       Size of the correction of the most recent continuation
C                  point; that is, the maximum norm of the distance between the
C                  predicted point and the accepted corrected point.
C
C  RWORK(16)       Estimate of the curvature between the last two
C                  continuation points.
C
C  RWORK(17)       Sign of the determinant of the augmented matrix at the
C                  last continuation point whose tangent vector has been
C                  calculated.
C
C  RWORK(18)       Not currently used.
C
C  RWORK(19)       Not currently used.
C
C  RWORK(20)       Maximum growth factor for the predictor stepsize based
C                  on the previous secant stepsize.  The stepsize algorithm
C                  will produce a suggested step that is no less that the
C                  previous secant step divided by this factor, and no greater
C                  than the previous secant step multiplied by that factor.
C                  RWORK(20) defaults to 3.
C
C  RWORK(21)       The (Euclidean) secant distance between the last two
C                  computed continuation points.
C
C  RWORK(22)       The previous value of RWORK(21).
C
C  RWORK(23)       A number judging the quality of the Newton corrector
C                  convergence at the last continuation point.
C
C  RWORK(24)       Value of the component of the current tangent vector
C                  corresponding to the current continuation index.
C
C  RWORK(25)       Value of the component of the previous tangent vector
C                  corresponding to the current continuation index.
C
C  RWORK(26)       Value of the component of the current tangent vector
C                  corresponding to the limit index in IWORK(6).
C
C  RWORK(27)       Value of the component of the previous tangent vector
C                  corresponding to the limit index in IWORK(6).
C
C  RWORK(28)       Value of RWORK(7) when the last target point was
C                  computed.
C
C  RWORK(29)       Sign of the determinant of the augmented matrix at the
C                  previous continuation point whose tangent vector has been
C                  calculated.
C
C  RWORK(30)       through RWORK(30+4*NVAR-1) are used by the program to hold
C                  an old and new continuation point, a tangent vector and a
C                  work vector.  Subsequent entries of RWORK are used by the
C                  linear solver.
C
C
C  G. Programming Notes
C
C
C  The minimal input and user routines required to apply the program are as
C  follows:
C    Write a function routine FX of the form described above.
C    Use DENSLV as the linear equation solver by setting SLVNAM to DENSLV.
C    Skip writing a Jacobian routine by using the finite difference option.
C    Pass the name of FX as the Jacobian name as well.
C    Declare the name of the function FX as EXTERNAL.
C    Set NVAR in accordance with your problem.
C
C  Then:
C
C    Dimension the vector IWORK to the size LIW=29+NVAR.
C    Dimension the vector RWORK to the size LRW=29+NVAR*(NVAR+6).
C    Dimension IPAR(1) and FPAR(1) as required in the function routine.
C    Dimension XR(NVAR) and set it to an approximate solution of F(XR)=0.
C
C  Set the work arrays as follows:
C
C    Initialize IWORK to 0 and RWORK to 0.0.
C
C    Set IWORK(1)=0 (Problem startup)
C    Set IWORK(7)=3 (Maximum internally generated output)
C    Set IWORK(9)=1 (Forward difference Jacobian)
C
C  Now call the program repeatedly, and never change any of its arguments.
C  Check IERROR to decide whether the code is working satisfactorily.
C  Print out the vector XR to see the current solution point.
C
C  The most obvious input to try to set appropriately after some practice
C  would be the error tolerances RWORK(1) and RWORK(2), the minimum, maximum
C  and initial stepsizes RWORK(3), RWORK(4) and RWORK(5), and the initial
C  continuation index IWORK(2).
C
C  For speed and efficiency, a Jacobian routine should be written. It can be
C  checked by comparing its results with the finite difference Jacobian.
C
C  For a particular problem, the target and limit point input can be very
C  useful.  For instance, in the case of a discretized boundary value problem
C  with a real parameter it may be desirable to compare the computed solutions
C  for different discretization-dimensions and equal values of the parameter.
C  For this the target option can be used with the prescribed values of the
C  parameter. Limit points usually are of importance in connection with
C  stability considerations.
C
C
C  H. References
C
C
C  1.
C  Werner Rheinboldt,
C  Solution Field of Nonlinear Equations and Continuation Methods,
C  SIAM Journal of Numerical Analysis,
C  Volume 17, 1980, pages 221-237.
C
C  2.
C  Cor den Heijer and Werner Rheinboldt,
C  On Steplength Algorithms for a Class of Continuation Methods,
C  SIAM Journal of Numerical Analysis,
C  Volume 18, 1981, pages 925-947.
C
C  3.
C  Werner Rheinboldt,
C  Numerical Analysis of Parametrized Nonlinear Equations
C  John Wiley and Sons, New York, 1986
C
C  4.
C  Werner Rheinboldt and John Burkardt,
C  A Locally Parameterized Continuation Process,
C  ACM Transactions on Mathematical Software,
C  Volume 9, Number 2, June 1983, pages 215-235.
C
C  5.
C  Werner Rheinboldt and John Burkardt,
C  Algorithm 596, A Program for a Locally Parameterized Continuation Process,
C  ACM Transactions on Mathematical Software,
C  Volume 9, Number 2, June 1983, Pages 236-241.
C
C  6.
C  J J Dongarra, J R Bunch, C B Moler and G W Stewart,
C  LINPACK User's Guide,
C  Society for Industrial and Applied Mathematics,
C  Philadelphia, 1979.
C
C  7.
C  Richard Brent,
C  Algorithms for Minimization without Derivatives,
C  Prentice Hall, 1973.
C
C  8.
C  Tony Chan,
C  Deflated Decomposition of Solutions of Nearly Singular Systems,
C  Technical Report 225,
C  Computer Science Department,
C  Yale University,
C  New Haven, Connecticut, 06520,
C  1982.
C
C
C  I.  Converting between REAL and DOUBLE PRECISION versions
C
C
C  PITCON was written to use single precision floating point arithmetic, and
C  for most problems, this has sufficed, even on machines for which the
C  default REAL variable is stored in 32 bits.  However, if PITCON cannot
C  solve a problem, the failure is sometimes caused by poor scaling of the
C  functions, a near-singular jacobian, or similar conditions that are
C  sometimes helped by using higher precision.
C
C  The current version of the code is fairly easy to convert.  The type of
C  each variable is declared in every routine.  Generic FORTRAN functions
C  are used.  All constants are declared in PARAMETER statements at the
C  beginning of each routine.
C
C  To create a DOUBLE PRECISION version from a REAL version, a user should 
C  make the following global substitutions:
C
C    Replace         by
C
C    REAL            DOUBLE PRECISION  or  REAL*8
C
C    ISAMAX          IDAMAX
C    SAXPY           DAXPY
C    SCOPY           DCOPY
C    SDOT            DDOT
C    SGBDI           DGBDI
C    SGBFA           DGBFA
C    SGBSL           DGBSL
C    SGEDI           DGEDI
C    SGEFA           DGEFA
C    SGESL           DGESL
C    SNRM2           DNRM2
C    SSCAL           DSCAL
C    SSWAP           DSWAP
C
C  and to convert from DOUBLE PRECISION to REAL, the changes should be
C  reversed.
C
C  The same changes can be made to the sample programs.  In most cases, this
C  should be sufficient to create proper double precision programs.
C
C
C  J.  A sample calling program
C
C
C  The following is a sample program that calls PITCON to handle the
C  Freudenstein-Roth function.
C
C
C  C  PCPRB1.FOR  22 February 1991
C  C
C        PROGRAM PCPRB1
C  C
C  C  The Freudenstein-Roth function.
C  C
C  C  For a more complicated version of this example, see PCPRB8.
C  C
C  C  Reference
C  C
C  C  F Freudenstein, B Roth,
C  C  Numerical Solutions of Nonlinear Equations,
C  C  Journal of the Association for Computing Machinery,
C  C  Volume 10, 1963, Pages 550-556.
C  C
C  C  The function F(X) is of the form
C  C
C  C    FX(1) = X1 - X2**3 + 5*X2**2 -  2*X2 - 13 + 34*(X3-1)
C  C    FX(2) = X1 + X2**3 +   X2**2 - 14*X2 - 29 + 10*(X3-1)
C  C
C  C  Starting from the point (15,-2,0), the program is required to produce
C  C  solution points along the curve until it reaches a solution point
C  C  (*,*,1).  It also may be requested to look for limit points in the
C  C  first or third components.
C  C
C  C  The correct value of the solution at X3=1 is (5,4,1).
C  C
C  C  Limit points in the first variable occur at:
C  C
C  C    (14.28309, -1.741377,  0.2585779)
C  C    (61.66936,  1.983801, -0.6638797)
C  C
C  C  Limit points for the third variable occur at:
C  C
C  C    (20.48586, -0.8968053, 0.5875873)
C  C    (61.02031,  2.230139, -0.6863528)
C  C
C  C
C        INTEGER   LIW
C        INTEGER   LRW
C        INTEGER   NVAR
C  C
C        PARAMETER (NVAR=3)
C        PARAMETER (LIW=NVAR+29)
C        PARAMETER (LRW=29+(6+NVAR)*NVAR)
C  C
C        EXTERNAL  FXROTH
C        EXTERNAL  DFROTH
C        EXTERNAL  DENSLV
C        EXTERNAL  PITCON
C  C
C        REAL      FPAR(1)
C        INTEGER   I
C        INTEGER   IERROR
C        INTEGER   IPAR(1)
C        INTEGER   IWORK(LIW)
C        INTEGER   J
C        CHARACTER NAME*12
C        REAL      RWORK(LRW)
C        REAL      XR(NVAR)
C  C
C  C  Set work arrays to zero:
C  C
C        DO 10 I=1,LIW
C          IWORK(I)=0
C  10      CONTINUE
C        DO 20 I=1,LRW
C          RWORK(I)=0.0
C  20      CONTINUE
C  C
C  C  Set some entries of work arrays.
C  C
C  C  IWORK(1)=0 ; This is a startup
C  C  IWORK(2)=2 ; Use X(2) for initial parameter
C  C  IWORK(3)=0 ; Program may choose parameter index
C  C  IWORK(4)=0 ; Update jacobian every newton step
C  C  IWORK(5)=3 ; Seek target values for X(3)
C  C  IWORK(6)=1 ; Seek limit points in X(1)
C  C  IWORK(7)=1 ; Control amount of output.
C  C  IWORK(8)=6 ; Output unit
C  C  IWORK(9)=2 ; Jacobian choice.
C  C
C        IWORK(1)=0
C        IWORK(2)=2
C        IWORK(3)=0
C        IWORK(4)=0
C        IWORK(5)=3
C        IWORK(6)=1
C        IWORK(7)=1
C        IWORK(8)=6
C        IWORK(9)=0
C  C
C  C  RWORK(1)=0.00001; Absolute error tolerance
C  C  RWORK(2)=0.00001; Relative error tolerance
C  C  RWORK(3)=0.01   ; Minimum stepsize
C  C  RWORK(4)=20.0   ; Maximum stepsize
C  C  RWORK(5)=0.3    ; Starting stepsize
C  C  RWORK(6)=1.0    ; Starting direction
C  C  RWORK(7)=1.0    ; Target value (Seek solution with X(3)=1)
C  C
C        RWORK(1)=0.00001
C        RWORK(2)=0.00001
C        RWORK(3)=0.01
C        RWORK(4)=20.0
C        RWORK(5)=0.3
C        RWORK(6)=1.0
C        RWORK(7)=1.0
C  C
C  C  Set starting point.
C  C
C        XR(1)=15.0
C        XR(2)=-2.0
C        XR(3)=0.0
C  C
C        WRITE(6,*)' '
C        WRITE(6,*)'PCPRB1:'
C        WRITE(6,*)' '
C        WRITE(6,*)'PITCON sample program.'
C        WRITE(6,*)'Freudenstein-Roth function'
C        WRITE(6,*)'2 equations, 3 variables.'
C        WRITE(6,*)' '
C        WRITE(6,*)'Step  Type of Point     '//
C       *'X(1)         X(2)         X(3)'
C        WRITE(6,*)' '
C        I=0
C        NAME='Start point  '
C        WRITE(6,'(1X,I3,2X,A12,2X,3G14.6)')I,NAME,(XR(J),J=1,NVAR)
C  C
C        DO 30 I=1,30
C  C
C          CALL PITCON(DFROTH,FPAR,FXROTH,IERROR,IPAR,IWORK,LIW,
C       *  NVAR,RWORK,LRW,XR,DENSLV)
C  C
C          IF(IWORK(1).EQ.1)THEN
C            NAME='Corrected    '
C          ELSEIF(IWORK(1).EQ.2)THEN
C            NAME='Continuation '
C          ELSEIF(IWORK(1).EQ.3)THEN
C            NAME='Target point '
C          ELSEIF(IWORK(1).EQ.4)THEN
C            NAME='Limit point  '
C            ENDIF
C  C
C          WRITE(6,'(1X,I3,2X,A12,2X,3G14.6)')I,NAME,(XR(J),J=1,NVAR)
C  C
C          IF(IWORK(1).EQ.3)THEN
C            WRITE(6,*)' '
C            WRITE(6,*)'We have reached the point we wanted.'
C            WRITE(6,*)'The code may stop now.'
C            STOP
C            ENDIF
C  C
C          IF(IERROR.NE.0)THEN
C            WRITE(6,*)' '
C            WRITE(6,*)'An error occurred.'
C            WRITE(6,*)'We will terminate the computation now.'
C            STOP
C            ENDIF
C  C
C  30      CONTINUE
C  C
C        WRITE(6,*)' '
C        WRITE(6,*)'PITCON did not reach the point of interest.'
C        STOP
C        END
C        SUBROUTINE FXROTH(NVAR,FPAR,IPAR,X,F,IERROR)
C  C
C  C  Evaluate the function at X.
C  C
C  C  ( X1 - ((X2-5.0)*X2+2.0)*X2 - 13.0 + 34.0*(X3-1.0)  )
C  C  ( X1 + ((X2+1.0)*X2-14.0)*X2 - 29.0 + 10.0*(X3-1.0) )
C  C
C        REAL      F(*)
C        REAL      FPAR(*)
C        INTEGER   IERROR
C        INTEGER   IPAR(*)
C        REAL      X(NVAR)
C  C
C        F(1)=X(1)
C       *     -((X(2)-5.0)*X(2)+2.0)*X(2)
C       *     -13.0
C       *     +34.0*(X(3)-1.0)
C  C
C        F(2)=X(1)
C       *    +((X(2)+1.0)*X(2)-14.0)*X(2)
C       *    -29.0
C       *    +10.0*(X(3)-1.0)
C  C
C        RETURN
C        END
C        SUBROUTINE DFROTH(NVAR,FPAR,IPAR,X,FJAC,IERROR)
C  C
C  C  Evaluate the Jacobian:
C  C
C  C  ( 1.0   (-3.0*X(2)+10.0)*X(2)-2.0      34.0   )
C  C  ( 1.0   (3.0*X(2)+2.0)*X(2)-14.0       10.0   )
C  C
C        REAL      FJAC(NVAR,NVAR)
C        REAL      FPAR(*)
C        INTEGER   IERROR
C        INTEGER   IPAR(*)
C        REAL      X(NVAR)
C  C
C        FJAC(1,1)=1.0
C        FJAC(1,2)=(-3.0*X(2)+10.0)*X(2)-2.0
C        FJAC(1,3)=34.0
C  C
C        FJAC(2,1)=1.0
C        FJAC(2,2)=(3.0*X(2)+2.0)*X(2)-14.0
C        FJAC(2,3)=10.0
C  C
C        RETURN
C        END
C
C
C  Here is the output from the run of this sample problem
C
C
C  PCPRB1:
C
C  PITCON sample program.
C  Freudenstein-Roth function
C  2 equations, 3 variables.
C
C  Step  Type of Point     X(1)         X(2)         X(3)
C
C    0  Start point      15.0000      -2.00000      0.000000E+00
C
C  PITCON 6.1
C  University of Pittsburgh Continuation Code
C
C  Last modification on 25 February 1991
C
C    1  Corrected        15.0000      -2.00000      0.000000E+00
C    2  Continuation     14.7105      -1.94205      0.653814E-01
C    3  Continuation     14.2846      -1.72915      0.268742
C    4  Limit point      14.2831      -1.74138      0.258578
C    5  Continuation     16.9061      -1.20941      0.546845
C    6  Continuation     24.9179     -0.599064      0.555136
C    7  Continuation     44.8783      0.487670      0.595261E-01
C    8  Continuation     60.0889       1.57585     -0.542365
C    9  Continuation    -11.1752       4.23516       1.55667
C   10  Target point     5.00000       4.00000       1.00000
C
C  We have reached the point we wanted.
C  The code may stop now.
C  FORTRAN STOP
C
      DOUBLE PRECISION EIGHT
      DOUBLE PRECISION HALF
      DOUBLE PRECISION HUNDRD
      DOUBLE PRECISION ONE
      DOUBLE PRECISION THREE
      DOUBLE PRECISION TWO
      DOUBLE PRECISION ZERO
C
      PARAMETER (EIGHT=8.0)
      PARAMETER (HALF=0.5)
      PARAMETER (HUNDRD=100.0)
      PARAMETER (ONE=1.0)
      PARAMETER (THREE=3.0)
      PARAMETER (TWO=2.0)
      PARAMETER (ZERO=0.0)
C
      EXTERNAL  COQUAL
      EXTERNAL  CORECT
      EXTERNAL  DF
      EXTERNAL  FX
      EXTERNAL  IDAMAX
      EXTERNAL  REPS
      EXTERNAL  ROOT
      EXTERNAL  DDOT
      EXTERNAL  SETSTP
      EXTERNAL  SLNAME
      EXTERNAL  DNRM2
      EXTERNAL  DSCAL
      EXTERNAL  START
      EXTERNAL  TANGNT
C
      INTRINSIC ABS
      INTRINSIC ATAN2
      INTRINSIC MAX
      INTRINSIC SIGN
      INTRINSIC SQRT
C
      INTEGER   LIW
      INTEGER   LRW
      INTEGER   NVAR
C
      DOUBLE PRECISION A
      DOUBLE PRECISION ATCIPC
      DOUBLE PRECISION ATCJPC
      DOUBLE PRECISION B
      DOUBLE PRECISION DETS
      DOUBLE PRECISION DIRLPC
      DOUBLE PRECISION FA
      DOUBLE PRECISION FB
      DOUBLE PRECISION FPAR(*)
      DOUBLE PRECISION HTAN
      INTEGER   I
      INTEGER   ICALL
      INTEGER   ICRIT
      INTEGER   IERROR
      INTEGER   IFLAG
      INTEGER   IHOLD
      INTEGER   IMITL
      INTEGER   IPAR(*)
      INTEGER   IPC
      INTEGER   IPL
      INTEGER   IDAMAX
      INTEGER   IT
      INTEGER   ITMP
      INTEGER   IWORK(LIW)
      INTEGER   IWRITE
      INTEGER   JOB
      INTEGER   JPC
      INTEGER   LIM
      INTEGER   LOUNIT
      INTEGER   LPC
      INTEGER   LTC
      INTEGER   LTC1
      INTEGER   LWK
      INTEGER   LWK1
      INTEGER   LXC
      INTEGER   LXC1
      INTEGER   LXF
      INTEGER   LXF1
      INTEGER   MLSTEP
      INTEGER   MODSAV
      DOUBLE PRECISION REPS
      DOUBLE PRECISION RWORK(LRW)
      DOUBLE PRECISION SCIPL
      DOUBLE PRECISION DDOT
      DOUBLE PRECISION SKALE
      DOUBLE PRECISION SN
      DOUBLE PRECISION SNL
      DOUBLE PRECISION DNRM2
      DOUBLE PRECISION STEPX
      DOUBLE PRECISION TCIPC
      DOUBLE PRECISION TCIPL
      DOUBLE PRECISION TCOS
      DOUBLE PRECISION TEMP
      DOUBLE PRECISION TLIPC
      DOUBLE PRECISION TMAX
      DOUBLE PRECISION TMAX2
      DOUBLE PRECISION TMP
      DOUBLE PRECISION TMP1
      DOUBLE PRECISION TSIN
      DOUBLE PRECISION TSN
      DOUBLE PRECISION XABS
      DOUBLE PRECISION XDIF
      DOUBLE PRECISION XLOW
      DOUBLE PRECISION XR(NVAR)
      DOUBLE PRECISION XUP
C
      SAVE      ICALL
C
      DATA      ICALL /0/
C
      ICALL=ICALL+1
C
C**********************************************************************
C
C  1.  Preparations.
C
C  Check entries of IWORK and RWORK, compute some constants.
C  For negative values of IWORK(1), compare user and finite difference 
C    jacobian and return.
C  For IWORK(1)=0, set up starting data, check starting point and return.
C  For positive IWORK(1), prepare to compute next point.
C
C**********************************************************************
C
      IERROR=0
      IF(IWORK(8).LT.1.OR.IWORK(8).GT.99)IWORK(8)=6
      LOUNIT=IWORK(8)
      IF(IWORK(7).LT.0.OR.IWORK(7).GT.3)IWORK(7)=1
      IWRITE=IWORK(7)
C
C  Initialization for first call
C
      IF(IWORK(1).EQ.0.OR.ICALL.EQ.1)THEN
        IF(IWRITE.GE.1)THEN
          WRITE(LOUNIT,*)' '
          WRITE(LOUNIT,*)'PITCON 6.1'
          WRITE(LOUNIT,*)'University of Pittsburgh Continuation Code'
          WRITE(LOUNIT,*)' '
          WRITE(LOUNIT,*)'Last modification on 27 February 1991'
          WRITE(LOUNIT,*)' '
          ENDIF
        DO 10 I=11,17
          RWORK(I)=ZERO
10        CONTINUE
        DO 20 I=21,29
          RWORK(I)=ZERO
20        CONTINUE
        IWORK(10)=0
        IWORK(11)=0
        IWORK(12)=0
        DO 30 I=18,28
          IWORK(I)=0
30        CONTINUE
C
C  This is the only place REPS is called.  It might be replaced by
C  a call to the SLATEC machine parameter function R1MACH:
C
C    RWORK(8)=R1MACH(4)
C
C  or by simply setting RWORK(8) to the "machine epsilon", usually
C  taken as the smallest power of 2, EPMACH, such that (1.0+EPMACH) is
C  greater than 1.0, but (1.0+(EPMACH/2.0)) equals 1.0.
C
        RWORK(8)=REPS()
        IF(IWRITE.GE.2)WRITE(LOUNIT,919)RWORK(8)
        TCOS=SQRT(ONE-RWORK(8))
        TSIN=SQRT(RWORK(8))
        RWORK(10)=TWO*ATAN2(TSIN,TCOS)
        IF(NVAR.LE.1)THEN
          IERROR=1
          IF(IWRITE.GE.1)WRITE(LOUNIT,*)
     *    'PITCON - Number of variables must be at least 2.'
          GO TO 900
          ENDIF
        ENDIF
C
      LXC=29
      LXC1=LXC+1
      LXF=LXC+NVAR
      LXF1=LXF+1
      LTC=LXF+NVAR
      LTC1=LTC+1
      LWK=LTC+NVAR
      LWK1=LWK+1
      IWORK(13)=30
      IWORK(14)=LIW
      IWORK(15)=LWK+NVAR+1
      IWORK(16)=LRW
      IF(LIW.LT.IWORK(13))THEN
        WRITE(LOUNIT,*)'PITCON - Input value of LIW=',LIW
        WRITE(LOUNIT,*)'         Minimal acceptable value=',IWORK(13)
        IERROR=1
        GO TO 900
      ELSEIF(LRW.LT.IWORK(15))THEN
        WRITE(LOUNIT,*)'PITCON - Input value of LRW=',LRW
        WRITE(LOUNIT,*)'         Minimal acceptable value=',IWORK(15)
        IERROR=1
        GO TO 900
        ENDIF
C
C  Check entries of IWORK
C
      IF(IWORK(2).LT.1.OR.IWORK(2).GT.NVAR)IWORK(2)=NVAR
      IPC=IWORK(2)
      IF(IWORK(3).NE.1)IWORK(3)=0
      IF(IWORK(4).LT.0.OR.IWORK(4).GT.2)IWORK(4)=0
      IF(IWORK(5).LT.1.OR.IWORK(5).GT.NVAR)IWORK(5)=0
      IT=IWORK(5)
      IF(IWORK(6).LT.1.OR.IWORK(6).GT.NVAR)IWORK(6)=0
      LIM=IWORK(6)
      IF(IWORK(9).LT.0.OR.IWORK(9).GT.2)IWORK(9)=0
      IF(IWORK(17).LT.1)IWORK(17)=10
C
C  Check entries of RWORK
C
      IF(RWORK(1).LE.ZERO)RWORK(1)=SQRT(RWORK(8))
      IF(RWORK(2).LE.ZERO)RWORK(2)=SQRT(RWORK(8))
      IF(RWORK(3).LT.SQRT(RWORK(8)))RWORK(3)=SQRT(RWORK(8))
      IF(RWORK(4).LT.RWORK(3))THEN
        TEMP=NVAR
        RWORK(4)=MAX(RWORK(3),SQRT(TEMP))
        ENDIF
      IF(RWORK(5).LT.ZERO)THEN
        RWORK(5)=-RWORK(5)
        RWORK(6)=-RWORK(6)
        ENDIF
      IF(RWORK(5).LT.RWORK(3).OR.RWORK(5).GT.RWORK(4))THEN
        RWORK(5)=HALF*(RWORK(3)+RWORK(4))
        ENDIF
      HTAN=RWORK(5)
      IF(RWORK(6).NE.(-ONE))RWORK(6)=ONE
      IF(RWORK(20).LT.ONE.OR.RWORK(20).GT.HUNDRD)RWORK(20)=THREE
C
C  Check user Jacobian routine versus finite difference calculation.
C
      IF(IWORK(1).LT.0)THEN
        JOB=3
        CALL SLNAME(DETS,FX,DF,FPAR,IERROR,IPC,IPAR,IWORK,LIW,
     1  JOB,NVAR,RWORK,LRW,XR,RWORK(LWK1))
        GO TO 900
        ENDIF
C
C  Starting point check
C
      IF(IWORK(1).EQ.0)THEN
        CALL START(DF,FPAR,FX,IERROR,IPAR,IPC,IWORK,IWRITE,LIW,
     *  LOUNIT,LRW,NVAR,RWORK,RWORK(LTC1),RWORK(LWK1),RWORK(LXC1),
     *  RWORK(LXF1),XR,SLNAME)
        GO TO 900
        ENDIF
C
C***********************************************************************
C
C  2.  Target point 
C
C  If (IT.NE.0) target points are sought.  Check to see if target component
C  IT has value XIT lying between XC(IT) and XF(IT).  If so, get linearly
C  interpolated starting point, and use Newton's method to get target point.
C
C***********************************************************************
C
      IF(IT.EQ.0.OR.IWORK(10).LE.1)GO TO 300
      IF( (IWORK(1).EQ.3) .AND. (RWORK(7).EQ.RWORK(28)) .AND. 
     *    (IT.EQ.IWORK(11)) ) GO TO 300
      MODSAV=IWORK(4)
210   CONTINUE
      XLOW=RWORK(LXC+IT)
      XUP=RWORK(LXF+IT)
      IF(RWORK(7).LT.XLOW.AND.RWORK(7).LT.XUP)GO TO 300
      IF(RWORK(7).GT.XLOW.AND.RWORK(7).GT.XUP)GO TO 300
      IF(IWRITE.GE.2)WRITE(LOUNIT,*)
     *'PITCON - Attempt correction of approximate target point.'
C
C  Approximate the target point using the bracketing solutions.
C
      IF(XLOW.NE.XUP)THEN
        SKALE=(RWORK(7)-XLOW)/(XUP-XLOW)
      ELSE
        SKALE=ONE
        ENDIF
      CALL DCOPY(NVAR,RWORK(LXF1),1,XR,1)
      CALL DSCAL(NVAR,SKALE,XR,1)
      SKALE=ONE-SKALE
      CALL DAXPY(NVAR,SKALE,RWORK(LXC1),1,XR,1)
      XR(IT)=RWORK(7)
C
C  Call CORECT to compute the exact target point, holding index IT fixed.
C
      ICRIT=0
      CALL CORECT(DF,FPAR,FX,IERROR,IT,IPAR,IWORK,
     1 NVAR,RWORK,TMP,RWORK(LWK1),XR,LRW,LIW,ICRIT,SLNAME)
      IWORK(24)=IWORK(24)+IWORK(28)
      IF(IERROR.NE.0.AND.IWORK(4).GT.0)THEN
        IERROR=0
        IWORK(4)=IWORK(4)-1
        IF(IWRITE.GE.1)WRITE(LOUNIT,1080)IWORK(4)
        GO TO 210
        ENDIF
      IWORK(4)=MODSAV
      IF(IERROR.NE.0)THEN
        WRITE(LOUNIT,*)'PITCON - Target point calculation failed.'
        GO TO 900
        ENDIF
C
C  Record the values of IT and XIT, and compute the arclength to the target 
C  point.
C
      IWORK(1)=3
      IWORK(11)=IT
      RWORK(28)=RWORK(7)
      SKALE=-ONE
      CALL DCOPY(NVAR,XR,1,RWORK(LWK1),1)
      CALL DAXPY(NVAR,SKALE,RWORK(LXC1),1,RWORK(LWK1),1)
      RWORK(14)=RWORK(12)+DNRM2(NVAR,RWORK(LWK1),1)
      IWORK(27)=IWORK(27)+1
      GO TO 900
C
C***********************************************************************
C
C  3.  Tangent and local continuation parameter calculation.  
C
C  Unless the tangent and limit point calculations were already performed,
C  (because the loop was interrupted for a limit point calculation),
C  set up and solve the equation for the tangent vector.
C
C  Force the tangent vector to be of unit length, and try to preserve
C  the "sense" or "direction" of the curve by forcing the IPL-th component
C  of the tangent vector to agree in sign with the IPL-th component of the
C  previous secant vector.  (On the first step, however, we have to use
C  the user's input direction to choose the sign).
C
C  Set the local continuation parameter IPC as the index of the
C  component of greatest magnitude in the tangent vector, unless a
C  limit point appears to be coming in that direction, and another
C  choice is available.
C
C***********************************************************************
C
  300 CONTINUE
      IF(IWORK(10).EQ.3) GO TO 600
C
C  STORE OLD TANGENT IN WORK ARRAY RWORK(LWK1)-RWORK(LWK+NVAR), COMPUTE
C  NEW TANGENT FOR CURRENT POINT XF IN RWORK(LXF1)-RWORK(LXF+NVAR).
C  THE TANGENT IS CALLED TC AND STORED IN RWORK(LTC1)-RWORK(LTC+NVAR).
C  NOTE THAT FOR A NORMAL RETURN THE CURRENT POINT XF WILL BE STORED
C  AS XC IN RWORK(LXC1)-RWORK(LXC+NVAR) AND HENCE THAT TC WILL THEN
C  CORRESPOND TO THE POINT XC
C
      IPL=IPC
      CALL DCOPY(NVAR,RWORK(LTC1),1,RWORK(LWK1),1)
      RWORK(29)=RWORK(17)
      CALL TANGNT(RWORK(17),FX,DF,FPAR,IERROR,IPC,IPAR,IWORK,NVAR,
     1 RWORK,RWORK(LTC1),RWORK(LXF1),LIW,LRW,SLNAME)
      IF(IERROR.NE.0)THEN
        IF(IWRITE.GE.1)WRITE(LOUNIT,*)
     *  'PITCON - Tangent calculation failed.'
        GO TO 900
        ENDIF
C
C  FIND LARGEST AND SECOND LARGEST COMPONENTS OF TANGENT
C
      IPC=IDAMAX(NVAR,RWORK(LTC1),1)
      TMAX=RWORK(LTC+IPC)
      RWORK(LTC+IPC)=ZERO
      JPC=IDAMAX(NVAR,RWORK(LTC1),1)
      RWORK(LTC+IPC)=TMAX
      TMAX=ABS(TMAX)
      TMAX2=ABS(RWORK(LTC+JPC))
      IF(JPC.EQ.0)JPC=IPC
      IF(IWORK(3).EQ.1)JPC=IPC
C
C  ADJUST SIGN OF THE TANGENT VECTOR.
C  COMPARE THE SIGN OF THE COMPONENT TC(IPL) WITH THE
C  SIGN OF XF(IPL)-XC(IPL). IF A TARGET OR LIMIT POINT
C  HAS BEEN COMPUTED BETWEEN XC AND XF THEN USE XF(IPL)-XR(IPL)
C  INSTEAD. AT THE FIRST STEP COMPARE WITH THE USER INPUT DIRECTION.
C  IF THESE SIGNS DIFFER, CHANGE THE SIGN OF THE TANGENT VECTOR
C  AND THE SIGN OF THE DETERMINANT.
C
      SCIPL=RWORK(6)
      TCIPL=RWORK(LTC+IPL)
      IF(IWORK(10).GT.1)THEN
        SCIPL=RWORK(LXF+IPL)
        TMP=RWORK(LXC+IPL)
        IF(IWORK(1).EQ.3.OR.IWORK(1).EQ.4)TMP=XR(IPL)
        SCIPL=SCIPL-TMP      
        ENDIF
      IF(SIGN(ONE,TCIPL).NE.SIGN(ONE,SCIPL))THEN
        SKALE=-ONE
        CALL DSCAL(NVAR,SKALE,RWORK(LTC1),1)
        RWORK(17)=-RWORK(17)
        ENDIF
C
C  Unless we are computing a starting point, record the new state.
C
      IF(IWORK(10).GT.1)IWORK(10)=3
C
C  THE LOCATION OF THE LARGEST COMPONENT OF THE TANGENT VECTOR
C  WILL BE USED FOR THE LOCAL PARAMETERIZATION OF THE CURVE UNLESS
C  A LIMIT POINT IN IPC APPEARS TO BE COMING.
C  TO CHECK THIS, WE COMPARE TCIPC=TC(IPC) AND THE
C  SECOND LARGEST COMPONENT TCJPC=TC(JPC).  IF TCJPC IS NO LESS
C  THAN .1 OF TCIPC, AND TC(JPC) IS LARGER THAN TL(JPC),
C  WHEREAS TC(IPC) IS LESS THAN TL(IPC), WE WILL RESET THE
C  LOCAL PARAMETER IPC TO JPC.
C  BUT IF NOT ALLOWED TO SWITCH PARAMETERS, IGNORE THE CHECK
C
      IF(IWORK(3).NE.1)THEN
        ATCIPC=ABS(RWORK(LTC+IPC))
        ATCJPC=ABS(RWORK(LTC+JPC))
        IF(JPC.NE.IPC.AND.IWORK(10).GT.1)THEN
          TLIPC=RWORK(LWK+IPC)
          TCIPC=RWORK(LTC+IPC)
          TMP=ABS(RWORK(LWK+JPC))
          IF((SIGN(ONE,TCIPC).EQ.SIGN(ONE,TLIPC))
     1      .AND.(ATCIPC.LT.ABS(TLIPC))
     2      .AND.(ATCJPC.GE.MAX(0.1*ATCIPC,TMP)))THEN
            IF(IWRITE.GE.3)WRITE(LOUNIT,350)IPC
            ITMP=IPC
            IPC=JPC
            JPC=ITMP
            ENDIF
          ENDIF
        ENDIF
      IF(IWRITE.GE.3.AND.IWORK(3).EQ.0)THEN
        WRITE(LOUNIT,360)IPC
        WRITE(LOUNIT,370)JPC
        ENDIF
C
C  RECORD VALUES OF THE COMPONENT TCIPC=TC(IPC) OF
C  NEW TANGENT VECTOR, AS WELL AS OF THE CORRESPONDING COMPONENT
C  TLIPC=WK(IPC) OF THE OLD TANGENT VECTOR.
C  SET SIGN OF THE DETERMINANT.
C  FOR USE IN THE LIMIT POINT COMPUTATION RECORD THE
C  COMPONENT TC(LIM) OF THE NEW TANGENT VECTOR
C
      IWORK(2)=IPC
      IWORK(12)=JPC
      RWORK(24)=RWORK(LTC+IPC)
      RWORK(25)=RWORK(LWK+IPC)
      RWORK(6)=RWORK(17)
      IF(LIM.GT.0)THEN
        RWORK(27)=RWORK(26)
        RWORK(26)=RWORK(LTC+LIM)
        IF(IWRITE.GE.2)WRITE(LOUNIT,1020)RWORK(26)
        ENDIF
C
C  COMPUTE ALPHLC, THE ANGLE BETWEEN OLD TANGENT AND TANGENT AT XC
C
      IF(IWORK(10).LE.1) GO TO 600
      TCOS=DDOT(NVAR,RWORK(LWK1),1,RWORK(LTC1),1)
      IF(TCOS.GT.ONE)TCOS=ONE
      IF(TCOS.LT.(-ONE))TCOS=-ONE
      TSIN=SQRT(ONE-TCOS*TCOS)
      RWORK(11)=ATAN2(TSIN,TCOS)
      IF((IWORK(10).LE.1).OR.(RWORK(17).EQ.RWORK(29)))GO TO 400
      IF(IWRITE.GE.2)WRITE(LOUNIT,*)
     *'PITCON - Possible bifurcation point detected.'
C
C***********************************************************************
C
C  4.  Limit point check.  
C
C  Skip this section if LIM=0.
C
C  Otherwise, user has requested a search for limit points in a given 
C  index by setting LIM to a nonzero value.
C
C  Compare LIM-th components of previous and current tangent vectors.
C  If a sign difference occurs, we assume a limit point has been passed.
C  Attempt to compute a point XR between the previous and current points,
C  for which the LIM-th component of the tangent is zero.
C
C  This search will be guided by a rootfinder.  The scalar function
C  to be zeroed out is the LIM-th tangent vector component.
C
C***********************************************************************
C
  400 CONTINUE
      IF((LIM.LE.0).OR.
     *   (IWORK(10).LE.1).OR.
     *   (SIGN(ONE,RWORK(26)).EQ.SIGN(ONE,RWORK(27)))) GO TO 600
      IF(IWRITE.GE.2)WRITE(LOUNIT,*)
     *'PITCON - Attempt correction of approximate limit point.'
      MODSAV=IWORK(4)
410   CONTINUE
C
C  SEE IF EITHER ENDPOINT CAN BE ACCEPTED AS LIMIT POINT.
C  IF XC IS LIMIT POINT, WORK ALREADY CONTAINS TANGENT AT XC.
C
      IF(ABS(RWORK(27)).LE.HALF*RWORK(1)) THEN
        CALL DCOPY(NVAR,RWORK(LXC1),1,XR,1)
        GO TO 490
        ENDIF
      IF(ABS(RWORK(26)).LE.HALF*RWORK(1)) THEN
        CALL DCOPY(NVAR,RWORK(LXF1),1,XR,1)
        CALL DCOPY(NVAR,RWORK(LTC1),1,RWORK(LWK1),1)
        GO TO 490
        ENDIF
C
C  If interval is extremely small, simply assign one
C  endpoint of the interval as the answer.
C
      XDIF=ABS(RWORK(LXC+LIM)-RWORK(LXF+LIM))
      XABS=MAX(ABS(RWORK(LXC+LIM)),ABS(RWORK(LXF+LIM)))
      IF(XDIF.LE.EIGHT*RWORK(8)*(ONE+XABS)) THEN
        IF(ABS(RWORK(27)).GT.ABS(RWORK(26))) THEN
          CALL DCOPY(NVAR,RWORK(LXF1),1,XR,1)
          CALL DCOPY(NVAR,RWORK(LTC1),1,RWORK(LWK1),1)
        ELSE
          CALL DCOPY(NVAR,RWORK(LXC1),1,XR,1)
          ENDIF
        GO TO 490
        ENDIF
C
C  BEGIN ROOT-FINDING ITERATION WITH INTERVAL (0,1) AND
C  FUNCTION VALUES TLLIM, TCLIM.
C
      A=ZERO
      FA=RWORK(27)
      B=ONE
      FB=RWORK(26)
C
C  FIND LPC, INDEX OF MAXIMUM ENTRY OF SECANT (EXCEPT THAT
C  LPC MUST NOT EQUAL LIM) AND SAVE SIGN IN DIRLPC
C  SO THAT NEW TANGENTS MAY BE PROPERLY SIGNED.
C
      TEMP=RWORK(LXC+LIM)
      RWORK(LXC+LIM)=RWORK(LXF+LIM)
      CALL DCOPY(NVAR,RWORK(LXF1),1,XR,1)
      SKALE=-ONE
      CALL DAXPY(NVAR,SKALE,RWORK(LXC1),1,XR,1)
      LPC=IDAMAX(NVAR,XR,1)
      RWORK(LXC+LIM)=TEMP
      DIRLPC=SIGN(ONE,RWORK(LXF+LPC)-RWORK(LXC+LPC))
C
C  SET FIRST APPROXIMATION TO ROOT TO WHICHEVER ENDPOINT
C  HAS SMALLEST LIM-TH COMPONENT OF TANGENT
C
      IF(ABS(RWORK(26)).GE.ABS(RWORK(27))) THEN
        SN=ZERO
        TSN=RWORK(27)
        CALL DCOPY(NVAR,RWORK(LXC1),1,XR,1)
      ELSE
        SN=ONE
        TSN=RWORK(26)
        CALL DCOPY(NVAR,RWORK(LXF1),1,XR,1)
        ENDIF
C
C  CALL ROOTFINDER FOR APPROXIMATE ROOT SN.  USE LINEAR COMBINATION
C  OF PREVIOUS ROOT SNL, AND ONE OF 0.0 AND 1.0 TO GET A STARTING
C  POINT FOR CORRECTION.  RETURN TO CURVE ON LINE X(LPC)=CONSTANT,
C  COMPUTE TANGENT THERE, AND SET FUNCTION VALUE TO TANGENT(LIM)
C
      MLSTEP=25
      IMITL=0
      IF(IWRITE.GE.2)THEN
        TMP=ZERO
        WRITE(LOUNIT,1100)TMP,RWORK(27)
        TMP=ONE
        WRITE(LOUNIT,1100)TMP,RWORK(26)
        ENDIF
441   CONTINUE
      SNL=SN
      CALL ROOT(A,FA,B,FB,SN,TSN,IMITL,IFLAG,IERROR,RWORK(8))
      IWORK(23)=IWORK(23)+1
      IF(IERROR.NE.0)THEN
        IF(IWRITE.GE.1)WRITE(LOUNIT,*)
     *  'PITCON - Bad interval for rootfinder'
        GO TO 900
        ENDIF
      IF(IFLAG.EQ.(-1).OR.IFLAG.EQ.0)GO TO 490
C
C  FIND WHETHER SN LIES IN (0.0,SNL) OR (SNL,1.0).
C  USE APPROPRIATE LINEAR COMBINATION TO GET STARTING POINT.
C
      IF(SN.LE.SNL) THEN
C
C  SET X(SN)=(SNL-SN)/(SNL-0.0)*X(0.0)+(SN-0.0)/(SNL-0.0)*X(SNL)
C
        IF(SNL.LE.ZERO)THEN
          SKALE=ZERO
        ELSE
          SKALE=SN/SNL
          ENDIF
        IF(SKALE.LE.ZERO)SKALE=ZERO
        IF(SKALE.GE.ONE)SKALE=ONE
        CALL DSCAL(NVAR,SKALE,XR,1)
        SKALE=ONE-SKALE
        CALL DAXPY(NVAR,SKALE,RWORK(LXC1),1,XR,1)
      ELSE
C
C  SET X(SN)=(SN-SNL)/(1.0-SNL)*X(1.0)+(1.0-SN)/(1.0-SNL)*X(SNL)
C
        IF(SNL.GE.ONE)THEN
          SKALE=ZERO
        ELSE
          SKALE=(ONE-SN)/(ONE-SNL)
          ENDIF
        IF(SKALE.LE.ZERO)SKALE=ZERO
        IF(SKALE.GE.ONE)SKALE=ONE
        CALL DSCAL(NVAR,SKALE,XR,1)
        SKALE=ONE-SKALE
        CALL DAXPY(NVAR,SKALE,RWORK(LXF1),1,XR,1)
        ENDIF
C
582   CONTINUE
      ICRIT=0
      CALL CORECT(DF,FPAR,FX,IERROR,LPC,IPAR,IWORK,
     1 NVAR,RWORK,TMP,RWORK(LWK1),XR,LRW,LIW,ICRIT,SLNAME)
      IF(IERROR.NE.0.AND.IWORK(4).GT.0)THEN
        IWORK(4)=IWORK(4)-1
        CALL DCOPY(NVAR,RWORK(LXC1),1,XR,1)
        SKALE=ONE-SN
        CALL DSCAL(NVAR,SKALE,XR,1)
        SKALE=SN
        CALL DAXPY(NVAR,SKALE,RWORK(LXF1),1,XR,1)
        IF(IWRITE.GE.1)WRITE(LOUNIT,1090)IWORK(4)
        GO TO 582
        ENDIF
      IWORK(4)=MODSAV 
      IF(IERROR.NE.0)THEN
        WRITE(LOUNIT,*)
     *  'PITCON - Corrector failed on limit point.'
        GO TO 900
        ENDIF
      CALL TANGNT(TEMP,FX,DF,FPAR,IERROR,LPC,IPAR,IWORK,NVAR,
     1 RWORK,RWORK(LWK1),XR,LIW,LRW,SLNAME)
      IF(IERROR.NE.0)THEN
        IF(IWRITE.GE.1)WRITE(LOUNIT,*)
     *  'PITCON - Tangent error in limit point calculation.'
        GO TO 900
        ENDIF
C
C  Adjust the sign of the tangent vector so the LPC-th component
C  has the same sign as the LPC-th component of the secant.
C
      IF(DIRLPC.NE.SIGN(ONE,RWORK(LWK+LPC))) THEN
        SKALE=-ONE
        CALL DSCAL(NVAR,SKALE,RWORK(LWK1),1)
        ENDIF
C
C  SEE IF WE CAN ACCEPT THE NEW POINT BECAUSE TANGENT(LIM) IS SMALL
C  OR MUST STOP BECAUSE 25 ITERATIONS TAKEN,
C  OR IF WE MUST GO ON.
C
      TSN=RWORK(LWK+LIM)
      IF(IWRITE.GE.2)WRITE(LOUNIT,1100)SN,TSN
      IF(ABS(TSN).LE.RWORK(1))GO TO 490
      IF(IMITL.LT.MLSTEP)GO TO 441
C
C  Limit point iteration has failed.  We set an error flag,
C  but we return the partial results of the abortive computation
C  anyway.
C
      IERROR=8
      IF(IWRITE.GE.1)WRITE(LOUNIT,*)
     *'PITCON - Too many steps in limit point calculation.'
C
C  Limit point iteration is over.  
C  Compute and store information.
C
  490 CONTINUE
      CALL DCOPY(NVAR,XR,1,RWORK(LWK1),1)
      SKALE=-ONE
      CALL DAXPY(NVAR,SKALE,RWORK(LXC1),1,RWORK(LWK1),1)
      RWORK(14)=RWORK(12)+DNRM2(NVAR,RWORK(LWK1),1)
      IWORK(27)=IWORK(27)+1
      IWORK(1)=4
      GO TO 900
C
C***********************************************************************
C
C  5.  Compute next predictor step length, HTAN.
C
C***********************************************************************
C
  600 CONTINUE
      IF(IWORK(10).GT.1)CALL SETSTP(HTAN,IWORK,LIW,LRW,RWORK)
C
C***********************************************************************
C
C  6.  Continuation step
C
C  Our current data is the current point XC, its tangent vector TC, and
C  a steplength HTAN.  We predict the location of the next point on the
C  curve using the Euler approximation XR=XC+HTAN*TC.
C
C  Newton iteration is applied to this point, to force it to lie on the
C  curve.  In order to make the system square, an augmenting equation
C  is added to the system, specifying that XR(IPC)=XC(IPC)+HTAN*TC(IPC).
C  (The right hand side is a constant.)
C
C  If the Newton correction process fails, the stepsize is reduced and
C  prediction and correction retried.  Failure will most likely be
C  signaled by repeated step reductions, until the minimum allowable
C  stepsize is reached.  If this occurs, PITCON has failed, and cannot
C  proceed along the curve any more.
C
C***********************************************************************
C
  700 CONTINUE
      IWORK(18)=0
      IPC=IWORK(2)
      JPC=IWORK(12)
      IHOLD=IPC
      MODSAV=IWORK(4)
710   CONTINUE
      IF(IWRITE.GE.2)WRITE(LOUNIT,715)HTAN
      CALL DCOPY(NVAR,RWORK(LXF1),1,XR,1)
      CALL DAXPY(NVAR,HTAN,RWORK(LTC1),1,XR,1)
  740 CONTINUE
      IF(IWRITE.GE.2.AND.IWORK(3).EQ.0)WRITE(LOUNIT,725)IHOLD
      ICRIT=0
      CALL CORECT(DF,FPAR,FX,IERROR,IHOLD,IPAR,IWORK,
     1 NVAR,RWORK,STEPX,RWORK(LWK1),XR,LRW,LIW,ICRIT,SLNAME)
      IWORK(25)=IWORK(25)+IWORK(28)
      IF(IERROR.EQ.0)GO TO 800
C
C  Only VERY fatal errors should abort the correction process.
C  Abort this process only after kicking and screaming.
C
      IF(IERROR.EQ.2)THEN
        WRITE(LOUNIT,*)'PITCON - Fatal error during Newton correction'
        WRITE(LOUNIT,*)'         of a continutation point!'
        GO TO 900
        ENDIF
C
C  FOR CASES WHERE CORRECTOR FAILED TO CONVERGE,
C  AND THE VALUE OF IHOLD WAS NOT JPC,
C  AND THE USER HAS NOT FIXED THE CONTINUATION PARAMETER
C  KEEP THE SAME STEPSIZE BUT USE JPC INSTEAD OF IPC.
C
      IF(IWORK(3).NE.1.AND.IHOLD.NE.JPC.AND.JPC.NE.0)THEN
        IHOLD=JPC
        IF(IERROR.EQ.5)GO TO 740
        GO TO 710
        ENDIF
C
C  IF JPC FAILS AS IHOLD VALUE, RETURN TO IPC.
C
      IHOLD=IPC
C
C  IF WE ARE USING SOME FORM OF MODIFIED NEWTON, BUT
C  WE HAVE REACHED MINIMUM STEPSIZE OR 
C  HAVE HAD TWO FAILURES IN A ROW ON THIS STEP,
C  USE A BETTER NEWTON METHOD
C
      IF(IWORK(4).GT.0.AND.
     *  (HTAN.LT.RWORK(20)*RWORK(3).OR.IWORK(18).GE.2) )THEN
        IWORK(4)=IWORK(4)-1
        WRITE(LOUNIT,1130)IWORK(4)
        IF(IERROR.NE.5)GO TO 710
        GO TO 740
        ENDIF
C
C  NO CONVERGENCE, TRY A SMALLER STEPSIZE
C
      IF(HTAN.LT.RWORK(20)*RWORK(3))THEN
        IERROR=4
        IF(IWRITE.GE.1)WRITE(LOUNIT,*) 
     *  'PITCON - Stepsize fell below minimum.'
        GO TO 900
        ENDIF
      HTAN=HTAN/RWORK(20)
      IWORK(18)=IWORK(18)+1
      IF(IERROR.NE.5)GO TO 710
      SKALE=ONE/RWORK(20)
      CALL DSCAL(NVAR,SKALE,XR,1)
      SKALE=ONE-SKALE
      CALL DAXPY(NVAR,SKALE,RWORK(LXF1),1,XR,1)
      GO TO 740
C
C***********************************************************************
C
C  7.  Successful step.  Update information.
C
C***********************************************************************
C
  800 CONTINUE
      IWORK(1)=2
      IF(IWORK(3).NE.1)IWORK(2)=IHOLD
      IWORK(4)=MODSAV
      IWORK(10)=2
      IWORK(26)=IWORK(26)+IWORK(18)
      IWORK(27)=IWORK(27)+1
      RWORK(5)=HTAN
      RWORK(22)=RWORK(21)
      IF(IWRITE.GE.1.AND.IWORK(18).GT.0)WRITE(LOUNIT,755)IWORK(18)
      CALL DCOPY(NVAR,XR,1,RWORK(LWK1),1)
      SKALE=-ONE
      CALL DAXPY(NVAR,SKALE,RWORK(LXF1),1,RWORK(LWK1),1)
      RWORK(21)=DNRM2(NVAR,RWORK(LWK1),1)
      RWORK(12)=RWORK(13)
      RWORK(13)=RWORK(12)+RWORK(21)
      RWORK(14)=RWORK(13)
C
C  UPDATE VALUES OF COMPUTED POINTS.  STORE OLD POINT IN
C  RWORK(LXC1)-RWORK(LXC+NVAR) AND NEW POINT IN RWORK(LXF1)-
C  RWORK(LXF+NVAR). COMPUTE AND STORE CORDIS, THE MAXIMUM NORM
C  OF THE CORRECTOR DISTANCE.
C
      RWORK(15)=ZERO
      IF(IWORK(28).NE.0)THEN
        DO 810 I=1,NVAR
          TMP1=XR(I)-(RWORK(LXF+I)+HTAN*RWORK(LTC+I))
          IF(ABS(TMP1).GT.RWORK(15))RWORK(15)=ABS(TMP1)
 810      CONTINUE
        ENDIF
      CALL DCOPY(NVAR,RWORK(LXF1),1,RWORK(LXC1),1)
      CALL DCOPY(NVAR,XR,1,RWORK(LXF1),1)
C
C  COMPUTE CONVERGENCE QUALITY
C
      CALL COQUAL(STEPX,IWORK,LIW,RWORK,LRW)
C
C**********************************************************************
C
C  8.  All returns to calling program should exit here.
C
C**********************************************************************
C
  900 CONTINUE
      IF(IERROR.EQ.0)THEN
      ELSEIF(IERROR.EQ.1)THEN
        WRITE(LOUNIT,*)'PITCON - FATAL ERROR.'
        WRITE(LOUNIT,*)'         Storage or data error.'
      ELSEIF(IERROR.EQ.2)THEN
        WRITE(LOUNIT,*)'PITCON - FATAL ERROR.'
        WRITE(LOUNIT,*)
     *  '         User-defined function or jacobian error.'
      ELSEIF(IERROR.EQ.3)THEN
        WRITE(LOUNIT,*)'PITCON - FATAL ERROR.'
        WRITE(LOUNIT,*)'         Solver failed.'
      ELSEIF(IERROR.EQ.4)THEN
        WRITE(LOUNIT,*)'PITCON - FATAL ERROR.'
        WRITE(LOUNIT,*)'         Iteration failed.'
      ELSEIF(IERROR.EQ.5)THEN
        WRITE(LOUNIT,*)'PITCON - FATAL ERROR.'
        WRITE(LOUNIT,*)'         Too many corrector steps.'
      ELSEIF(IERROR.EQ.6)THEN
        WRITE(LOUNIT,*)'PITCON - FATAL ERROR.'
        WRITE(LOUNIT,*)'         Zero tangent vector.'
      ELSEIF(IERROR.EQ.7)THEN
        WRITE(LOUNIT,*)'PITCON - Nonfatal error.'
        WRITE(LOUNIT,*)'         Root finder failed on limit point.'
      ELSEIF(IERROR.EQ.8)THEN
        WRITE(LOUNIT,*)'PITCON - Nonfatal error.'
        WRITE(LOUNIT,*)'         Too many limit point steps.'
      ELSE
        IERROR=9
        WRITE(LOUNIT,*)'PITCON - FATAL ERROR.'
        WRITE(LOUNIT,*)'         Unidentified error.'
        ENDIF
      RETURN
350   FORMAT(' PITCON - Expect limit point in index ',I5)
360   FORMAT(' PITCON - Continuation index: First choice',I5)
370   FORMAT(' PITCON -                    Second choice',I5)
715   FORMAT(' PITCON - Predictor using stepsize ',G14.6)
725   FORMAT(' PITCON - Corrector fixing index',I5)
755   FORMAT(' PITCON - Predictor stepsize was reduced ',I6,' times.')
919   FORMAT(' PITCON - Machine epsilon=',G14.6)
1020  FORMAT(' PITCON - Tangent vector has limit component =',G14.6)
1080  FORMAT(' PITCON - Retry target computation with IWORK(4)=',I6)
1090  FORMAT(' PITCON - Retry limit computation with IWORK(4)=',I6)
1100  FORMAT(' PITCON - For S=',G14.6,' TAN(X(S))(LIM)=',G14.6)
1130  FORMAT(' PITCON - Retrying step with IWORK(4)=',I6)
      END
      SUBROUTINE COQUAL(STEPX,IWORK,LIW,RWORK,LRW)
C
C***********************************************************************
C
C  COQUAL computes the factor QUAL which is based on the 'quality'
C  (number of steps, last step/total step) of the corrector iteration.  
C  This factor is used as part of the stepsize algorithm.  
C
C  See the paper "On Steplength Algorithms for a Class of Continuation
C  Methods", listed in the documentation.
C
C  STEPX  = Input, size of the last correction.
C  CORDIS = Input, distance between first and last point.
C  MAXCOR = Input, maximum number of corrections allowed.
C  MODNEW = Input, defines type of corrector process used.
C  NCOR   = Input, actual number of corrections used.
C  QUAL   = Output, the quality factor, between 1/8 and 8,
C           with 1/8 poor, 1 average, 8 superior.  Used to
C           modify the next stepsize.
C
      DOUBLE PRECISION EIGHT
      DOUBLE PRECISION ONE
      DOUBLE PRECISION THGIE
C
      PARAMETER (EIGHT=8.0)
      PARAMETER (ONE=1.0)
      PARAMETER (THGIE=0.125)
C
      INTEGER   LIW
      INTEGER   LRW
C
      DOUBLE PRECISION BASE
      DOUBLE PRECISION BOT
      DOUBLE PRECISION CORDIS
      DOUBLE PRECISION EPSATE
      DOUBLE PRECISION ESAB
      DOUBLE PRECISION EXPO
      INTEGER   IBOT
      INTEGER   ITOP
      INTEGER   IWORK(LIW)
      INTEGER   LOUNIT
      INTEGER   MAXCOR
      INTEGER   MODNEW
      INTEGER   NAVE
      INTEGER   NMAX
      DOUBLE PRECISION QUAL
      DOUBLE PRECISION RWORK(LRW)
      DOUBLE PRECISION STEPX
      DOUBLE PRECISION TERM
      DOUBLE PRECISION TEST
      DOUBLE PRECISION TOP
C
      CORDIS=RWORK(15)
      EPSATE=EIGHT*RWORK(8)
      MODNEW=IWORK(4)
      MAXCOR=IWORK(17)
C
C  SEE IF MINIMAL NUMBER OF STEPS TAKEN
C
      IF((IWORK(28).LE.1).OR.(CORDIS.LE.EPSATE)) THEN
        QUAL=EIGHT
        GO TO 88
        ENDIF
C
C  SEE IF AVERAGE NUMBER OF STEPS TAKEN
C
      IF(MODNEW.EQ.0)THEN
        NAVE=(MAXCOR-1)/2
      ELSE
        NAVE=MAXCOR
        ENDIF
      IF(IWORK(28).EQ.NAVE)THEN
        QUAL=ONE
        GO TO 88
        ENDIF
C
C  SEE IF MAXIMUM NUMBER OF STEPS TAKEN
C
      IF(MODNEW.EQ.0)THEN
        NMAX=MAXCOR
      ELSE
        NMAX=2*MAXCOR
        ENDIF
      IF(IWORK(28).GE.NMAX)THEN
        QUAL=THGIE
        GO TO 88
        ENDIF
C
C  COMPUTE QUAL
C
C  FOR MODNEW=0, LET W=(STEPX/CORDIS),
C                    IEXP=1/(2**(NCOR-1)-1)
C                    U=W**IEXP
C                    JEXP=2**(NCOR-NAVE)
C              THEN  QUAL=(U+1+(1/U)) / (U**JEXP+1+(1/U**JEXP))
C
C  OTHERWISE,    EXP=(NCOR-NAVE)/(NCOR-1)
C                W=(STEPX/CORDIS)
C                QUAL=W**EXP
C
      IF(MODNEW.EQ.0)THEN
        ITOP=2**(IWORK(28)-NAVE)
        IBOT=2**(IWORK(28)-1)-1
        EXPO=ONE/FLOAT(IBOT)
        BASE=(STEPX/CORDIS)**EXPO
        TOP=BASE+ONE+(ONE/BASE)
        TERM=BASE**ITOP
        BOT=TERM+ONE+(ONE/TERM)
        QUAL=TOP/BOT
        IF(QUAL.GT.EIGHT)QUAL=EIGHT
        IF(QUAL.LT.THGIE)QUAL=THGIE
        GO TO 88
        ENDIF
C
C  TRY TO ANTICIPATE UNDERFLOW AND OVERFLOW
C
      ITOP=IWORK(28)-NAVE
      IBOT=IWORK(28)-1
      EXPO=FLOAT(IBOT)/FLOAT(ITOP)
      TEST=EIGHT**EXPO
      BASE=STEPX/CORDIS
      ESAB=CORDIS/STEPX
      IF((IWORK(28).LT.NAVE.AND.TEST.GT.BASE)
     1  .OR.(IWORK(28).GT.NAVE.AND.TEST.LT.BASE))THEN
        QUAL=EIGHT
        GO TO 88
        ENDIF
      IF((IWORK(28).LT.NAVE.AND.TEST.GT.ESAB)
     1  .OR.(IWORK(28).GT.NAVE.AND.TEST.LT.ESAB))THEN
        QUAL=THGIE
        GO TO 88
        ENDIF
C
C  COMPUTE QUAL
C
      EXPO=FLOAT(ITOP)/FLOAT(IBOT)
      QUAL=BASE**EXPO
      IF(QUAL.GT.EIGHT)QUAL=EIGHT
      IF(QUAL.LT.THGIE)QUAL=THGIE
88    CONTINUE
      RWORK(23)=QUAL
      IF(IWORK(7).GE.3)THEN
        LOUNIT=IWORK(8)
        WRITE(LOUNIT,1000)QUAL
        ENDIF
      RETURN
1000  FORMAT(' COQUAL - Corrector convergence quality factor=',G14.6)
      END
      SUBROUTINE CORECT(DF,FPAR,FX,IERROR,IHOLD,IPAR,IWORK,
     1 NVAR,RWORK,STEPX,WK,XR,LRW,LIW,ICRIT,SLNAME)
C
C***********************************************************************
C
C  CORECT PERFORMS THE CORRECTION OF AN APPROXIMATE
C  SOLUTION OF THE EQUATION F(XR)=0.0. FOR THE CORRECTION  EITHER
C  NEWTON'S METHOD OR THE CHORD NEWTON METHOD IS USED. IN THE LATTER
C  CASE THE JACOBIAN IS  EVALUATED ONLY AT THE STARTING POINT.
C  IF B IS THE VALUE OF XR(IHOLD) FOR THE INPUT STARTING POINT,
C  THEN THE AUGMENTING EQUATION IS XR(IHOLD)=B, THAT IS, THE IHOLD-TH
C  COMPONENT OF XR IS TO BE HELD FIXED.  THE AUGMENTED SYSTEM TO BE
C  SOLVED IS THEN DFA(XR,IHOLD)*(-DELX)=FA(XR)
C
C  ACCEPTANCE AND REJECTION CRITERIA-
C
C  LET NCOR DENOTE THE CURRENT ITERATION INDEX; THAT IS,  NCOR=0 FOR
C  THE PREDICTED POINT WHICH SERVES AS STARTING POINT.
C  After each iteration, the current point will be accepted
C  if any of the following conditions hold:
C
C  STRONG ACCEPTANCE CRITERION
C
C  1.  FNRM.LE.ABSERR AND STEPX.LE.(ABSERR+RELERR*XNRM))
C
C  WEAK ACCEPTANCE CRITERIA
C
C  2.  (NCOR.EQ.0) AND
C      FNRM.LE.(.5*ABSERR)
C  3.  FNRM.LE.EPSATE OR STEPX.LE.EPSATE
C  4.  (NCOR.GE.2) AND
C      (FNRM+FNRML).LE.ABSERR AND
C      STEPX.LE.8*(ABSERR+RELERR*XNRM)
C  5.  (NCOR.GE.2) AND
C      FNRM.LE.8.0*ABSERR AND
C      (STEPX+STEPXL).LE.(ABSERR+RELERR*XNRM)
C
C  AFTER EACH STEP OF THE ITERATION, THE PROCESS IS TO BE ABORTED IF
C  ANY OF THE FOLLOWING CONDITIONS HOLDS
C
C  1.  FNRM.GT.(FMP*FNRML+ABSERR)
C  2.  (NCOR.GE.2) AND (ICRIT.EQ.0) AND
C      (STEPX.GT.(FMP*STEPXL+ABSERR))
C  3.  NCOR.GE.MAXCOR (NUMBER OF ITERATIONS EXCEEDED).
C
C  HERE FMP=2.0 FOR NCOR.EQ.1, FMP=1.05 FOR NCOR.GT.1
C
C  ERROR CONDITIONS
C         IERROR=1  DATA OR STORAGE ERROR
C         IERROR=2  ERROR IN FUNCTION OR DERIVATIVE CALL
C         IERROR=3  SOLVER FAILED
C         IERROR=4  UNSUCCESSFUL ITERATION
C         IERROR=5  TOO MANY CORRECTOR STEPS
C
      DOUBLE PRECISION EIGHT
      DOUBLE PRECISION HALF
      DOUBLE PRECISION ONE
      DOUBLE PRECISION ONEFIV
      DOUBLE PRECISION TWO
      DOUBLE PRECISION ZERO
C
      PARAMETER (EIGHT=8.0)
      PARAMETER (HALF=0.5)
      PARAMETER (ONE=1.0)
      PARAMETER (ONEFIV=1.05)
      PARAMETER (TWO=2.0)
      PARAMETER (ZERO=0.0)
C
      EXTERNAL  DF
      EXTERNAL  FX
      EXTERNAL  IDAMAX
      EXTERNAL  DAXPY
      EXTERNAL  SLNAME
      EXTERNAL  DNRM2
C
      INTRINSIC ABS
C
      INTEGER   LIW
      INTEGER   LRW
      INTEGER   NVAR
C
      DOUBLE PRECISION ABSERR
      DOUBLE PRECISION DETS
      DOUBLE PRECISION EPSATE
      DOUBLE PRECISION FMP
      DOUBLE PRECISION FNRM
      DOUBLE PRECISION FNRML
      DOUBLE PRECISION FPAR(*)
      INTEGER   I
      INTEGER   ICRIT
      INTEGER   IERROR
      INTEGER   IFMAX
      INTEGER   IHOLD
      INTEGER   IPAR(*)
      INTEGER   IDAMAX
      INTEGER   IWORK(LIW)
      INTEGER   IWRITE
      INTEGER   IXMAX
      INTEGER   JOB
      INTEGER   KSMAX
      INTEGER   LOUNIT
      INTEGER   MAXCOR
      INTEGER   MAXNEW
      INTEGER   MODNEW
      DOUBLE PRECISION RELERR
      DOUBLE PRECISION RWORK(LRW)
      DOUBLE PRECISION SKALE
      DOUBLE PRECISION DNRM2
      DOUBLE PRECISION STEPX
      DOUBLE PRECISION STEPXL
      DOUBLE PRECISION TLSTEP
      DOUBLE PRECISION WK(NVAR)
      DOUBLE PRECISION XNRM
      DOUBLE PRECISION XR(NVAR)
      DOUBLE PRECISION XVALUE
C
C  Initialize.
C
      ABSERR=RWORK(1)
      RELERR=RWORK(2)
      EPSATE=EIGHT*RWORK(8)
      MODNEW=IWORK(4)
      IWRITE=IWORK(7)
      LOUNIT=IWORK(8)
      MAXCOR=IWORK(17)
      IERROR=0
      IWORK(28)=0
      MAXNEW=MAXCOR
      IF(MODNEW.NE.0)MAXNEW=2*MAXCOR
      FMP=TWO
      STEPX=ZERO
      XVALUE=XR(IHOLD)
C
C  STORE INITIAL FUNCTION VALUE IN THE WORK VECTOR WK
C
      CALL FX(NVAR,FPAR,IPAR,XR,WK,IERROR)
      IWORK(22)=IWORK(22)+1
      IF(IERROR.NE.0)THEN
        WRITE(LOUNIT,*)
     *  'CORECT - Error flag from user function routine.'
        RETURN
        ENDIF
      WK(NVAR)=XR(IHOLD)-XVALUE
      IFMAX=IDAMAX(NVAR,WK,1)
      FNRM=DNRM2(NVAR-1,WK,1)
      IXMAX=IDAMAX(NVAR,XR,1)
      XNRM=DNRM2(NVAR,XR,1)
      IF(IWRITE.GE.2)WRITE(LOUNIT,70)IWORK(28),FNRM,IFMAX
      IF(FNRM.LE.HALF*ABSERR)RETURN
C
C  NEWTON ITERATION LOOP BEGINS
C
      DO 100 I=1,MAXNEW
        IWORK(28)=I
C
C  SOLVE SYSTEM FPRIME*(-DELX)=FX FOR NEWTON DIRECTION DELX
C
        JOB=0
        IF(I.NE.1.AND.I.NE.MAXCOR.AND.MODNEW.EQ.1)JOB=1
        IF(MODNEW.EQ.2)JOB=1
        CALL SLNAME(DETS,FX,DF,FPAR,IERROR,IHOLD,IPAR,IWORK,LIW,
     1  JOB,NVAR,RWORK,LRW,XR,WK)
        IF(IERROR.NE.0)THEN
          WRITE(LOUNIT,12)IERROR
          RETURN
          ENDIF
C
C  UPDATE X, COMPUTE SIZE OF STEP AND OF X
C
        SKALE=-ONE
        CALL DAXPY(NVAR,SKALE,WK,1,XR,1)
        STEPXL=STEPX
        KSMAX=IDAMAX(NVAR,WK,1)
        STEPX=ABS(WK(KSMAX))
        IXMAX=IDAMAX(NVAR,XR,1)
        XNRM=DNRM2(NVAR,XR,1)
C
C  Compute F(X) and take its norm.
C
        CALL FX(NVAR,FPAR,IPAR,XR,WK,IERROR)
        IWORK(22)=IWORK(22)+1
        IF(IERROR.NE.0) THEN
          WRITE(LOUNIT,*)
     *    'CORECT - Error flag from user function routine.'
          RETURN
          ENDIF
        WK(NVAR)=XR(IHOLD)-XVALUE
        FNRML=FNRM
        IFMAX=IDAMAX(NVAR,WK,1)
        FNRM=DNRM2(NVAR-1,WK,1)
        IF(IWRITE.GE.2) THEN
          WRITE(LOUNIT,80)IWORK(28),STEPX,KSMAX
          WRITE(LOUNIT,70)IWORK(28),FNRM,IFMAX
          ENDIF
C
C  Check for strong acceptance of function and stepsize.
C
        TLSTEP=ABSERR+RELERR*XNRM
        IF(FNRM.LE.ABSERR.AND.STEPX.LE.TLSTEP)RETURN
C
C  Check for weak acceptance of function and stepsize.
C
        IF(FNRM.LE.EPSATE.OR.STEPX.LE.EPSATE)RETURN
        IF(IWORK(28).GT.1)THEN
          IF((FNRM+FNRML).LE.ABSERR.AND.STEPX.LE.EIGHT*TLSTEP)RETURN
          IF(FNRM.LE.EIGHT*ABSERR.AND.(STEPX+STEPXL).LE.TLSTEP)RETURN
          ENDIF
C
C  Decide if iteration should be aborted
C
        IF(IWORK(28).GT.1)THEN
          IF(ICRIT.LT.1.AND.STEPX.GT.(FMP*STEPXL+ABSERR)) THEN
            IERROR=4
            IF(IWRITE.GE.2)WRITE(LOUNIT,*)
     *      'CORECT - Size of correction not decreasing.'
            RETURN
            ENDIF
          ENDIF
        IF(ICRIT.LT.2.AND.FNRM.GT.(FMP*FNRML+ABSERR)) THEN
           IERROR=4
           IF(IWRITE.GE.2)WRITE(LOUNIT,*)
     *     'CORECT - Residual is not decreasing.'
           RETURN
           ENDIF
        FMP=ONEFIV
  100   CONTINUE
C
C  Reached maximum number of steps without acceptance or rejection.
C
      IERROR=5
      IF(IWRITE.GE.2)WRITE(LOUNIT,*)'CORECT - Convergence too slow.'
      RETURN
70    FORMAT(' CORECT - Residual ',I6,'=',G14.6,' I=',I6)
80    FORMAT(' CORECT - Step     ',I6,15X,G14.6,' I=',I6)
12    FORMAT(' CORECT - Error flag=',I6,' from solver.')
      END
      SUBROUTINE ROOT(A,FA,B,FB,U,FU,KOUNT,IFLAG,IERROR,EPMACH)
C
C***********************************************************************
C
C  ROOT SEEKS A ROOT OF THE EQUATION F(X)=0.0,
C  GIVEN A STARTING INTERVAL (A,B) ON WHICH F CHANGES SIGN.
C  ON FIRST CALL TO ROOT, THE INTERVAL AND FUNCTION VALUES FA AND FB
C  ARE INPUT AND AN APPROXIMATION U FOR THE ROOT IS RETURNED.
C  BEFORE EACH SUBSEQUENT CALL, THE USER EVALUATES FU=F(U), AND THE
C  PROGRAM TRIES TO RETURN A BETTER APPROXIMATION U.
C
C  SEE THE BOOK BY BRENT LISTED in the documentation.
C
C  VARIABLES
C
C  A     = IS ONE ENDPOINT OF AN INTERVAL IN WHICH F CHANGES SIGN.
C  FA    = THE VALUE OF F(A).  THE USER MUST EVALUATE F(A) BEFORE
C          FIRST CALL ONLY.  THEREAFTER THE PROGRAM SETS FA.
C  B     = IS THE OTHER ENDPOINT OF THE INTERVAL IN WHICH
C          F CHANGES SIGN.  NOTE THAT THE PROGRAM WILL RETURN
C          IMMEDIATELY WITH AN ERROR FLAG IF FB*FA.GT.0.0.
C  FB    = THE VALUE OF F(B).  THE USER MUST EVALUATE F(B) BEFORE
C          FIRST CALL ONLY.  THERAFTER THE PROGRAM SETS FB.
C  U     = ON FIRST CALL, U SHOULD NOT BE SET BY THE USER.
C          ON SUBSEQUENT CALLS, U SHOULD NOT BE CHANGED
C          FROM ITS OUTPUT VALUE, THE CURRENT APPROXIMANT
C          TO THE ROOT.
C  FU    = ON FIRST CALL, FU SHOULD NOT BE SET BY THE USER.
C          THEREAFTER, THE USER SHOULD EVALUATE THE FUNCTION
C          AT THE OUTPUT VALUE U, AND RETURN FU=F(U).
C  KOUNT = A COUNTER FOR THE NUMBER OF CALLS TO ROOT.  KOUNT
C          SHOULD BE SET TO ZERO ON THE FIRST CALL FOR A GIVEN
C          ROOT PROBLEM.
C  IFLAG = PROGRAM RETURN FLAG
C          IFLAG=-1  THE CURRENT BRACKETING INTERVAL WITH
C                    ENDPOINTS  STORED IN A AND B IS LESS THAN
C                    4*EPMACH*ABS(U)+EPMACH
C                    HENCE U SHOULD BE ACCEPTED AS THE ROOT.
C                    THE FUNCTION VALUE F(U) IS STORED IN FU.
C          IFLAG= 0  THE INPUT VALUE FU IS EXACTLY ZERO, AND
C                    U SHOULD BE ACCEPTED AS THE ROOT.
C          IFLAG>0   THE CURRENT APPROXIMATION TO THE ROOT IS
C                    CONTAINED IN U.  IF A BETTER APPROXIMATION IS
C                    DESIRED, SET FU=F(U) AND CALL ROOT AGAIN.
C                    THE VALUE OF IFLAG INDICATES
C                    THE METHOD THAT WAS USED TO PRODUCE U.
C
C          IFLAG= 1  BISECTION WAS USED.
C          IFLAG= 2  LINEAR INTERPOLATION (SECANT METHOD).
C          IFLAG= 3  INVERSE QUADRATIC INTERPOLATION.
C
C  IERROR= GLOBAL ERROR FLAG.
C          IERROR=0 NO ERROR FOUND
C          IERROR=7  ON FIRST CALL, FA*FB.GT.0.0. AND HENCE
C                    THE GIVEN INTERVAL IS UNACCEPTABLE.
C  EPMACH= THE RELATIVE MACHINE PRECISION
C
      DOUBLE PRECISION EIGHT
      DOUBLE PRECISION HALF
      DOUBLE PRECISION ONE
      DOUBLE PRECISION ONEP5
      DOUBLE PRECISION TWO
      DOUBLE PRECISION ZERO
C
      PARAMETER (EIGHT=8.0)
      PARAMETER (HALF=0.5)
      PARAMETER (ONE=1.0)
      PARAMETER (ONEP5=1.5)
      PARAMETER (TWO=2.0)
      PARAMETER (ZERO=0.0)
C
      INTRINSIC ABS
      INTRINSIC SIGN
C
      DOUBLE PRECISION A
      DOUBLE PRECISION B
      DOUBLE PRECISION EPMACH
      DOUBLE PRECISION FA
      DOUBLE PRECISION FB
      DOUBLE PRECISION FU
      DOUBLE PRECISION HALFUB
      INTEGER   IERROR
      INTEGER   IFLAG
      INTEGER   KOUNT
      DOUBLE PRECISION P
      DOUBLE PRECISION Q 
      DOUBLE PRECISION R
      DOUBLE PRECISION S
      DOUBLE PRECISION SDEL1
      DOUBLE PRECISION SDEL2
      DOUBLE PRECISION SDEL3
      DOUBLE PRECISION SDEL4
      DOUBLE PRECISION STEP
      DOUBLE PRECISION TOLER
      DOUBLE PRECISION U
C
C  SEGMENT 1   FIRST CALL HANDLED SPECIALLY.  DO BOOKKEEPING.
C
      IF(KOUNT.LE.0)THEN
        IF((FA.GT.ZERO.AND.FB.GT.ZERO) 
     1  .OR.(FA.LT.ZERO.AND.FB.LT.ZERO))THEN
          IERROR=7
          KOUNT=0
          RETURN
          ENDIF
        KOUNT=1
        SDEL1=TWO*ABS(B-A)
        SDEL2=TWO*SDEL1
        SDEL3=TWO*SDEL2
        U=B
        B=A
        FU=FB
        FB=FA
      ELSE
C
C  INCREMENT COUNTER AND CHECK WHETHER F(U)=0.
C
        KOUNT=KOUNT+1
        IF(FU.EQ.ZERO)THEN
          IFLAG=0
          RETURN
          ENDIF
C
C  IF FU AND FB HAVE THE SAME SIGN OVERWRITE B WITH A
C
        IF(SIGN(ONE,FU).EQ.SIGN(ONE,FB))THEN
          B=A
          FB=FA
          ENDIF
        ENDIF
C
C  SEGMENT 2   REARRANGE POINTS AND FUNCTION VALUES IF
C  NECESSARY SO THAT  ABS(FU).LT.ABS(FB)
C
      IF(ABS(FB).LT.ABS(FU)) THEN
        A=U
        U=B
        B=A
        FA=FU
        FU=FB
        FB=FA
        ENDIF
C
C  SEGMENT 3   CHECK FOR ACCEPTANCE BECAUSE OF SMALL INTERVAL
C  CURRENT CHANGE IN SIGN INTERVAL IS (B,U) OR (U,B).
C
      TOLER=TWO*EPMACH*ABS(U)+EPMACH
      HALFUB=HALF*(B-U)
      SDEL4=SDEL3
      SDEL3=SDEL2
      SDEL2=SDEL1
      SDEL1=ABS(B-U)
      IF(ABS(HALFUB).LE.TOLER) THEN
        IFLAG=-1
        A=U
        FA=FU
        RETURN
        ENDIF
C
C  SEGMENT 4   COMPUTE NEW APPROXIMANT TO ROOT OF THE FORM
C  U(NEW)=U(OLD)+STEP.
C  METHODS AVAILABLE ARE LINEAR INTERPOLATION
C  INVERSE QUADRATIC INTERPOLATION
C  AND BISECTION.
C
      IF(ABS(FU).GE.ABS(FA)) THEN
        IFLAG=1
        STEP=HALFUB
        GO TO 80
        ENDIF
C
C  ATTEMPT LINEAR INTERPOLATION IF ONLY TWO POINTS AVAILABLE
C  COMPUTE P AND Q FOR APPROXIMATION U(NEW)=U(OLD)+P/Q
C
      IF(A.EQ.B) THEN
        IFLAG=2
        S=FU/FA
        P=TWO*HALFUB*S
        Q=ONE-S
C    
C  ATTEMPT INVERSE QUADRATIC INTERPOLATION IF THREE POINTS AVAILABLE
C  COMPUTE P AND Q FOR APPROXIMATION U(NEW)=U(OLD)+P/Q
C
      ELSE
        IFLAG=3
        S=FU/FA
        Q=FA/FB
        R=FU/FB
        P=S*(TWO*HALFUB*Q*(Q-R)-(U-A)*(R-ONE))
        Q=(Q-ONE)*(R-ONE)*(S-ONE)
        ENDIF
C
C  CORRECT THE SIGNS OF P AND Q
C
      IF(P.GT.ZERO)Q=-Q
      P=ABS(P)
C
C  IF P/Q IS TOO LARGE, GO BACK TO BISECTION
C
      IF((EIGHT*SDEL1.GT.SDEL4) 
     1 .OR.(P.GE.ONEP5*ABS(HALFUB*Q)-ABS(TOLER*Q))) THEN
        IFLAG=1
        STEP=HALFUB
        GO TO 80
        ENDIF
      STEP=P/Q
C
C  SEGMENT 5   VALUE OF STEP HAS BEEN COMPUTED.
C  UPDATE INFORMATION  A =U, FA =FU, U =U+STEP.
C  CHANGE IN SIGN INTERVAL IS NOW (A,B) OR (B,A).
C
80    CONTINUE
      A=U
      FA=FU
      IF(ABS(STEP).LE.TOLER) STEP=SIGN(TOLER,HALFUB)
      U=U+STEP
      RETURN
      END
      SUBROUTINE SETSTP(HTAN,IWORK,LIW,LRW,RWORK)
C
C***********************************************************************
C
C  Predictor stepsize computation.
C
C  THE FORMULAS UNDERLYING THE ALGORITHM ARE
C
C  ALPHLC=MAXIMUM OF ARCCOS(TL,TC) AND ALFMIN=2*ARCCOS(1-EPMACH)
C  HSEC  =NORM(XC-XF)
C  HSECL =NORM(XL-XC)
C  ABSNLC=ABS(SIN(.5*ALPHLC))
C  CURV  =LAST VALUE OF THE CURVATURE
C  CURVN =2*ABSNLC/HSEC
C  CORDIS=CORRECTOR DISTANCE TO CURRENT CONTINUATION POINT.
C           FORCE CORDIS TO LIE BETWEEN .01*HSEC AND HSEC.
C           UNLESS (CORDIS.EQ.0.0), BECAUSE THE PREDICTED POINT WAS
C           ACCEPTED.  IN SUCH A CASE, SET HTAN=HFACT*HSEC
C           INSTEAD OF USING FIRST ESTIMATE FOR HTAN.
C
C  THEN
C
C  CURVX=CURVN+HSEC*(CURVN-CURV)/(HSEC+HSECL)
C  A SIMPLER FORMULA IS USED IF WE DO NOT HAVE DATA AT TWO PREVIOUS
C  POINTS.
C
C  IF (IWORK(10).GE.2) CURVX MUST BE AT LEAST AS LARGE AS
C  THE MAXIMUM OF 0.001 AND .01/HSEC
C
C  FIRST ESTIMATE   (UNLESS (CORDIS.EQ.0.0) )
C
C  HTAN =SQRT(2*QUAL*CORDIS/CURVX)
C
C  ADJUSTED VALUE
C
C  HTAN=HTAN*(1.0+HTAN*(TC(IPC)-TL(IPC))/(2*HSEC*TC(IPC)))
C
C  READJUSTMENT AND TRUNCATIONS
C
C  IF STEPSIZE REDUCTION OCCURRED DURING LAST CORRECTOR PROCESS,
C  HTAN IS FORCED TO BE LESS THAN (HFACT-1)*HSEC/2.
C
C  HTAN MUST LIE BETWEEN (HSEC/HFACT) AND (HSEC*HFACT).
C  HTAN IS ALWAYS FORCED TO LIE BETWEEN USER SPECIFIED
C  MINIMUM AND MAXIMUM STEPS.
C
      DOUBLE PRECISION HALF
      DOUBLE PRECISION HUNDTH
      DOUBLE PRECISION ONE
      DOUBLE PRECISION THOUTH
      DOUBLE PRECISION TWO
      DOUBLE PRECISION ZERO
C
      PARAMETER (HALF=0.5)
      PARAMETER (HUNDTH=0.01)
      PARAMETER (ONE=1.0)
      PARAMETER (THOUTH=0.001)
      PARAMETER (TWO=2.0)
      PARAMETER (ZERO=0.0)
C
      INTRINSIC ABS
      INTRINSIC MAX
      INTRINSIC MIN
      INTRINSIC SIN
      INTRINSIC SQRT
C
      INTEGER   LIW
      INTEGER   LRW
C
      DOUBLE PRECISION CURV
      DOUBLE PRECISION CURVX
      DOUBLE PRECISION HTAN
      INTEGER   IWORK(LIW)
      DOUBLE PRECISION RWORK(LRW)
      DOUBLE PRECISION TEMP
      DOUBLE PRECISION TMP
C
      RWORK(11)=MAX(RWORK(10),RWORK(11))
C
C  COMPUTE NEW CURVATURE DATA
C
      CURV=RWORK(16)
      RWORK(16)=TWO*ABS(SIN(HALF*RWORK(11)))/RWORK(21)
      IF(CURV.EQ.ZERO)CURV=RWORK(16)
      CURVX=RWORK(16)
      IF(RWORK(22).NE.ZERO)CURVX=
     1 RWORK(16)+RWORK(21)*(RWORK(16)-CURV)/(RWORK(21)+RWORK(22))
      TMP=MAX(THOUTH,(HUNDTH)/RWORK(21))
      CURVX=MAX(CURVX,TMP)
C
C  IF CONVERGENCE DISTANCE IS ZERO, SET ESTIMATE TO HFACT*HSEC.
C  ELSE TRUNCATE QUAL*CORDIS TO LIE BETWEEN .01*HSEC AND HSEC.
C
      HTAN=RWORK(20)*RWORK(21)
      IF(RWORK(15).NE.ZERO)THEN
        TEMP=MAX(RWORK(23)*RWORK(15),HUNDTH*RWORK(21))
        TEMP=MIN(TEMP,RWORK(21))
        HTAN=SQRT(TWO*TEMP/CURVX)
        ENDIF
C
C  Adjust the step to account for estimated curvature in the direction
C  of the parameter.
C
      IF(IWORK(18).GT.0)
     * HTAN=MIN(HTAN,HALF*(RWORK(20)-ONE)*RWORK(21))
      IF(IWORK(3).NE.1)THEN
        TEMP=ONE+(ONE-RWORK(25)/RWORK(24))*(HALF*HTAN)/RWORK(21)
        HTAN=HTAN*TEMP
        ENDIF
C
C  Enforce restrictions on growth and size of the step.
C
      HTAN=MAX(HTAN,RWORK(21)/RWORK(20))
      HTAN=MIN(HTAN,RWORK(21)*RWORK(20))
      HTAN=MAX(HTAN,RWORK(3))
      HTAN=MIN(HTAN,RWORK(4))
      RETURN
      END
      SUBROUTINE START(DF,FPAR,FX,IERROR,IPAR,IPC,IWORK,IWRITE,LIW,
     *LOUNIT,LRW,NVAR,RWORK,TC,WORK1,XC,XF,XR,SLNAME)
C
C***********************************************************************
C
C  On first call, make sure that the input point satisfies the
C  nonlinear equations.  If not, call CORECT and attempt to force this.
C  
      DOUBLE PRECISION ONE
      DOUBLE PRECISION ZERO
C
      PARAMETER (ONE=1.0)
      PARAMETER (ZERO=0.0)
C
      EXTERNAL  COQUAL
      EXTERNAL  CORECT
      EXTERNAL  DF
      EXTERNAL  FX
      EXTERNAL  IDAMAX
      EXTERNAL  DAXPY
      EXTERNAL  DCOPY
      EXTERNAL  SLNAME
C
      INTRINSIC ABS
C
      INTEGER   LIW
      INTEGER   LRW
      INTEGER   NVAR
C
      DOUBLE PRECISION DETS
      DOUBLE PRECISION FPAR(*)
      INTEGER   I
      INTEGER   ICRIT
      INTEGER   IERROR
      INTEGER   IMAX
      INTEGER   IPAR(*)
      INTEGER   IPC
      INTEGER   IDAMAX
      INTEGER   IWORK(LIW)
      INTEGER   IWRITE
      INTEGER   JOB
      INTEGER   LOUNIT
      INTEGER   MODSAV
      DOUBLE PRECISION RWORK(LRW)
      DOUBLE PRECISION SKALE
      DOUBLE PRECISION STEPX
      DOUBLE PRECISION TC(NVAR)
      DOUBLE PRECISION WORK1(NVAR)
      DOUBLE PRECISION XC(NVAR)
      DOUBLE PRECISION XF(NVAR)
      DOUBLE PRECISION XR(NVAR)
C
C  If user is requesting that Jacobian be used as long as possible,
C  then go ahead, generate and factor the first one now.
C
      IF(IWORK(4).EQ.2)THEN
        JOB=2
        CALL SLNAME(DETS,FX,DF,FPAR,IERROR,IPC,IPAR,IWORK,LIW,
     1  JOB,NVAR,RWORK,LRW,XR,WORK1)
        RWORK(17)=DETS
        IF(IERROR.NE.0)THEN
          WRITE(LOUNIT,*)
     *    'START  - Could not factor initial jacobian.'
          RETURN
          ENDIF
        ENDIF
      IF(IWRITE.GE.2)WRITE(LOUNIT,1040)IPC
1040  FORMAT(' START  - Correct initial point, fixing index ',I5)
C
C  Set up a pseudo-tangent vector and other data for first time,
C  check that starting point satisfies the equations.
C
      DO 50 I=1,NVAR
        TC(I)=ZERO
50      CONTINUE
      CALL DCOPY(NVAR,XR,1,XC,1)
      TC(IPC)=ONE
      MODSAV=IWORK(4)
      ICRIT=1
C
60    CONTINUE
      CALL DCOPY(NVAR,XC,1,XR,1)
      CALL CORECT(DF,FPAR,FX,IERROR,IPC,IPAR,IWORK,NVAR,RWORK,STEPX,
     *WORK1,XR,LRW,LIW,ICRIT,SLNAME)
      IWORK(25)=IWORK(25)+IWORK(28)
C
C  If possible, retry with ICRIT=2.
C
      IF(IERROR.NE.0.AND.ICRIT.EQ.1)THEN
        IF(IWRITE.GE.1)WRITE(LOUNIT,*)
     *  'START -  Retry starting point correction'
        ICRIT=2
        GO TO 60
      ELSEIF(IERROR.NE.0)THEN
        ICRIT=1
        ENDIF
C
      IF(IERROR.NE.0.AND.IWORK(4).GT.0)THEN
        IWORK(4)=IWORK(4)-1
        IERROR=0
1110  FORMAT(' START  - Retrying starting point with IWORK(4)=',I6)
        IF(IWRITE.GE.1)WRITE(LOUNIT,1110)IWORK(4)
        GO TO 60
        ENDIF
      IWORK(4)=MODSAV
      IF(IERROR.NE.0)THEN
        WRITE(LOUNIT,*)
     *  'START  - Starting point correction failed.'
        RETURN
        ENDIF
      SKALE=-ONE
      CALL DAXPY(NVAR,SKALE,XR,1,XC,1)
      IMAX=IDAMAX(NVAR,XC,1)
      RWORK(15)=ABS(XC(IMAX))
      CALL DCOPY(NVAR,XR,1,XC,1)
      CALL DCOPY(NVAR,XR,1,XF,1)
      CALL COQUAL(STEPX,IWORK,LIW,RWORK,LRW)
      RWORK(14)=RWORK(13)
      IWORK(27)=IWORK(27)+1
      IWORK(10)=1
      IWORK(1)=1
      RETURN
      END
      SUBROUTINE TANGNT(DETSN,FX,DF,FPAR,IERROR,IP,IPAR,IWORK,
     1 NVAR,RWORK,TAN,XR,LIW,LRW,SLNAME)
C
C***********************************************************************
C
C  TANGNT COMPUTES A UNIT TANGENT VECTOR TO THE SOLUTION
C  CURVE OF THE UNDERDETERMINED NONLINEAR SYSTEM FX = 0.  THE
C  TANGENT VECTOR TAN IS THE SOLUTION OF THE LINEAR SYSTEM
C
C        DFA(X,IPL)*TAN = E(NVAR)
C
C  HERE, E(I) ALWAYS DENOTES THE I-TH BASIS NATURAL BASIS VECTOR
C  IN NVAR-SPACE; THAT IS, THE VECTOR WITH A 1 IN THE I-TH
C  COMPONENT AND ZEROS ELSEWHERE. THEN DFA(X,IPL) IS THE
C  AUGMENTED JACOBIAN WHOSE FIRST NVAR-1 ROWS ARE DFX/DX (X), THE
C  DERIVATIVE OF FX EVELUATED AT X, AND WHOSE LAST ROW IS
C  THE TRANSPOSE OF E(IPL).
C
C  THE TANGENT VECTOR IS THEN NORMALIZED, BUT THE ADJUSTMENT
C  OF ITS SIGN IS PERFORMED OUTSIDE THE ROUTINE.
C
C  ERROR RETURNS  IERROR=1  DATA OR STORAGE ERROR
C                 IERROR=2  ERROR IN DERIVATIVE CALL
C                 IERROR=3  SOLVER FAILED
C                 IERROR=6  TANGENT VECTOR ZERO
C
      DOUBLE PRECISION ONE
      DOUBLE PRECISION ZERO
C
      PARAMETER (ONE=1.0)
      PARAMETER (ZERO=0.0)
C
      EXTERNAL  FX
      EXTERNAL  DF
      EXTERNAL  SLNAME
      EXTERNAL  DNRM2
      EXTERNAL  DSCAL
C
      INTEGER   LIW
      INTEGER   LRW
      INTEGER   NVAR
C
      DOUBLE PRECISION DETSN
      DOUBLE PRECISION FPAR(*)
      INTEGER   I
      INTEGER   IERROR
      INTEGER   IP
      INTEGER   IPAR(*)
      INTEGER   IWORK(LIW)
      INTEGER   JOB
      DOUBLE PRECISION RWORK(LRW)
      DOUBLE PRECISION SKALE
      DOUBLE PRECISION DNRM2
      DOUBLE PRECISION TAN(NVAR)
      DOUBLE PRECISION TNORM
      DOUBLE PRECISION XR(NVAR)
C
C  SET RIGHT HAND SIDE OF TANGENT SYSTEM
C
      DO 10 I=1,NVAR
        TAN(I)=ZERO
   10   CONTINUE
      TAN(NVAR)=ONE
C
C  CALL SOLVER
C
      JOB=0
      IF(IWORK(4).EQ.2)JOB=1
      CALL SLNAME(DETSN,FX,DF,FPAR,IERROR,IP,IPAR,IWORK,LIW,
     1JOB,NVAR,RWORK,LRW,XR,TAN)
      IF(IERROR.NE.0)RETURN
C
C  Normalize the tangent vector.
C
      TNORM=DNRM2(NVAR,TAN,1)
      IF(TNORM.EQ.ZERO)THEN
        IERROR=6
      ELSE
        SKALE=ONE/TNORM
        CALL DSCAL(NVAR,SKALE,TAN,1)
        IERROR=0
        ENDIF
      RETURN
      END
      SUBROUTINE DENSLV(DETS,FX,DF,FPAR,IERROR,IPC,IPAR,
     1 IWORK,LIW,JOB,NVAR,RWORK,LRW,X,Y)
C
C***********************************************************************
C
C  DENSLV SOLVES THE NVAR*NVAR LINEAR SYSTEM
C
C               (  DF(X)  )
C  (1)          (         ) * Y   = Y
C               (  E(IPC) )
C
C  WHERE DF(X) IS THE JACOBIAN OF THE GIVEN FUNCTION FX AT X, AND
C  E(IPC) IS THE IP-TH NATURAL BASIS VECTOR; THAT IS, THE LAST ROW
C  CONSISTS OF ALL ZEROS EXCEPT FOR A 1 IN COLUMN IPC.
C
C  THE MATRIX IS STORED IN DENSE FORM IN THE ONE-DIMENSIONAL ARRAY
C  RWORK(LRBEG)-RWORK(LRLST) WHERE LRLST=LRBEG+NVAR*NVAR - 1 AND
C  LRBEG IS STORED IN IWORK(15). A DATA ERROR IS CAUSED IF LRLST.GT.LRW
C
C  THE ROUTINE STORES THE PIVOT ARRAY IN IWORK(IWORK(13))) THROUGH 
C  IWORK(LILST) WHERE LILST=IWORK(13)+NVAR - 1.
C  THE ROUTINE RETURNS WITH A DATA ERROR IF LILST.GT.LIW.
C
C  SINCE THE MATRIX OF THE SYSTEM (1) IS STORED IN DENSE FORM THE USER
C  PROGRAM DF MAY HAVE THE FORM
C
C         SUBROUTINE DF(NVAR,FPAR,IPAR,X,A,IERR)
C         DIMENSION A(NVAR,NVAR), X(NVAR), FPAR(*),IPAR(*)
C         .....
C         A(I,J)=DF(I)/DX(J) , I=1,...,NVAR-1,J=1,...,NVAR
C         .....
C
C  WHERE DF(I)/DX(J) DENOTES THE DERIVATIVE OF THE I-TH COMPONENT
C  OF THE FUNCTION FX WITH RESPECT TO THE J-TH VARIABLE.  THE USER
C  NEED NOT SUPPLY THE LAST ROW OF THE MATRIX OF THE SYSTEM (1).
C
C  THE LINPACK SUBROUTINES DGEFA, DGEDI, AND DGESL ARE USED.
C
C  LIST OF VARIABLES
C
C  DETS    THE SIGN OF THE DETERMINANT OF THE MATRIX IN (1).
C  FX      AN EXTERNAL ROUTINE, THE NAME OF THE USER SUPPLIED
C          SUBROUTINE WHICH COMPUTES THE NVAR-1 DIMENSIONAL
C          FUNCTION.
C
C  DF      AN EXTERNAL ROUTINE, THE NAME OF THE USER SUPPLIED
C          SUBROUTINE WHICH COMPUTES THE JACOBIAN OF THE FUNCTION.
C  FPAR    A REAL ARRAY FOR THE TRANSMISSION OF PARAMETERS TO
C          DENSLV AND DF.
C  IERROR  ERROR FLAG
C         = 0   NORMAL RETURN
C         = 1   DATA OR STORAGE ERROR
C         = 2   ERROR IN DERIVATIVE ROUTINE DF
C         = 3   NUMERICALLY SINGULAR MATRIX DETECTED.
C  IPC     THE LOCATION OF THE 1 IN THE LAST ROW OF THE MATRIX
C  IPAR    AN INTEGER ARRAY FOR TRANSMISSION OF PARAMETERS TO DENSLV
C          AND DF.
C  IWORK   INTEGER WORK ARRAY USED TO STORE THE PIVOT ARRAY
C          (SEE ABOVE)
C  LIW     DIMENSION OF IWORK IN THE CALLING PROGRAM
C  JOB     WORK REQUEST SWITCH
C          = 0   DECOMPOSE THE MATRIX, SOLVE THE SYSTEM, AND
C          COMPUTE THE SIGN OF THE DETERMINANT.
C          = 1   SOLVE THE SYSTEM, ASSUMING THAT THE MATRIX HAS
C          BEEN PREVIOUSLY DECOMPOSED.
C          2 = Factor system, compute determinant.
C          3 = Check jacobian matrix.  Call user jacobian routine,
C          multiply by -1.0, add finite difference jacobian,
C          print largest entry.
C
C  NVAR    THE DIMENSION OF THE SYSTEM.
C  RWORK   REAL WORK ARRAY USED TO STORE THE MATRIX (SEE ABOVE).
C  LRW     THE DIMENSION OF RWORK IN THE CALLING PROGRAM.
C  X       A REAL VECTOR OF LENGTH NVAR, THE POINT AT WHICH THE
C          JACOBIAN IS TO BE EVALUATED.
C  Y       A REAL VECTOR OF LENGTH NVAR. ON INPUT Y CONTAINS THE
C          RIGHT HAND SIDE OF THE LINEAR SYSTEM (1), ON RETURN
C          WITH IERROR = 0 THE SOLUTION OF THE SYSTEM IS GIVEN IN Y.
C
      DOUBLE PRECISION ONE
      DOUBLE PRECISION ZERO
C
      PARAMETER (ONE=1.0)
      PARAMETER (ZERO=0.0)
C
      EXTERNAL  DENJAC
      EXTERNAL  DF
      EXTERNAL  FX
      EXTERNAL  IDAMAX
      EXTERNAL  DGEDI
      EXTERNAL  DGEFA
      EXTERNAL  DGESL
      EXTERNAL  DSCAL
C
      INTRINSIC MOD
      INTRINSIC SQRT
C
      INTEGER   LIW
      INTEGER   LRW
      INTEGER   NVAR
C
      DOUBLE PRECISION DET(2)
      DOUBLE PRECISION DETS
      DOUBLE PRECISION EPS
      DOUBLE PRECISION FPAR(*)
      INTEGER   I
      INTEGER   IERROR
      INTEGER   IPAR(*)
      INTEGER   IPC
      INTEGER   IDAMAX
      INTEGER   IWORK(LIW)
      INTEGER   J
      INTEGER   JAC
      INTEGER   JACK
      INTEGER   JOB
      INTEGER   JOB2 
      INTEGER   K
      INTEGER   LDF
      INTEGER   LFXM
      INTEGER   LFXP
      INTEGER   LILST
      INTEGER   LOUNIT
      INTEGER   LPIV
      INTEGER   LRLST
      INTEGER   NDIM
      DOUBLE PRECISION RWORK(LRW)
      DOUBLE PRECISION SKALE
      DOUBLE PRECISION X(NVAR)
      DOUBLE PRECISION Y(NVAR)
C
C  CHECK INPUT VALUES OF NVAR, AND IPC.
C  DEPENDING ON VALUE OF JOB, EITHER SET UP
C  AUGMENTED JACOBIAN, DECOMPOSE INTO L-U FACTORS, AND GET DETERMINANT,
C  OR USE CURRENT FACTORED JACOBIAN WITH NEW RIGHT HAND SIDE.
C
      LOUNIT=IWORK(8)
      IERROR=0
      LPIV=IWORK(13)
      LDF=IWORK(15)
      LILST=LPIV+NVAR-1
      JAC=IWORK(9)
      IF(JAC.NE.0.AND.JOB.EQ.3)THEN
        IERROR=4
        WRITE(LOUNIT,*)'DENSLV - Error!  Jacobian check requested'
        WRITE(LOUNIT,*)'         but no user Jacobian routine.'
        RETURN
        ENDIF
      IF(JAC.EQ.0.AND.JOB.NE.3)THEN
        LRLST=LDF-1+NVAR*NVAR
      ELSE
        LFXP=LDF+NVAR*NVAR
        LFXM=LFXP+NVAR
        LRLST=LDF-1+NVAR*NVAR+2*NVAR
        ENDIF
      IF((LILST.GT.LIW).OR.(LRLST.GT.LRW))THEN
        IERROR=1
        WRITE(LOUNIT,1040)LILST,LIW
        WRITE(LOUNIT,1050)LRLST,LRW
        RETURN
        ENDIF
      IF(JOB.EQ.1)GO TO 10
C
C  IF JOB IS 0 OR 2, THEN WE MUST EVALUATE THE JACOBIAN, USING THE USER
C  ROUTINE OR FINITE DIFFERENCES, AND THEN FACTOR IT AND GET THE
C  SIGN OF THE DETERMINANT.
C
      NDIM=NVAR*NVAR
      DO 5 I=1,NDIM
        RWORK(LDF+I-1)=ZERO
5       CONTINUE
      IF(JAC.EQ.0)THEN
        CALL DF(NVAR,FPAR,IPAR,X,RWORK(LDF),IERROR)
        IWORK(19)=IWORK(19)+1
        RWORK(LDF+IPC*NVAR-1)=ONE
        ENDIF
      IF(JOB.EQ.3)THEN
        SKALE=-ONE
        CALL DSCAL(NDIM,SKALE,RWORK(LDF),1)
        ENDIF
      IF(JAC.EQ.1.OR.JAC.EQ.2.OR.JOB.EQ.3)THEN
        JACK=JAC
        IF(JOB.EQ.3)JACK=2
        EPS=SQRT(SQRT(RWORK(8)))
        CALL DENJAC(EPS,FPAR,RWORK(LDF),FX,IERROR,IPAR,IPC,IWORK,
     *  JACK,LIW,LOUNIT,NVAR,X,RWORK(LFXP),RWORK(LFXM))
        ENDIF
      IF(IERROR.NE.0)RETURN
C
C  If JOB=3, print out largest entry of matrix.
C
      IF(JOB.EQ.3)THEN
        K=IDAMAX(NDIM,RWORK(LDF),1)
        I=MOD(K-1,NVAR)+1
        J=(K-I)/NVAR+1
        WRITE(LOUNIT,1070)RWORK(LDF+K-1),I,J
        IF(IWORK(1).EQ.(-2))THEN
          WRITE(LOUNIT,*)' '
          WRITE(LOUNIT,*)'DENSLV - Entire difference matrix:'
          WRITE(LOUNIT,*)' '
          DO 99 I=1,NVAR
            DO 98 J=1,NVAR
              K=LDF+(J-1)*NVAR+I-1
              WRITE(LOUNIT,1080)RWORK(K),I,J
98            CONTINUE
            WRITE(LOUNIT,*)' '
99          CONTINUE
          ENDIF
        RETURN
        ENDIF
C
C  DECOMPOSE MATRIX
C
      CALL DGEFA(RWORK(LDF),NVAR,NVAR,IWORK(LPIV),IERROR)
      IWORK(20)=IWORK(20)+1
      IF(IERROR.NE.0)THEN
        WRITE(LOUNIT,1492)IERROR
        IERROR=3
        RETURN
        ENDIF
C
C  COMPUTE DETERMINANT
C
      JOB2=10
      CALL DGEDI(RWORK(LDF),NVAR,NVAR,IWORK(LPIV),DET,Y,JOB2)
C
C  RECORD THE SIGN OF THE DETERMINANT
C
      DETS=ZERO
      IF(DET(1).GT.ZERO)THEN
        DETS=ONE
      ELSEIF(DET(1).LT.ZERO)THEN
        DETS=-ONE
        ENDIF
      IF(JOB.EQ.2)RETURN
C
C  USING L-U FACTORED MATRIX, SOLVE SYSTEM USING FORWARD-BACKWARD
C  ELIMINATION, AND OVERWRITE RIGHT HAND SIDE WITH SOLUTION
C
10    CONTINUE
      CALL DGESL(RWORK(LDF),NVAR,NVAR,IWORK(LPIV),Y,0)
      IWORK(21)=IWORK(21)+1
      RETURN
1040  FORMAT(' DENSLV - Need LIW=',I6,', have LIW=',I6)
1050  FORMAT(' DENSLV - Need LRW=',I6,', have LRW=',I6)
1070  FORMAT(' DENSLV - Maximum difference between user and estimated'/
     *       '          jacobian is ',G14.6,' row ',I6,' column ',I6)
1080  FORMAT(1X,G14.6,' =FP(I,J)-DELF(I,J), I, J=',2I6)
1492  FORMAT(' DENSLV - Zero pivot, DGEFA returns INFO=',I6)
      END
      SUBROUTINE DENJAC(EPS,FPAR,FPRIME,FX,IERROR,IPAR,IPC,IWORK,
     * JAC,LIW,LOUNIT,NVAR,X,WORK1,WORK2)
C
C************************************************************************
C
C  DENJAC ESTIMATES THE JACOBIAN FPRIME OF THE FUNCTION FX ASSUMING
C  THAT FULL (DENSE) STORAGE IS USED.  IT IS CALLED AUTOMATICALLY
C  BY DENSLV WHEN JAC=1 OR 2.
C
C  EPS    - A TOLERANCE TO USE FOR SHIFTING THE X VALUES.  
C           EPS=SQRT(MACHINE EPSILON) FOR THE VAX, OR
C           EPS=SQRT(SQRT(MACHINE EPSILON)) FOR THE PC 
C           HAVE BEEN FOUND SUITABLE.
C
C  FPAR   - USER REAL PARAMETER VECTOR, PASSED TO FX BUT NOT OTHERWISE
C           REFERENCED.
C
C  FPRIME - REAL(NVAR,NVAR), THE ARRAY INTO WHICH THE JACOBIAN WILL
C           BE STORED, INCLUDING THE LAST AUXILLIARY ROW.
C
C  FX     - EXTERNAL NAME OF USER ROUTINE DEFINING FUNCTION, OF THE
C           FORM SUBROUTINE FX(NVAR,FPAR,IPAR,X,F,IERROR).
C
C  IERROR - ERROR RETURN FLAG.  IERROR NONZERO MEANS THERE WAS A PROBLEM
C           IN THE USER ROUTINE FX OR IN DENJAC.
C
C  IPAR   - USER INTEGER PARAMETER VECTOR, PASSED TO FX BUT NOT OTHERWISE
C           REFERENCED.
C
C  IPC    - INDEX OF CURRENT CONTINUATION PARAMETER, DETERMINES FORM OF
C           LAST ROW OF JACOBIAN.
C
C  IWORK  - INTEGER WORK VECTOR OF DIMENSION LIW.  ONLY REQUIRED IN ORDER
C           TO UPDATE IWORK(22), WHICH COUNTS FUNCTION EVALUATIONS.
C
C  JAC    - USER DEFINED JACOBIAN OPTION.  0 MEANS USER SUPPLIES JACOBIAN.
C           1 MEANS USE FORWARD, 2 MEANS USE CENTRAL DIFFERENCES TO
C           ESTIMATE JACOBIAN FROM FX.
C
C  LIW    - DIMENSION OF IWORK.
C
C  LOUNIT - OUTPUT UNIT.
C
C  NVAR   - DIMENSION OF X, FPRIME, WORK1, WORK2.  THE NUMBER OF VARIABLES.
C
C  X      - POINT AT WHICH JACOBIAN IS TO BE ESTIMATED.
C
C  WORK1  - WORK VECTOR OF DIMENSION NVAR.
C
C  WORK2  - WORK VECTOR OF DIMENSION NVAR.
C
      DOUBLE PRECISION ONE
      DOUBLE PRECISION ZERO
C
      PARAMETER (ONE=1.0)
      PARAMETER (ZERO=0.0)
C
      EXTERNAL  FX
      EXTERNAL  DAXPY
      EXTERNAL  DSCAL
C
      INTRINSIC ABS
C
      INTEGER   LIW
      INTEGER   NVAR
C
      DOUBLE PRECISION DELM
      DOUBLE PRECISION DELP
      DOUBLE PRECISION EPS
      DOUBLE PRECISION FPAR(*)
      DOUBLE PRECISION FPRIME(NVAR,NVAR)
      INTEGER   IPAR(*)
      INTEGER   IERROR
      INTEGER   IPC
      INTEGER   IWORK(LIW)
      INTEGER   J
      INTEGER   JAC
      INTEGER   LOUNIT
      DOUBLE PRECISION SKALE
      DOUBLE PRECISION X(NVAR)
      DOUBLE PRECISION XSAVE
      DOUBLE PRECISION WORK1(NVAR)
      DOUBLE PRECISION WORK2(NVAR)
C
      IF(JAC.EQ.1)THEN
        CALL FX(NVAR,FPAR,IPAR,X,WORK2,IERROR)
        DELM=ZERO
        IWORK(22)=IWORK(22)+1
        IF(IERROR.NE.0)RETURN
        ENDIF
C
      DO 20 J=1,NVAR
        XSAVE=X(J)
        DELP=EPS*(ONE+ABS(X(J)))
        X(J)=X(J)+DELP
        CALL FX(NVAR,FPAR,IPAR,X,WORK1,IERROR)
        IWORK(22)=IWORK(22)+1
        IF(IERROR.NE.0)RETURN
        IF(JAC.EQ.2)THEN
          DELM=-DELP
          X(J)=XSAVE+DELM
          CALL FX(NVAR,FPAR,IPAR,X,WORK2,IERROR)
          IWORK(22)=IWORK(22)+1
          IF(IERROR.NE.0)RETURN
          ENDIF
        X(J)=XSAVE
C
C  Compute DFDX(*,J)= (F(X+)-F(X-))/DELX.
C  Note that we contrive to ADD this quantity to DFDX,
C  This makes it possible to use this routine also to check
C  the accuracy of the user's jacobian routine.
C
        SKALE=-ONE
        CALL DAXPY(NVAR-1,SKALE,WORK2,1,WORK1,1)
        SKALE=ONE/(DELP-DELM)
        CALL DSCAL(NVAR-1,SKALE,WORK1,1)
        SKALE=ONE
        CALL DAXPY(NVAR-1,SKALE,WORK1,1,FPRIME(1,J),1)
20      CONTINUE
C
      FPRIME(NVAR,IPC)=FPRIME(NVAR,IPC)+ONE
      RETURN
      END
      SUBROUTINE BANSLV(DETS,FX,DF,FPAR,IERROR,IPC,IPAR,IWORK,LIW,
     1 JOB,NVAR,RWORK,LRW,X,Y)
C
C***********************************************************************
C
C  BANSLV SOLVES A LINEAR SYSTEM OF THE FORM
C
C  ( DFDY  DFDZ )
C  (            ) * X=B
C  (   E(IPC)   )
C
C  WHERE DFDY IS FORMALLY AN (NVAR-1) BY (NVAR-1) MATRIX WHICH IS
C  TO BE STORED IN LINPACK GENERAL BAND STORAGE, DFDZ IS A COLUMN
C  VECTOR, AND E(IPC) IS AN NVAR-DIMENSIONAL ROW VECTOR WHICH IS 0
C  EXCEPT FOR A 1 IN THE IPC-TH POSITION.  IT IS ASSUMED THAT THE
C  FULL MATRIX ABOVE REPRESENTS THE JACOBIAN OF A SET OF NONLINEAR
C  EQUATIONS, WITH THE LAST EQUATION BEING X(IPC)=CONSTANT.
C
C  THE PURPOSE OF THIS ROUTINE IS TO SOLVE THE FULL SYSTEM, WHILE
C  TAKING ADVANTAGE OF SPECIAL PROPERTIES OF THE (NVAR-1) SUBSYSTEM
C  (IN THIS CASE BANDEDNESS), WHICH WOULD BE LOST IF THE FULL
C  SYSTEM WAS SOLVED DIRECTLY.
C
C  SEE THE PAPER BY CHAN LISTED ABOVE FOR DETAILS.
C
C  SUBROUTINE ARGUMENTS
C
C  DETS   - THE SIGN OF THE DETERMINANT OF THE FULL MATRIX.
C
C  FX     - AN EXTERNAL ROUTINE, THE NAME OF THE USER SUPPLIED
C           SUBROUTINE WHICH COMPUTES THE NVAR-1 DIMENSIONAL
C           FUNCTION.
C
C  DF     - AN EXTERNAL ROUTINE, THE NAME OF THE USER SUPPLIED
C           SUBROUTINE WHICH COMPUTES THE JACOBIAN OF THE NVAR-1
C           NONLINEAR FUNCTIONS.  THE LAST, AUGMENTING FUNCTION,
C           IS HANDLED BY THIS ROUTINE.  BECAUSE OF THE SPECIAL
C           STORAGE ARRANGEMENTS, GREAT CARE MUST BE TAKEN TO
C           STORE INFORMATION PROPERLY.
C
C           LET MU AND ML BE THE UPRER AND LOWER BANDWIDTHS.
C           THESE VALUES MUST BE STORED IN IPAR(*) AND IPAR(2),
C           RESPECTIVELY. SET NBAND=2*ML+MU+1.
C           THE INDEX K OF RWORK IN WHICH WE ARE TO STORE THE
C           (I,J) ENTRY OF THE JACOBIAN IS DETERMINED AS FOLLOWS:
C
C           IF(J.EQ.NVAR) K=(NVAR-1)*NBAND+I
C
C           OTHERWISE
C
C           IF((J-I.LE.ML).AND.(I-J.LE.MU)) K=I+J*(NBAND-1)-ML
C
C           FOR ALL OTHER VALUES OF I AND J THE ENTRY IS ZERO AND
C           NOT STORED.
C
C           THE FORM OF THE CALLING SEQUENCE OF DF IS
C           SUBROUTINE DF(NVAR,FPAR,IPAR,X,RWORK,IERR)
C           DIMENSION FPAR(*),IPAR(*),X(NVAR),RWORK(1)
C
C           SET IERR NONZERO IF EXECUTION IS TO BE HALTED FOR ANY REASON
C
C  FPAR   - A REAL ARRAY FOR TRANSMISSION OF PARAMETERS FROM THE
C           USER CALLING PROGRAM THROUGH THE CONTINUATION CODE TO
C           USER SUBROUTINES.  THE CONTINUATION CODE ASSUMES A
C           DIMENSION OF 1 FOR FPAR, AND NEVER ACCESSES ANY ENTRIES.
C
C  IERROR - ERROR RETURN FLAG.
C           IERROR= 0, NO ERRORS DETECTED.
C           IERROR= 1, DATA OR STORAGE ERROR.
C                      ILLEGAL VALUES OF NVAR, IPC, MU, ML, OR
C                      INSUFFICIENT STORAGE IN RWORK OR IWORK.
C           IERROR= 2, ERROR RETURN FROM DF.
C                      THE USER ROUTINE DF HAS SET AN ERROR FLAG.
C           IERROR= 3, NUMERICALLY SINGULAR MATRIX DETECTED.
C                      EITHER THE SUBMATRIX AS MODIFIED BY THIS
C                      ROUTINE IS SINGULAR, AND THE DECOMPOSITION
C                      OR THE CHOICE OF IPC IS INAPPROPRIATE,
C                      OR THE FULL SYSTEM MAY ACTUALLY BE SINGULAR.
C
C  IPC    - AN INDEX DETERMINED BY THE CONTINUATION CODE, WHICH
C           DEFINES THE AUGMENTING EQUATION, AND HENCE THE FORM
C           OF THE AUGMENTING ROW OF THE JACOBIAN.  THE FULL
C           ALGORITHM EMPLOYED HERE IS REALLY ONLY REQUIRED
C           WHEN IPC IS NOT EQUAL TO NVAR.  OTHERWISE, THE SOLUTION
C           IS QUITE EASY.
C
C  IPAR   - AN INTEGER ARRAY SIMILAR TO RPAR, EXCEPT THAT LOCATIONS
C           1 AND 2 OF IPAR ARE REFERENCED BY BANSLV.  IPAR(*)=ML,
C           THE LOWER BANDWIDTH OF THE JACOBIAN, AND IPAR(2)=MU,
C           THE UPPER BANDWIDTH.
C
C  IWORK  - AN INTEGER WORK ARRAY, USED BY THE CONTINUATION CODE
C           TO STORE STATISTICS, POINTERS, AND THE PIVOT VECTOR.
C           NOTE THAT IWORK(13) STORES THE FIRST ENTRY IN IWORK
C           DEVOTED TO THE PIVOT VECTOR, IWORK(15) STORES THE
C           FIRST ELEMENT OF RWORK DEVOTED TO THE JACOBIAN SUBSYSTEM.
C           IWORK(20) COUNTS MATRIX FACTORIZATIONS, AND IWORK(21)
C           COUNTS BACK-SOLVES.
C
C  LIW    - DIMENSION OF IWORK IN THE CALLING PROGRAM.
C
C  JOB    - WORK CONTROL SWITCH.
C           JOB=0, DECOMPOSE MATRIX, GET DETERMINANT, SOLVE SYSTEM.
C           JOB=1, SOLVE A NEW SYSTEM WITH SAME OLD MATRIX.
C           JOB=2, DECOMPOSE, COMPUTE DETERMINANT.
C           3, Check jacobian matrix.  Call user jacobian routine,
C           multiply by -1.0, add finite difference jacobian,
C           print largest entry.
C
C  NVAR   - THE NUMBER OF VARIABLES X, THE FORMAL DIMENSION OF
C           THE FULL LINEAR SYSTEM.
C
C  RWORK  - A REAL ARRAY USED FOR STORING THE MATRIX AND THE TWO
C           AUXILIARY VECTORS NEEDED.
C
C  LRW    - THE DIMENSION OF RWORK IN THE CALLING PROGRAM.
C
C  X      - A REAL VECTOR OF LENGTH NVAR, THE POINT AT WHICH
C           THE FULL LINEAR SYSTEM IS TO BE EVALUATED.
C
C  Y      - A REAL VECTOR OF LENGTH NVAR, WHICH ON INPUT IS
C           THE RIGHT HAND SIDE OF THE LINEAR SYSTEM TO BE SOLVED,
C           AND ON SUCCESSFUL RETURN WITH IERROR=0, IS THE
C           SOLUTION OF THAT LINEAR SYSTEM.
C
C
      DOUBLE PRECISION ONE
      DOUBLE PRECISION ZERO
C
      PARAMETER (ONE=1.0)
      PARAMETER (ZERO=0.0)
C
      EXTERNAL  BANJAC
      EXTERNAL  DF
      EXTERNAL  FX
      EXTERNAL  IDAMAX
      EXTERNAL  DAXPY
      EXTERNAL  DDOT
      EXTERNAL  DGBDI
      EXTERNAL  DGBFA
      EXTERNAL  DGBSL
      EXTERNAL  DSCAL
      EXTERNAL  DSWAP
C
      INTRINSIC MAX
      INTRINSIC MIN
      INTRINSIC SQRT
C
      INTEGER   LIW
      INTEGER   LRW
      INTEGER   NVAR
C
      DOUBLE PRECISION AK
      DOUBLE PRECISION DET(2)
      DOUBLE PRECISION DETS
      DOUBLE PRECISION EPS
      DOUBLE PRECISION FPAR(*)
      INTEGER   I
      INTEGER   IERROR
      INTEGER   IPAR(*)
      INTEGER   IPC
      INTEGER   IRL
      INTEGER   IRU
      INTEGER   IDAMAX
      INTEGER   ITEMP
      INTEGER   IWORK(LIW)
      INTEGER   J
      INTEGER   JAC
      INTEGER   JACK
      INTEGER   JOB
      INTEGER   JTEMP
      INTEGER   K
      INTEGER   LDFL
      INTEGER   LDFX
      INTEGER   LDX
      INTEGER   LFXM
      INTEGER   LFXP
      INTEGER   LILST
      INTEGER   LOUNIT
      INTEGER   LPIV
      INTEGER   LRLST
      INTEGER   LROWIP
      INTEGER   MBAND
      INTEGER   ML
      INTEGER   MU
      INTEGER   NBAND
      INTEGER   NDIM
      INTEGER   NEQN
      INTEGER   NSWAP
      DOUBLE PRECISION RWORK(LRW)
      DOUBLE PRECISION DDOT
      DOUBLE PRECISION SKALE
      DOUBLE PRECISION TEMP
      DOUBLE PRECISION X(NVAR)
      DOUBLE PRECISION Y(NVAR)
C
C  CHECK INPUT DATA
C
      IERROR=0
      LOUNIT=IWORK(8)
      ML=IPAR(1)
      MU=IPAR(2)
      NEQN=NVAR-1
      IF(ML.LT.0.OR.ML.GT.NEQN)THEN
        IERROR=1
        WRITE(LOUNIT,1020)ML
        RETURN
        ENDIF
      IF(MU.LT.0.OR.MU.GT.NEQN)THEN
        IERROR=1
        WRITE(LOUNIT,1030)MU
        RETURN
        ENDIF
      MBAND=ML+MU+1
      NBAND=MBAND+ML
      LPIV=IWORK(13)
      LILST=LPIV+NEQN-1
      LDFX=IWORK(15)
      LDFL=LDFX+NBAND*NEQN
      LROWIP=LDFL+NVAR
      JAC=IWORK(9)
      IF(JAC.EQ.0.AND.JOB.NE.3)THEN
        LRLST=LROWIP+NVAR-1
      ELSE
        LFXP=LROWIP+NVAR
        LFXM=LFXP+NVAR
        LDX=LFXM+NVAR
        LRLST=LDX+NVAR-1
        ENDIF
      NDIM=NEQN*NBAND+NVAR+NVAR-1
      IF(LILST.GT.LIW.OR.LRLST.GT.LRW)THEN
        WRITE(LOUNIT,1040)LILST,LIW
        WRITE(LOUNIT,1050)LRLST,LRW
        IERROR=1
        RETURN
        ENDIF
      IF(JOB.EQ.1)THEN
        IF(IPC.EQ.NVAR)THEN
          GO TO 70
        ELSE
          GO TO 40
        ENDIF
      ENDIF
C
C  JOB=0 OR 2 MEANS WE MUST EVALUATE THE JACOBIAN, EITHER WITH THE USER'S
C  ROUTINE OR BY FINITE DIFFERENCES, FACTOR IT AND GET THE SIGN
C  OF THE DETERMINANT
C
      DO 10 I=1,NDIM
        RWORK(LDFX+I-1)=ZERO
10      CONTINUE
      IF(JAC.EQ.0)THEN
        CALL DF(NVAR,FPAR,IPAR,X,RWORK(LDFX),IERROR)
        IWORK(19)=IWORK(19)+1
        IF(IERROR.NE.0)RETURN
        RWORK(LROWIP-1+IPC)=ONE
        ENDIF
      IF(JOB.EQ.3)THEN
        SKALE=-ONE
        CALL DSCAL(NDIM,SKALE,RWORK(LDFX),1)
        ENDIF
      IF(JAC.EQ.1.OR.JAC.EQ.2.OR.JOB.EQ.3)THEN
        JACK=JAC
        IF(JOB.EQ.3)JACK=2
        EPS=SQRT(SQRT(RWORK(8)))
        CALL BANJAC(EPS,RWORK(LDFL),FPAR,RWORK(LDFX),RWORK(LROWIP),
     *  FX,IERROR,IPAR,IPC,IWORK,JACK,LIW,LOUNIT,NBAND,NEQN,NVAR,X,
     *  RWORK(LDX),RWORK(LFXP),RWORK(LFXM))
        ENDIF
C
C  Figure out formulas for I and J
C
      IF(JOB.EQ.3)THEN
        K=IDAMAX(NDIM,RWORK(LDFX),1)
        AK=RWORK(LDFX+K-1)
        IF(K.LE.NEQN*NBAND)THEN
          J=((K-1)/NBAND)+1
          I=K-(J-1)*NBAND+J-ML-MU-1
        ELSEIF(K.LE.NEQN*NBAND+NEQN)THEN
          I=K-NEQN*NBAND
          J=NVAR
        ELSE
          I=NVAR
          J=K-NEQN*NBAND-NEQN
          ENDIF
        WRITE(LOUNIT,1070)AK,I,J
        IF(IWORK(1).EQ.-2)THEN
          WRITE(LOUNIT,*)' '
          WRITE(LOUNIT,*)'BANSLV - Entire difference matrix:'
          WRITE(LOUNIT,*)' '
          DO 99 I=1,NVAR
            DO 98 J=1,NVAR
              IF(J.EQ.NVAR)THEN
                K=LDFX-1+(NVAR-1)*NBAND+I
                WRITE(LOUNIT,1080)RWORK(K),I,J
              ELSEIF((J-I.LE.ML).AND.(I-J.LE.MU))THEN
                K=LDFX-1+I+J*(NBAND-1)-ML
                WRITE(LOUNIT,1080)RWORK(K),I,J
                ENDIF
98            CONTINUE
            WRITE(LOUNIT,*)' '
99          CONTINUE
          ENDIF
        RETURN
        ENDIF
      IF(IPC.EQ.NVAR)GO TO 60
C
C  SWITCH THE NVAR-TH AND IPC-TH ROWS.
C
      IRL=MAX(1,IPC-ML)
      IRU=MIN(NEQN,IPC+MU)
      NSWAP=IRU+1-IRL
      ITEMP=LDFX-ML-1+IPC+IRL*(NBAND-1)
      JTEMP=NBAND-1
      CALL DSWAP(NSWAP,RWORK(LROWIP-1+IRL),1,RWORK(ITEMP),JTEMP)
C
C  DECOMPOSE THE SUBMATRIX AND OBTAIN DETERMINANT SIGN
C
      CALL DGBFA(RWORK(LDFX),NBAND,NEQN,ML,MU,IWORK(LPIV),IERROR)
      IWORK(20)=IWORK(20)+1
      IF(IERROR.NE.0)THEN
        WRITE(LOUNIT,1000)IERROR,IPC
        IERROR=3
        RETURN
        ENDIF
      CALL DGBDI(RWORK(LDFX),NBAND,NEQN,ML,MU,IWORK(LPIV),DET)
      DETS=ZERO
      IF(DET(1).GT.ZERO)THEN
        DETS=-ONE
      ELSEIF(DET(1).LT.ZERO)THEN
        DETS=ONE
        ENDIF
C
C  SET THE RIGHT HAND SIDE OF THE AUXILLIARY SYSTEM TO
C  THE LAST COLUMN OF THE JACOBIAN, MINUS E(IPC).  SHUFFLE THE
C  IPC-TH AND NVAR-TH ENTRIES OF THIS RIGHT HAND SIDE
C  TO REFLECT THE PIVOTING OF THE EQUATIONS, THEN SOLVE.
C
      TEMP=RWORK(LDFL+IPC-1)-ONE
      RWORK(LDFL+IPC-1)=RWORK(LDFL+NVAR-1)
      RWORK(LDFL+NVAR-1)=TEMP
      CALL DGBSL(RWORK(LDFX),NBAND,NEQN,ML,MU,IWORK(LPIV),RWORK(LDFL)
     * ,0)
      IWORK(21)=IWORK(21)+1
C
C  SOLVE FOR LAST ENTRY OF AUXILLIARY SOLUTION
C
      RWORK(LDFL+NVAR-1)=RWORK(LDFL+NVAR-1)
     * -DDOT(NEQN,RWORK(LROWIP),1,RWORK(LDFL),1)
C
C  ADJUST DETERMINANT SIGN
C
      IF(ONE+RWORK(LDFL+NVAR-1).EQ.ZERO)THEN
        IERROR=3
        WRITE(LOUNIT,*)'BANSLV - Algorithm fails, DENOM=0.0'
        RETURN
        ENDIF
      IF(ONE+RWORK(LDFL+NVAR-1).LT.ZERO)DETS=-DETS
      IF(JOB.EQ.2)RETURN
C
C  SOLVE SYSTEM
C
40    CONTINUE
      IF(IPC.EQ.NVAR)GO TO 70
C
C  MODIFY RIGHT HAND SIDE OF MAIN SYSTEM
C
      TEMP=Y(IPC)
      Y(IPC)=Y(NVAR)
      Y(NVAR)=TEMP
C
C  SOLVE SUBSYSTEM
C
      CALL DGBSL(RWORK(LDFX),NBAND,NEQN,ML,MU,IWORK(LPIV),Y,0)
      IWORK(21)=IWORK(21)+1
C
C  SOLVE FOR LAST ENTRY OF MAIN SOLUTION
C
      Y(NVAR)=Y(NVAR)-DDOT(NEQN,RWORK(LROWIP),1,Y,1)
C
C  CORRECT MAIN SOLUTION WITH MULTIPLE OF SUBSOLUTION
C
      SKALE=-Y(NVAR)/(ONE+RWORK(LDFL+NVAR-1))
      CALL DAXPY(NVAR,SKALE,RWORK(LDFL),1,Y,1)
      RETURN
C
C  FACTOR MATRIX FOR THE SPECIAL CASE IPC=NVAR
C
   60 CONTINUE
      CALL DGBFA(RWORK(LDFX),NBAND,NEQN,ML,MU,IWORK(LPIV),IERROR)
      IWORK(20)=IWORK(20)+1
      IF(IERROR.NE.0)THEN
        WRITE(LOUNIT,1000)IERROR,IPC
        IERROR=3
        RETURN
        ENDIF
      CALL DGBDI(RWORK(LDFX),NBAND,NEQN,ML,MU,IWORK(LPIV),DET)
      DETS=ZERO
      IF(DET(1).LT.ZERO)THEN
        DETS=-ONE
      ELSEIF(DET(1).GT.ZERO)THEN
        DETS=ONE
        ENDIF
      IF(JOB.EQ.2)RETURN
C
C  SOLVE SYSTEM, FOR SPECIAL CASE IPC=NVAR
C
   70 CONTINUE
      SKALE=-Y(NVAR)
      CALL DAXPY(NEQN,SKALE,RWORK(LDFL),1,Y,1)
      CALL DGBSL(RWORK(LDFX),NBAND,NEQN,ML,MU,IWORK(LPIV),Y,0)
      IWORK(21)=IWORK(21)+1
      RETURN
1000  FORMAT(' BANSLV - Zero pivot, DGBFA returns INFO=',I6,' IPC=',I6)
1020  FORMAT(' BANSLV - Illegal ML=',I6)
1030  FORMAT(' BANSLV - Illegal MU=',I6)
1040  FORMAT(' BANSLV - Need LIW=',I6,', have LIW=',I6)
1050  FORMAT(' BANSLV - Need LRW=',I6,', have LRW=',I6)
1070  FORMAT(' BANSLV - Maximum difference between user and estimated'/
     *       '          jacobian is ',G14.6,' row ',I6,' column ',I6)
1080  FORMAT(1X,G14.6,' =FP(I,J)-DELF(I,J), I, J=',2I6)
      END
      SUBROUTINE BANJAC(EPS,FCOL,FPAR,FPRIME,FROW,FX,IERROR,IPAR,IPC,
     * IWORK,JAC,LIW,LOUNIT,NBAND,NEQN,NVAR,X,XTEMP,WORK1,WORK2)
C
C**********************************************************************
C
C  BANJAC estimates the jacobian matrix FPRIME of the function FX, 
C  using forward or central finite differences.  BANJAC is called by 
C  BANSLV when the user has specified the jacobian option as 1 or 2.
C
C  EPS    Input, a tolerance used for shifting the X values.  A value
C         of the square root of the machine precision is usually
C         appropriate.
C
C  FCOL   Output, REAL FCOL(NEQN), the last column of the approximate 
C         jacobian, which is allowed to be "full".  This comprises
C         matrix entries FPRIME(1,NVAR) through FPRIME(NEQN,NVAR).
C
C  FPAR   Input/output, REAL FPAR(*), user parameter vector, not
C         touched by this routine, but passed on to user routines.
C
C  FPRIME Output, REAL FPRIME(NBAND,NEQN), is the array into which the
C         the banded portion of the computed jacobian will be stored.
C         The LINPACK general band format is used, assigning entry (I,J)
C         to FPRIME(I-J+ML+MU+1,J), where ML and MU are the lower and
C         upper half bandwidths respectively.
C
C  FROW   Output, REAL FROW(NVAR), storage for the last (augmenting) row
C         of the jacobian, which will be all zero except for a 1 in
C         location IPC.
C
C  FX     Input, EXTERNAL FX, the name of the routine which evaluates the 
C         function.
C
C         FX computes the value of the nonlinear function.  This name must be 
C         declared EXTERNAL in the calling program.  FX should evaluate the 
C         NVAR-1 function components at the input point X, and store the result 
C         in the vector FVEC.  An augmenting equation will be stored in entry 
C         NVAR of FVEC by the PITCON program.
C
C         FX should have the following form:
C
C           SUBROUTINE FX(NVAR,FPAR,IPAR,X,FVEC,IERROR)
C
C           NVAR   Input, INTEGER NVAR, number of variables.
C
C           FPAR   Input/output, REAL FPAR(*), array of user parameters.
C
C           IPAR   Input/output, INTEGER IPAR(*), array of user parameters.
C
C           X      Input, REAL X(NVAR), the point at which function evaluation
C                  is required.
C
C           FVEC   Output, REAL FVEC(NVAR), the value of the function at point 
C                  X.  Only the first NVAR-1 entries of FVEC are to be set by 
C                  the routine.  PITCON sets the final value itself.
C 
C           IERROR Output, INTEGER IERROR, error flag.  FX should set this to 0 
C                  if there are no problems, or to 2 if there is a problem.
C
C  IERROR Output, INTEGER IERROR, error flag.  A nonzero value means that
C         there was an error in the user routine FX, or in BANJAC itself.
C         In either case, the jacobian has not been computed.
C
C  IPAR   Input, INTEGER IPAR(*), a user parameter vector passed to FX.  
C         However, because this is a problem with a banded jacobian, entries
C         IPAR(1) and IPAR(2) are read by this routine.  IPAR(1) contains
C         ML, the lower half bandwidth of the jacobian, and IPAR(2) contains
C         MU, the upper half bandwidth of the jacobian.
C
C  IPC    Input, INTEGER IPC, the index of the current continuation parameter,
C         which is needed to determine the form of FROW.
C
C  IWORK  Input, INTEGER IWORK(LIW), work and statistics vector.  Only
C         required here so that we can count the number of function
C         evaluations.
C
C  JAC    Input, INTEGER JAC, the user requested jacobian option.  For
C         our purposes, the only two values of interest are:
C
C           1 = estimate jacobian with forward differences,
C           2 = estimate jacobian with central differences (twice the work)
C
C  LIW    Input, INTEGER LIW, the dimension of IWORK.
C
C  LOUNIT Input, INTEGER LOUNIT, the FORTRAN output unit for messages.
C
C  NBAND  Input, INTEGER NBAND, the first dimension of the jacobian matrix
C         FPRIME, NBAND=ML+MU+1.
C
C  NEQN   Input, INTEGER NEQN, the number of equations, equal to NVAR-1.
C
C  NVAR   Input, INTEGER NVAR, the number of variables.
C
C  X      Input, REAL X(NVAR), the point at which the jacobian is desired.
C
C  XTEMP,
C  WORK1,
C  WORK2  Work arrays, REAL XTEMP(NVAR), WORK1(NVAR), WORK2(NVAR).
C
      DOUBLE PRECISION ONE
      DOUBLE PRECISION TWO
C
      PARAMETER (ONE=1.0)
      PARAMETER (TWO=2.0)
C
      EXTERNAL  FX
      EXTERNAL  DAXPY
      EXTERNAL  DCOPY
      EXTERNAL  DSCAL
C
      INTRINSIC ABS
      INTRINSIC MAX
      INTRINSIC MIN
C
      INTEGER   LIW
      INTEGER   NBAND
      INTEGER   NEQN
      INTEGER   NVAR
C
      DOUBLE PRECISION EPS
      DOUBLE PRECISION FCOL(NEQN)
      DOUBLE PRECISION FPAR(*)
      DOUBLE PRECISION FPRIME(NBAND,NEQN)
      DOUBLE PRECISION FROW(NVAR)
      INTEGER   IBAND
      INTEGER   IERROR
      INTEGER   IHI
      INTEGER   ILO
      INTEGER   IPAR(2)
      INTEGER   IPC
      INTEGER   IROW
      INTEGER   IWORK(LIW)
      INTEGER   J
      INTEGER   JAC
      INTEGER   KCALL
      INTEGER   LOUNIT
      INTEGER   MBAND
      INTEGER   ML
      INTEGER   MU
      DOUBLE PRECISION SKALE
      DOUBLE PRECISION X(NVAR)
      DOUBLE PRECISION XJAC
      DOUBLE PRECISION XTEMP(NVAR)
      DOUBLE PRECISION WORK1(NVAR)
      DOUBLE PRECISION WORK2(NVAR)
C
      ML=IPAR(1)
      MU=IPAR(2)
      MBAND=ML+MU+1
      IF(JAC.EQ.1)THEN
        CALL FX(NVAR,FPAR,IPAR,X,WORK2,IERROR)
        IWORK(22)=IWORK(22)+1
        IF(IERROR.NE.0)RETURN
        ENDIF
      XJAC=ONE
      IF(JAC.EQ.2)XJAC=TWO
      DO 40 KCALL=1,MBAND
        CALL DCOPY(NVAR,X,1,XTEMP,1)
        DO 10 J=KCALL,NEQN,MBAND
          XTEMP(J)=X(J)+EPS*(ONE+ABS(X(J)))
10        CONTINUE
        CALL FX(NVAR,FPAR,IPAR,XTEMP,WORK1,IERROR)
        IWORK(22)=IWORK(22)+1
        IF(IERROR.NE.0)RETURN
        IF(JAC.EQ.2)THEN
          CALL DCOPY(NVAR,X,1,XTEMP,1)
          DO 20 J=KCALL,NEQN,MBAND
            XTEMP(J)=X(J)-EPS*(ONE+ABS(X(J)))
20          CONTINUE
          CALL FX(NVAR,FPAR,IPAR,XTEMP,WORK2,IERROR)
          IWORK(22)=IWORK(22)+1
          IF(IERROR.NE.0)RETURN
          ENDIF
        DO 30 J=KCALL,NEQN,MBAND
          ILO=MAX(1,J-MU)
          IHI=MIN(NEQN,J+ML)
          IROW=ILO-J+ML+MU+1
          IBAND=IHI-ILO+1
          SKALE=-ONE
          CALL DAXPY(IBAND,SKALE,WORK2(ILO),1,WORK1(ILO),1)
          SKALE=ONE/(XJAC*EPS*(ONE+ABS(X(J))))
          CALL DSCAL(IBAND,SKALE,WORK1(ILO),1)
          SKALE=ONE
          CALL DAXPY(IBAND,SKALE,WORK1(ILO),1,FPRIME(IROW,J),1)
30        CONTINUE
40      CONTINUE
C
C  Compute last column of jacobian, rows 1 to NEQN
C
      CALL DCOPY(NVAR,X,1,XTEMP,1)
      XTEMP(NVAR)=X(NVAR)+EPS*(ONE+ABS(X(NVAR)))
      CALL FX(NVAR,FPAR,IPAR,XTEMP,WORK1,IERROR)
      IWORK(22)=IWORK(22)+1
      IF(IERROR.NE.0)RETURN
      IF(JAC.EQ.2)THEN
        XTEMP(NVAR)=X(NVAR)-EPS*(ONE+ABS(X(NVAR)))
        CALL FX(NVAR,FPAR,IPAR,XTEMP,WORK2,IERROR)
        IWORK(22)=IWORK(22)+1
        IF(IERROR.NE.0)RETURN  
        ENDIF
      SKALE=-ONE
      CALL DAXPY(NEQN,SKALE,WORK2,1,WORK1,1)
      SKALE=ONE/(XJAC*EPS*(ONE+ABS(X(NVAR))))
      CALL DSCAL(NEQN,SKALE,WORK1,1)
      SKALE=ONE
      CALL DAXPY(NEQN,SKALE,WORK1,1,FCOL,1)
C
C  Do last row, J=1,NVAR
C
      FROW(IPC)=FROW(IPC)+ONE
      RETURN
      END
      FUNCTION REPS()
C
C********************************************************************
C
C  Compute the machine relative precision.
C
C  If you would prefer a simpler computation, you can replace this routine 
C  by a line that reads "REPS=1.0E-7" for example, or "REPS=R1MACH(4)"
C  if you have the PORT/SLATEC machine constant routines.  
C
      DOUBLE PRECISION HALF
      DOUBLE PRECISION ONE
      DOUBLE PRECISION TWO
      DOUBLE PRECISION ZERO
C
      PARAMETER (HALF=0.5)
      PARAMETER (ONE=1.0)
      PARAMETER (TWO=2.0)
      PARAMETER (ZERO=0.0)
C
      DOUBLE PRECISION EPS
      INTEGER   I
      DOUBLE PRECISION RADD
      DOUBLE PRECISION RADDOLD
      DOUBLE PRECISION REPS
      DOUBLE PRECISION RMANT
      DOUBLE PRECISION RMANTOLD
      DOUBLE PRECISION TEMP1
      DOUBLE PRECISION TEMP2
C
      RMANT=ONE
      RADD=ONE
      DO 10 I=1,100
        RADDOLD=RADD
        RADD=HALF*RADD
        RMANTOLD=RMANT
        RMANT=RMANT+RADD
        IF((RMANT.EQ.RMANTOLD).OR.
     *     (RMANT-RADD.NE.RMANTOLD))GO TO 20
        IF(RMANT.EQ.TWO)THEN
          RADDOLD=RADD
          GO TO 20
          ENDIF
10      CONTINUE
C
C  Loop doesn't terminate after 100 steps!
C  We'll just use that value.
C
20    CONTINUE
C
      RMANT=RMANTOLD
      EPS=RADDOLD
C
C  Additional requirement on the value of EPS is that
C  (1.0+EPS)-EPS.EQ.(1.0-EPS)+EPS.EQ.1.0)
C
30    CONTINUE
      TEMP1=ONE+EPS
      TEMP2=ONE-EPS
      IF(TEMP1-EPS.NE.ONE.OR.TEMP2+EPS.NE.ONE)THEN
        EPS=TWO*EPS
        GO TO 30
        ENDIF
C
      REPS=EPS
      RETURN
      END 

C dpcon61w.f 29 February 2004

C PySCeS - Python Simulator for Cellular Systems 
C            (http://pysces.sourceforge.net)
C Copyright (C) B.G. Olivier, J.M. Rohwer, J.-H.S. Hofmeyr
C Stellenbosch, 2004-2008.
C Triple-J Group for Molecular Cell Physiology
C Stellenbosch University, South Africa
C Author: Brett G. Olivier
C
C PySCeS is Open Source Software distributed under
C the GNU GENERAL PUBLIC LICENSE (see docs/GPL)

CFILE: dpcon61w.f
      SUBROUTINE PITCON1(DF,FPAR,FX,IERROR,IPAR,IWORK,LIW,NVAR,RWORK,
     *LRW,XR,IMTH)
      EXTERNAL  DF
      EXTERNAL  FX
      EXTERNAL  DENSLV
      EXTERNAL  BANSLV
      INTEGER   LIW
cf2py integer optional,check(len(iwork)>=liw),depend(iwork) :: liw=len(iwork)
      INTEGER   LRW
cf2py integer optional,check(len(rwork)>=lrw),depend(rwork) :: lrw=len(rwork)
      INTEGER   NVAR
cf2py integer optional,check(len(xr)>=nvar),depend(xr) :: nvar=len(xr)
      DOUBLE PRECISION FPAR(*)
cf2py double precision dimension(*)),intent(in) :: fpar 
      INTEGER   IPAR(*)
cf2py integer dimension(*),intent(in) :: ipar 
      INTEGER   IWORK(LIW)
cf2py integer dimension(liw),intent(in,out,copy) :: iwork
      INTEGER   IERROR
cf2py integer intent(out) :: ierror
      DOUBLE PRECISION RWORK(LRW)
cf2py double precision dimension(lrw),intent(in,out,copy) :: rwork
      DOUBLE PRECISION XR(NVAR)
cf2py double precision dimension(nvar),intent(in,out,copy) :: xr
cf2py DOUBLE PRECISION X(NVAR), FVEC(NVAR), FJAC(NVAR,NVAR)
cf2py double precision,intent(out) :: fvec
cf2py double precision,intent(out) :: fjac
cf2py INTEGER IMTH = 1
      INTEGER IMTH
cf2py CALL FX(NVAR,FPAR,IPAR,X,FVEC,IERROR)
cf2py CALL DF(NVAR,FPAR,IPAR,X,FJAC,IERROR)
      IF (IMTH.eq.1) THEN
         CALL PITCON(DF,FPAR,FX,IERROR,IPAR,IWORK,LIW,NVAR,RWORK,
     *LRW,XR,DENSLV)
      ELSE
         CALL PITCON(DF,FPAR,FX,IERROR,IPAR,IWORK,LIW,NVAR,RWORK,
     *LRW,XR,BANSLV)
      ENDIF
      END

      DOUBLE PRECISION FUNCTION WNORM(N,Z,XW)
      INTEGER N
      DOUBLE PRECISION Z(N), XW(N)
C     ------------------------------------------------------------
C
C*    Summary :
C
C     E N O R M : Return the norm to be used in exit (termination)
C                 criteria
C
C*    Input parameters
C     ================
C
C     N         Int Number of equations/unknowns
C     Z(N)     Dble  The vector, of which the norm is to be computed
C     XW(N)    Dble  The scaling values of Z(N)
C
C*    Output
C     ======
C
C     WNORM(N,Z,XW)  Dble  The mean square root norm of Z(N) subject
C                          to the scaling values in XW(N):
C                          = Sqrt( Sum(1,...N)((Z(I)/XW(I))**2) / N )
C
C     ------------------------------------------------------------
C*    End Prologue
      INTEGER I
      DOUBLE PRECISION S
C*    Begin
      S = 0.0D0
      DO 10 I=1,N
        S = S + ( Z(I)/XW(I) ) ** 2
10    CONTINUE
      WNORM = DSQRT( S / DBLE(FLOAT(N)) )
C     End of function WNORM
      RETURN
      END

      SUBROUTINE MON
C
C* Begin Prologue MON
C
C  ---------------------------------------------------------------------
C
C* Title
C
C  Time monitor to discover cpu time consumption of interesting parts
C  of a code.
C
C* Written by        U. Nowak, U. Poehle, L. Weimann
C* Purpose           Cpu time measuring
C* Category          ...
C* File              mon.f
C* Version           2.1
C* Latest Change     96/03/04 (1.3)
C* Library           CodeLib
C* Code              Fortran 77
C                    Single precision
C
C  ---------------------------------------------------------------------
C
C* Summary
C  -------
C 
C  MON provides different entries 
C   - to initialize the time monitor, 
C   - to start and to stop the measuring, 
C   - to start and to stop a number of stop-watches which may be nested,
C   - to print a summary table,
C   - to define text labels for the summary table, and
C   - to store the vector of average cpu times
C
C  Errors detected during the measuring will disable the time monitor
C  but will not affect the calling program.
C
C  ---------------------------------------------------------------------
C
C* Parameter list description
C  --------------------------
C
C* Input parameters
C  ----------------
C
C  TEXTH      Char    Text to identify the measuring (up to 31
C                     characters will be printed in the headline of the
C                     summary table)
C                     Used by MONINI
C
C  IOUNIT     Int     Output unit for error messages and summary table
C                     Used by MONINI
C
C  INDX       Int     Number of a range of source code lines (a distinct
C                     part of the algorithm normally) for which the
C                     cpu time will be measured by a kind of stop-watch
C                     Used by MONDEF, MONON, and MONOFF
C
C  NAMEH      Char    Text to label the summary lines (up to 17
C                     characters will be printed)
C                     Used by MONDEF
C
C* Output parameters
C  -----------------
C
C  IRET       Int     Return code of ZIBSEC
C                     Used by MONSTR
C
C  AVER       Dble    Vector of average cpu time for all measurings
C                     Used by MONGET
C
C
C* End Prologue
C  ------------
C
C
C* Constants
C  ---------
C
C  MAXTAB     Int     Maximum number of stop-watches
C  MNEST      Int     Maximum number of nested measurings
C
C
C* Local Variables
C  ---------------
C
C  ASEC       Real    Array of averages per call
C  INDACT     Int     Array for indices of nested measurings
C  NCALL      Int     Array of call counts
C  PC1        Real    Array of per cent values with respect to all
C                     measurings
C  PC2        Real    Array of per cent values with respect to the sum
C                     of all stop-watches
C  QDISAB     Log     Time monitor disabled
C  QON        Log     Array reflecting if an index is active
C  QSTART     Log     Time monitor started
C  SEC        Real    Array of cpu time measurings
C
C
C
      INTEGER MAXTAB, MNEST
C
      PARAMETER (MAXTAB = 25, MNEST=20)
C
      INTEGER INDACT(MNEST), NCALL(0:MAXTAB)
      REAL ASEC(0:MAXTAB), PC1(0:MAXTAB), PC2(0:MAXTAB), SEC(0:MAXTAB)
      DOUBLE PRECISION AVER(0:MAXTAB)
      LOGICAL QDISAB, QON(0:MAXTAB), QSTART
      CHARACTER NAME(0:MAXTAB)*17, TEXT*30 
      CHARACTER*(*) NAMEH, TEXTH
C
      SAVE ASEC, CPTIM, INDACT, IONCNT, MAXIND, MONI, NAME, NCALL, PC1,
     $     PC2, QDISAB, QON, QSTART, SEC, TEXT
C
C
      DATA CPTIM /0.0E0/, MONI /6/, INFO /1/, IONCNT /-1/,
     $     QDISAB /.FALSE./, QSTART /.FALSE./
C
      RETURN
C
C
      ENTRY MONINI (TEXTH, IOUNIT)
C     Initialize monitor.
C     Has to be called first. May be called again after MONHLT.
C
      TEXT = TEXTH
      MONI = IOUNIT
C
      IF (IONCNT .GT. 0 .AND. .NOT. QDISAB) GOTO 1070
C
      MAXIND = 0
      IONCNT = 0
      QDISAB = .FALSE.
C
      DO 1000 I = 0,MAXTAB
         SEC(I) = 0.
         ASEC(I) = 0.
         NCALL(I) = 0
         QON(I) = .FALSE.
         WRITE (NAME(I), '(A, I2)') 'Part ', I
 1000 CONTINUE
      NAME(0) = 'General'
C
      DO 1010 I = 1,MNEST
         INDACT(I) = 0
 1010 CONTINUE
C
      RETURN
C
C
      ENTRY MONDEF(INDX, NAMEH)
C     Define one monitor entry.
C     May be called at any time before MONPRT.
C
      IF (QDISAB) RETURN
      IF (INDX.LT.0 .OR. INDX.GT.MAXTAB) GOTO 1080
C
      NAME(INDX) = NAMEH
C
      RETURN
C
C
      ENTRY MONSTR (IRET)
C     Start monitor measurings.
C     Has to be called once after initialization.
C
      IF (QDISAB) RETURN
      IF (IONCNT .LT. 0) GOTO 1090
      IF (IONCNT .GT. 0) GOTO 1100
      IF (QON(0)) GOTO 1110
C
      IFAIL = 0
      CALL ZIBSEC (CPTIM, IFAIL)
C
      IF (IFAIL .EQ. 0) THEN
C        Switch on general stop-watch
         SEC(0) = -CPTIM
         QON(0) = .TRUE.
         IONCNT = 1
         QSTART = .TRUE.
      ENDIF
      IRET = IFAIL
C
      RETURN
C
C
      ENTRY MONON (INDX)
C     Start one measuring.
C     A running stop-watch will be deactivated until the new stop-watch
C     stops.
C
      IF (.NOT. QSTART) RETURN
      IF (QDISAB) RETURN
      IF (IONCNT .LT. 1) GOTO 1120
      IF (INDX .GT. MAXTAB .OR. INDX .LE. 0) GOTO 1130
      IF (QON(INDX)) GOTO 1140
C
      MAXIND = MAX(MAXIND, INDX)
      CALL ZIBSEC (CPTIM, IFAIL)
C
C     Hold actual stop-watch
      SEC(INDACT(IONCNT)) = SEC(INDACT(IONCNT)) + CPTIM
C
C     Switch on new stop-watch
      IF (INFO .GT. 1) WRITE (MONI,*) ' Enter ', NAME(INDX), SEC(INDX)
C
      IONCNT = IONCNT + 1
      IF (IONCNT .GT. MNEST) GOTO 1150
C
      INDACT(IONCNT) = INDX
      SEC(INDX) = SEC(INDX) - CPTIM
      QON(INDX) = .TRUE.
C
      RETURN
C
C
      ENTRY MONOFF (INDX)
C     Stop one measuring.
C     May be called for the stop-watch started most recently.
C     The stop-watch deactivated most recently will be activated.
C
      IF (.NOT. QSTART) RETURN
      IF (QDISAB) RETURN
      IF (INDX .GT. MAXTAB .OR. INDX .LE. 0) GOTO 1160
      IF (INDACT(IONCNT) .NE. INDX) GOTO 1170
C
      CALL ZIBSEC (CPTIM, IFAIL)
C
C     Switch off actual stop-watch
      QON(INDX) = .FALSE.
      SEC(INDX) = SEC(INDX) + CPTIM
      NCALL(INDX) = NCALL(INDX) + 1
      IONCNT = IONCNT - 1
      IF (INFO .GT. 1) WRITE (MONI,*) ' Exit ', NAME(INDX), SEC(INDX)
C
C     Continue previous stop-watch
      SEC(INDACT(IONCNT)) = SEC(INDACT(IONCNT)) - CPTIM
C
      RETURN
C
C
      ENTRY MONHLT
C     Terminate monitor.
C     Stops all active stop-watches.
C
      IF (.NOT. QSTART) RETURN
      IF (QDISAB) RETURN
C
      CALL ZIBSEC (CPTIM, IFAIL)
C
      DO 1020 I=IONCNT,1,-1
         QON(INDACT(I)) = .FALSE.
         SEC(INDACT(I)) = SEC(INDACT(I)) + CPTIM
         NCALL(INDACT(I)) = NCALL(INDACT(I)) + 1
 1020 CONTINUE
C
      IONCNT = 0
C     This means that the time monitor has to be started by MONSTR
C     before another measuring.
C
      RETURN
C
C
C
      ENTRY MONPRT
C     Print statistics.
C     May be called after MONHLT only.
C
      IF (IONCNT .GT. 0) GOTO 1180
      IF (.NOT. QSTART) GOTO 1190
C
      SUM = 1.E - 10
      DO 1030 I = 1,MAXIND
         SUM = SUM + SEC(I)
         IF (NCALL(I) .GT. 0) ASEC(I) = SEC(I)/FLOAT(NCALL(I))
 1030 CONTINUE
      SUM0 = SUM + SEC(0)
      IF (NCALL(0) .GT. 0) ASEC(0) = SEC(0)/FLOAT(NCALL(0))
C
      DO 1040 I = 1,MAXIND
         PC1(I) = 100.*SEC(I)/SUM0
         PC2(I) = 100.*SEC(I)/SUM
 1040 CONTINUE
      PC1(0) = 100.*SEC(0)/SUM0
C
      WRITE (MONI,9000)
      WRITE (MONI,9010)
      WRITE (MONI,9020) ' '
 9000 FORMAT (///)
 9010 FORMAT (1X, 77('#'))
 9020 FORMAT (' #   ', A, T75,  '   #')
C
      IF (QDISAB) THEN
         WRITE (MONI,9020) ' '
         WRITE (MONI,9020)
     $        'Warning  The following results may be misleading'
         WRITE (MONI,9020)
     $        'because an error occured and disabled the time monitor'
      ENDIF
C
      WRITE (MONI,9020) ' '
      WRITE (MONI,9030) 'Results from time monitor program for:', TEXT
 9030 FORMAT (' #   ', A40, 1X, A31, '#')
C
      WRITE (MONI,9020) ' '
      WRITE (MONI,9040) 'Total time:', SUM0, 'Sum of parts:', SUM
 9040 FORMAT (' #   ', A11, F11.3, 5X, A13, F11.3, 21X, '#')
C
      WRITE (MONI,9020) ' '
      WRITE (MONI,9050)
 9050 FORMAT (' #   ', 2X, 'Name', 14X, 'Calls', 7X, 'Time', 4X,
     $     'Av-time', 4X, '% Total', 6X, '% Sum   #')
C
      WRITE (MONI,9060) NAME(0), NCALL(0), SEC(0), ASEC(0), PC1(0)
 9060 FORMAT (' #   ', A17, I8, F11.3, F11.4, F11.2, 14X, '#')
C
      DO 1050 I = 1,MAXIND
         WRITE (MONI,9070) NAME(I), NCALL(I), SEC(I), ASEC(I), PC1(I),
     $        PC2(I)
 1050 CONTINUE
C
 9070 FORMAT (' #   ', A17, I8, F11.3, F11.4, F11.2, F11.2, 3X, '#')
C
C
      WRITE (MONI,9020) ' '
      WRITE (MONI,9010)
      WRITE (MONI,9000)
C
      RETURN
C
C
      ENTRY MONGET(AVER)
C     Store average cpu times per call.
C     May be called at any time after MONPRT.
C
      IF (.NOT. QSTART) RETURN
      IF (QDISAB) RETURN
C
      DO 1060 I=0,MAXIND
         AVER(I) = DBLE(ASEC(I))
 1060 CONTINUE
C
      RETURN
C
C  Error exits
C
 1070 CONTINUE
      WRITE (MONI,9080) 'MONINI', 'Time monitor is running already.'
      GOTO 1200
C
 1080 CONTINUE
      WRITE (MONI,9090) 'MONDEF', 'Index out of range', INDX
      GOTO 1200
C
 1090 CONTINUE
      WRITE (MONI,9080) 'MONSTR',
     $     'Time monitor has to be initialized by MONINI first.'
      GOTO 1200
C
 1100 CONTINUE
      WRITE (MONI,9080) 'MONSTR', 'Time monitor is running already.'
      GOTO 1200
C
 1110 CONTINUE
      WRITE (MONI,9080) 'MONSTR',
     $     'Time monitor has been started already.'
      GOTO 1200
C
 1120 CONTINUE
      WRITE (MONI,9080) 'MONON', 'Time monitor is not yet started.'
      GOTO 1200
C
 1130 CONTINUE
      WRITE (MONI,9090) 'MONON', 'Index out of range', INDX
      GOTO 1200
C
 1140 CONTINUE
      WRITE (MONI,9090) 'MONON',
     $     'Measuring is running already for this INDX', INDX
      GOTO 1200
C
 1150 CONTINUE
      WRITE (MONI,9100) 'MONON', 'Nesting is too deep.',
     $     'The following indices are active', (INDACT(I),I=0,IONCNT)
      GOTO 1200
C
 1160 CONTINUE
      WRITE (MONI,9090) 'MONOFF', 'Index out of range', INDX
      GOTO 1200
C
 1170 CONTINUE
      WRITE (MONI,9110) 'MONOFF', 'Measuring ', INDX,
     $     'cannot be stopped.',
     $     'The following indices are active', (INDACT(I),I=0,IONCNT)
      GOTO 1200
C
 1180 CONTINUE
      WRITE (MONI,9080) 'MONPRT', 'Time monitor is still running.'
      GOTO 1200
C
 1190 CONTINUE
      WRITE (MONI,9080) 'MONPRT', 'Time monitor was not started.'
      GOTO 1200
C
 1200 QDISAB = .TRUE.
      RETURN
C
 9080 FORMAT (/, ' ++ Error in subroutine ', A, ' ++',/, 4X, A)
C
 9090 FORMAT (/, ' ++ Error in subroutine ', A, ' ++',/, 4X, A,
     $     ' (', I6, ').')
C
 9100 FORMAT (/, ' ++ Error in subroutine ', A, ' ++', 4X, A,/, 4X, A,
     $     (10I4))
C
 9110 FORMAT (/, ' ++ Error in subroutine ', A, ' ++', 4X, A, I3, 1X, A,
     $     /, 4X, A, (10I4))
C
C  End subroutine monitor
C
      END

      SUBROUTINE NLEQ2(N,FCN,JAC,X,XSCAL,RTOL,IOPT,IERR,
     $LIWK,IWK,LRWK,RWK)
C*    Begin Prologue NLEQ2
      INTEGER N
      EXTERNAL FCN,JAC
      DOUBLE PRECISION X(N),XSCAL(N)
      DOUBLE PRECISION RTOL
      INTEGER IOPT(50)
      INTEGER IERR
      INTEGER LIWK
      INTEGER IWK(LIWK)
      INTEGER LRWK
      DOUBLE PRECISION RWK(LRWK)
C     ------------------------------------------------------------
C
C*  Title
C
C     Numerical solution of nonlinear (NL) equations (EQ)
C     especially designed for numerically sensitive problems.
C
C*  Written by        U. Nowak, L. Weimann 
C*  Purpose           Solution of systems of highly nonlinear equations
C*  Method            Damped affine invariant Newton method with rank-
C                     strategy (see references below)
C*  Category          F2a. - Systems of nonlinear equations
C*  Keywords          Nonlinear equations, Newton methods
C*  Version           2.3
C*  Revision          September 1991
C*  Latest Change     January 2006
C*  Library           CodeLib
C*  Code              Fortran 77, Double Precision
C*  Environment       Standard Fortran 77 environment on PC's,
C                     workstations and hosts.
C*  Copyright     (c) Konrad-Zuse-Zentrum fuer
C                     Informationstechnik Berlin (ZIB)
C                     Takustrasse 7, D-14195 Berlin-Dahlem
C                     phone : + 49/30/84185-0
C                     fax   : + 49/30/84185-125
C*  Contact           Lutz Weimann
C                     ZIB, Division Scientific Computing, 
C                          Department Numerical Analysis and Modelling
C                     phone : + 49/30/84185-185
C                     fax   : + 49/30/84185-107
C                     e-mail: weimann@zib.de
C
C*    References:
C
C     /1/ P. Deuflhard:
C         Newton Methods for Nonlinear Problems. -
C         Affine Invariance and Adaptive Algorithms.
C         Series Computational Mathematics 35, Springer (2004)
C
C     /2/ U. Nowak, L. Weimann:
C         A Family of Newton Codes for Systems of Highly Nonlinear
C         Equations - Algorithm, Implementation, Application.
C         ZIB, Technical Report TR 90-10 (December 1990)
C
C  ---------------------------------------------------------------
C
C* Licence
C    You may use or modify this code for your own non commercial
C    purposes for an unlimited time. 
C    In any case you should not deliver this code without a special 
C    permission of ZIB.
C    In case you intend to use the code commercially, we oblige you
C    to sign an according licence agreement with ZIB.
C
C* Warranty 
C    This code has been tested up to a certain level. Defects and
C    weaknesses, which may be included in the code, do not establish
C    any warranties by ZIB. ZIB does not take over any liabilities
C    which may follow from acquisition or application of this code.
C
C* Software status 
C    This code is under care of ZIB and belongs to ZIB software class 1.
C
C     ------------------------------------------------------------
C
C*    Summary:
C     ========
C     Damped Newton-algorithm with rank strategy for systems of 
C     highly nonlinear equations - damping strategy due to Ref.(1).
C
C     (The iteration is done by subroutine N2INT currently. NLEQ2
C      itself does some house keeping and builds up workspace.)
C
C     Jacobian approximation by numerical differences or user
C     supplied subroutine JAC.
C
C     The numerical solution of the arising linear equations is
C     done by means of the subroutines DECCON and SOLCON (QR de-
C     composition with subcondition estimation, rank decision and
C     computation of the rank-deficient pseudoinverse) .
C     For special purposes these routines may be substituted.
C
C     This is a driver routine for the core solver N2INT.
C
C     ------------------------------------------------------------
C
C*    Parameters list description (* marks inout parameters)
C     ======================================================
C
C*    External subroutines (to be supplied by the user)
C     =================================================
C 
C     (Caution: Arguments declared as (input) must not
C               be altered by the user subroutines ! )
C
C     FCN(N,X,F,IFAIL) Ext    Function subroutine
C       N              Int    Number of vector components (input)
C       X(N)           Dble   Vector of unknowns (input)
C       F(N)           Dble   Vector of function values (output)
C       IFAIL          Int    FCN evaluation-failure indicator. (output)
C                             On input:  Has always value 0 (zero).
C                             On output: Indicates failure of FCN eval-
C                                uation, if having a value <= 2.
C                             If <0: NLEQ2 will be terminated with 
C                                    error code = 82, and IFAIL stored
C                                    to IWK(23).
C                             If =1: A new trial Newton iterate will
C                                    computed, with the damping factor
C                                    reduced to it's half.
C                             If =2: A new trial Newton iterate will
C                                    computed, with the damping factor
C                                    reduced by a reduct. factor, which 
C                                    must be output through F(1) by FCN,
C                                    and it's value must be >0 and < 1.
C                             Note, that if IFAIL = 1 or 2, additional
C                             conditions concerning the damping factor,
C                             e.g. the minimum damping factor or the
C                             bounded damping strategy may also influ-
C                             ence the value of the reduced damping 
C                             factor.
C
C
C     JAC(N,LDJAC,X,DFDX,IFAIL) 
C                       Ext    Jacobian matrix subroutine
C       N                 Int    Number of vector components (input)
C       LDJAC             Int    Leading dimension of Jacobian array
C                                (input)
C       X(N)              Dble   Vector of unknowns (input)
C       DFDX(LDJAC,N)     Dble   DFDX(i,k): partial derivative of
C                                I-th component of FCN with respect
C                                to X(k) (output)
C       IFAIL             Int    JAC evaluation-failure indicator. 
C                                (output)
C                                Has always value 0 (zero) on input.
C                                Indicates failure of JAC evaluation
C                                and causes termination of NLEQ2,
C                                if set to a negative value on output
C
C
C*    Input parameters of NLEQ2
C     =========================
C
C     N              Int    Number of unknowns
C   * X(N)           Dble   Initial estimate of the solution
C   * XSCAL(N)       Dble   User scaling (lower threshold) of the 
C                           iteration vector X(N)
C   * RTOL           Dble   Required relative precision of
C                           solution components -
C                           RTOL.GE.EPMACH*TEN*N
C   * IOPT(50)       Int    Array of run-time options. Set to zero
C                           to get default values (details see below)
C
C*    Output parameters of NLEQ2
C     ==========================
C
C   * X(N)           Dble   Solution values ( or final values,
C                           respectively )
C   * XSCAL(N)       Dble   After return with IERR.GE.0, it contains
C                           the latest internal scaling vector used
C                           After return with IERR.EQ.-1 in onestep-
C                           mode it contains a possibly adapted 
C                           (as described below) user scaling vector:
C                           If (XSCAL(I).LT. SMALL) XSCAL(I) = SMALL ,
C                           If (XSCAL(I).GT. GREAT) XSCAL(I) = GREAT .
C                           For SMALL and GREAT, see section machine
C                           constants below  and regard note 1.
C   * RTOL           Dble   Finally achieved (relative) accuracy
C                           The estimated absolute error of component i
C                           of x_out is approximately given by
C                             abs_err(i) = RTOL * XSCAL_out(i) ,
C                           where (approximately)
C                             XSCAL_out(i) = 
C                                max(abs(X_out(i)),XSCAL_in(i)).
C     IERR           Int    Return value parameter
C                           =-1 sucessfull completion of one iteration
C                               step, subsequent iterations are needed 
C                               to get a solution. (stepwise mode only)
C                           = 0 successfull completion of iteration
C                           > 0 see list of error messages below
C
C     Note 1.
C        The machine dependent values SMALL, GREAT and EPMACH are
C        gained from calls of the machine constants function ZIBCONST.
C        As delivered, this function is adapted to use constants 
C        suitable for all machines with IEEE arithmetic. If you use
C        another type of machine, you have to change ZIBCONST to
C        statements suitable for your machine.
C
C*    Workspace parameters of NLEQ2
C     =============================
C
C     LIWK           Int    Declared dimension of integer
C                           workspace.
C                           Required minimum (for standard linear system
C                           solver) : N+52
C   * IWK(LIWK)      Int    Integer Workspace
C     LRWK           Int    Declared dimension of real workspace.
C                           Required minimum (for standard linear system
C                           solver and Jacobian computed by numerical
C                           approximation - if the Jacobian is computed
C                           by a user subroutine JAC, decrease the 
C                           expression noted below by N):
C                           (N+NBROY+15)*N+61
C                           NBROY = Maximum number of Broyden steps
C                           (Default: if Broyden steps are enabled, e.g.
C                                                IOPT(32)=1            -
C                                       NBROY=MAX(N,10)
C                                     else (if IOPT(32)=0) - 
C                                       NBROY=0 ;
C                            see equally named IWK-field below)
C   * RWK(LRWK)      Dble   Real Workspace
C
C     Note 2a.  A test on sufficient workspace is made. If this
C               test fails, IERR is set to 10 and an error-message
C               is issued from which the minimum of required
C               workspace size can be obtained.
C
C     Note 2b.  The first 50 elements of IWK and RWK are partially 
C               used as input for internal algorithm parameters (for
C               details, see below). In order to set the default values
C               of these parameters, the fields must be set to zero.
C               Therefore, it's recommanded always to initialize the
C               first 50 elements of both workspaces to zero.
C
C*   Options IOPT:
C    =============
C
C     Pos. Name   Default  Meaning
C
C       1  QSUCC  0        =0 (.FALSE.) initial call:
C                             NLEQ2 is not yet initialized, i.e. this is
C                             the first call for this nonlinear system.
C                             At successfull return with MODE=1,
C                             QSUCC is set to 1.
C                          =1 (.TRUE.) successive call:
C                             NLEQ2 is initialized already and is now
C                             called to perform one or more following
C                             Newton-iteration steps.
C                             ATTENTION:
C                                Don't destroy the contents of
C                                IOPT(i) for 1 <= i <= 50 ,
C                                IWK(j)  for 1 <= j < NIWKFR and
C                                RWK(k)  for 1 <= k < NRWKFR.
C                                (Nevertheless, some of the options, e.g.
C                                 FCMIN, SIGMA, MPR..., can be modified
C                                 before successive calls.)
C       2  MODE   0        =0 Standard mode initial call:
C                             Return when the required accuracy for the
C                             iteration vector is reached. User defined
C                             parameters are evaluated and checked.
C                             Standard mode successive call:
C                             If NLEQ2 was called previously with MODE=1,
C                             it performs all remaining iteration steps.
C                          =1 Stepwise mode:
C                             Return after one Newton iteration step.
C       3  JACGEN 0        Method of Jacobian generation
C                          =0 Standard method is JACGEN=2
C                          =1 User supplied subroutine JAC will be 
C                             called to generate Jacobian matrix
C                          =2 Jacobian approximation by numerical
C                             differentation (see subroutine N2JAC)
C                          =3 Jacobian approximation by numerical
C                             differentation with feedback control
C                             (see subroutine N2JCF)
C       4..8               Reserved
C       9  ISCAL  0        Determines how to scale the iterate-vector:
C                          =0 The user supplied scaling vector XSCAL is
C                             used as a (componentwise) lower threshold
C                             of the current scaling vector
C                          =1 The vector XSCAL is always used as the
C                             current scaling vector
C      10                  Reserved
C      11  MPRERR 0        Print error messages
C                          =0 No output
C                          =1 Error messages
C                          =2 Warnings additionally
C                          =3 Informal messages additionally
C      12  LUERR  6        Logical unit number for error messages
C      13  MPRMON 0        Print iteration Monitor
C                          =0 No output
C                          =1 Standard output
C                          =2 Summary iteration monitor additionally
C                          =3 Detailed iteration monitor additionally
C                          =4,5,6 Outputs with increasing level addi-
C                             tional increasing information for code
C                             testing purposes. Level 6 produces
C                             in general extremely large output!
C      14  LUMON  6        Logical unit number for iteration monitor
C      15  MPRSOL 0        Print solutions
C                          =0 No output
C                          =1 Initial values and solution values
C                          =2 Intermediate iterates additionally
C      16  LUSOL  6        Logical unit number for solutions
C      17..18              Reserved
C      19  MPRTIM 0        Output level for the time monitor
C                          = 0 : no time measurement and no output
C                          = 1 : time measurement will be done and
C                                summary output will be written -
C                                regard note 4a.
C      20  LUTIM  6        Logical output unit for time monitor
C      21..30              Reserved
C      31  NONLIN 3        Problem type specification
C                          =1 Linear problem
C                             Warning: If specified, no check will be
C                             done, if the problem is really linear, and
C                             NLEQ2 terminates unconditionally after one
C                             Newton-iteration step.
C                          =2 Mildly nonlinear problem
C                          =3 Highly nonlinear problem
C                          =4 Extremely nonlinear problem
C      32  QRANK1 0        =0 (.FALSE.) Rank-1 updates by Broyden-
C                             approximation are inhibited.
C                          =1 (.TRUE.) Rank-1 updates by Broyden-
C                             approximation are allowed.
C      33..34              Reserved
C      35  QNSCAL 0        Inhibit automatic row scaling: 
C                          =0 (.FALSE.) Automatic row scaling of
C                             the linear system is activ: 
C                             Rows i=1,...,N will be divided by
C                             max j=1,...,N (abs(a(i,j))) 
C                          =1 (.TRUE.) No row scaling of the linear
C                             system. Recommended only for well row-
C                             scaled nonlinear systems.
C      36..37              Reserved
C      38  IBDAMP          Bounded damping strategy switch:
C                          =0 The default switch takes place, dependent
C                             on the setting of NONLIN (=IOPT(31)):
C                             NONLIN = 0,1,2,3 -> IBDAMP = off ,
C                             NONLIN = 4 -> IBDAMP = on
C                          =1 means always IBDAMP = on 
C                          =2 means always IBDAMP = off 
C      39  IORMON          Convergence order monitor 
C                          =0 Standard option is IORMON=2 
C                          =1 Convergence order is not checked,
C                             the iteration will be always proceeded
C                             until the solution has the required 
C                             precision RTOL (or some error condition
C                             occured)
C                          =2 Use additional 'weak stop' criterion:
C                             Convergence order is monitored
C                             and termination due to slowdown of the
C                             convergence may occur.
C                          =3 Use additional 'hard stop' criterion:
C                             Convergence order is monitored
C                             and termination due to superlinear 
C                             convergence slowdown may occur. 
C                          In case of termination due to convergence
C                          slowdown, the warning code IERR=4 will be
C                          set.
C                          In cases, where the Newton iteration con-
C                          verges but superlinear convergence order has
C                          never been detected, the warning code IERR=5 
C                          is returned.
C      40..45              Reserved
C      46..50              User options (see note 4b)
C
C     Note 3:
C         If NLEQ2 terminates with IERR=2 (maximum iterations)
C         or  IERR=3 (small damping factor), you may try to continue
C         the iteration by increasing NITMAX or decreasing FCMIN
C         (see RWK) and setting QSUCC to 1.
C
C     Note 4a:
C        The integrated time monitor calls the machine dependent
C        subroutine ZIBSEC to get the current time stamp in form
C        of a real number (Single precision). As delivered, this
C        subroutine always return 0.0 as time stamp value. Refer
C        to the compiler- or library manual of the FORTRAN compiler
C        which you currently use to find out how to get the current
C        time stamp on your machine.
C
C     Note 4b:
C         The user options may be interpreted by the user replacable
C         routines N2SOUT, N2FACT, N2SOLV - the distributed version
C         of N2SOUT currently uses IOPT(46) as follows:
C         0 = standard plotdata output (may be postprocessed by a user-
C             written graphical program)
C         1 = plotdata output is suitable as input to the graphical
C             package GRAZIL (based on GKS), which has been developed
C             at ZIB. 
C
C
C*   Optional INTEGER input/output in IWK:
C    =======================================
C
C     Pos. Name          Meaning
C
C      1   NITER  IN/OUT Number of Newton-iterations
C      2                 reserved
C      3   NCORR  IN/OUT Number of corrector steps
C      4   NFCN   IN/OUT Number of FCN-evaluations
C      5   NJAC   IN/OUT Number of Jacobian generations or
C                        JAC-calls
C      6                 reserved
C      7                 reserved
C      8   NFCNJ  IN/OUT Number of FCN-evaluations for Jacobian
C                        approximation
C      9   NREJR1 IN/OUT Number of rejected Newton iteration steps
C                        done with a rank-1 approximated Jacobian
C     10..11             Reserved
C     12   IDCODE IN/OUT Output: The 8 decimal digits program identi-
C                        fication number ppppvvvv, consisting of the
C                        program code pppp and the version code vvvv.
C                        Input: If containing a negative number,
C                        it will only be overwritten by the identi-
C                        fication number, immediately followed by
C                        a return to the calling program.      
C     13..15             Reserved
C     16   NIWKFR OUT    First element of IWK which is free to be used
C                        as workspace between Newton iteration steps.
C                        For standard linear solver: N+53
C     17   NRWKFR OUT    First element of RWK which is free to be used
C                        as workspace between Newton iteration steps.
C                        For standard linear solver and numerically 
C                        approximated Jacobian computed by the 
C                        expression: (N+9+NBROY)*N+62 
C                        If the Jacobian is computed by a user routine
C                        JAC, subtract N in this expression.
C     18   LIWKA  OUT    Length of IWK currently required
C     19   LRWKA  OUT    Length of RWK currently required
C     20..22             Reserved
C     23   IFAIL  OUT    Set in case of failure of N2FACT (IERR=80),
C                        N2SOLV (IERR=81), FCN (IERR=82) or JAC(IERR=83)
C                        to the nonzero IFAIL value returned by the 
C                        routine indicating the failure .
C     24..30             Reserved
C     31   NITMAX IN     Maximum number of permitted iteration
C                        steps (default: 50)
C     32   IRANK  IN     Initial rank of the Jacobian 
C                        (at the iteration starting point)
C                        =0 : full rank N
C                        =k with min_rank <= k < N : 
C                           deficient rank assumed,
C                        where min_rank = max (1,N-max(N/10,10))
C     33   NEW    IN/OUT Count of consecutive rank-1 updates
C     34..35             Reserved
C     36   NBROY  IN     Maximum number of possible consecutive 
C                        iterative Broyden steps. The total real 
C                        workspace needed (RWK) depends on this value
C                        (see LRWK above).
C                        Default is N (see parameter N),
C                        if MSTOR=0 (=IOPT(4)), 
C                        and ML+MU+1 (=IOPT(6)+IOPT(7)+1), if MSTOR=1
C                        (but minimum is always 10) - 
C                        provided that Broyden is allowed. 
C                        If Broyden is inhibited, NBROY is always set to
C                        zero.
C     37..50             Reserved
C
C*   Optional REAL input/output in RWK:
C    ====================================
C
C     Pos. Name          Meaning
C
C      1..16             Reserved
C     17   CONV   OUT    The achieved relative accuracy after the  
C                        current step
C     18   SUMX   OUT    Natural level (not Normx of printouts)
C                        of the current iterate, i.e. Sum(DX(i)**2),
C                        where DX = scaled Newton correction.
C     19   DLEVF  OUT    Standard level (not Normf of printouts)
C                        of the current iterate, i.e. Norm2(F(X)),
C                        where F =  nonlinear problem function.
C     20   FCBND  IN     Bounded damping strategy restriction factor
C                        (Default is 10)
C     21   FCSTRT IN     Damping factor for first Newton iteration -
C                        overrides option NONLIN, if set (see note 5)
C     22   FCMIN  IN     Minimal allowed damping factor (see note 5)
C     23   SIGMA  IN     Broyden-approximation decision parameter
C                        Required choice: SIGMA.GE.1. Increasing this
C                        parameter make it less probable that the algo-
C                        rith performs rank-1 updates.
C                        Rank-1 updates are inhibited, if 
C                        SIGMA.GT.1/FCMIN is set. (see note 5)
C     24   SIGMA2 IN     Decision parameter about increasing damping
C                        factor to corrector if predictor is small.
C                        Required choice: SIGMA2.GE.1. Increasing this
C                        parameter make it less probable that the algo-
C                        rith performs rank-1 updates.
C     25   COND   IN     Maximum permitted subcondition for rank-
C                        decision by linear solver.
C                        (Default: 1/epmach, epmach: relative
C                         machine precision) 
C     26   AJDEL  IN     Jacobian approximation without feedback:
C                        Relative pertubation for components
C                        (Default: sqrt(epmach*10), epmach: relative
C                         machine precision) 
C     27   AJMIN  IN     Jacobian approximation without feedback:
C                        Threshold value (Default: 0.0d0)
C                          The absolute pertubation for component k is
C                          computed by 
C                          DELX := AJDEL*max(abs(Xk),AJMIN)
C     28  ETADIF  IN     Jacobian approximation with feedback:
C                        Target value for relative pertubation ETA of X
C                        (Default: 1.0d-6)
C     29  ETAINI  IN     Jacobian approximation with feedback:
C                        Initial value for denominator differences
C                        (Default: 1.0d-6)
C     30..50             Reserved
C
C     Note 5:
C       The default values of the internal parameters may be obtained
C       from the monitor output with at least IOPT field MPRMON set to 2
C       and by initializing the corresponding RWK-fields to zero. 
C
C*   Error and warning messages:
C    ===========================
C
C      1    Termination at stationary point (rank deficient Jacobian
C           and termination criterion fulfilled)
C      2    Termination after NITMAX iterations ( as indicated by
C           input parameter NITMAX=IWK(31) )
C      3    Termination, since damping factor became to small and
C           rank of Jacobian matrix is already zero
C      4    Warning: Superlinear or quadratic convergence slowed down
C           near the solution.
C           Iteration has been stopped therefore with an approximation
C           of the solution not such accurate as requested by RTOL,
C           because possibly the RTOL requirement may be too stringent
C           (i.e. the nonlinear problem is ill-conditioned)
C      5    Warning: Iteration stopped with termination criterion 
C           (using RTOL as requested precision) satisfied, but no 
C           superlinear or quadratic convergence has been indicated yet.
C           Therefore, possibly the error estimate for the solution may
C           not match good enough the really achieved accuracy.
C     10    Integer or real workspace too small
C     20    Bad input to dimensional parameter N
C     21    Nonpositive value for RTOL supplied
C     22    Negative scaling value via vector XSCAL supplied
C     30    One or more fields specified in IOPT are invalid
C           (for more information, see error-printout)
C     80    Error signalled by linear solver routine N2FACT,
C           for more detailed information see IFAIL-value
C           stored to IWK(23)
C           (not used by standard routine N2FACT)
C     81    Error signalled by linear solver routine N2SOLV,
C           for more detailed information see IFAIL-value
C           stored to IWK(23)
C           (not used by standard routine N2SOLV)
C     82    Error signalled by user routine FCN (Nonzero value
C           returned via IFAIL-flag; stored to IWK(23) )
C     83    Error signalled by user routine JAC (Nonzero value
C           returned via IFAIL-flag; stored to IWK(23) )
C
C     Note 6 : in case of failure:
C        -    use non-standard options
C        -    use another initial guess
C        -    or reformulate model
C        -    or apply continuation techniques
C
C*    Machine dependent constants used:
C     =================================
C
C     DOUBLE PRECISION EPMACH  in  NLEQ2, N2PCHK, N2INT
C     DOUBLE PRECISION GREAT   in  N2PCHK
C     DOUBLE PRECISION SMALL   in  N2PCHK, N2INT, N2SCAL
C
C*    Subroutines called: N2PCHK, N2INT, ZIBCONST
C
C     ------------------------------------------------------------
C*    End Prologue
C
C*    Summary of changes:
C     ===================
C      
C     2.2.1  91, June  3    Time monitor included
C     2.2.2  91, June  3    Bounded damping strategy implemented
C     2.2.3  91, July 26    AJDEL, AJMIN as RWK-options for JACGEN.EQ.2,
C                           ETADIF, ETAINI as RWK-opts. for JACGEN.EQ.3
C                           FCN-count changed for anal. Jacobian
C     2.2.4  91, August 16  Convergence order monitor included
C     2.2.5  91, August 19  Standard Broyden updates replaced by
C                           iterative Broyden
C            91, Sept.      Rank strategy modified
C                           DECCON with new fail exit, for the case that
C                           the square root of a negative number will
C                           appear during pseudo inverse computation.
C                           (Occured, although theoretical impossible!)
C     2.2.6  91, Sept.  17  Damping factor reduction by FCN-fail imple-
C                           mented
C     2.3    91, Dec.   20  New Release for CodeLib
C            00, July   12  RTOL output-value bug fixed
C            06, Jan.   24  IERR=5 no longer returned if residuum of
C                           final iterate is exactly zero
C   
C     ------------------------------------------------------------
C
C     PARAMETER (IRWKI=xx, LRWKI=yy)  
C     IRWKI: Start position of internally used RWK part
C     LRWKI: Length of internally used RWK part
C     (current values see parameter statement below)
C
C     INTEGER L4,L41,L5,L51,L6,L61,L62,L63,L7,L71,L9,L11,L12,L121,
C             L13,L14,L20
C     Starting positions in RWK of formal array parameters of internal
C     routine N1INT (dynamically determined in driver routine NLEQ1,
C     dependent on N and options setting)
C
C     Further RWK positions (only internally used)
C
C     Position  Name     Meaning
C
C     IRWKI     FCKEEP   Damping factor of previous successfull iter.
C     IRWKI+1   FCA      Previous damping factor
C     IRWKI+2   FCPRI    A priori estimate of damping factor
C     IRWKI+3   DMYCOR   Number My of latest corrector damping factor
C                        (kept for use in rank-1 decision criterium)
C     IRWKI+(4..LRWKI-1) Free
C
C     Internal arrays stored in RWK (see routine N2INT for descriptions)
C
C     Position  Array         Type   Remarks
C
C     L4        QA(N,N)       Perm   Arrays QA and DXSAVE need never to
C     L4        DXSAVE(N,NBROY)      be kept the same time and therefore
C                             Perm   may be stored to the same workspace
C                                    part
C     L41       A(N,N)        Perm
C     L5        DX(N)         Perm  
C     L51       DXQ(N)        Perm 
C     L6        XA(N)         Perm
C     L61       F(N)          Perm
C     L62       FW(N)         Perm
C     L63       XWA(N)        Perm
C     L7        FA(N)         Perm
C     L71       ETA(N)        Perm   Only used for JACGEN=IOPT(3)=3
C     L8                      Perm   Start position of array workspace 
C                                    needed for linear solver  
C     L9        XW(N)         Temp
C     L11       DXQA(N)       Temp
C     L111      QU(N)         Temp
C     L12       T1(N)         Temp
C     L121      T2(N)         Temp
C     L13       T3(N)         Temp   Not yet used or even reserved
C                                    (for future band mode implementat.)
C     
C
      EXTERNAL N2INT
      INTRINSIC DBLE
      INTEGER IRWKI, LRWKI
      PARAMETER (IRWKI=51, LRWKI=10)  
      DOUBLE PRECISION ONE
      PARAMETER (ONE=1.0D0)
      DOUBLE PRECISION TEN
      PARAMETER (TEN=1.0D1)
      DOUBLE PRECISION ZERO
      PARAMETER (ZERO=0.0D0)
      INTEGER IRANK,NITMAX,LUERR,LUMON,LUSOL,MPRERR,MPRMON,
     $MPRSOL,M1,M2,NRWKFR,NRFRIN,NRW,NIWKFR,NIFRIN,NIW,NONLIN,JACGEN
      INTEGER L4,L41,L5,L51,L6,L61,L62,L63,L7,L71,L8,L9,L11,L12,L121,
     $        L13,L20
      DOUBLE PRECISION COND,FC,FCMIN,PERCI,PERCR
      DOUBLE PRECISION EPMACH, SMALL
      LOGICAL QINIMO,QRANK1,QFCSTR,QSUCC,QBDAMP
      CHARACTER CHGDAT*20, PRODCT*8
C     Which version ?
      LOGICAL QVCHK
      INTEGER IVER
      PARAMETER( IVER=21122301 )
C
C     Version: 2.3               Latest change:
C     -----------------------------------------
C
      DATA      CHGDAT      /'July 12, 2000       '/
      DATA      PRODCT      /'NLEQ2   '/
C*    Begin
      CALL ZIBCONST(EPMACH,SMALL)
      IERR = 0
      QVCHK = IWK(12).LT.0
      IWK(12) = IVER
      IF (QVCHK) RETURN
C        Print error messages?
      MPRERR = IOPT(11)
      LUERR = IOPT(12)
      IF (LUERR .EQ. 0) THEN
        LUERR = 6
        IOPT(12)=LUERR
      ENDIF
C        Print iteration monitor?
      MPRMON = IOPT(13)
      LUMON = IOPT(14)
      IF (LUMON .LE. 0 .OR. LUMON .GT. 99) THEN
        LUMON = 6
        IOPT(14)=LUMON
      ENDIF
C        Print intermediate solutions?
      MPRSOL = IOPT(15)
      LUSOL = IOPT(16)
      IF (LUSOL .EQ. 0) THEN
        LUSOL = 6
        IOPT(16)=LUSOL
      ENDIF
C        Print time summary statistics?
      MPRTIM = IOPT(19)
      LUTIM = IOPT(20)
      IF (LUTIM .EQ. 0) THEN
        LUTIM = 6
        IOPT(20)=LUTIM
      ENDIF
      QSUCC = IOPT(1).EQ.1
      QINIMO = MPRMON.GE.1.AND..NOT.QSUCC
C     Print NLEQ2 heading lines
      IF(QINIMO)THEN
10000   FORMAT('    N L E Q 2  *****  V e r s i o n  ',
     $         '2 . 3 ***',//,1X,'Newton-Method ',
     $         'for the solution of nonlinear systems',//)
        WRITE(LUMON,10000)
      ENDIF
C     Check input parameters and options
      CALL N2PCHK(N,X,XSCAL,RTOL,IOPT,IERR,LIWK,IWK,LRWK,RWK)
C     Exit, if any parameter error was detected till here
      IF (IERR.NE.0) RETURN 
      M1=N
      M2=N
      JACGEN=IOPT(3)
      IF (JACGEN.EQ.0) JACGEN=2
      IOPT(3)=JACGEN
      QRANK1=IOPT(32).EQ.1
      IF (QRANK1) THEN
        NBROY=IWK(36)
        IF (NBROY.EQ.0) NBROY=MAX(M2,10)
        IWK(36)=NBROY
      ELSE
        NBROY=0
      ENDIF
C     WorkSpace: RWK
      L4=IRWKI+LRWKI
      L41=L4+NBROY*N
      L5=L41+M1*N
      L51=L5+N
      L6=L51+N
      L61=L6+N
      L62=L61+N
      L63=L62+N
      L7=L63+N
      L71=L7+N
      IF (JACGEN.NE.3) THEN
        L8=L71
      ELSE
        L8=L71+N
      ENDIF
      NRWKFR = L8
      L9=LRWK+1-N
      L11=L9-N
      L111=L11-N
      L12=L111-N
      L121=L12-N
C     L13 : Work array T3, for future band mode implementation
      L13=L121
      NRW=NRWKFR+LRWK-L13+1
C     End WorkSpace at NRW
C     WorkSpace: IWK
      L20=51
      NIWKFR = L20
      NIW = NIWKFR-1
      NIFRIN = NIWKFR
      NRFRIN = NRWKFR
      LIWL=N+2
      LRWL=2*N+1
      IF (QRANK1) THEN
        NRWKFR=NRWKFR+LRWL
        NIWKFR=NIWKFR+LIWL
      ENDIF
      NRW = NRW+LRWL
      NIW = NIW+LIWL
C     End WorkSpace at NIW
      IWK(16) = NIWKFR
      IWK(17) = NRWKFR
C
      IF(NRW.GT.LRWK.OR.NIW.GT.LIWK)THEN
        IERR=10
      ELSE
        IF(QINIMO)THEN
          PERCR = DBLE(NRW)/DBLE(LRWK)*100.0D0
          PERCI = DBLE(NIW)/DBLE(LIWK)*100.0D0
C         Print statistics concerning workspace usage
10050     FORMAT(' Real    Workspace declared as ',I9,
     $    ' is used up to ',I9,' (',F5.1,' percent)',//,
     $    ' Integer Workspace declared as ',I9,
     $    ' is used up to ',I9,' (',F5.1,' percent)',//)
          WRITE(LUMON,10050)LRWK,NRW,PERCR,LIWK,NIW,PERCI
        ENDIF
        IF(QINIMO)THEN
10051     FORMAT(/,' N =',I4,//,' Prescribed relative ',
     $    'precision',D10.2,/)
          WRITE(LUMON,10051)N,RTOL
10052     FORMAT(' The Jacobian is supplied by ',A)
          IF (JACGEN.EQ.1) THEN
            WRITE(LUMON,10052) 'a user subroutine'
          ELSE IF (JACGEN.EQ.2) THEN
             WRITE(LUMON,10052) 
     $        'numerical differentiation (without feedback strategy)'
          ELSE IF (JACGEN.EQ.3) THEN
             WRITE(LUMON,10052) 
     $        'numerical differentiation (feedback strategy included)'
          ENDIF
10057     FORMAT(' Automatic row scaling of the Jacobian is ',A,/)
          IF (IOPT(35).EQ.1) THEN
            WRITE(LUMON,10057) 'inhibited'
          ELSE
            WRITE(LUMON,10057) 'allowed'
          ENDIF
        ENDIF
        NONLIN=IOPT(31)
        IF (IOPT(38).EQ.0) QBDAMP = NONLIN.EQ.4
        IF (IOPT(38).EQ.1) QBDAMP = .TRUE.
        IF (IOPT(38).EQ.2) QBDAMP = .FALSE.
        IF (QBDAMP) THEN
          IF (RWK(20).LT.ONE) RWK(20) = TEN
        ENDIF
10064   FORMAT(' Rank-1 updates are ',A)
        IF (QINIMO) THEN
          IF (QRANK1) THEN
            WRITE(LUMON,10064) 'allowed'
          ELSE
            WRITE(LUMON,10064) 'inhibited'
          ENDIF
10065     FORMAT(' Problem is specified as being ',A)
          IF (NONLIN.EQ.1) THEN
            WRITE(LUMON,10065) 'linear'
          ELSE IF (NONLIN.EQ.2) THEN
            WRITE(LUMON,10065) 'mildly nonlinear'
          ELSE IF (NONLIN.EQ.3) THEN
            WRITE(LUMON,10065) 'highly nonlinear'
          ELSE IF (NONLIN.EQ.4) THEN
            WRITE(LUMON,10065) 'extremely nonlinear'
          ENDIF
10066     FORMAT(' Bounded damping strategy is ',A,:,/, 
     $           ' Bounding factor is ',D10.3)
          IF (QBDAMP) THEN
            WRITE(LUMON,10066) 'active', RWK(20)
          ELSE
            WRITE(LUMON,10066) 'off'
          ENDIF
        ENDIF
C       Maximum permitted number of iteration steps
        NITMAX=IWK(31)
        IF (NITMAX.LE.0) NITMAX=50
        IWK(31)=NITMAX
10068   FORMAT(' Maximum permitted number of iteration steps : ',
     $         I6)
        IF (QINIMO) WRITE(LUMON,10068) NITMAX
C       Initial damping factor for highly nonlinear problems
        QFCSTR=RWK(21).GT.ZERO
        IF (.NOT.QFCSTR) THEN
          RWK(21)=1.0D-2
          IF (NONLIN.EQ.4) RWK(21)=1.0D-4
        ENDIF
C       Minimal permitted damping factor
        IF (RWK(22).LE.ZERO) THEN
          RWK(22)=1.0D-4
          IF (NONLIN.EQ.4) RWK(22)=1.0D-8
        ENDIF
        FCMIN=RWK(22)
C       Rank1 decision parameter SIGMA
        IF (RWK(23).LT.ONE) RWK(23)=3.0D0
        IF (.NOT.QRANK1) RWK(23)=10.0D0/FCMIN
C       Decision parameter about increasing too small predictor
C       to greater corrector value
        IF (RWK(24).LT.ONE) RWK(24)=10.0D0/FCMIN       
C       Starting value of damping factor (FCMIN.LE.FC.LE.1.0)
        IF(NONLIN.LE.2.AND..NOT.QFCSTR)THEN
C         for linear or mildly nonlinear problems
          FC = ONE
        ELSE
C         for highly or extremely nonlinear problems
          FC = RWK(21)
        ENDIF
        RWK(21)=FC
C       Initial rank
        IRANK = IWK(32)
        IF (IRANK.LE.0.OR.IRANK.GT.N) IWK(32) = N
C       Maximum permitted sub condition number of matrix A
        COND = RWK(25)
        IF (COND.LT.ONE) COND = ONE/EPMACH
        RWK(25) = COND
        IF (MPRMON.GE.2.AND..NOT.QSUCC) THEN
10069     FORMAT(//,' Internal parameters:',//,
     $      ' Starting value for damping factor FCSTART = ',D9.2,/,
     $      ' Minimum allowed damping factor FCMIN = ',D9.2,/,
     $      ' Rank-1 updates decision parameter SIGMA = ',D9.2,/,
     $      ' Initial Jacobian pseudo-rank IRANK =',I6,/,
     $      ' Maximum permitted subcondition COND = ',D9.2)
          WRITE(LUMON,10069) RWK(21),FCMIN,RWK(23),IWK(32),COND
        ENDIF
C       Store lengths of currently required workspaces
        IWK(18) = NIFRIN-1
        IWK(19) = NRFRIN-1
C
C       Initialize and start time measurements monitor
C
        IF ( IOPT(1).EQ.0 .AND. MPRTIM.NE.0 ) THEN
          CALL MONINI (' NLEQ2',LUTIM)
          CALL MONDEF (0,'NLEQ2')
          CALL MONDEF (1,'FCN')
          CALL MONDEF (2,'Jacobi')
          CALL MONDEF (3,'Lin-Fact')
          CALL MONDEF (4,'Lin-Sol')
          CALL MONDEF (5,'Output')
          CALL MONSTR (IERR)
        ENDIF
C
C
        IERR=-1
C       If IERR is unmodified on exit, successive steps are required
C       to complete the Newton iteration
        IF (NBROY.EQ.0) NBROY=1
        CALL N2INT(N,FCN,JAC,X,XSCAL,RTOL,NITMAX,NONLIN,IWK(32),IOPT,
     $  IERR,LRWK,RWK,NRFRIN,LRWL,LIWK,IWK,NIFRIN,LIWL,M1,M2,NBROY,
     $  RWK(L4),RWK(L41),RWK(L4),RWK(L5),RWK(L51),RWK(L6),RWK(L63),
     $  RWK(L61),
     $  RWK(L7),RWK(L71),RWK(L9),RWK(L62),RWK(L11),RWK(L111),RWK(L12),
     $  RWK(L121),RWK(L13),RWK(21),RWK(22),RWK(23),RWK(24),RWK(IRWKI+1),
     $  RWK(IRWKI),RWK(IRWKI+2),COND,RWK(IRWKI+3),RWK(17),RWK(18),
     $  RWK(19),MPRERR,MPRMON,MPRSOL,LUERR,LUMON,LUSOL,IWK(1),IWK(3),
     $  IWK(4),IWK(5),IWK(8),IWK(9),IWK(33),QBDAMP)
C
      IF (MPRTIM.NE.0.AND.IERR.NE.-1.AND.IERR.NE.10) THEN
        CALL MONHLT
        CALL MONPRT
      ENDIF
C
C       Free workspaces, so far not used between steps
        IWK(16) = NIWKFR
        IWK(17) = NRWKFR
      ENDIF
C     Print statistics
      IF (MPRMON.GE.1.AND.IERR.NE.-1.AND.IERR.NE.10) THEN
10080   FORMAT(/, '   ******  Statistics * ', A8, ' *******', /,
     $            '   ***  Newton iterations : ', I7,'  ***', /,
     $            '   ***  Corrector steps   : ', I7,'  ***', /,
     $            '   ***  Rejected rk-1 st. : ', I7,'  ***', /,
     $            '   ***  Jacobian eval.    : ', I7,'  ***', /,
     $            '   ***  Function eval.    : ', I7,'  ***', /,
     $            '   ***  ...  for Jacobian : ', I7,'  ***', /,
     $            '   *************************************', /)
        WRITE (LUMON,10080) PRODCT,IWK(1),IWK(3),IWK(9),IWK(5),
     $  IWK(4),IWK(8)
      ENDIF
C     Print workspace requirements, if insufficient
      IF (IERR.EQ.10) THEN
10090   FORMAT(///,20('*'),'Workspace Error',20('*'))
        IF (MPRERR.GE.1) WRITE(LUERR,10090)
        IF(NRW.GT.LRWK)THEN
10091     FORMAT(/,' Real Workspace dimensioned as',1X,I9,
     $    1X,'must be enlarged at least up to ',
     $    I9,//)
          IF (MPRERR.GE.1) WRITE(LUERR,10091)LRWK,NRFRIN-1
        ENDIF
        IF(NIW.GT.LIWK)THEN
10092     FORMAT(/,' Integer Workspace dimensioned as ',
     $    I9,' must be enlarged at least up ',
     $    'to ',I9,//)
          IF (MPRERR.GE.1) WRITE(LUERR,10092)LIWK,NIFRIN-1
        ENDIF
      ENDIF
C     End of subroutine NLEQ2
      RETURN
      END
C
      SUBROUTINE N2PCHK(N,X,XSCAL,RTOL,IOPT,IERR,LIWK,IWK,LRWK,RWK)
C*    Begin Prologue N2PCHK
      INTEGER N
      DOUBLE PRECISION X(N),XSCAL(N)
      DOUBLE PRECISION RTOL
      INTEGER IOPT(50)
      INTEGER IERR
      INTEGER LIWK
      INTEGER IWK(LIWK)
      INTEGER LRWK
      DOUBLE PRECISION RWK(LRWK)
C     ------------------------------------------------------------
C
C*    Summary :
C
C     N 2 P C H K : Checking of input parameters and options
C                   for NLEQ2.
C
C*    Parameters:
C     ===========
C
C     See parameter description in driver routine.
C
C*    Subroutines called: ZIBCONST
C
C*    Machine dependent constants used:
C     =================================
C
C     EPMACH = relative machine precision
C     GREAT = squareroot of maxreal divided by 10
C     SMALL = squareroot of "smallest positive machine number
C             divided by relative machine precision"
      DOUBLE PRECISION EPMACH,GREAT,SMALL
C
C     ------------------------------------------------------------
C*    End Prologue
C
      INTRINSIC DBLE
      DOUBLE PRECISION ONE
      PARAMETER (ONE=1.0D0)
      DOUBLE PRECISION TEN
      PARAMETER (TEN=1.0D1)
      DOUBLE PRECISION ZERO
      PARAMETER (ZERO=0.0D0)
C
      PARAMETER (NUMOPT=50)
      INTEGER IOPTL(NUMOPT),IOPTU(NUMOPT)
      DOUBLE PRECISION TOLMIN,TOLMAX,DEFSCL
C
      DATA IOPTL /0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,1,0,0,0,1,
     $            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     $            0,0,0,0,0,0,0,0,0,0,
     $            -9999999,-9999999,-9999999,-9999999,-9999999/
      DATA IOPTU /1,1,3,0,0,0,0,0,1,0,3,99,6,99,3,99,0,0,1,99,
     $            0,0,0,0,0,0,0,0,0,0,4,1,0,0,1,
     $            0,0,2,3,0,0,0,0,0,0,
     $            9999999,9999999,9999999,9999999,9999999/
C
      CALL ZIBCONST(EPMACH,SMALL)
      GREAT  = 1.0D0/SMALL
      IERR = 0
C        Print error messages?
      MPRERR = IOPT(11)
      LUERR = IOPT(12)
      IF (LUERR .LE. 0 .OR. LUERR .GT. 99) THEN
        LUERR = 6
        IOPT(12)=LUERR
      ENDIF
C
C     Checking dimensional parameter N
      IF ( N.LE.0 ) THEN
        IF (MPRERR.GE.1)  WRITE(LUERR,10011) N
10011   FORMAT(/,' Error: Bad input to dimensional parameter N supplied'
     $         ,/,8X,'choose N positive, your input is: N = ',I5)
        IERR = 20
      ENDIF
C
C     Problem type specification by user
      NONLIN=IOPT(31)
      IF (NONLIN.EQ.0) NONLIN=3
      IOPT(31)=NONLIN
C
C     Checking and conditional adaption of the user-prescribed RTOL
      IF (RTOL.LE.ZERO) THEN
        IF (MPRERR.GE.1) 
     $      WRITE(LUERR,'(/,A)') ' Error: Nonpositive RTOL supplied'
        IERR = 21
      ELSE
        TOLMIN = EPMACH*TEN*DBLE(N)
        IF(RTOL.LT.TOLMIN) THEN
          RTOL = TOLMIN
          IF (MPRERR.GE.2) 
     $      WRITE(LUERR,10012) 'increased ','smallest',RTOL
        ENDIF
        TOLMAX = 1.0D-1
        IF(RTOL.GT.TOLMAX) THEN
          RTOL = TOLMAX
          IF (MPRERR.GE.2) 
     $      WRITE(LUERR,10012) 'decreased ','largest',RTOL
        ENDIF
10012   FORMAT(/,' Warning: User prescribed RTOL ',A,'to ',
     $         'reasonable ',A,' value RTOL = ',D11.2)
      ENDIF
C     
C     Test user prescribed accuracy and scaling on proper values
      IF (N.LE.0) RETURN 
      IF (NONLIN.GE.3) THEN
        DEFSCL = RTOL
      ELSE
        DEFSCL = ONE
      ENDIF
      DO 10 I=1,N
        IF (XSCAL(I).LT.ZERO) THEN
          IF (MPRERR.GE.1) THEN 
            WRITE(LUERR,10013) I
10013       FORMAT(/,' Error: Negative value in XSCAL(',I5,') supplied')
          ENDIF
          IERR = 22
        ENDIF
        IF (XSCAL(I).EQ.ZERO) XSCAL(I) = DEFSCL
        IF ( XSCAL(I).GT.ZERO .AND. XSCAL(I).LT.SMALL ) THEN
          IF (MPRERR.GE.2) THEN
            WRITE(LUERR,10014) I,XSCAL(I),SMALL
10014       FORMAT(/,' Warning: XSCAL(',I5,') = ',D9.2,' too small, ',
     $             'increased to',D9.2)
          ENDIF
          XSCAL(I) = SMALL
        ENDIF
        IF (XSCAL(I).GT.GREAT) THEN
          IF (MPRERR.GE.2) THEN
            WRITE(LUERR,10015) I,XSCAL(I),GREAT
10015       FORMAT(/,' Warning: XSCAL(',I5,') = ',D9.2,' too big, ',
     $             'decreased to',D9.2)
          ENDIF
          XSCAL(I) = GREAT
        ENDIF
10    CONTINUE
C     Checks options
      DO 20 I=1,30
        IF (IOPT(I).LT.IOPTL(I) .OR. IOPT(I).GT.IOPTU(I)) THEN
          IERR=30
          IF (MPRERR.GE.1) THEN
            WRITE(LUERR,20001) I,IOPT(I),IOPTL(I),IOPTU(I)
20001       FORMAT(' Invalid option specified: IOPT(',I2,')=',I12,';',
     $             /,3X,'range of permitted values is ',I8,' to ',I8)
          ENDIF
        ENDIF
20    CONTINUE
C     End of subroutine N2PCHK
      RETURN
      END
C
      SUBROUTINE N2INT(N,FCN,JAC,X,XSCAL,RTOL,NITMAX,NONLIN,IRANK,IOPT,
     $IERR,LRWK,RWK,NRWKFR,LRWL,LIWK,IWK,NIWKFR,LIWL,M1,M2,NBROY,
     $QA,A,DXSAVE,DX,DXQ,XA,XWA,F,FA,ETA,XW,FW,DXQA,QU,T1,T2,T3,FC,
     $FCMIN,SIGMA,SIGMA2,FCA,FCKEEP,FCPRI,COND,DMYCOR,CONV,SUMX,DLEVF,
     $MPRERR,MPRMON,MPRSOL,LUERR,LUMON,LUSOL,NITER,NCORR,NFCN,NJAC,
     $NFCNJ,NREJR1,NEW,QBDAMP)
C*    Begin Prologue N2INT
      INTEGER N
      EXTERNAL FCN,JAC
      DOUBLE PRECISION X(N),XSCAL(N)
      DOUBLE PRECISION RTOL
      INTEGER NITMAX,NONLIN,IRANK
      INTEGER IOPT(50)
      INTEGER IERR
      INTEGER LRWK
      DOUBLE PRECISION RWK(LRWK)
      INTEGER NRWKFR,LRWL,LIWK
      INTEGER IWK(LIWK)
      INTEGER NIWKFR,LIWL,M1,M2,NBROY
      DOUBLE PRECISION QA(M2,N),A(M1,N),DXSAVE(N,NBROY)
      DOUBLE PRECISION DX(N),DXQ(N),XA(N),XWA(N),F(N),FA(N),ETA(N)
      DOUBLE PRECISION XW(N),FW(N),DXQA(N),QU(N),T1(N),T2(N),T3(N)
      DOUBLE PRECISION FC,FCMIN,SIGMA,SIGMA2,FCA,FCKEEP,COND,CONV,SUMX,
     $                 DLEVF,FCPRI,DMYCOR
      INTEGER MPRERR,MPRMON,MPRSOL,LUERR,LUMON,LUSOL,NITER,
     $NCORR,NFCN,NJAC,NFCNJ,NREJR1,NEW
      LOGICAL QBDAMP
C     ------------------------------------------------------------
C
C*    Summary :
C
C     N 2 I N T : Core routine for NLEQ2 .
C     Damped Newton-algorithm with rank-strategy for systems of 
C     highly nonlinear equations especially designed for
C     numerically sensitive problems.
C
C*    Parameters:
C     ===========
C
C       N,FCN,JAC,X,XSCAL,RTOL   
C                         See parameter description in driver routine
C
C       NITMAX     Int    Maximum number of allowed iterations
C       NONLIN     Int    Problem type specification
C                         (see IOPT-field NONLIN)
C       IRANK      Int    Initially proposed (in) and final (out) rank
C                         of Jacobian
C       IOPT       Int    See parameter description in driver routine
C       IERR       Int    See parameter description in driver routine
C       LRWK       Int    Length of real workspace
C       RWK(LRWK)  Dble   Real workspace array
C       NRWKFR     Int    First free position of RWK on exit 
C       LIWK       Int    Length of integer workspace
C       IWK(LIWK)  Int    Integer workspace array
C       NIWKFR     Int    First free position of IWK on exit 
C       M1         Int    Leading dimension of Jacobian array A
C                         for full case Jacobian: N
C                         (other matrix types are not yet implemented)
C       M2         Int    Leading dimension of Jacobian array QA
C                         for full case Jacobian: N
C       NBROY      Int    Maximum number of possible consecutive
C                         iterative Broyden steps. (See IWK(36))
C       QA(M2,N)   Dble   Holds the originally computed Jacobian
C                         or the pseudo inverse in case of rank-
C                         deficiency
C       A(M1,N)    Dble   Holds the Jacobian matrix (decomposed form
C                         after call of linear decomposition
C                         routine)
C       DXSAVE(X,NBROY)
C                  Dble   Used to save the quasi Newton corrections of
C                         all previously done consecutive Broyden
C                         steps.
C       DX(N)      Dble   Current Newton correction
C       DXQ(N)     Dble   Simplified Newton correction J(k-1)*X(k)
C       XA(N)      Dble   Previous Newton iterate
C       XWA(N)     Dble   Scaling factors used for latest decomposed
C                         Jacobian for column scaling - may differ
C                         from XW, if Broyden updates are performed
C       F(N)       Dble   Function (FCN) value of current iterate
C       FA(N)      Dble   Function (FCN) value of previous iterate
C       ETA(N)     Dble   Jacobian approximation: updated scaled
C                         denominators
C       XW(N)      Dble   Scaling factors for iteration vector
C       FW(N)      Dble   Scaling factors for rows of the system
C       DXQA(N)    Dble   Previous Newton correction
C       QU(N)      Dble   Savespace for right hand side belonging
C                         to upper triangular linear system
C       T1(N)      Dble   Workspace for linear solvers and internal
C                         subroutines
C       T2(N)      Dble   Workspace array for internal subroutines
C       T3(N)      Dble   Workspace array for internal subroutines
C       FC         Dble   Current Newton iteration damping factor.
C       FCMIN      Dble   Minimum permitted damping factor. If
C                         FC becomes smaller than this value, one
C                         of the following may occur:
C                         a.    Recomputation of the Jacobian
C                               matrix by means of difference
C                               approximation (instead of Rank1
C                               update), if Rank1 - update
C                               previously was used
C                         b.    Rank reduction of Jacobi
C                               matrix ,  if difference
C                               approximation was used previously
C                               and Rank(A).NE.0
C                         c.    Fail exit otherwise
C       SIGMA      Dble   Decision parameter for rank1-updates.
C       SIGMA2     Dble   Decision parameter for damping factor
C                         increasing to corrector value
C       FCA        Dble   Previous Newton iteration damping factor.
C       FCKEEP     Dble   Keeps the damping factor as it is at start
C                          of iteration step.
C       COND       Dble   Maximum permitted subcondition for rank-
C                         decision by linear solver.
C       CONV       Dble   Scaled maximum norm of the Newton-
C                         correction. Passed to RWK-field on output.
C       SUMX       Dble   Square of the natural level (see equal-
C                         named IOPT-output field)
C       DLEVF      Dble   Square of the standard level (see equal-
C                         named IOPT-output field)
C       MPRERR,MPRMON,MPRSOL,LUERR,LUMON,LUSOL :
C                         See description of equal named IOPT-fields
C                         in the driver subroutine
C       NITER,NCORR,NFCN,NJAC,NFCNJ,NREJR1,NEW :
C                         See description of equal named IWK-fields
C                         in the driver subroutine
C       QBDAMP     Logic  Flag, that indicates, whether bounded damping
C                         strategy is active:
C                         .true.  = bounded damping strategy is active
C                         .false. = normal damping strategy is active
C
C
C*    Internal double variables
C     =========================
C
C       AJDEL    See RWK(26) (num. diff. without feedback)
C       AJMIN    See RWK(27) (num. diff. without feedback)
C       COND1    Gets the subcondition of the linear system
C                as estimated by the linear solver (N2FACT)
C       CONVA    Holds the previous value of CONV .
C       DEL      Gets the projection defect in case of rank-
C                deficiency.
C       DMUE     Temporary value used during computation of damping 
C                factors predictor.
C       EPDIFF   sqrt(10*epmach) (num. diff. with feedback)
C       ETADIF   See description of RWK(28) (num. diff. with feedback)
C       ETAINI   Initial value for all ETA-components (num. diff. fb.)
C       ETAMAX   Maximum allowed pertubation (num. diff. with feedback)
C       ETAMIN   Minimum allowed pertubation (num. diff. with feedback)
C       FCDNM    Used to compute the denominator of the damping 
C                factor FC during computation of it's predictor,
C                corrector and aposteriori estimate (in the case of
C                performing a Rank1 update) .
C       FCK2     Aposteriori estimate of FC.
C       FCMIN2   FCMIN**2 . Used for FC-predictor computation.
C       FCMINH   DSQRT(FCMIN).
C                Used in rank decision logical expression.
C       FCNUMP   Gets the numerator of the predictor formula for FC.
C       FCNMP2   Temporary used for predictor numerator computation.
C       FCNUMK   Gets the numerator of the corrector computation 
C                of FC .
C       SENS1    Gets the sensitivity of the Jacobian as
C                estimated by the linear solver N2FACT.
C       SUMXA    Natural level of the previous iterate.
C       TH       Temporary variable used during corrector- and 
C                aposteriori computations of FC.
C
C*    Internal integer variables
C     ==========================
C
C     IFAIL      Gets the return value from subroutines called from
C                N2INT (N2FACT, N2SOLV, FCN, JAC)
C     ISCAL      Holds the scaling option from the IOPT-field ISCAL      
C     MODE       Matrix storage mode (see IOPT-field MODE) 
C     NRED       Count of successive corrector steps
C     NILUSE     Gets the amount of IWK used by the linear solver
C     NRLUSE     Gets the amount of RWK used by the linear solver
C     NIWLA      Index of first element of IWK provided to the
C                linear solver
C     NRWLA      Index of first element of RWK provided to the
C                linear solver
C     LIWL       Holds the maximum amount of integer workspace
C                available to the linear solver
C     LRWL       Holds the maximum amount of real workspace
C                available to the linear solver
C
C*    Internal logical variables
C     ==========================
C
C     QGENJ      Jacobian updating technique flag:
C                =.TRUE.  : Call of analytical subroutine JAC or
C                           numerical differentiation
C                =.FALSE. : rank1- (Broyden-) update
C     QINISC     Iterate initial-scaling flag:
C                =.TRUE.  : at first call of N2SCAL
C                =.FALSE. : at successive calls of N2SCAL
C     QSUCC      See description of IOPT-field QSUCC.
C     QJCRFR     Jacobian refresh flag:
C                set to .TRUE. if damping factor gets too small
C                and Jacobian was computed by rank1-update. 
C                Indicates, that the Jacobian needs to be recomputed
C                by subroutine JAC or numerical differentation.
C     QLINIT     Initialization state of linear solver workspace:
C                =.FALSE. : Not yet initialized
C                =.TRUE.  : Initialized - N2FACT has been called at
C                           least one time.
C     QREPET     Operation mode flag for linear solver:
C                =.FALSE. : Normal operation (full rank matrix)
C                =.TRUE.  : Special operation in rank deficient case:
C                           Compute rank-deficient pseudo-inverse,
C                           partial recomputation when solving the
C                           linear system again prescribing a lower
C                           rank as before.
C     QNEXT      Set to .TRUE. to indicate success of the current
C                Newton-step, i.e. : sucessfull monotonicity-test.
C     
C     QREDU      Set to .TRUE. to indicate that rank-reduction (or
C                refreshment of the Jacobian) is needed - if the
C                computed damping factor gets too small.
C     QSCALE     Holds the value of .NOT.QNSCAL. See description
C                of IOPT-field QNSCAL.
C
C*    Subroutines called:
C     ===================
C
C       N2FACT, N2SOLV, N2JAC,  N2JCF,  N2LVLS, N2PRJN,
C       N2SCRF, N2SOUT, N2PRV1, N2PRV2, N2SCAL,
C       MONON,  MONOFF
C
C*    Functions called:
C     =================
C
C       ZIBCONST, WNORM
C
C*    Machine constants used
C     ======================
C
      DOUBLE PRECISION EPMACH,SMALL
C 
C     ------------------------------------------------------------
C*    End Prologue
      EXTERNAL N2FACT, N2SOLV, N2JAC,  N2JCF, N2LVLS, N2PRJN,
     $         N2SCRF, N2SOUT, N2PRV1, N2PRV2, N2SCAL,
     $         MONON,  MONOFF, WNORM
      INTRINSIC DSQRT,DMIN1
      DOUBLE PRECISION ONE
      PARAMETER (ONE=1.0D0)
      DOUBLE PRECISION ZERO
      PARAMETER (ZERO=0.0D0)
      DOUBLE PRECISION HALF
      PARAMETER (HALF=0.5D0)
      DOUBLE PRECISION TEN
      PARAMETER (TEN=10.0D0)
      INTEGER IFAIL,ILOOP,ISCAL,K,MODE,NRED,NILUSE,NRLUSE,NIWLA,
     $NRWLA,L1,JACGEN,MINRNK
      DOUBLE PRECISION AJDEL,AJMIN,ALFA1,ALFA2,ALFA,BETA,
     $COND1,CONVA,DLEVXA,DEL,DMYPRI,DXANRM,DXNRM,WNORM,EPDIFF,
     $ETAMIN,ETAMAX,ETAINI,ETADIF,FCDNM,FCBND,FCBH,FCK2,FCMIN2,FCMINH,
     $FCNUMP,FCCOR,FCNMP2,FCNUMK,FCREDU,DLEVFN,SENS1,SUMXA,SUM1,SUM2,
     $S1,TH,RSMALL,APREC
      LOGICAL QGENJ,QINISC,QSUCC,QJCRFR,QLINIT,QNEXT,QRANK1,QREPET,
     $        QREDU,QREP,QSCALE,QMIXIO
CWEI
      INTRINSIC DLOG
      DOUBLE PRECISION CLIN0,CLIN1,CALPHA,CALPHK,ALPHAE,ALPHAK,ALPHAA,
     $                 SUMXA0,SUMXA1,SUMXA2,SUMXTE,FCMON,DLOG
      INTEGER ICONV, IORMON
      LOGICAL QMSTOP
      SAVE CLIN0,CLIN1,CALPHA,ALPHAE,ALPHAK,ALPHAA,SUMXA0,SUMXA1,SUMXA2,
     $     ICONV,QMSTOP
C
      CALL ZIBCONST(EPMACH,SMALL)
C*    Begin
C       ----------------------------------------------------------
C       1 Initialization
C       ----------------------------------------------------------
C       1.1 Control-flags and -integers
        QSUCC = IOPT(1).EQ.1
        QSCALE = .NOT. IOPT(35).EQ.1
        QRANK1 = IOPT(32).EQ.1
        IORMON = IOPT(39)
        IF (IORMON.EQ.0) IORMON=2
        ISCAL = IOPT(9)
        MODE = IOPT(2)
        JACGEN = IOPT(3)
        QMIXIO = LUMON.EQ.LUSOL .AND. MPRMON.NE.0 .AND. MPRSOL.NE.0
        MPRTIM = IOPT(19)
C       ----------------------------------------------------------
C       1.2 Derivated dimensional parameters
        MINRNK = MAX0(1,N-MAX0(INT(FLOAT(N)/10.0),10))
C       ----------------------------------------------------------
C       1.3 Derivated internal parameters
        FCMIN2 = FCMIN*FCMIN
        FCMINH = DSQRT(FCMIN)
        TOLMIN = DSQRT(TEN*EPMACH)
        RSMALL = DSQRT(TEN*RTOL)
C       ----------------------------------------------------------
C       1.4 Adaption of input parameters, if necessary
        IF(FC.LT.FCMIN) FC = FCMIN
        IF(FC.GT.ONE) FC = ONE
C       ----------------------------------------------------------
C       1.5 Initial preparations
        QJCRFR = .FALSE.
        QLINIT = .FALSE.
        QREPET = .FALSE.
        IFAIL = 0
        FCBND = ZERO
        IF (QBDAMP) FCBND = RWK(20)
C       ----------------------------------------------------------
C       1.5.1 Numerical differentation related initializations
        IF (JACGEN.EQ.2) THEN
          AJDEL = RWK(26)
          IF (AJDEL.LE.SMALL) AJDEL = DSQRT(EPMACH*TEN)
          AJMIN = RWK(27)
        ELSE IF (JACGEN.EQ.3) THEN
          ETADIF = RWK(28)
          IF (ETADIF .LE. SMALL) ETADIF = 1.0D-6
          ETAINI = RWK(29)
          IF (ETAINI .LE. SMALL) ETAINI = 1.0D-6
          EPDIFF = DSQRT(EPMACH*TEN)
          ETAMAX = DSQRT(EPDIFF)
          ETAMIN = EPDIFF*ETAMAX
        ENDIF
C       ----------------------------------------------------------
C       1.5.2 Miscellaneous preparations of first iteration step
        IF (.NOT.QSUCC) THEN
          NITER = 0
          NCORR = 0
          NREJR1 = 0
          NFCN = 0
          NJAC = 0
          NFCNJ = 0
          QGENJ = .TRUE.
          QINISC = .TRUE.
          FCKEEP = FC
          FCA = FC
          FCPRI = FC
          FCK2 = FC
          CONV = ZERO
          IF (JACGEN.EQ.3) THEN
            DO 1520 L1=1,N
              ETA(L1)=ETAINI
1520        CONTINUE
          ENDIF
          DO 1521 L1=1,N
            XA(L1)=X(L1)
1521      CONTINUE
CWEI      
          ICONV = 0
          ALPHAE = ZERO
          SUMXA1 = ZERO
          SUMXA0 = ZERO
          CLIN0  = ZERO
          QMSTOP = .FALSE.
C         ------------------------------------------------------
C         1.6 Print monitor header
          IF(MPRMON.GE.2 .AND. .NOT.QMIXIO)THEN
16003       FORMAT(///,2X,66('*'))
            WRITE(LUMON,16003)
16004       FORMAT(/,8X,'It',7X,'Normf ',10X,'Normx ',6X,
     $             'Damp.Fct.',3X,'New',6X,'Rank',8X,'Cond')
            WRITE(LUMON,16004)
          ENDIF
C         --------------------------------------------------------
C         1.7 Startup step
C         --------------------------------------------------------
C         1.7.1 Computation of the residual vector
          IF (MPRTIM.NE.0) CALL MONON(1)
          CALL FCN(N,X,F,IFAIL)
          IF (MPRTIM.NE.0) CALL MONOFF(1)
          NFCN = NFCN+1
C     Exit, if ...
          IF (IFAIL.NE.0) THEN
            IERR = 82
            GOTO 4299
          ENDIF
        ELSE
          QINISC = .FALSE.
        ENDIF
C
C       Main iteration loop
C       ===================
C
C       Repeat
2       CONTINUE
C         --------------------------------------------------------
C         2 Startup of iteration step
          IF (.NOT.QJCRFR) THEN
C           ------------------------------------------------------
C           2.1 Scaling of variables X(N)
            CALL N2SCAL(N,X,XA,XSCAL,XW,ISCAL,QINISC,IOPT,LRWK,RWK)
            QINISC = .FALSE.
            IF(NITER.NE.0)THEN
C             Preliminary pseudo-rank
              IRANKA = IRANK
C             ----------------------------------------------------
C             2.2 Aposteriori estimate of damping factor
              DO 2200 L1=1,N
                DXQA(L1)=DXQ(L1)
2200          CONTINUE
              FCNUMP = ZERO
              DO 2201 L1=1,N
                FCNUMP=FCNUMP+(DX(L1)/XW(L1))**2
2201          CONTINUE
              TH = FC-ONE
              FCDNM = ZERO
              DO 2202 L1=1,N
                FCDNM=FCDNM+((DXQA(L1)+TH*DX(L1))/XW(L1))**2
2202          CONTINUE
C             ----------------------------------------------------
C             2.2.2 Decision criterion for Jacobian updating
C                   technique:
C                   QGENJ.EQ..TRUE. numerical differentation,
C                   QGENJ.EQ..FALSE. rank1 updating
              QGENJ = .TRUE.
              IF (FC.EQ.FCPRI) THEN
                QGENJ = FC.LT.ONE.OR.FCA.LT.ONE.OR.DMYCOR.LE.FC*SIGMA
     $                  .OR. .NOT.QRANK1 .OR. NEW+2.GT.NBROY 
                FCA = FC
              ELSE
                DMYCOR = FCA*FCA*HALF*DSQRT(FCNUMP/FCDNM)
                IF (NONLIN.LE.3) THEN
                  FCCOR = DMIN1(ONE,DMYCOR)
                ELSE
                  FCCOR = DMIN1(ONE,HALF*DMYCOR)
                ENDIF
                FCA = DMAX1(DMIN1(FC,FCCOR),FCMIN)
C$Test-begin
                IF (MPRMON.GE.5) THEN
                  WRITE(LUMON,22201) FCCOR, FC, DMYCOR, FCNUMP,
     $                               FCDNM
22201             FORMAT (/, ' +++ aposteriori estimate +++', /,
     $                    ' FCCOR  = ', D18.10, '  FC     = ', D18.10, /,
     $                    ' DMYCOR = ', D18.10, '  FCNUMP = ', D18.10, /,
     $                    ' FCDNM  = ', D18.10, /,
     $                       ' ++++++++++++++++++++++++++++', /)
                ENDIF
C$Test-end 
              ENDIF
              FCK2 = FCA
C             ------------------------------------------------------
C             2.2.1 Computation of the numerator of damping
C                   factor predictor
              FCNMP2 = ZERO
              DO 221 L1=1,N
                FCNMP2=FCNMP2+(DXQA(L1)/XW(L1))**2
221           CONTINUE
              FCNUMP = FCNUMP*FCNMP2
            ENDIF
          ENDIF
          QJCRFR =.FALSE.
C         --------------------------------------------------------
C         2.3 Jacobian matrix (stored to array A(M1,N))
C         --------------------------------------------------------
C         2.3.1 Jacobian generation by routine JAC or
C               difference approximation (If QGENJ.EQ..TRUE.)
C               - or -
C               Rank-1 update of Jacobian (If QGENJ.EQ..FALSE.)
          IF(QGENJ)THEN
            NEW = 0
            IF (JACGEN.EQ.1) THEN
               IF (MPRTIM.NE.0) CALL MONON(2)
               CALL JAC(N,M1,X,A,IFAIL)
               IF (MPRTIM.NE.0) CALL MONOFF(2)
            ELSE
              IF (MPRTIM.NE.0) CALL MONON(2)
              IF (JACGEN.EQ.3) 
     $          CALL N2JCF(FCN,N,M1,X,F,A,XW,ETA,ETAMIN,ETAMAX,
     $                     ETADIF,CONV,NFCNJ,T1,IFAIL)
              IF (JACGEN.EQ.2) 
     $          CALL N2JAC(FCN, N, M1, X, F, A, XW,  AJDEL, AJMIN,
     $                     NFCNJ, T1, IFAIL)
              IF (MPRTIM.NE.0) CALL MONOFF(2)
             ENDIF
            NJAC = NJAC + 1
C     Exit, If ...
            IF (JACGEN.EQ.1 .AND. IFAIL.LT.0) THEN
              IERR = 83
              GOTO 4299
            ENDIF
            IF (JACGEN.NE.1 .AND. IFAIL.NE.0) THEN
              IERR = 82
              GOTO 4299
            ENDIF
          ELSE
            NEW = NEW+1
          ENDIF
          IF ( NEW.EQ.0 ) THEN
C           ------------------------------------------------------
C           2.3.2 Save scaling values
            DO 232 L1=1,N
              XWA(L1) = XW(L1)
232         CONTINUE
C           --------------------------------------------------------
C           2.4 Prepare solution of the linear system
C           --------------------------------------------------------
C           2.4.1 internal column scaling of matrix A
            DO 2410 K=1,N
              S1 =-XW(K)
              DO 2412 L1=1,N
                A(L1,K)=A(L1,K)*S1
2412          CONTINUE
2410        CONTINUE
C           ------------------------------------------------------
C           2.4.2 Row scaling of matrix A
            IF (QSCALE) THEN
              CALL N2SCRF(N,N,A,FW)
            ELSE
              DO 242 K=1,N
                FW(K)=ONE
242           CONTINUE
            ENDIF
          ENDIF
C         --------------------------------------------------------
C         2.4.3 Save and scale values of F(N)
          DO 243 L1=1,N
            FA(L1)=F(L1)
            T1(L1)=F(L1)*FW(L1)
243       CONTINUE
          IRANKA = IRANK
          IF (NITER.NE.0) IRANK = N
          QNEXT = .FALSE.
C         --------------------------------------------------------
C         3 Central part of iteration step
C
C         Pseudo-rank reduction loop
C         ==========================
C         DO (Until)
3         CONTINUE
C           --------------------------------------------------------
C           3.1 Solution of the linear system
C           --------------------------------------------------------
C           3.1.1 Decomposition of (N,N)-matrix A
            IF (.NOT.QLINIT) THEN
              NIWLA = NIWKFR
              NRWLA = NRWKFR
            ENDIF
            IF (NEW.EQ.0) THEN
              COND1 = COND
              IF (QREPET) THEN
                IWK(NIWLA) = 1
              ELSE
                IWK(NIWLA) = 0
              ENDIF
              IF (MPRTIM.NE.0) CALL MONON(3)
              CALL N2FACT(N,M1,N,ML,MU,A,QA,COND1,IRANK,IOPT,IFAIL,LIWL,
     $                    IWK(NIWLA),NILUSE,LRWL,RWK(NRWLA),NRLUSE)
              IF (MPRTIM.NE.0) CALL MONOFF(3)
C     Exit Repeat If ...
              IF(IFAIL.NE.0) THEN
                IERR = 80
                GOTO 4299
              ENDIF
              IF (.NOT.QLINIT) THEN
                NIWKFR = NIWKFR+NILUSE
                NRWKFR = NRWKFR+NRLUSE
C               Store lengths of currently required workspaces
                IWK(18) = NIWKFR-1
                IWK(19) = NRWKFR-1
              ENDIF
              SENS1 = RWK(NRWLA)
            ENDIF
            QLINIT = .TRUE.
C           --------------------------------------------------------
C           3.1.2 Solution of linear (N,N)-system
            IF(NEW.EQ.0) THEN 
              IF (MPRTIM.NE.0) CALL MONON(4)
              CALL N2SOLV(N,M1,N,ML,MU,A,QA,T1,T2,IRANK,IOPT,IFAIL,LIWL,
     $                   IWK(NIWLA),IDUMMY,LRWL,RWK(NRWLA),IDUMMY)
              IF (MPRTIM.NE.0) CALL MONOFF(4)
C     Exit Repeat If ...
              IF(IFAIL.NE.0)  THEN
                IERR = 81
                GOTO 4299
              ENDIF
              IF(.NOT.QREPET.AND.IRANK.NE.0)THEN
                DO 312 L1=1,N
                  QU(L1)=T1(L1)
312             CONTINUE
              ENDIF
            ELSE  
              ALFA1=ZERO
              ALFA2=ZERO
              DO 3121 I=1,N
                ALFA1=ALFA1+DX(I)*DXQ(I)/XW(I)**2
                ALFA2=ALFA2+DX(I)**2/XW(I)**2
3121          CONTINUE
              ALFA=ALFA1/ALFA2
              BETA=ONE-ALFA
              DO 3122 I=1,N
                T2(I)=(DXQ(I)+(FCA-ONE)*ALFA*DX(I))/BETA
3122          CONTINUE
              IF(NEW.EQ.1) THEN
                DO 3123 I=1,N
                  DXSAVE(I,1)=DX(I)
3123            CONTINUE
              ENDIF
              DO 3124 I=1,N
                DXSAVE(I,NEW+1)=T2(I)
                DX(I)=T2(I)
                T2(I)=T2(I)/XW(I)
3124          CONTINUE
            ENDIF
C           --------------------------------------------------------
C           3.2 Evaluation of scaled natural level function SUMX
C               scaled maximum error norm CONV
C               evaluation of (scaled) standard level function
C               DLEVF ( DLEVF only, if MPRMON.GE.2 )
C               and computation of ordinary Newton corrections DX(
C               N)
            CALL N2LVLS(N,T2,XW,F,DX,CONV,SUMX,DLEVF,MPRMON,NEW.EQ.0)
            DO 32 L1=1,N
              XA(L1)=X(L1)
32          CONTINUE
            SUMXA = SUMX
            DLEVXA = DSQRT(SUMXA/DBLE(FLOAT(N)))
            CONVA = CONV
            DXANRM = WNORM(N,DX,XW)
C           --------------------------------------------------------
C           3.3 A - priori estimate of damping factor FC
            QREDU = .FALSE.
            IF(NITER.NE.0.AND.NONLIN.NE.1)THEN
CWei;              IF(NEW.EQ.0.AND.(IRANK.EQ.N.OR.IRANKA.EQ.N).OR.
CWei;     *           QREPET)THEN
              IF(NEW.EQ.0.OR.QREPET)THEN
C               ------------------------------------------------------
C               3.3.1 Computation of the denominator of a-priori
C                     estimate
                FCDNM = ZERO
                DO 331 L1=1,N
                  FCDNM=FCDNM+((DX(L1)-DXQ(L1))/XW(L1))**2
331             CONTINUE
                IF(IRANK.NE.N)THEN
C                 --------------------------------------------
C                 3.3.2 Rank-deficient case (if previous rank
C                           was full) computation of the projected
C                       denominator of a-priori estimate
                  DO 332 L1=1,N
                    T1(L1)=DXQ(L1)/XW(L1)
332               CONTINUE
C                 Norm of projection of reduced component T1(N)
                  CALL N2PRJN(N,IRANK,DEL,T1,RWK(NRWLA+1),T2,QA,
     $                       IWK(NIWLA+2))
                  FCDNM = FCDNM-DEL
                ENDIF
                FCDNM = FCDNM*SUMX
C               ------------------------------------------------------
C               3.3.3 New damping factor
                IF(FCDNM.GT.FCNUMP*FCMIN2 .OR.
     $            (NONLIN.EQ.4 .AND. FCA**2*FCNUMP .LT. 4.0D0*FCDNM)) 
     $          THEN
                  DMYPRI = FCA*DSQRT(FCNUMP/FCDNM)
                  FCPRI = DMIN1(DMYPRI,ONE)
                  IF (NONLIN.EQ.4) FCPRI = DMIN1(HALF*DMYPRI,ONE)
                ELSE
                  FCPRI = ONE
C$Test-begin
                  DMYPRI = -1.0D0
C$Test-end
                ENDIF
C$Test-begin
                IF (MPRMON.GE.5) THEN
                  WRITE(LUMON,33201) FCPRI, FC, FCA, DMYPRI, FCNUMP,
     $                               FCDNM
33201             FORMAT (/, ' +++ apriori estimate +++', /,
     $                   ' FCPRI  = ', D18.10, '  FC     = ', D18.10, /,
     $                   ' FCA    = ', D18.10, '  DMYPRI = ', D18.10, /,
     $                   ' FCNUMP = ', D18.10, '  FCDNM  = ', D18.10, /,
     $                       ' ++++++++++++++++++++++++', /)
                ENDIF
C$Test-end 
                FC = FCPRI
                IF ( IRANK.EQ.N .OR. IRANK.LE.MINRNK )
     $            FC=DMAX1(FC,FCMIN)
                IF (QBDAMP) THEN
                  FCBH = FCA*FCBND
                  IF (FC.GT.FCBH) THEN
                    FC = FCBH
                    IF (MPRMON.GE.4)
     $                WRITE(LUMON,*)' *** incr. rest. act. (a prio) ***'
                  ENDIF
                  FCBH = FCA/FCBND
                  IF (FC.LT.FCBH) THEN
                    FC = FCBH
                    IF (MPRMON.GE.4)
     $                WRITE(LUMON,*)' *** decr. rest. act. (a prio) ***'
                  ENDIF
                ENDIF
              ENDIF
              QREDU = FC.LT.FCMIN
            ENDIF
            QREPET = .FALSE.
CWEI
            IF (IORMON.GE.2) THEN
              SUMXA2=SUMXA1
              SUMXA1=SUMXA0
              SUMXA0=DLEVXA
              IF (SUMXA0.EQ.ZERO) SUMXA0=SMALL
C             Check convergence rates (linear and superlinear)
C             ICONV : Convergence indicator
C                     =0: No convergence indicated yet
C                     =1: Damping factor is 1.0d0
C                     =2: Superlinear convergence detected (alpha >=1.2)
C                     =3: Quadratic convergence detected (alpha > 1.8)
              FCMON = DMIN1(FC,FCMON)
              IF (FCMON.LT.ONE) THEN
                ICONV = 0
                ALPHAE = ZERO
              ENDIF
              IF (FCMON.EQ.ONE .AND. ICONV.EQ.0) ICONV=1
              IF (NITER.GE.1) THEN
                CLIN1 = CLIN0
                CLIN0 = SUMXA0/SUMXA1
              ENDIF
              IF (ICONV.GE.1.AND.NITER.GE.2) THEN
                ALPHAK = ALPHAE
                ALPHAE = ZERO
                IF (CLIN1.LE.0.95D0) ALPHAE = DLOG(CLIN0)/DLOG(CLIN1)
                IF (ALPHAK.NE.ZERO) ALPHAK =0.5D0*(ALPHAE+ALPHAK)
                ALPHAA = DMIN1(ALPHAK,ALPHAE)
                CALPHK = CALPHA
                CALPHA = ZERO
                IF (ALPHAE.NE.ZERO) CALPHA = SUMXA1/SUMXA2**ALPHAE
                SUMXTE = DSQRT(CALPHA*CALPHK)*SUMXA1**ALPHAK-SUMXA0
                IF (ALPHAA.GE.1.2D0 .AND. ICONV.EQ.1) ICONV = 2
                IF (ALPHAA.GT.1.8D0) ICONV = 3
                IF (MPRMON.GE.4)  WRITE(LUMON,32001) ICONV, ALPHAE, 
     $                              CALPHA, CLIN0, ALPHAK, SUMXTE
32001           FORMAT(' ** ICONV: ',I1,'  ALPHA: ',D9.2,
     $                '  CONST-ALPHA: ',D9.2,'  CONST-LIN: ',D9.2,' **',
     $                /,' **',11X,'ALPHA-POST: ',D9.2,' CHECK: ',D9.2,
     $                25X,'**')
                IF ( ICONV.GE.2 .AND. ALPHAA.LT.0.9D0 ) THEN
                   IF (IORMON.EQ.3) THEN
                     IERR = 4
                     GOTO 4299
                   ELSE
                     QMSTOP = .TRUE.
                   ENDIF 
                ENDIF
              ENDIF
            ENDIF
            FCMON = FC
C
            IF (MPRMON.GE.2) THEN
              IF (MPRTIM.NE.0) CALL MONON(5)
              CALL N2PRV1(DLEVF,DLEVXA,FCKEEP,NITER,NEW,IRANK,MPRMON,
     $                    LUMON,QMIXIO,COND1)
              IF (MPRTIM.NE.0) CALL MONOFF(5)
            ENDIF
            IF(.NOT.QREDU)THEN
C             --------------------------------------------------------
C             3.4 Save natural level for later computations of
C                 corrector and print iterate
              FCNUMK = SUMX
              NRED = 0
              QREP  = .FALSE.   
C             QREP = ITER .GT. ITMAX   or  QREP = ITER .GT. 0
C             Damping-factor reduction loop
C             ================================
C             DO (Until)
34            CONTINUE
C               ------------------------------------------------------
C               3.5 Preliminary new iterate
                DO 35 L1=1,N
                  X(L1)=XA(L1)+DX(L1)*FC
35              CONTINUE
C               -----------------------------------------------------
C               3.5.2 Exit, if problem is specified as being linear
C     Exit Repeat If ...
                IF( NONLIN.EQ.1 )THEN
                  IERR = 0
                  GOTO 4299
                ENDIF
C               ------------------------------------------------------
C               3.6.1 Computation of the residual vector
                IF (MPRTIM.NE.0) CALL MONON(1)
                CALL FCN(N,X,F,IFAIL)
                IF (MPRTIM.NE.0) CALL MONOFF(1)
                NFCN = NFCN+1
C     Exit, if ...
                IF (IFAIL.LT.0) THEN
                  IERR = 82
                  GOTO 4299
                ENDIF
                IF(IFAIL.EQ.1 .OR. IFAIL.EQ.2) THEN
                  IF (IFAIL.EQ.1) THEN
                    FCREDU = HALF
                  ELSE
                    FCREDU = F(1)
C     Exit, If ...
                    IF (FCREDU.LE.0 .OR. FCREDU.GE.1) THEN
                      IERR = 83
                      GOTO 4299
                    ENDIF
                  ENDIF
                  IF (MPRMON.GE.2) THEN
36101               FORMAT(8X,I2,' FCN could not be evaluated  ',
     $                     8X,F7.5,4X,I2,6X,I4)
                    WRITE(LUMON,36101)NITER,FC,NEW,IRANK
                  ENDIF
                  FCH = FC
                  FC = FCREDU*FC
                  IF (FCH.GT.FCMIN) FC = DMAX1(FC,FCMIN)
                  IF (QBDAMP) THEN
                    FCBH = FCH/FCBND
                    IF (FC.LT.FCBH) THEN
                      FC = FCBH
                      IF (MPRMON.GE.4) WRITE(LUMON,*)
     $                   ' *** decr. rest. act. (FCN redu.) ***'
                    ENDIF
                  ENDIF
                  IF (FC.LT.FCMIN) THEN
                    IERR = 3
                    GOTO 4299
                  ENDIF  
C     Break DO (Until) ...
                  GOTO 3109
                ENDIF
                DO 361 L1=1,N
                  T1(L1)=F(L1)*FW(L1)
361             CONTINUE
C               ------------------------------------------------------
C               3.6.2 Solution of linear (N,N)-system
                IF (QREPET) THEN
                  IWK(NIWLA) = 1
                ELSE
                  IWK(NIWLA) = 0
                ENDIF
                IF (MPRTIM.NE.0) CALL MONON(4)
                CALL N2SOLV(N,M1,N,ML,MU,A,QA,T1,T2,IRANK,IOPT,IFAIL,
     $                      LIWL,IWK(NIWLA),IDUMMY,LRWL,RWK(NRWLA),
     $                      IDUMMY)
                IF (MPRTIM.NE.0) CALL MONOFF(4)
C     Exit Repeat If ...
                IF(IFAIL.NE.0)  THEN
                  IERR = 81
                  GOTO 4299
                ENDIF
                IF(NEW.GT.0) THEN 
                  DO 3630 I=1,N
                    DXQ(I) = T2(I)*XWA(I)
3630              CONTINUE                   
                  DO 363 ILOOP=1,NEW 
                    SUM1=ZERO
                    SUM2=ZERO
                    DO 3631 I=1,N
                      SUM1=SUM1+(DXQ(I)*DXSAVE(I,ILOOP))/ XW(I)**2
                      SUM2=SUM2+(DXSAVE(I,ILOOP)/XW(I))**2
3631                CONTINUE
                    BETA=SUM1/SUM2
                    DO 3632 I=1,N
                      DXQ(I)=DXQ(I)+BETA*DXSAVE(I,ILOOP+1)
                      T2(I) = DXQ(I)/XW(I)
3632                CONTINUE
363               CONTINUE
                ENDIF
C               ------------------------------------------------------
C               3.6.3 Evaluation of scaled natural level function
C                     SUMX
C                     scaled maximum error norm CONV and evaluation
C                     of (scaled) standard level function DLEVF
                CALL N2LVLS(N,T2,XW,F,DXQ,CONV,SUMX,DLEVFN,MPRMON,
     $                      NEW.EQ.0)
                DXNRM = WNORM(N,DXQ,XW)
C               ------------------------------------------------------
C               3.6.4 Convergence test
C     Exit Repeat If ...
                IF ( DXNRM.LE.RTOL .AND. DXANRM.LE.RSMALL .AND. 
     $              FC.EQ.ONE ) THEN
                  IERR = 0
                  GOTO 4299
                ENDIF
C           
                FCA = FC
C               ----------------------------------------------------
C               3.6.5 Evaluation of reduced damping factor
                TH = FCA-ONE
                FCDNM = ZERO
                DO 39 L1=1,N
                  FCDNM=FCDNM+((DXQ(L1)+TH*DX(L1))/XW(L1))**2
39              CONTINUE
                IF (FCDNM.NE.ZERO) THEN
                  DMYCOR = FCA*FCA*HALF*DSQRT(FCNUMK/FCDNM)
                ELSE
                  DMYCOR = 1.0D+35
                ENDIF
                IF (NONLIN.LE.3) THEN
                  FCCOR = DMIN1(ONE,DMYCOR)
                ELSE
                  FCCOR = DMIN1(ONE,HALF*DMYCOR)
                ENDIF
C$Test-begin
                IF (MPRMON.GE.5) THEN
                  WRITE(LUMON,39001) FCCOR, FC, DMYCOR, FCNUMK,
     $                               FCDNM, FCA
39001             FORMAT (/, ' +++ corrector computation +++', /,
     $                   ' FCCOR  = ', D18.10, '  FC     = ', D18.10, /,
     $                   ' DMYCOR = ', D18.10, '  FCNUMK = ', D18.10, /,
     $                   ' FCDNM  = ', D18.10, '  FCA    = ', D18.10, /,
     $                       ' +++++++++++++++++++++++++++++', /)
                ENDIF
C$Test-end 
C               ------------------------------------------------------
C               3.7 Natural monotonicity test
                IF(SUMX.GT.SUMXA)THEN
C                 ----------------------------------------------------
C                 3.8 Output of iterate
                  IF(MPRMON.GE.3) THEN
                    IF (MPRTIM.NE.0) CALL MONON(5)
                    CALL N2PRV2(DLEVFN,DSQRT(SUMX/DBLE(FLOAT(N))),FC,
     $                          NITER,MPRMON,LUMON,QMIXIO,'*')
                    IF (MPRTIM.NE.0) CALL MONOFF(5)
                  ENDIF
                  IF (QMSTOP) THEN
                    IERR = 4
                    GOTO 4299
                  ENDIF
                  FC = DMIN1(FCCOR,HALF*FC)
                  IF ((IRANK.EQ.N .OR. IRANK.EQ.MINRNK) .AND.
     $               FCA.GT.FCMIN)
     $               FC=DMAX1(FC,FCMIN)
                  IF (QBDAMP) THEN
                    FCBH = FCA/FCBND
                    IF (FC.LT.FCBH) THEN
                      FC = FCBH
                      IF (MPRMON.GE.4) WRITE(LUMON,*) 
     $                    ' *** decr. rest. act. (a post) ***'
                    ENDIF
                  ENDIF
CWEI
                  FCMON = FC
C
C$Test-begin
                  IF (MPRMON.GE.5) THEN
                    WRITE(LUMON,39002) FC
39002               FORMAT (/, ' +++ corrector setting 1 +++', /,
     $                      ' FC     = ', D18.10, /,
     $                         ' +++++++++++++++++++++++++++', /)
                  ENDIF
C$Test-end 
                  QREP = .TRUE.
                  NCORR = NCORR+1
                  NRED = NRED+1
C                 ----------------------------------------------------
C                  3.10 If damping factor is too small:
C                       Refresh Jacobian,if current Jacobian was computed
C                       by a Rank1-update, else reduce pseudo-rank
                  QREDU  = FC.LT.FCMIN.OR.NEW.GT.0.AND.NRED.GT.1
                ELSE
                  IF (.NOT.QREP .AND. FCCOR.GT.SIGMA2*FC) THEN
                    IF(MPRMON.GE.3) THEN
                      IF (MPRTIM.NE.0) CALL MONON(5)
                      CALL N2PRV2(DLEVFN,DSQRT(SUMX/DBLE(FLOAT(N))),FC,
     $                            NITER,MPRMON,LUMON,QMIXIO,'+')
                      IF (MPRTIM.NE.0) CALL MONOFF(5)
                    ENDIF
                    FC = FCCOR
C$Test-begin
                    IF (MPRMON.GE.5) THEN
                      WRITE(LUMON,39003) FC
39003                 FORMAT (/, ' +++ corrector setting 2 +++', /,
     $                        ' FC     = ', D18.10, /,
     $                           ' +++++++++++++++++++++++++++', /)
                    ENDIF
C$Test-end 
                    QREP = .TRUE.
                  ELSE
                    QNEXT = .TRUE.
                  ENDIF
                ENDIF
3109          CONTINUE
              IF(.NOT.(QNEXT.OR.QREDU)) GOTO  34
C             UNTIL ( expression - negated above)
C             End of damping-factor reduction loop
C           =======================================
            ENDIF
            IF(QREDU)THEN
C             ------------------------------------------------------
C             3.11 Restore former values for repeting step
C                  step
              NREJR1 = NREJR1+1
              DO 3111 L1=1,N
                X(L1)=XA(L1)
3111          CONTINUE
              DO 3112 L1=1,N
                F(L1)=FA(L1)
3112          CONTINUE
              DO 3113 L1=1,N
                DXQ(L1)=DXQA(L1)
3113          CONTINUE
              IF(MPRMON.GE.2)THEN
31130           FORMAT(8X,I2,' Not accepted damping ',
     $                 'factor',9X,F7.5,4X,I2,6X,I4)
                WRITE(LUMON,31130)NITER,FC,NEW,IRANK
              ENDIF
              FC = FCKEEP
              FCA = FCK2
              IF(NITER.EQ.0)THEN
                FC = FCMIN
              ENDIF
              IF(NEW.GT.0)THEN
                QGENJ = .TRUE.
                QJCRFR = .TRUE.
                QREDU = .FALSE.
              ELSE
C               ------------------------------------------------
C               3.12 Pseudo-rank reduction
                QREPET = .TRUE.
                DO 42 L1=1,N
                  T1(L1)=QU(L1)
42              CONTINUE
                IRANK = IRANK-1
                IF(IRANK.LT.MINRNK)THEN
                  IERR = 3
                  GOTO 4299
                ENDIF
              ENDIF
            ENDIF
          IF(.NOT.(.NOT.QREDU)) GOTO  3
C         UNTIL ( expression - negated above)
C
C         End of pseudo-rank reduction loop
C         =================================
          IF (QNEXT) THEN
C           ------------------------------------------------------
C           4 Preparations to start the following iteration step
C           ------------------------------------------------------
C           4.1 Print values
            IF(MPRMON.GE.3) THEN
              IF (MPRTIM.NE.0) CALL MONON(5)
              CALL N2PRV2(DLEVFN,DSQRT(SUMX/DBLE(FLOAT(N))),FC,NITER+1,
     $                    MPRMON,LUMON,QMIXIO,'*')
              IF (MPRTIM.NE.0) CALL MONOFF(5)
            ENDIF
C           Print the natural level of the current iterate and return
C           it in one-step mode
            SUMX = SUMXA
            IF(MPRSOL.GE.2.AND.NITER.NE.0) THEN
              IF (MPRTIM.NE.0) CALL MONON(5)
              CALL N2SOUT(N,XA,2,IOPT,RWK,LRWK,IWK,LIWK,MPRSOL,LUSOL)
              IF (MPRTIM.NE.0) CALL MONOFF(5)
            ELSE IF(MPRSOL.GE.1.AND.NITER.EQ.0)THEN
              IF (MPRTIM.NE.0) CALL MONON(5)
              CALL N2SOUT(N,XA,1,IOPT,RWK,LRWK,IWK,LIWK,MPRSOL,LUSOL)
              IF (MPRTIM.NE.0) CALL MONOFF(5)
            ENDIF
            NITER = NITER+1
            DLEVF = DLEVFN
C     Exit Repeat If ...
            IF(NITER.GE.NITMAX)THEN
              IERR = 2
              GOTO 4299
            ENDIF
            FCKEEP = FC
C           ------------------------------------------------------
C           4.2 Return, if in one-step mode
C Exit Subroutine If ...
            IF (MODE.EQ.1) THEN
              IWK(18)=NIWLA-1
              IWK(19)=NRWLA-1
              IOPT(1)=1
              RETURN
            ENDIF
          ENDIF
        GOTO 2
C       End Repeat
4299    CONTINUE
C
C       End of main iteration loop
C       ==========================
C       ----------------------------------------------------------
C       9 Exits
C       ----------------------------------------------------------
C       9.1 Solution exit
        APREC = -1.0D0
C
        IF(IERR.EQ.0 .OR. IERR.EQ.4)THEN
          IF (NONLIN.NE.1) THEN
            IF ( IERR.EQ.0 ) THEN
              APREC = DSQRT(SUMX/DBLE(FLOAT(N)))
              DO 91 L1=1,N
                X(L1)=X(L1)+DXQ(L1)
91            CONTINUE
            ELSE 
              APREC = DSQRT(SUMXA/DBLE(FLOAT(N)))
              IF (ALPHAA.GT.ZERO .AND. IORMON.EQ.3) THEN
                DO 92 L1=1,N
                  X(L1)=X(L1)+DX(L1)
92              CONTINUE
              ENDIF
            ENDIF
            IF(IRANK.LT.N)THEN
              IERR = 1
            ENDIF
C           Print final monitor output
            IF(MPRMON.GE.2) THEN
              IF (IERR.EQ.0) THEN
                IF (MPRTIM.NE.0) CALL MONON(5)
                CALL N2PRV2(DLEVFN,DSQRT(SUMX/DBLE(FLOAT(N))),FC,
     $                      NITER+1,MPRMON,LUMON,QMIXIO,'*')
                IF (MPRTIM.NE.0) CALL MONOFF(5)
              ELSE IF (IORMON.EQ.3) THEN
                IF (MPRTIM.NE.0) CALL MONON(5)
                CALL N2PRV1(DLEVFN,DSQRT(SUMXA/DBLE(FLOAT(N))),FC,
     $                      NITER,NEW,IRANK,MPRMON,LUMON,QMIXIO,COND1)
                IF (MPRTIM.NE.0) CALL MONOFF(5)
              ENDIF
            ENDIF
            IF (  IORMON.GE.2 ) THEN
              IF ( ICONV.LE.1 .AND. ALPHAE .NE. ZERO 
     $                        .AND. ALPHAK .NE. ZERO ) IERR = 5
            ENDIF
C
            IF(MPRMON.GE.1.AND. IERR.NE.1) THEN
91001         FORMAT(///' Solution of nonlinear system ',
     $        'of equations obtained within ',I3,
     $        ' iteration steps',//,' Achieved relative accuracy',D10.3)
              IF (IERR.EQ.4) THEN
                WRITE(LUMON,91001) NITER,APREC
              ELSE
                WRITE(LUMON,91001) NITER+1,APREC
              ENDIF 
            ENDIF
          ELSE
            IF(MPRMON.GE.1) THEN
91002         FORMAT(///' Solution of linear system ',
     $        'of equations obtained by NLEQ2',//,' No estimate ',
     $        'available for the achieved relative accuracy')
                WRITE(LUMON,91002)
            ENDIF
          ENDIF
        ENDIF
C       ----------------------------------------------------------
C       9.2 Fail exit messages
C       ----------------------------------------------------------
C       9.2.1 Termination at stationary point
        IF(IERR.EQ.1.AND.MPRERR.GE.1)THEN
92101     FORMAT(/,' Iteration terminates at stationary point',/)
          WRITE(LUERR,92101)
        ENDIF
C       ----------------------------------------------------------
C       9.2.2 Termination after more than NITMAX iterations
        IF(IERR.EQ.2.AND.MPRERR.GE.1)THEN
92201     FORMAT(/,' Iteration terminates after NITMAX ',
     $    '=',I3,'  Iteration steps')
          WRITE(LUERR,92201)NITMAX
        ENDIF
C       ----------------------------------------------------------
C       9.2.3 Newton method fails to converge
        IF(IERR.EQ.3.AND.MPRERR.GE.1)THEN
92301     FORMAT(/,' Newton method fails to converge')
          WRITE(LUERR,92301)
        ENDIF
CWEI
C       ----------------------------------------------------------
C       9.2.4.1 Superlinear convergence slowed down
        IF(IERR.EQ.4.AND.MPRERR.GE.1)THEN
92401     FORMAT(/,' Warning: Monotonicity test failed after ',A,
     $           ' convergence was already checked;',/,
     $    ' RTOL requirement may be too stringent',/)
92402     FORMAT(/,' Warning: ',A,' convergence slowed down;',/,
     $    ' RTOL requirement may be too stringent',/)
          IF (QMSTOP) THEN
            IF (ICONV.EQ.2) WRITE(LUERR,92401) 'superlinear'
            IF (ICONV.EQ.3) WRITE(LUERR,92401) 'quadratic'
          ELSE
            IF (ICONV.EQ.2) WRITE(LUERR,92402) 'superlinear'
            IF (ICONV.EQ.3) WRITE(LUERR,92402) 'quadratic'
          ENDIF
        ENDIF
C       ----------------------------------------------------------
C       9.2.4.2 Convergence criterion satisfied before superlinear
C               convergence has been established
        IF (IERR.EQ.5.AND.DLEVFN.EQ.ZERO) IERR=0
        IF(IERR.EQ.5.AND.MPRERR.GE.1)THEN
92410     FORMAT(/,' Warning: No quadratic or superlinear convergence ',
     $           'established yet',/,
     $           10X,'your solution may perhaps may be less accurate ',
     $           /,10X,'as indicated by the standard error estimate')
          WRITE(LUERR,92410)
        ENDIF
C       ----------------------------------------------------------
C       9.2.5 Error exit due to linear solver routine N2FACT
        IF(IERR.EQ.80.AND.MPRERR.GE.1)THEN
92501     FORMAT(/,' Error ',I5,' signalled by linear solver N2FACT')
          WRITE(LUERR,92501) IFAIL
        ENDIF
C       ----------------------------------------------------------
C       9.2.6 Error exit due to linear solver routine N2SOLV
        IF(IERR.EQ.81.AND.MPRERR.GE.1)THEN
92601     FORMAT(/,' Error ',I5,' signalled by linear solver N2SOLV')
          WRITE(LUERR,92601) IFAIL
        ENDIF
C       ----------------------------------------------------------
C       9.2.7 Error exit due to fail of user function FCN
        IF(IERR.EQ.82.AND.MPRERR.GE.1)THEN
92701     FORMAT(/,' Error ',I5,' signalled by user function FCN')
          WRITE(LUERR,92701) IFAIL
        ENDIF
C       ----------------------------------------------------------
C       9.2.8 Error exit due to fail of user function JAC
        IF(IERR.EQ.83.AND.MPRERR.GE.1)THEN
92801     FORMAT(/,' Error ',I5,' signalled by user function JAC')
          WRITE(LUERR,92801) IFAIL
        ENDIF
        IF(IERR.GE.80.AND.IERR.LE.83) IWK(23) = IFAIL
        IF ((IERR.EQ.82.OR.IERR.EQ.83).AND.NITER.LE.1.AND.MPRERR.GE.1)
     $  THEN
          WRITE (LUERR,92810)
92810     FORMAT(' Try to find a better initial guess for the solution')
        ENDIF
C       ----------------------------------------------------------
C       9.3 Common exit
        IF (MPRERR.GE.3.AND.IERR.NE.0.AND.IERR.NE.4.AND.NONLIN.NE.1)
     $    THEN
93100     FORMAT(/,'    Achieved relative accuracy',D10.3,2X)
          WRITE(LUERR,93100)CONVA
          APREC = CONVA
        ENDIF
        IF(MPRMON.GE.1)THEN
93001     FORMAT(/,3X,'Subcondition ( 1,',I4,')',1X,D10.3,2X,
     $    /,3X,'Sensitivity ( 1,',I4,')',1X,D10.3,2X,/)
          WRITE(LUMON,93001)IRANK,COND1,IRANK,SENS1
        ENDIF
        RTOL = APREC
        SUMX = SUMXA
        IF(MPRSOL.GE.2.AND.NITER.NE.0) THEN
          IF (MPRTIM.NE.0) CALL MONON(5)
          CALL N2SOUT(N,XA,2,IOPT,RWK,LRWK,IWK,LIWK,MPRSOL,LUSOL)
          IF (MPRTIM.NE.0) CALL MONOFF(5)
        ELSE IF(MPRSOL.GE.1.AND.NITER.EQ.0)THEN
          IF (MPRTIM.NE.0) CALL MONON(5)
          CALL N2SOUT(N,XA,1,IOPT,RWK,LRWK,IWK,LIWK,MPRSOL,LUSOL)
          IF (MPRTIM.NE.0) CALL MONOFF(5)
        ENDIF
        IF (IERR.NE.4) NITER = NITER+1
        DLEVF = DLEVFN
        IF(MPRSOL.GE.1)THEN
C         Print Solution or final iteration vector
          IF(IERR.EQ.0)THEN
             MODEFI = 3
          ELSE
             MODEFI = 4
          ENDIF
          IF (MPRTIM.NE.0) CALL MONON(5)
          CALL N2SOUT(N,X,MODEFI,IOPT,RWK,LRWK,IWK,LIWK,MPRSOL,LUSOL)
          IF (MPRTIM.NE.0) CALL MONOFF(5)
        ENDIF
C       Return the latest internal scaling to XSCAL
        DO 93 I=1,N
          XSCAL(I)=XW(I)
93      CONTINUE
C       End of exits
C       End of subroutine N2INT
      RETURN
      END
C
      SUBROUTINE N2SCAL(N,X,XA,XSCAL,XW,ISCAL,QINISC,IOPT,LRWK,RWK)
C*    Begin Prologue SCALE
      INTEGER N
      DOUBLE PRECISION X(N),XSCAL(N),XA(N),XW(N)
      INTEGER ISCAL
      LOGICAL QINISC
      INTEGER IOPT(50),LRWK
      DOUBLE PRECISION RWK(LRWK)
C     ------------------------------------------------------------
C
C*    Summary :
C    
C     S C A L E : To be used in connection with NLEQ2 .
C       Computation of the internal scaling vector XW used for the
C       Jacobian matrix, the iterate vector and it's related
C       vectors - especially for the solution of the linear system
C       and the computations of norms to avoid numerical overflow.
C
C*    Input parameters
C     ================
C
C     N         Int     Number of unknowns
C     X(N)      Dble    Current iterate
C     XA(N)     Dble    Previous iterate
C     XSCAL(N)  Dble    User scaling passed from parameter XSCAL
C                       of interface routine NLEQ2
C     ISCAL     Int     Option ISCAL passed from IOPT-field
C                       (for details see description of IOPT-fields)
C     QINISC    Logical = .TRUE.  : Initial scaling
C                       = .FALSE. : Subsequent scaling
C     IOPT(50)  Int     Options array passed from NLEQ2 parameter list
C     LRWK      Int     Length of real workspace
C     RWK(LRWK) Dble    Real workspace (see description above)
C
C*    Output parameters
C     =================
C
C     XW(N)     Dble   Scaling vector computed by this routine
C                      All components must be positive. The follow-
C                      ing relationship between the original vector
C                      X and the scaled vector XSCAL holds:
C                      XSCAL(I) = X(I)/XW(I) for I=1,...N
C
C*    Subroutines called: ZIBCONST
C
C*    Machine constants used
C     ======================
C
      DOUBLE PRECISION EPMACH,SMALL
C
C     ------------------------------------------------------------
C*    End Prologue
      INTRINSIC DABS,DMAX1
      DOUBLE PRECISION HALF
      PARAMETER (HALF=0.5D0)
      INTEGER MPRMON,LUMON
      CALL ZIBCONST(EPMACH,SMALL)
C*    Begin
      DO 1 L1=1,N
        IF (ISCAL.EQ.1) THEN
          XW(L1) = XSCAL(L1)
        ELSE
          XW(L1)=DMAX1(XSCAL(L1),(DABS(X(L1))+DABS(XA(L1)))*HALF,SMALL)
        ENDIF
1     CONTINUE
C$Test-Begin
      MPRMON = IOPT(13)
      IF (MPRMON.GE.6) THEN
        LUMON = IOPT(14)
        WRITE(LUMON,*) ' '
        WRITE(LUMON,*) ' ++++++++++++++++++++++++++++++++++++++++++'
        WRITE(LUMON,*) '      X-components   Scaling-components    '
        WRITE(LUMON,10) (X(L1), XW(L1), L1=1,N)
10      FORMAT('  ',D18.10,'  ',D18.10)
        WRITE(LUMON,*) ' ++++++++++++++++++++++++++++++++++++++++++'
        WRITE(LUMON,*) ' '
      ENDIF
C$Test-End
C     End of subroutine N2SCAL
      RETURN
      END
C
      SUBROUTINE N2SCRF(M,N,A,FW)
C*    Begin Prologue SCROWF
      INTEGER M,N
      DOUBLE PRECISION A(M,N),FW(M)
C     ------------------------------------------------------------
C
C*    Summary :
C
C     S C R O W F : Row Scaling of a (M,N)-matrix in full storage
C                   mode
C
C*    Input parameters (* marks inout parameters)
C     ===========================================
C
C       M           Int    Number of rows of the matrix
C       N           Int    Number of columns of the matrix
C     * A(M,N)      Dble   Matrix to be scaled
C
C*    Output parameters
C     =================
C
C       FW(M)       Dble   Row scaling factors - FW(i) contains
C                          the factor by which the i-th row of A
C                          has been multiplied
C
C     ------------------------------------------------------------
C*    End Prologue
      INTRINSIC DABS
      DOUBLE PRECISION ONE
      PARAMETER (ONE=1.0D0)
      DOUBLE PRECISION ZERO
      PARAMETER (ZERO=0.0D0)
      INTEGER J,K
      DOUBLE PRECISION S1,S2
C*    Begin
      DO 1 K=1,M
        S1=ZERO
        DO 2 J=1,N
          S2=DABS(A(K,J))
          IF (S2.GT.S1) S1=S2
2       CONTINUE
        IF (S1.GT.ZERO) THEN
          S1=ONE/S1
          FW(K)=S1
          DO 3 J=1,N
            A(K,J)=A(K,J)*S1
3         CONTINUE
        ELSE
          FW(K)=ONE
        ENDIF
1     CONTINUE
C     End of subroutine N1SCRF
      RETURN
      END
C
      SUBROUTINE N2FACT(N,LDA,LDAINV,ML,MU,A,AINV,COND,IRANK,IOPT,
     $IFAIL,LIWK,IWK,LAIWK,LRWK,RWK,LARWK)
C*    Begin Prologue FACT
      INTEGER N,LDA,LDAINV,ML,MU
      DOUBLE PRECISION A(LDA,N),AINV(LDAINV,N)
      DOUBLE PRECISION COND
      INTEGER IRANK
      INTEGER IOPT(50)
      INTEGER IFAIL
      INTEGER LIWK
      INTEGER IWK(LIWK)
      INTEGER LAIWK,LRWK
      DOUBLE PRECISION RWK(LRWK)
      INTEGER LARWK
C     ------------------------------------------------------------
C
C*    Summary :
C
C     F A C T : Call linear algebra subprogram for factorization of
C               a (N,N)-matrix with rank decision and casual compu-
C               tation of the rank deficient pseudo-inverse matrix
C
C*    Input parameters (* marks inout parameters)
C     ===========================================
C
C     N             Int    Order of the linear system
C     LDA           Int    Leading dimension of the matrix array A
C     LDAINV        Int    Leading dimension of the matrix array AINV
C     ML            Int    Lower bandwidth of the matrix (only for
C                          banded systems)
C     MU            Int    Upper bandwidth of the matrix (only for
C                          banded systems)
C   * A(LDA,N)      Dble   Matrix storage.
C   * COND          Dble   On Input, COND holds the maximum permitted
C                          subcondition for the prescribed rank
C                          On Output, it holds the estimated subcon-
C                          dition of A
C     IOPT(50)      Int    Option vector passed from NLEQ2
C
C*    Output parameters
C     =================
C
C     AINV(LDAINV,N) Dble   If matrix A is rank deficient, this array
C                           holds the pseudo-inverse of A
C     IFAIL          Int    Error indicator returned by this routine:
C                           = 0 matrix decomposition successfull
C                           =10 supplied (integer) workspace too small
C
C*    Workspace parameters
C     ====================
C
C     LIWK           Int    Length of integer workspace passed to this
C                           routine (In)
C     IWK(LIWK)      Int    Integer Workspace supplied for this routine
C     LAIWK          Int    Length of integer Workspace used by this 
C                           routine (out)       
C     LRWK           Int    Length of real workspace passed to this
C                           routine (In)                  
C     RWK(LRWK)      Dble   Real Workspace supplied for this routine
C     LARWK          Int    Length of real Workspace used by this 
C                           routine (out)
C
C*    Subroutines called:  DECCON
C
C     ------------------------------------------------------------
C*    End Prologue
      EXTERNAL DECCON
      INTRINSIC DABS
      DOUBLE PRECISION ONE
      PARAMETER (ONE=1.0D0)
      DOUBLE PRECISION ZERO
      PARAMETER (ZERO=0.0D0)
      INTEGER IREPET,MCON
C*    Begin
      MPRERR=IOPT(11)
      LUERR=IOPT(12)
      LAIWK = N+2
      LARWK = 2*N+1
      IF (LIWK.GE.LAIWK.AND.LRWK.GE.LARWK) THEN
        MCON = 0
        IREPET = -IWK(1)
        IF (IREPET.EQ.0)  IWK(2) = MCON
        CALL DECCON(A,LDA,N,MCON,N,N,IWK(2),IRANK,COND,RWK(2),IWK(3),
     $              IREPET,AINV,RWK(N+2),IFAIL)
        IF (IFAIL.EQ.-2 .AND. MPRERR.GT.0) WRITE(LUERR,10001)
10001   FORMAT(1X,
     $       'DECCON failed to compute rank-deficient QR-decomposition',
     $        /)
        IF(IRANK.NE.0)THEN
          COND = DABS(RWK(2)/RWK(IRANK+1))
          RWK(1) = DABS(RWK(2))
        ELSE
          COND = ONE
          RWK(1) = ZERO
        ENDIF
      ELSE
        IFAIL = 10
10002   FORMAT(/,' Insuffient workspace for linear solver,',
     $         ' at least needed more needed : ',/,
     $         ' ',A,' workspace : ',I4)
        IF (LIWK.LT.LAIWK.AND.MPRERR.GT.0) 
     $    WRITE(LUERR,10002) 'Integer',LAIWK-LIWK
        IF (LRWK.LT.LARWK.AND.MPRERR.GT.0) 
     $    WRITE(LUERR,10002) 'Double',LARWK-LRWK
      ENDIF
      RETURN
      END
C
      SUBROUTINE N2SOLV(N,LDA,LDAINV,ML,MU,A,AINV,B,Z,IRANK,IOPT,
     $IFAIL,LIWK,IWK,LAIWK,LRWK,RWK,LARWK)
C*    Begin Prologue SOLVE
      INTEGER N,LDA,LDAINV,ML,MU
      DOUBLE PRECISION A(LDA,N),AINV(LDAINV,N)
      DOUBLE PRECISION B(N),Z(N)
      INTEGER IRANK
      INTEGER IOPT(50)
      INTEGER IFAIL
      INTEGER LIWK
      INTEGER IWK(LIWK)
      INTEGER LRWK,LAIWK
      DOUBLE PRECISION RWK(LRWK)
      INTEGER LARWK
C     ------------------------------------------------------------
C
C*    Summary :
C
C     S O L V E : Call linear algebra subprogram for solution of
C                 the linear system A*Z = B
C
C*    Parameters
C     ==========
C
C     N,LDA,LDAINV,ML,MU,A,AINV,IRANK,IOPT,IFAIL,LIWK,IWK,LAIWK,LRWK,
C     RWK,LARWK :
C                        See description for subroutine N2FACT.          
C     B          Dble    In:  Right hand side of the linear system
C                        Out: Rhs. transformed to the upper trian-
C                             gular part of the linear system
C     Z          Dble    Out: Solution of the linear system
C
C     Subroutines called: SOLCON
C
C     ------------------------------------------------------------
C*    End Prologue
      EXTERNAL SOLCON
      INTEGER IREPET
C*    Begin
      MCON = 0
      IREPET = -IWK(1)
      CALL SOLCON(A,LDA,N,MCON,N,N,Z,B,IWK(2),IRANK,RWK(2),IWK(3),
     $            IREPET,AINV,RWK(N+2))
      IFAIL = 0
      RETURN
      END
C
      SUBROUTINE N2LVLS(N,DX1,XW,F,DXQ,CONV,SUMX,DLEVF,MPRMON,QDSCAL)
C*    Begin Prologue LEVELS
      INTEGER N,MPRMON
      DOUBLE PRECISION DX1(N),XW(N),F(N),DXQ(N)
      DOUBLE PRECISION CONV,SUMX,DLEVF
      LOGICAL QDSCAL
C     ------------------------------------------------------------
C
C*    Summary :
C
C     L E V E L S : To be used in connection with NLEQ2 .
C     provides descaled solution, error norm and level functions
C
C*    Input parameters (* marks inout parameters)
C     ===========================================
C
C       N              Int    Number of parameters to be estimated
C       DX1(N)         Dble   array containing the scaled Newton
C                             correction
C       XW(N)          Dble   Array containing the scaling values
C       F(N)           Dble   Array containing the residuum
C
C*    Output parameters
C     =================
C
C       DXQ(N)         Dble   Array containing the descaled Newton
C                             correction
C       CONV           Dble   Scaled maximum norm of the Newton
C                             correction
C       SUMX           Dble   Scaled natural level function value
C       DLEVF          Dble   Standard level function value (only
C                             if needed for print)
C       MPRMON         Int    Print information parameter (see
C                             driver routine NLEQ2 )
C       QDSCAL         Logic  .TRUE., if descaling of DX1 required,
C                             else .FALSE.
C
C     ------------------------------------------------------------
C*    End Prologue
      INTRINSIC DABS
      DOUBLE PRECISION ZERO
      PARAMETER (ZERO=0.0D0)
      INTEGER L1
      DOUBLE PRECISION S1
C*    Begin
      IF (QDSCAL) THEN
C       ------------------------------------------------------------
C       1.2 Descaling of solution DX1 ( stored to DXQ )
        DO 12 L1=1,N
          DXQ(L1)=DX1(L1)*XW(L1)
12      CONTINUE
      ENDIF
C     ------------------------------------------------------------
C     2 Evaluation of scaled natural level function SUMX and
C       scaled maximum error norm CONV
      CONV = ZERO
      DO 20 L1=1,N
        S1 = DABS(DX1(L1))
        IF(S1.GT.CONV) CONV=S1
20    CONTINUE
      SUMX = ZERO
      DO 21 L1=1,N
        SUMX = SUMX+DX1(L1)**2
21    CONTINUE
C     ------------------------------------------------------------
C     3 Evaluation of (scaled) standard level function DLEVF
      DLEVF = ZERO
      DO 3 L1=1,N
        DLEVF = DLEVF+F(L1)**2
3     CONTINUE
      DLEVF = DSQRT(DLEVF/DBLE(FLOAT(N)))
C     End of subroutine N2LVLS
      RETURN
      END
C
      SUBROUTINE N2JAC (FCN, N, LDA, X, FX, A, YSCAL, AJDEL, AJMIN,
     $                  NFCN, FU, IFAIL)
C* Begin Prologue N2JAC
      EXTERNAL FCN
      INTEGER N, LDA
      DOUBLE PRECISION X(N), FX(N), A(LDA,N), YSCAL(N), AJDEL, AJMIN
      INTEGER NFCN
      DOUBLE PRECISION FU(N)
      INTEGER IFAIL
C
C  ---------------------------------------------------------------------
C
C* Title
C
C  Evaluation of a dense Jacobian matrix using finite difference
C  approximation adapted for use in nonlinear systems solver NLEQ2
C
C* Environment       Fortran 77
C                    Double Precision
C                    Sun 3/60, Sun OS
C* Latest Revision   January 1991
C
C
C* Parameter list description
C  --------------------------
C
C* External subroutines (to be supplied by the user)
C  -------------------------------------------------
C
C  FCN        Ext     FCN (N, X, FX, IFAIL)
C                     Subroutine in order to provide right-hand
C                     side of first-order differential equations
C    N        Int     Number of rows and columns of the Jacobian
C    X(N)     Dble    The current scaled iterates
C    FX(N)    Dble    Array containing FCN(X)
C    IFAIL    Int     Return code
C                     Whenever a negative value is returned by FCN
C                     routine N2JAC is terminated immediately.
C
C
C* Input parameters (* marks inout parameters)
C  ----------------
C
C  N          Int     Number of rows and columns of the Jacobian
C  LDA        Int     Leading Dimension of array A
C  X(N)       Dble    Array containing the current scaled
C                     iterate
C  FX(N)      Dble    Array containing FCN(X)
C  YSCAL(N)   Dble    Array containing the scaling factors
C  AJDEL      Dble    Perturbation of component k: abs(Y(k))*AJDEL
C  AJMIN      Dble    Minimum perturbation is AJMIN*AJDEL
C  NFCN       Int  *  FCN - evaluation count
C
C* Output parameters (* marks inout parameters)
C  -----------------
C
C  A(LDA,N)   Dble    Array to contain the approximated
C                     Jacobian matrix ( dF(i)/dx(j)in A(i,j))
C  NFCN       Int  *  FCN - evaluation count adjusted
C  IFAIL      Int     Return code non-zero if Jacobian could not
C                     be computed.
C
C* Workspace parameters
C  --------------------
C
C  FU(N)      Dble    Array to contain FCN(x+dx) for evaluation of
C                     the numerator differences
C
C* Called
C  ------
C
      INTRINSIC DABS, DMAX1, DSIGN
C  ---------------------------------------------------------------------
C
C* End Prologue
C
C* Local variables
C  ---------------
C
      INTEGER I, K
      DOUBLE PRECISION U, W
C
C* Begin
C
      IFAIL = 0
      DO 1 K = 1,N
         W = X(K)
         U = DSIGN(DMAX1(DABS(X(K)),AJMIN,YSCAL(K))*AJDEL, X(K))
         X(K) = W + U
C
         CALL FCN (N, X, FU, IFAIL)
         NFCN = NFCN + 1
         IF (IFAIL .NE. 0) GOTO 99
C
         X(K) = W
         DO 11 I = 1,N
            A(I,K) = (FU(I) - FX(I)) / U  
 11      CONTINUE
 1    CONTINUE
C
99    CONTINUE
      RETURN
C
C
C* End of N2JAC
C
      END
      SUBROUTINE N2JCF (FCN, N, LDA, X, FX, A, YSCAL, ETA, ETAMIN,
     $     ETAMAX, ETADIF, CONV, NFCN, FU, IFAIL)
C* Begin Prologue N2JCF
      EXTERNAL FCN
      INTEGER N, LDA
      DOUBLE PRECISION X(N), FX(N), A(LDA,N), YSCAL(N), ETA(N),
     $     ETAMIN, ETAMAX, ETADIF, CONV
      INTEGER NFCN
      DOUBLE PRECISION FU(N)
      INTEGER IFAIL
C
C  ---------------------------------------------------------------------
C
C* Title
C
C  Approximation of dense Jacobian matrix for nonlinear systems solver
C  NLEQ2 with feed-back control of discretization and rounding errors
C
C* Environment       Fortran 77
C                    Double Precision
C                    Sun 3/60, Sun OS
C* Latest Revision   May 1990
C
C
C* Parameter list description
C  --------------------------
C
C* External subroutines (to be supplied by the user)
C  -------------------------------------------------
C
C  FCN        Ext     FCN (N, X, FX, IFAIL)
C                     Subroutine in order to provide right-hand
C                     side of first-order differential equations
C    N        Int     Number of rows and columns of the Jacobian
C    X(N)     Dble    The current scaled iterates
C    FX(N)    Dble    Array containing FCN(X)
C    IFAIL    Int     Return code
C                     Whenever a negative value is returned by FCN
C                     routine N2JCF is terminated immediately.
C
C
C* Input parameters (* marks inout parameters)
C  ----------------
C
C  N          Int     Number of rows and columns of the Jacobian
C  LDA        Int     Leading dimension of A (LDA .GE. N)
C  X(N)       Dble    Array containing the current scaled
C                     iterate
C  FX(N)      Dble    Array containing FCN(X)
C  YSCAL(N)   Dble    Array containing the scaling factors
C  ETA(N)     Dble *  Array containing the scaled denominator
C                     differences
C  ETAMIN     Dble    Minimum allowed scaled denominator
C  ETAMAX     Dble    Maximum allowed scaled denominator
C  ETADIF     Dble    DSQRT (1.1*EPMACH)
C                     EPMACH = machine precision
C  CONV       Dble    Maximum norm of last (unrelaxed) Newton correction
C  NFCN       Int  *  FCN - evaluation count
C
C* Output parameters (* marks inout parameters)
C  -----------------
C
C  A(LDA,N)   Dble    Array to contain the approximated
C                     Jacobian matrix ( dF(i)/dx(j)in A(i,j))
C  ETA(N)     Dble *  Scaled denominator differences adjusted
C  NFCN       Int  *  FCN - evaluation count adjusted
C  IFAIL      Int     Return code non-zero if Jacobian could not
C                     be computed.
C
C* Workspace parameters
C  --------------------
C
C  FU(N)      Dble    Array to contain FCN(x+dx) for evaluation of
C                     the numerator differences
C
C* Called
C  ------
C
      INTRINSIC DABS, DMAX1, DMIN1, DSIGN, DSQRT
C
C* Constants
C  ---------
C
      DOUBLE PRECISION SMALL2, ZERO
      PARAMETER (SMALL2 = 0.1D0,
     $           ZERO   = 0.0D0)
C
C  ---------------------------------------------------------------------
C
C* End Prologue
C
C* Local variables
C  ---------------
C
      INTEGER I, K, IS
      DOUBLE PRECISION FHI, HG, U, SUMD, W
      LOGICAL QFINE
C
C* Begin
C
      DO 1 K = 1,N
         IS = 0
C        DO (Until)
 11         CONTINUE
            W = X(K)
            U = DSIGN (ETA(K)*YSCAL(K), X(K))
            X(K) = W + U
            CALL FCN (N, X, FU, IFAIL)
            NFCN = NFCN + 1
C           Exit, If ...
            IF (IFAIL .NE. 0) GOTO 99
            X(K) = W
            SUMD = ZERO
            DO 111 I = 1,N
               HG = DMAX1 (DABS (FX(I)), DABS (FU(I)))
               FHI = FU(I) - FX(I)
               IF (HG .NE. ZERO) SUMD = SUMD + (FHI/HG)**2
               A(I,K) = FHI / U
 111        CONTINUE
            SUMD = DSQRT (SUMD / DBLE(N))
            QFINE = .TRUE.
            IF (SUMD .NE. ZERO .AND. IS .EQ. 0)THEN
               ETA(K) = DMIN1 (ETAMAX,
     $              DMAX1 (ETAMIN, DSQRT (ETADIF / SUMD)*ETA(K)))
               IS = 1
               QFINE = CONV .LT. SMALL2 .OR. SUMD .GE. ETAMIN
            ENDIF
            IF (.NOT.(QFINE)) GOTO  11
C        UNTIL ( expression - negated above)
 1    CONTINUE
C
C     Exit from DO-loop
 99   CONTINUE
C
      RETURN
C
C* End of subroutine N2JCF
C
      END
      SUBROUTINE N2PRJN(N,IRANK,DEL,U,D,V,QE,PIVOT)
C*    Begin Prologue PRJCTN
      INTEGER IRANK,N
      INTEGER PIVOT(N)
      DOUBLE PRECISION DEL
      DOUBLE PRECISION QE(N,N)
      DOUBLE PRECISION U(N),D(N),V(N)
C     ------------------------------------------------------------
C
C*    Summary :
C
C     P R J C T N :
C     To be used in connection with either DECOMP/SOLVE or 
C     DECCON/SOLCON .
C     Provides the projection to the appropriate subspace in case
C     of rank - reduction
C
C*    Input parameters (* marks inout parameters)
C     ===========================================
C
C       N              Int    Number of parameters to be estimated
C       IRANK                 Pseudo rank of decomposed Jacobian
C                             matrix
C       U(N)           Dble   Scaled Newton correction
C       D(N)           Dble   Diagonal elements of upper
C                             triangular matrix
C       QE(N,N)        Dble   Part of pseudoinverse Jacobian
C                             matrix ( see QA of DECCON )
C       PIVOT(N)       Dble   Pivot vector resulting from matrix
C                             decomposition (DECCON)
C       V(N)           Dble   Real work array
C
C*    Output parameters
C     =================
C
C       DEL            Dble   Defekt
C
C     ------------------------------------------------------------
C*    End Prologue
      DOUBLE PRECISION ZERO
      PARAMETER (ZERO=0.0D0)
      INTEGER L1,I,IRK1
      DOUBLE PRECISION S,SH
C*    Begin
      DO 1 I=1,N
        V(I)=U(PIVOT(I))
1     CONTINUE
      IRK1 = IRANK+1
      DEL = ZERO
      DO 2 I=IRK1,N
        SH = 0.0
        DO 21 L1=1,I-1
          SH = SH+QE(L1,I)*V(L1)
21      CONTINUE
        S =(V(I)-SH)/D(I)
        DEL = S*S+DEL
        V(I)=S
2     CONTINUE
C     End of subroutine N2PRJN
      RETURN
      END
C
      SUBROUTINE N2PRV1(DLEVF,DLEVX,FC,NITER,NEW,IRANK,MPRMON,LUMON,
     $                  QMIXIO,COND1)
C*    Begin Prologue N2PRV1
      DOUBLE PRECISION DLEVF,DLEVX,FC,COND1
      INTEGER NITER,NEW,IRANK,MPRMON,LUMON
      LOGICAL QMIXIO
C     ------------------------------------------------------------
C
C*    Summary :
C
C     N 2 P R V 1 : Printing of intermediate values (Type 1 routine)
C
C     Parameters
C     ==========
C
C     DLEVF, DLEVX   See descr. of internal double variables of N2INT
C     FC,NITER,NEW,IRANK,MPRMON,LUMON,COND1
C                  See parameter descr. of subroutine N2INT
C     QMIXIO Logical  = .TRUE.  , if LUMON.EQ.LUSOL
C                     = .FALSE. , if LUMON.NE.LUSOL
C
C     ------------------------------------------------------------
C*    End Prologue
C     Print Standard - and natural level
      IF(QMIXIO)THEN
1       FORMAT(2X,66('*'))
        WRITE(LUMON,1)
2       FORMAT(8X,'It',7X,'Normf ',10X,'Normx ',20X,'New',6X,'Rank',
     $         8X,'Cond')
        IF (MPRMON.GE.3) WRITE(LUMON,2)
3       FORMAT(8X,'It',7X,'Normf ',10X,'Normx ',8X,'Damp.Fct.',3X,'New',
     $         6X,'Rank',8X,'Cond')
        IF (MPRMON.EQ.2) WRITE(LUMON,3)
      ENDIF
4     FORMAT(6X,I4,5X,D10.3,2X,4X,D10.3,17X,I2,6X,I4,2X,D10.3)
      IF (MPRMON.GE.3.OR.NITER.EQ.0) 
     $  WRITE(LUMON,4) NITER,DLEVF,DLEVX,NEW,IRANK,COND1
5     FORMAT(6X,I4,5X,D10.3,6X,D10.3,6X,F7.5,4X,I2,6X,I4,2X,D10.3)
      IF (MPRMON.EQ.2.AND.NITER.NE.0) 
     $  WRITE(LUMON,5) NITER,DLEVF,DLEVX,FC,NEW,IRANK,COND1
      IF(QMIXIO)THEN
6       FORMAT(2X,66('*'))
        WRITE(LUMON,6)
      ENDIF
C     End of subroutine N2PRV1
      RETURN
      END
C
      SUBROUTINE N2PRV2(DLEVF,DLEVX,FC,NITER,MPRMON,LUMON,QMIXIO,
     $                  CMARK)
C*    Begin Prologue N2PRV2
      DOUBLE PRECISION DLEVF,DLEVX,FC
      INTEGER NITER,MPRMON,LUMON
      LOGICAL QMIXIO
      CHARACTER*1 CMARK
C     ------------------------------------------------------------
C
C*    Summary :
C
C     N 2 P R V 2 : Printing of intermediate values (Type 2 routine)
C
C*    Parameters
C     ==========
C
C     DLEVF, DLEVX   See descr. of internal double variables of N2INT
C     FC,NITER,MPRMON,LUMON
C                  See parameter descr. of subroutine N2INT
C     QMIXIO Logical  = .TRUE.  , if LUMON.EQ.LUSOL
C                     = .FALSE. , if LUMON.NE.LUSOL
C     CMARK Char*1    Marker character to be printed before DLEVX
C
C     ------------------------------------------------------------
C*    End Prologue
C     Print Standard - and natural level, and damping
C     factor
      IF(QMIXIO)THEN
1       FORMAT(2X,66('*'))
        WRITE(LUMON,1)
2       FORMAT(8X,'It',7X,'Normf ',10X,'Normx ',8X,'Damp.Fct.')
        WRITE(LUMON,2)
      ENDIF
3     FORMAT(6X,I4,5X,D10.3,4X,A1,1X,D10.3,6X,F7.5)
      WRITE(LUMON,3)NITER,DLEVF,CMARK,DLEVX,FC
      IF(QMIXIO)THEN
4       FORMAT(2X,66('*'))
        WRITE(LUMON,4)
      ENDIF
C     End of subroutine N2PRV2
      RETURN
      END
C
      SUBROUTINE N2SOUT(N,X,MODE,IOPT,RWK,NRW,IWK,NIW,MPRINT,LUOUT)
C*    Begin Prologue SOLOUT
      INTEGER N
      DOUBLE PRECISION X(N)
      INTEGER NRW
      INTEGER MODE
      INTEGER IOPT(50)
      DOUBLE PRECISION RWK(NRW)
      INTEGER NIW
      INTEGER IWK(NIW)
      INTEGER MPRINT,LUOUT
C     ------------------------------------------------------------
C
C*    Summary :
C
C     S O L O U T : Printing of iterate (user customizable routine)
C
C*    Input parameters
C     ================
C
C     N         Int Number of equations/unknowns
C     X(N)   Dble   iterate vector
C     MODE          =1 This routine is called before the first
C                      Newton iteration step
C                   =2 This routine is called with an intermedi-
C                      ate iterate X(N)
C                   =3 This is the last call with the solution
C                      vector X(N)
C                   =4 This is the last call with the final, but
C                      not solution vector X(N)
C     IOPT(50)  Int The option array as passed to the driver
C                   routine (elements 46 to 50 may be used
C                   for user options)
C     MPRINT    Int Solution print level 
C                   (see description of IOPT-field MPRINT)
C     LUOUT     Int the solution print unit 
C                   (see description of see IOPT-field LUSOL)
C
C
C*    Workspace parameters
C     ====================
C
C     NRW, RWK, NIW, IWK    see description in driver routine
C
C*    Use of IOPT by this routine
C     ===========================
C
C     Field 46:       =0 Standard output
C                     =1 GRAZIL suitable output
C
C     ------------------------------------------------------------
C*    End Prologue
      LOGICAL QGRAZ,QNORM
C*    Begin
      QNORM = IOPT(46).EQ.0
      QGRAZ = IOPT(46).EQ.1
      IF(QNORM) THEN
1        FORMAT('  ',A,' data:',/)
         IF (MODE.EQ.1) THEN
101        FORMAT('  Start data:',/,'  N =',I5,//,
     $            '  Format: iteration-number, (x(i),i=1,...N), ',
     $            'Normf , Normx ',/)
           WRITE(LUOUT,101) N
           WRITE(LUOUT,1) 'Initial'
         ELSE IF (MODE.EQ.3) THEN
           WRITE(LUOUT,1) 'Solution'
         ELSE IF (MODE.EQ.4) THEN
           WRITE(LUOUT,1) 'Final'
         ENDIF
2        FORMAT(' ',I5)
C        WRITE          NITER
         WRITE(LUOUT,2) IWK(1)
3        FORMAT((12X,3(D18.10,1X)))
         WRITE(LUOUT,3)(X(L1),L1=1,N)
C        WRITE          DLEVF,  DLEVX
         WRITE(LUOUT,3) RWK(19),DSQRT(RWK(18)/DBLE(FLOAT(N)))
         IF(MODE.EQ.1.AND.MPRINT.GE.2) THEN
           WRITE(LUOUT,1) 'Intermediate'
         ELSE IF(MODE.GE.3) THEN
           WRITE(LUOUT,1) 'End'
         ENDIF
      ENDIF
      IF(QGRAZ) THEN
        IF(MODE.EQ.1) THEN
10        FORMAT('&name com',I3.3,:,255(7(', com',I3.3,:),/))
          WRITE(LUOUT,10)(I,I=1,N+2)
15        FORMAT('&def  com',I3.3,:,255(7(', com',I3.3,:),/))
          WRITE(LUOUT,15)(I,I=1,N+2)
16        FORMAT(6X,': X=1, Y=',I3)
          WRITE(LUOUT,16) N+2
        ENDIF
20      FORMAT('&data ',I5)
C        WRITE          NITER
        WRITE(LUOUT,20) IWK(1) 
21      FORMAT((6X,4(D18.10)))
        WRITE(LUOUT,21)(X(L1),L1=1,N)
C        WRITE          DLEVF,  DLEVX
        WRITE(LUOUT,21) RWK(19),DSQRT(RWK(18)/DBLE(FLOAT(N)))
        IF(MODE.GE.3) THEN
30        FORMAT('&wktype 3111',/,'&atext x ''iter''')
          WRITE(LUOUT,30)
35        FORMAT('&vars = com',I3.3,/,'&atext y ''x',I3,'''',
     $           /,'&run')
          WRITE(LUOUT,35) (I,I,I=1,N)
36        FORMAT('&vars = com',I3.3,/,'&atext y ''',A,'''',
     $           /,'&run')
          WRITE(LUOUT,36) N+1,'Normf ',N+2,'Normx '
C39       FORMAT('&stop')
C         WRITE(LUOUT,39)
        ENDIF
      ENDIF
C     End of subroutine N2SOUT
      RETURN
      END

#!/bin/bash

### building Anaconda packages for pysces under Python 3.6 - 3.9
echo "\nBuilding Anaconda packages..."
echo "=============================\n"
mamba build .

### building wheels for Python 3.6 - 3.9
source $CONDA_PREFIX/etc/profile.d/conda.sh

echo "\nBuilding Python wheels..."
echo "=========================\n"
cd ../..

conda create -y -n py36-build python=3.6 numpy=1.15
conda activate py36-build
pip wheel --no-deps -w dist .
conda deactivate
conda env remove -y -n py36-build

conda create -y -n py37-build python=3.7 numpy=1.15
conda activate py37-build
pip wheel --no-deps -w dist .
conda deactivate
conda env remove -y -n py37-build

conda create -y -n py38-build python=3.8 numpy=1.17
conda activate py38-build
pip wheel --no-deps -w dist .
conda deactivate
conda env remove -y -n py38-build

conda create -y -n py39-build python=3.9 numpy=1.20
conda activate py39-build
pip wheel --no-deps -w dist .
conda deactivate
conda env remove -y -n py39-build

### move linked shared libraries into the wheel with delocate
# install delocate in base environment with:
# (base) $ conda install -c conda-forge delocate
echo "\nCreating portable wheels with delocate..."
echo "=========================================\n"

cd dist
for I in *macosx_10_9_x86_64.whl; do
    delocate-wheel -w wheelhouse $I
done

@echo off
rem This creates an Anaconda environment suitable
rem for the building of PySCeS binary wheels under Windows

if "%1"=="" (
	echo Provide name of new environment as first argument
	goto:end
)

conda create -y -n %1 certifi icc_rt intel-openmp libpython mkl numpy=1.11.3 pip python=2.7 setuptools vc vs2008_runtime wheel wincertstore

:end
endlocal
	

@echo off
rem This fixes a freshly created Anaconda environment
rem for the building of PySCeS binary wheels under Windows

echo Environment: %CONDA_PREFIX%
copy %CONDA_PREFIX%\libs\libmsvcr90.dll.a %CONDA_PREFIX%\libs\libmsvcr90.a
copy %CONDA_PREFIX%\libs\libpython27.dll.a %CONDA_PREFIX%\libs\libpython27.a

#!/bin/bash
export PATH=$HOME/.local/bin:$PATH

for PYBIN in /opt/python/cp3[67]*/bin; do
    ${PYBIN}/pip --cache-dir /io/packaging/many_linux/pip_cache install numpy~=1.15.0 --user
    ${PYBIN}/python /io/setup.py bdist_wheel
done

for PYBIN in /opt/python/cp38*/bin; do
    ${PYBIN}/pip --cache-dir /io/packaging/many_linux/pip_cache install numpy~=1.17.0 --user
    ${PYBIN}/python /io/setup.py bdist_wheel
done

for PYBIN in /opt/python/cp39*/bin; do
    ${PYBIN}/pip --cache-dir /io/packaging/many_linux/pip_cache install numpy~=1.20.0 --user
    ${PYBIN}/python /io/setup.py bdist_wheel
done

# Bundle external shared libraries into the wheels
for whl in /io/dist/pysces*linux*.whl; do
    auditwheel repair $whl -w /io/dist/wheelhouse/
    mv $whl $whl.bak
done

#!/bin/bash
DNS_SERVER=8.8.4.4
# DNS_SERVER=146.232.20.10

export DOCKER_IMAGE=quay.io/pypa/manylinux2014_x86_64
docker run --dns $DNS_SERVER --rm -v `pwd`/../..:/io $DOCKER_IMAGE /io/packaging/many_linux/build_pysces.sh

:: building Anaconda packages for pysces under Python 3.6 - 3.9 (Windows)
@echo off

echo;
echo Building Anaconda packages...
echo =============================
echo;

call mamba build .

:: building wheels for Python 3.6 - 3.9
echo;
echo Building Python wheels...
echo =========================
echo;

cd ..\..

call conda create -y -n py36-build python=3.6 numpy=1.15
call conda activate py36-build
pip wheel --no-deps -w dist .
call conda deactivate
call conda env remove -y -n py36-build
rmdir /s /q %USERPROFILE%\miniconda3\envs\py36-build

call conda create -y -n py37-build python=3.7 numpy=1.15
call conda activate py37-build
pip wheel --no-deps -w dist .
call conda deactivate
call conda env remove -y -n py37-build
rmdir /s /q %USERPROFILE%\miniconda3\envs\py37-build

call conda create -y -n py38-build python=3.8 numpy=1.17
call conda activate py38-build
pip wheel --no-deps -w dist .
call conda deactivate
call conda env remove -y -n py38-build
rmdir /s /q %USERPROFILE%\miniconda3\envs\py38-build

call conda create -y -n py39-build python=3.9 numpy=1.20
call conda activate py39-build
pip wheel --no-deps -w dist .
call conda deactivate
call conda env remove -y -n py39-build
rmdir /s /q %USERPROFILE%\miniconda3\envs\py39-build

cd packaging\conda

#!/bin/bash

# building Anaconda packages for pysces under Python 3.6 - 3.9
# new automated variants build using conda_build_config.yaml
# also use faster mamba instead of conda

echo "\nBuilding Anaconda packages..."
echo "=============================\n"

mamba build .

# Additional licences

Licences for other software (or parts thereof) distributed with, or used by, PySCeS.

## NLEQ2

The NLEQ2 algorithm from ZIB which has its own licence and warranty and does not fall
under the PySCeS GPL licence. ZIB has kindly given us permission to distribute NLEQ2
with PySCeS provided its use falls within their terms of usage (/nleq2/nleq2_readme):

You may use or modify this code for your own non-commercial purposes for an unlimited
time. In any case you should not deliver this code without a special permission of ZIB.
In case you intend to use the code commercially, we oblige you to sign an according
licence agreement with ZIB.

If you are not using PySCeS for research or personal use you **must** disable NLEQ2 by
setting `nleq2 = 0` in setup.py before installation. This is a plug-in solver and its
removal does not otherwise influence PySCeS.

## PLY

David Beazley's PLY 3.3 (http://www.dabeaz.com/ply/). This package is included unchanged
and consists of two files *lex.py* and *yacc.py* in the `pysces/lib` and `pysces/core2`
modules.

© Brett G. Olivier & Johann M. Rohwer, August 2021

# Installing PySCeS

Binary install packages for all three OSs and recent Python versions are 
provided. Anaconda packages are available for 64-bit Windows and Linux, as well as 
macOS *x86_64* and Apple Silicon (*arm64*) architectures. Anaconda users can 
conveniently install PySCeS with:

```bash
$ conda install -c conda-forge -c pysces pysces
```  

Any dependencies will be installed automatically, including the optional dependencies 
*Assimulo*, *ipyparallel* and *libSBML*.
> **NOTE:** Anaconda packages are only provided for Python versions 3.9-3.11. The 
> reason is that Assimulo has not been ported to Python 3.12 and still depends on 
> `numpy.distutils`. As soon as this has happened, PySCeS Anaconda packages for 3.12 
> will be built.

Alternatively, you can use *pip* to
install PySCeS from PyPI. Core dependencies will be installed automatically. Wheels
are available for 64-bit Windows and Linux, as well as macOS architectures *x86_64* and
*arm64* (starting from PySCeS version 1.2.0, supporting Python 3.11 and 3.12).

```bash
$ pip install pysces
```

To install the optional dependences:

- `pip install "pysces[parscan]"` - for *ipyparallel*
- `pip install "pysces[sbml]"` - for *libSBML*
- `pip install "pysces[cvode]"` - for *Assimulo*
- `pip install "pysces[all]"` - for all of the above

>  **_NOTE:_**  Installation of *Assimulo* via `pip` may well require C and Fortran 
>  compilers to be
>  properly set up on your system, as binary packages are only provided for a
>  very limited number of Python versions and operating systems on PyPI. 
>  **This is not guaranteed to work!** If you require Assimulo, the conda
>  install is by far the easier option as up-to-date binaries are supplied
>  for all OSs and recent Python versions.

For more information on installing and configuring PySCeS please see the
[PySCeS User Guide](https://github.com/PySCeS/pysces-documentation/blob/main/source/userguide_doc.rst#installing-and-configuring)

## Compilation from source

As an alternative to a binary installation, you can also build your own PySCeS
installation from source. This requires Fortran and C compilers.

### Windows build

The fastest way to build your own copy of PySCeS is to use Anaconda for 
installing Python and the required libraries. In addition, the *RTools* compiler 
toolchain is required.

* Download and install 
  [Anaconda for Python 3](https://www.anaconda.com/download#Downloads)
* Obtain [Git for Windows](https://git-scm.com/download/win)
* Obtain the *RTools* compiler toolchain (**version 4.0.0.20220206**), either using
  [Chocolatey](https://chocolatey.org/install) 
  (`choco install rtools -y --version=4.0.0.20220206`) or by
  [direct download](https://github.com/r-windows/rtools-installer/releases/download/2022-02-06/rtools40-x86_64.exe)
  - Install in `C:\rtools40` (Chocolatey automatically installs to this path)
  - Add `c:\rtools40\ucrt64\bin` and `c:\rtools40\usr\bin` to the system `PATH`
* Create a PySCeS environment using conda and activate it:

```bash
$ conda create -n pyscesdev -c conda-forge python=3.11 numpy=1.26 scipy \ 
  matplotlib sympy packaging pip wheel ipython python-libsbml \
  assimulo meson meson-python ninja
$ conda activate pyscesdev
```

* Clone and enter the PySCeS code repository using git

```bash
(pyscesdev)$ git clone https://github.com/PySCeS/pysces.git pysces-src
(pyscesdev)$ cd pysces-src
```

* Now you can build and install PySCeS into the *pyscesdev* environment

```bash
(pyscesdev)$ pip install --no-deps --no-build-isolation .
```

### Linux build

All modern Linux distributions ship with gcc and gfortran. In addition, the Python
development headers (*python-dev* or *python-devel*, depending on your distro) need to
be installed.

Clone the source from Github as described above, change into the source directory and
run:

```bash
$ pip install .
```

### macOS build

The Anaconda build method, described above for Windows, should also work on macOS.

Alternatively, Python 3 may be obtained via [Homebrew](https://brew.sh) and the
compilers may be installed via [Xcode](https://developer.apple.com/xcode). Clone the
source from Github as described above, change into the source directory and run:

```bash
$ pip install .
```

© Johann M. Rohwer & Brett G. Olivier, January 2024

OUTDATED: Please see README.md
==============================

Building with VS 2019-C++  and MINGW64-gfortran 8.1

* It appears that for newer Pythons one should use Visual C++ as a compiler, rather than MINGW64-GCC.
* For newer versions of numpy, you apparently need a recent version of MINGW64-gfortran. The one that comes with Anaconda (as part of the mingw package) is 4.7.0 which does not work!

Here is how I have managed to build a wheel for Python 3.7 that seems to work:

* I have Visual Studio 2017 installed for C++ stuff, however, the VS build tools are available for free. Try here for download details: https://wiki.python.org/moin/WindowsCompilers>
** Anaconda might also have the VC build tools (package vc) but I have never used it.
* Create a conda environment: conda create -n "pscbuild" python=3.7 ipython pip wheel numpy scipy matplotlib
** Alternatively, if using an existing environment, make sure the Anaconda mingw package is not installed (remove it now)
* I unpacked MINGW64 that I obtained here (https://sourceforge.net/projects/mingw-w64/files/Toolchains%20targetting%20Win64/Personal%20Builds/mingw-builds/8.1.0/threads-posix/seh/x86_64-8.1.0-release-posix-seh-rt_v6-rev0.7z/download) based on the information I found here (https://stackoverflow.com/questions/48826283/compile-fortran-module-with-f2py-and-python-3-6-on-windows-10)
* In a terminal I then activated the conda environment and added the new GCC to the path (making sure there was no existing gcc)
** conda activate pscbuild
** path=c:\tools\mingw64\bin;%path%
* Build/install PySCeS with python setup.py build --compiler=msvc --fcompiler=gfortran install bdist_wheel

For conda build we need the following:

* Open a VS2015 terminal (v10) and change to your build directory
** path=c:\tools\mingw64\bin;%path%
** path="c:\Program Files (x86)\Windows Kits\10\bin\10.0.18362.0\x64";%path%
* 3.6 <= Python < 3.8
** conda build --python 3.6 --numpy 1.15 .
** conda build --python 3.7 --numpy 1.15 .
* Python >= 3.8
** conda build --python 3.8 --numpy 1.18 .

* cleanup and upload
** conda build purge
** conda clean --all
** anaconda upload -u pysces pysces-builds\*
 


Brett 2020

PySCeS main authors are [Brett Olivier](https://research.vu.nl/en/persons/bg-olivier)
and [Johann Rohwer](https://github.com/jmrohwer) and in particular, PySCeS founding
father [Jannie Hofmeyr]().

We would also like to acknowledge everyone who has contributed to PySCeS and would like
to thank the following (in alphabetical order):

* Evert Bosdriesz
* James Dominy
* Jannie Hofmeyr
* Morgan Hough
* Jonathan Karr
* Ruchir Khandelwal
* Charl Moller
* Danie Palm
* Herbert Sauro
* Lafras Uys

In addition we would like to acknowledge financial support from the following funding
organisations:

* The South African National Bioinformatics Network (2003-2008)
* The South African National Research Foundation (2000-2004)

© Brett G. Olivier & Johann M. Rohwer, August 2021

# For the latest code

Primary development is on Github, see
[https://github.com/PySCeS/pysces](https://github.com/PySCeS/pysces). Feel free to
fork and submit pull requests!

```
git clone git@github.com:PySCeS/pysces.git
```

PySCeS binaries for release versions are available from PyPI and the Anaconda.org 
for 64-bit Windows, Linux and macOS.

**For PyPI:**

```
pip install pysces
```

**For Anaconda:**

```
conda install -c sbmlteam -c pysces pysces
```

© Brett G. Olivier & Johann M. Rohwer, August 2021

# PySCeS - the Python Simulator for Cellular Systems

PySCeS was originally developed by the Triple-J Group for Molecular 
Cell Physiology at Stellenbosch University in order to try to model and understand the 
complex processes and systems which make up the living cell. The project is 
maintained by Brett Olivier (AIMMS, Vrije Universiteit Amsterdam) and Johann Rohwer 
(Laboratory for Molecular Systems Biology, Stellenbosch University).

PySCeS features, amongst other things:
- A text-based model description language.
- A structural analysis module.
- Integrators for time simulation.
- Non-linear solvers for steady-state analysis.
- A module for performing Metabolic Control Analysis.
- A bifurcation module for systems which exhibit multiple steady states.
- A variety of extra utilities for parameter scans, data output and plotting.
- A dynamic module loading framework.
- Systems Biology Markup Language (SBML) import and export capability.

# Create export library

If F2Py is failing to find an msvcr90.dll

 cd <workdir>
 copy C:\WINDOWS\winsxs\amd64_microsoft.vc90.crt_1fc8b3b9a1e18e3b_9.0.30729.1_none_99b61f5e8371c1d4\msvcr90.dll .
 
 
 gendef.exe msvcr90.dll

dlltool.exe -D msvcr90.dll -l libmsvcr90.a -d msvcr90.def

copy libmsvcr90.a MINGW64_PATH\lib
